/* application.c generated by valac 0.56.7, the Vala compiler
 * generated from application.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2017-2020 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <glib-object.h>
#include <ibus.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
typedef struct _ApplicationPrivate ApplicationPrivate;

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))
typedef struct _ParamSpecApplication ParamSpecApplication;

struct _Application {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ApplicationPrivate * priv;
};

struct _ApplicationClass {
	GTypeClass parent_class;
	void (*finalize) (Application *self);
};

struct _ApplicationPrivate {
	IBusBus* m_bus;
	Panel* m_panel;
};

struct _ParamSpecApplication {
	GParamSpec parent_instance;
};

static gint Application_private_offset;
static gpointer application_parent_class = NULL;

VALA_EXTERN gpointer application_ref (gpointer instance);
VALA_EXTERN void application_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_application (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_application (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_application (const GValue* value);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, application_unref)
VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
VALA_EXTERN Application* application_new (gchar** argv,
                              gint argv_length1);
VALA_EXTERN Application* application_construct (GType object_type,
                                    gchar** argv,
                                    gint argv_length1);
static void application_bus_connected (Application* self,
                                IBusBus* bus);
static void _application_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                                    gpointer self);
static void application_bus_disconnected (Application* self,
                                   IBusBus* bus);
static void _application_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                          gpointer self);
static void application_init (Application* self);
static void application_bus_name_acquired_cb (Application* self,
                                       GDBusConnection* connection,
                                       const gchar* sender_name,
                                       const gchar* object_path,
                                       const gchar* interface_name,
                                       const gchar* signal_name,
                                       GVariant* parameters);
static void _application_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                               const gchar* sender_name,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* signal_name,
                                                               GVariant* parameters,
                                                               gpointer self);
static void application_bus_name_lost_cb (Application* self,
                                   GDBusConnection* connection,
                                   const gchar* sender_name,
                                   const gchar* object_path,
                                   const gchar* interface_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _application_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                           const gchar* sender_name,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* signal_name,
                                                           GVariant* parameters,
                                                           gpointer self);
VALA_EXTERN gint application_run (Application* self);
VALA_EXTERN Panel* panel_new (IBusBus* bus);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
static void application_main (gchar** argv,
                       gint argv_length1);
static void application_finalize (Application * obj);
static GType application_get_type_once (void);

static inline gpointer
application_get_instance_private (Application* self)
{
	return G_STRUCT_MEMBER_P (self, Application_private_offset);
}

static void
_application_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                               gpointer self)
{
#line 36 "application.vala"
	application_bus_connected ((Application*) self, _sender);
#line 178 "application.c"
}

static void
_application_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                     gpointer self)
{
#line 37 "application.vala"
	application_bus_disconnected ((Application*) self, _sender);
#line 187 "application.c"
}

Application*
application_construct (GType object_type,
                       gchar** argv,
                       gint argv_length1)
{
	Application* self = NULL;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	IBusBus* _tmp2_;
	IBusBus* _tmp3_;
#line 28 "application.vala"
	self = (Application*) g_type_create_instance (object_type);
#line 29 "application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 30 "application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 31 "application.vala"
	ibus_init ();
#line 32 "application.vala"
	gtk_init ((gint*) (&argv_length1), &argv);
#line 34 "application.vala"
	_tmp0_ = ibus_bus_new ();
#line 34 "application.vala"
	g_object_ref_sink (_tmp0_);
#line 34 "application.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 34 "application.vala"
	self->priv->m_bus = _tmp0_;
#line 36 "application.vala"
	_tmp1_ = self->priv->m_bus;
#line 36 "application.vala"
	g_signal_connect (_tmp1_, "connected", (GCallback) _application_bus_connected_ibus_bus_connected, self);
#line 37 "application.vala"
	_tmp2_ = self->priv->m_bus;
#line 37 "application.vala"
	g_signal_connect (_tmp2_, "disconnected", (GCallback) _application_bus_disconnected_ibus_bus_disconnected, self);
#line 39 "application.vala"
	_tmp3_ = self->priv->m_bus;
#line 39 "application.vala"
	if (ibus_bus_is_connected (_tmp3_)) {
#line 40 "application.vala"
		application_init (self);
#line 232 "application.c"
	}
#line 28 "application.vala"
	return self;
#line 236 "application.c"
}

Application*
application_new (gchar** argv,
                 gint argv_length1)
{
#line 28 "application.vala"
	return application_construct (TYPE_APPLICATION, argv, argv_length1);
#line 245 "application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "application.vala"
	return self ? g_object_ref (self) : NULL;
#line 253 "application.c"
}

static void
_application_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                          const gchar* sender_name,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* signal_name,
                                                          GVariant* parameters,
                                                          gpointer self)
{
#line 46 "application.vala"
	application_bus_name_acquired_cb ((Application*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 267 "application.c"
}

static void
_application_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                      const gchar* sender_name,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* signal_name,
                                                      GVariant* parameters,
                                                      gpointer self)
{
#line 53 "application.vala"
	application_bus_name_lost_cb ((Application*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 281 "application.c"
}

static void
application_init (Application* self)
{
	GDBusConnection* connection = NULL;
	IBusBus* _tmp0_;
	GDBusConnection* _tmp1_;
	GDBusConnection* _tmp2_;
	IBusBusNameFlag flags = 0U;
	IBusBus* _tmp3_;
#line 44 "application.vala"
	g_return_if_fail (self != NULL);
#line 45 "application.vala"
	_tmp0_ = self->priv->m_bus;
#line 45 "application.vala"
	_tmp1_ = ibus_bus_get_connection (_tmp0_);
#line 45 "application.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 45 "application.vala"
	connection = _tmp2_;
#line 46 "application.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameAcquired", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL, G_DBUS_SIGNAL_FLAGS_NONE, _application_bus_name_acquired_cb_gd_bus_signal_callback, application_ref (self), application_unref);
#line 53 "application.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameLost", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL, G_DBUS_SIGNAL_FLAGS_NONE, _application_bus_name_lost_cb_gd_bus_signal_callback, application_ref (self), application_unref);
#line 60 "application.vala"
	flags = IBUS_BUS_NAME_FLAG_ALLOW_REPLACEMENT | IBUS_BUS_NAME_FLAG_REPLACE_EXISTING;
#line 63 "application.vala"
	_tmp3_ = self->priv->m_bus;
#line 63 "application.vala"
	ibus_bus_request_name (_tmp3_, IBUS_SERVICE_PANEL, (guint32) flags);
#line 44 "application.vala"
	_g_object_unref0 (connection);
#line 315 "application.c"
}

gint
application_run (Application* self)
{
	gint result;
#line 66 "application.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 67 "application.vala"
	gtk_main ();
#line 68 "application.vala"
	result = 0;
#line 68 "application.vala"
	return result;
#line 330 "application.c"
}

static void
application_bus_name_acquired_cb (Application* self,
                                  GDBusConnection* connection,
                                  const gchar* sender_name,
                                  const gchar* object_path,
                                  const gchar* interface_name,
                                  const gchar* signal_name,
                                  GVariant* parameters)
{
	IBusBus* _tmp0_;
	Panel* _tmp1_;
	Panel* _tmp2_;
#line 71 "application.vala"
	g_return_if_fail (self != NULL);
#line 71 "application.vala"
	g_return_if_fail (connection != NULL);
#line 71 "application.vala"
	g_return_if_fail (object_path != NULL);
#line 71 "application.vala"
	g_return_if_fail (interface_name != NULL);
#line 71 "application.vala"
	g_return_if_fail (signal_name != NULL);
#line 71 "application.vala"
	g_return_if_fail (parameters != NULL);
#line 77 "application.vala"
	g_debug ("application.vala:77: signal_name = %s", signal_name);
#line 78 "application.vala"
	_tmp0_ = self->priv->m_bus;
#line 78 "application.vala"
	_tmp1_ = panel_new (_tmp0_);
#line 78 "application.vala"
	g_object_ref_sink (_tmp1_);
#line 78 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 78 "application.vala"
	self->priv->m_panel = _tmp1_;
#line 79 "application.vala"
	_tmp2_ = self->priv->m_panel;
#line 79 "application.vala"
	panel_load_settings (_tmp2_);
#line 373 "application.c"
}

static void
application_bus_name_lost_cb (Application* self,
                              GDBusConnection* connection,
                              const gchar* sender_name,
                              const gchar* object_path,
                              const gchar* interface_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	Panel* _tmp0_;
#line 82 "application.vala"
	g_return_if_fail (self != NULL);
#line 82 "application.vala"
	g_return_if_fail (connection != NULL);
#line 82 "application.vala"
	g_return_if_fail (object_path != NULL);
#line 82 "application.vala"
	g_return_if_fail (interface_name != NULL);
#line 82 "application.vala"
	g_return_if_fail (signal_name != NULL);
#line 82 "application.vala"
	g_return_if_fail (parameters != NULL);
#line 94 "application.vala"
	g_debug ("application.vala:94: signal_name = %s", signal_name);
#line 97 "application.vala"
	_tmp0_ = self->priv->m_panel;
#line 97 "application.vala"
	panel_disconnect_signals (_tmp0_);
#line 98 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 98 "application.vala"
	self->priv->m_panel = NULL;
#line 408 "application.c"
}

static void
application_bus_disconnected (Application* self,
                              IBusBus* bus)
{
#line 101 "application.vala"
	g_return_if_fail (self != NULL);
#line 101 "application.vala"
	g_return_if_fail (bus != NULL);
#line 102 "application.vala"
	g_debug ("application.vala:102: connection is lost.");
#line 103 "application.vala"
	gtk_main_quit ();
#line 423 "application.c"
}

static void
application_bus_connected (Application* self,
                           IBusBus* bus)
{
#line 106 "application.vala"
	g_return_if_fail (self != NULL);
#line 106 "application.vala"
	g_return_if_fail (bus != NULL);
#line 107 "application.vala"
	application_init (self);
#line 436 "application.c"
}

static void
application_main (gchar** argv,
                  gint argv_length1)
{
	Application* app = NULL;
	Application* _tmp0_;
#line 116 "application.vala"
	g_unsetenv ("GDK_CORE_DEVICE_EVENTS");
#line 118 "application.vala"
	gdk_set_allowed_backends ("x11");
#line 120 "application.vala"
	_tmp0_ = application_new (argv, argv_length1);
#line 120 "application.vala"
	app = _tmp0_;
#line 121 "application.vala"
	application_run (app);
#line 110 "application.vala"
	_application_unref0 (app);
#line 457 "application.c"
}

int
main (int argc,
      char ** argv)
{
#line 110 "application.vala"
	application_main (argv, argc);
#line 110 "application.vala"
	return 0;
#line 468 "application.c"
}

static void
value_application_init (GValue* value)
{
#line 24 "application.vala"
	value->data[0].v_pointer = NULL;
#line 476 "application.c"
}

static void
value_application_free_value (GValue* value)
{
#line 24 "application.vala"
	if (value->data[0].v_pointer) {
#line 24 "application.vala"
		application_unref (value->data[0].v_pointer);
#line 486 "application.c"
	}
}

static void
value_application_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 24 "application.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "application.vala"
		dest_value->data[0].v_pointer = application_ref (src_value->data[0].v_pointer);
#line 498 "application.c"
	} else {
#line 24 "application.vala"
		dest_value->data[0].v_pointer = NULL;
#line 502 "application.c"
	}
}

static gpointer
value_application_peek_pointer (const GValue* value)
{
#line 24 "application.vala"
	return value->data[0].v_pointer;
#line 511 "application.c"
}

static gchar*
value_application_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 24 "application.vala"
	if (collect_values[0].v_pointer) {
#line 522 "application.c"
		Application * object;
		object = collect_values[0].v_pointer;
#line 24 "application.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "application.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 529 "application.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "application.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 533 "application.c"
		}
#line 24 "application.vala"
		value->data[0].v_pointer = application_ref (object);
#line 537 "application.c"
	} else {
#line 24 "application.vala"
		value->data[0].v_pointer = NULL;
#line 541 "application.c"
	}
#line 24 "application.vala"
	return NULL;
#line 545 "application.c"
}

static gchar*
value_application_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	Application ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "application.vala"
	if (!object_p) {
#line 24 "application.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 560 "application.c"
	}
#line 24 "application.vala"
	if (!value->data[0].v_pointer) {
#line 24 "application.vala"
		*object_p = NULL;
#line 566 "application.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "application.vala"
		*object_p = value->data[0].v_pointer;
#line 570 "application.c"
	} else {
#line 24 "application.vala"
		*object_p = application_ref (value->data[0].v_pointer);
#line 574 "application.c"
	}
#line 24 "application.vala"
	return NULL;
#line 578 "application.c"
}

GParamSpec*
param_spec_application (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecApplication* spec;
#line 24 "application.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_APPLICATION), NULL);
#line 24 "application.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "application.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "application.vala"
	return G_PARAM_SPEC (spec);
#line 597 "application.c"
}

gpointer
value_get_application (const GValue* value)
{
#line 24 "application.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION), NULL);
#line 24 "application.vala"
	return value->data[0].v_pointer;
#line 607 "application.c"
}

void
value_set_application (GValue* value,
                       gpointer v_object)
{
	Application * old;
#line 24 "application.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION));
#line 24 "application.vala"
	old = value->data[0].v_pointer;
#line 24 "application.vala"
	if (v_object) {
#line 24 "application.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_APPLICATION));
#line 24 "application.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "application.vala"
		value->data[0].v_pointer = v_object;
#line 24 "application.vala"
		application_ref (value->data[0].v_pointer);
#line 629 "application.c"
	} else {
#line 24 "application.vala"
		value->data[0].v_pointer = NULL;
#line 633 "application.c"
	}
#line 24 "application.vala"
	if (old) {
#line 24 "application.vala"
		application_unref (old);
#line 639 "application.c"
	}
}

void
value_take_application (GValue* value,
                        gpointer v_object)
{
	Application * old;
#line 24 "application.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION));
#line 24 "application.vala"
	old = value->data[0].v_pointer;
#line 24 "application.vala"
	if (v_object) {
#line 24 "application.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_APPLICATION));
#line 24 "application.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "application.vala"
		value->data[0].v_pointer = v_object;
#line 660 "application.c"
	} else {
#line 24 "application.vala"
		value->data[0].v_pointer = NULL;
#line 664 "application.c"
	}
#line 24 "application.vala"
	if (old) {
#line 24 "application.vala"
		application_unref (old);
#line 670 "application.c"
	}
}

static void
application_class_init (ApplicationClass * klass,
                        gpointer klass_data)
{
#line 24 "application.vala"
	application_parent_class = g_type_class_peek_parent (klass);
#line 24 "application.vala"
	((ApplicationClass *) klass)->finalize = application_finalize;
#line 24 "application.vala"
	g_type_class_adjust_private_offset (klass, &Application_private_offset);
#line 684 "application.c"
}

static void
application_instance_init (Application * self,
                           gpointer klass)
{
#line 24 "application.vala"
	self->priv = application_get_instance_private (self);
#line 24 "application.vala"
	self->ref_count = 1;
#line 695 "application.c"
}

static void
application_finalize (Application * obj)
{
	Application * self;
#line 24 "application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
#line 24 "application.vala"
	g_signal_handlers_destroy (self);
#line 25 "application.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 26 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 710 "application.c"
}

static GType
application_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_application_init, value_application_free_value, value_application_copy_value, value_application_peek_pointer, "p", value_application_collect_value, "p", value_application_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Application), 0, (GInstanceInitFunc) application_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType application_type_id;
	application_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Application", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Application_private_offset = g_type_add_instance_private (application_type_id, sizeof (ApplicationPrivate));
	return application_type_id;
}

GType
application_get_type (void)
{
	static volatile gsize application_type_id__once = 0;
	if (g_once_init_enter (&application_type_id__once)) {
		GType application_type_id;
		application_type_id = application_get_type_once ();
		g_once_init_leave (&application_type_id__once, application_type_id);
	}
	return application_type_id__once;
}

gpointer
application_ref (gpointer instance)
{
	Application * self;
	self = instance;
#line 24 "application.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "application.vala"
	return instance;
#line 746 "application.c"
}

void
application_unref (gpointer instance)
{
	Application * self;
	self = instance;
#line 24 "application.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "application.vala"
		APPLICATION_GET_CLASS (self)->finalize (self);
#line 24 "application.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 760 "application.c"
	}
}

