/* emojierapp.c generated by valac 0.56.7, the Vala compiler
 * generated from emojierapp.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright (c) 2017 Peng Wu <alexepico@gmail.com>
 * Copyright (c) 2017-2021 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <config.h>
#include <stdio.h>
#include <gdk/gdkwayland.h>
#include <ibus.h>

#define IBUS_EMOJIER_BUTTON_CLOSE_BUTTON ((guint) 1000)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EMOJI_APPLICATION (emoji_application_get_type ())
#define EMOJI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EMOJI_APPLICATION, EmojiApplication))
#define EMOJI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EMOJI_APPLICATION, EmojiApplicationClass))
#define IS_EMOJI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EMOJI_APPLICATION))
#define IS_EMOJI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EMOJI_APPLICATION))
#define EMOJI_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EMOJI_APPLICATION, EmojiApplicationClass))

typedef struct _EmojiApplication EmojiApplication;
typedef struct _EmojiApplicationClass EmojiApplicationClass;
typedef struct _EmojiApplicationPrivate EmojiApplicationPrivate;

#define TYPE_IBUS_EMOJIER (ibus_emojier_get_type ())
#define IBUS_EMOJIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IBUS_EMOJIER, IBusEmojier))
#define IBUS_EMOJIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IBUS_EMOJIER, IBusEmojierClass))
#define IS_IBUS_EMOJIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IBUS_EMOJIER))
#define IS_IBUS_EMOJIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IBUS_EMOJIER))
#define IBUS_EMOJIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IBUS_EMOJIER, IBusEmojierClass))

typedef struct _IBusEmojier IBusEmojier;
typedef struct _IBusEmojierClass IBusEmojierClass;
enum  {
	EMOJI_APPLICATION_0_PROPERTY,
	EMOJI_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* emoji_application_properties[EMOJI_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))

struct _EmojiApplication {
	GtkApplication parent_instance;
	EmojiApplicationPrivate * priv;
};

struct _EmojiApplicationClass {
	GtkApplicationClass parent_class;
};

struct _EmojiApplicationPrivate {
	IBusEmojier* m_emojier;
	GSettings* m_settings_emoji;
	GApplicationCommandLine* m_command_line;
};

VALA_EXTERN gchar* emoji_font;
gchar* emoji_font = NULL;
VALA_EXTERN gchar* annotation_lang;
gchar* annotation_lang = NULL;
VALA_EXTERN gboolean partial_match;
gboolean partial_match = FALSE;
VALA_EXTERN gint partial_match_length;
gint partial_match_length = -1;
VALA_EXTERN gint partial_match_condition;
gint partial_match_condition = -1;
static gint EmojiApplication_private_offset;
static gpointer emoji_application_parent_class = NULL;

VALA_EXTERN GType emoji_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EmojiApplication, g_object_unref)
VALA_EXTERN GType ibus_emojier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IBusEmojier, g_object_unref)
static EmojiApplication* emoji_application_new (void);
static EmojiApplication* emoji_application_construct (GType object_type);
static void emoji_application_save_selected_string (EmojiApplication* self,
                                             const gchar* selected_string,
                                             gboolean cancelled);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void emoji_application_show_dialog (EmojiApplication* self,
                                    GApplicationCommandLine* command_line);
VALA_EXTERN void ibus_emojier_reset (IBusEmojier* self);
VALA_EXTERN void ibus_emojier_set_annotation (IBusEmojier* self,
                                  const gchar* annotation);
VALA_EXTERN void emoji_application_candidate_clicked_lookup_table (EmojiApplication* self,
                                                       guint index,
                                                       guint button,
                                                       guint state);
VALA_EXTERN guint ibus_emojier_get_number_of_candidates (IBusEmojier* self);
VALA_EXTERN void ibus_emojier_set_cursor_pos (IBusEmojier* self,
                                  guint cursor_pos);
VALA_EXTERN gboolean ibus_emojier_has_variants (IBusEmojier* self,
                                    guint index,
                                    gboolean need_commit_signal);
VALA_EXTERN gchar* ibus_emojier_get_current_candidate (IBusEmojier* self);
VALA_EXTERN void emoji_application_activate_dialog (EmojiApplication* self,
                                        GApplicationCommandLine* command_line);
static gint _emoji_application_command_line (EmojiApplication* self,
                                      GApplicationCommandLine* command_line);
VALA_EXTERN void ibus_emojier_set_emoji_font (const gchar* emoji_font);
VALA_EXTERN gboolean ibus_emojier_is_running (IBusEmojier* self);
VALA_EXTERN void ibus_emojier_present_centralize (IBusEmojier* self,
                                      GdkEvent* event);
static void _vala_GdkEvent_free (GdkEvent* self);
VALA_EXTERN void ibus_emojier_set_annotation_lang (const gchar* lang);
VALA_EXTERN void ibus_emojier_set_partial_match (gboolean has_partial_match);
VALA_EXTERN void ibus_emojier_set_partial_match_length (gint length);
VALA_EXTERN void ibus_emojier_set_partial_match_condition (gint condition);
VALA_EXTERN void ibus_emojier_set_favorites (gchar** unowned_favorites,
                                 gint unowned_favorites_length1,
                                 gchar** unowned_favorite_annotations,
                                 gint unowned_favorite_annotations_length1);
VALA_EXTERN void ibus_emojier_load_unicode_dict (void);
VALA_EXTERN IBusEmojier* ibus_emojier_new (gboolean is_wayland);
VALA_EXTERN IBusEmojier* ibus_emojier_construct (GType object_type,
                                     gboolean is_wayland);
static void ___lambda26_ (EmojiApplication* self,
                   guint i,
                   guint b,
                   guint s);
static void ____lambda26__ibus_emojier_candidate_clicked (IBusEmojier* _sender,
                                                   guint index,
                                                   guint button,
                                                   guint state,
                                                   gpointer self);
static void ___lambda27_ (EmojiApplication* self);
static void ____lambda27__ibus_emojier_cancel (IBusEmojier* _sender,
                                        gpointer self);
static void ___lambda28_ (EmojiApplication* self);
VALA_EXTERN gchar* ibus_emojier_get_selected_string (IBusEmojier* self);
static void ____lambda28__ibus_emojier_commit_text (IBusEmojier* _sender,
                                             const gchar* text,
                                             gpointer self);
static gint emoji_application_real_command_line (GApplication* base,
                                          GApplicationCommandLine* command_line);
static void emoji_application_real_shutdown (GApplication* base);
static gint emoji_application_main (gchar** args,
                             gint args_length1);
static void emoji_application_finalize (GObject * obj);
static GType emoji_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
emoji_application_get_instance_private (EmojiApplication* self)
{
	return G_STRUCT_MEMBER_P (self, EmojiApplication_private_offset);
}

static EmojiApplication*
emoji_application_construct (GType object_type)
{
	EmojiApplication * self = NULL;
#line 38 "emojierapp.vala"
	self = (EmojiApplication*) g_object_new (object_type, "application-id", "org.freedesktop.IBus.Panel.Emojier", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 40 "emojierapp.vala"
	g_application_set_inactivity_timeout ((GApplication*) self, (guint) 100000);
#line 37 "emojierapp.vala"
	return self;
#line 209 "emojierapp.c"
}

static EmojiApplication*
emoji_application_new (void)
{
#line 37 "emojierapp.vala"
	return emoji_application_construct (TYPE_EMOJI_APPLICATION);
#line 217 "emojierapp.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "emojierapp.vala"
	return self ? g_object_ref (self) : NULL;
#line 225 "emojierapp.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 64 "emojierapp.vala"
	if ((*length) == (*size)) {
#line 64 "emojierapp.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 64 "emojierapp.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 240 "emojierapp.c"
	}
#line 64 "emojierapp.vala"
	(*array)[(*length)++] = value;
#line 64 "emojierapp.vala"
	(*array)[*length] = NULL;
#line 246 "emojierapp.c"
}

static void
emoji_application_save_selected_string (EmojiApplication* self,
                                        const gchar* selected_string,
                                        gboolean cancelled)
{
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	GtkClipboard* _tmp4_;
	gchar** emojier_favorites = NULL;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint emojier_favorites_length1;
	gint _emojier_favorites_size_;
	gboolean has_favorite = FALSE;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GApplicationCommandLine* _tmp13_;
#line 44 "emojierapp.vala"
	g_return_if_fail (self != NULL);
#line 46 "emojierapp.vala"
	if (cancelled) {
#line 273 "emojierapp.c"
		GApplicationCommandLine* _tmp0_;
#line 47 "emojierapp.vala"
		_tmp0_ = self->priv->m_command_line;
#line 47 "emojierapp.vala"
		g_application_command_line_print (_tmp0_, "%s\n", _ ("Canceled to choose an emoji."));
#line 48 "emojierapp.vala"
		return;
#line 281 "emojierapp.c"
	}
#line 50 "emojierapp.vala"
	g_return_if_fail (selected_string != NULL);
#line 51 "emojierapp.vala"
	_tmp1_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
#line 51 "emojierapp.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 51 "emojierapp.vala"
	clipboard = _tmp2_;
#line 52 "emojierapp.vala"
	_tmp3_ = clipboard;
#line 52 "emojierapp.vala"
	gtk_clipboard_set_text (_tmp3_, selected_string, -1);
#line 53 "emojierapp.vala"
	_tmp4_ = clipboard;
#line 53 "emojierapp.vala"
	gtk_clipboard_store (_tmp4_);
#line 55 "emojierapp.vala"
	_tmp5_ = self->priv->m_settings_emoji;
#line 55 "emojierapp.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "favorites");
#line 55 "emojierapp.vala"
	emojier_favorites = _tmp7_;
#line 55 "emojierapp.vala"
	emojier_favorites_length1 = _vala_array_length (_tmp6_);
#line 55 "emojierapp.vala"
	_emojier_favorites_size_ = emojier_favorites_length1;
#line 56 "emojierapp.vala"
	has_favorite = FALSE;
#line 57 "emojierapp.vala"
	_tmp8_ = emojier_favorites;
#line 57 "emojierapp.vala"
	_tmp8__length1 = emojier_favorites_length1;
#line 315 "emojierapp.c"
	{
		gchar** favorite_collection = NULL;
		gint favorite_collection_length1 = 0;
		gint _favorite_collection_size_ = 0;
		gint favorite_it = 0;
#line 57 "emojierapp.vala"
		favorite_collection = _tmp8_;
#line 57 "emojierapp.vala"
		favorite_collection_length1 = _tmp8__length1;
#line 57 "emojierapp.vala"
		for (favorite_it = 0; favorite_it < favorite_collection_length1; favorite_it = favorite_it + 1) {
#line 327 "emojierapp.c"
			const gchar* favorite = NULL;
#line 57 "emojierapp.vala"
			favorite = favorite_collection[favorite_it];
#line 331 "emojierapp.c"
			{
				const gchar* _tmp9_;
#line 58 "emojierapp.vala"
				_tmp9_ = favorite;
#line 58 "emojierapp.vala"
				if (g_strcmp0 (_tmp9_, selected_string) == 0) {
#line 59 "emojierapp.vala"
					has_favorite = TRUE;
#line 60 "emojierapp.vala"
					break;
#line 342 "emojierapp.c"
				}
			}
		}
	}
#line 63 "emojierapp.vala"
	if (!has_favorite) {
#line 349 "emojierapp.c"
		gchar* _tmp10_;
		GSettings* _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 64 "emojierapp.vala"
		_tmp10_ = g_strdup (selected_string);
#line 64 "emojierapp.vala"
		_vala_array_add1 (&emojier_favorites, &emojier_favorites_length1, &_emojier_favorites_size_, _tmp10_);
#line 65 "emojierapp.vala"
		_tmp11_ = self->priv->m_settings_emoji;
#line 65 "emojierapp.vala"
		_tmp12_ = emojier_favorites;
#line 65 "emojierapp.vala"
		_tmp12__length1 = emojier_favorites_length1;
#line 65 "emojierapp.vala"
		g_settings_set_strv (_tmp11_, "favorites", _tmp12_);
#line 366 "emojierapp.c"
	}
#line 67 "emojierapp.vala"
	_tmp13_ = self->priv->m_command_line;
#line 67 "emojierapp.vala"
	g_application_command_line_print (_tmp13_, "%s\n", _ ("Copied an emoji to your clipboard."));
#line 44 "emojierapp.vala"
	emojier_favorites = (_vala_array_free (emojier_favorites, emojier_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 44 "emojierapp.vala"
	_g_object_unref0 (clipboard);
#line 376 "emojierapp.c"
}

static void
emoji_application_show_dialog (EmojiApplication* self,
                               GApplicationCommandLine* command_line)
{
	GApplicationCommandLine* _tmp0_;
	IBusEmojier* _tmp1_;
	IBusEmojier* _tmp2_;
	IBusEmojier* _tmp3_;
#line 71 "emojierapp.vala"
	g_return_if_fail (self != NULL);
#line 71 "emojierapp.vala"
	g_return_if_fail (command_line != NULL);
#line 72 "emojierapp.vala"
	_tmp0_ = _g_object_ref0 (command_line);
#line 72 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_command_line);
#line 72 "emojierapp.vala"
	self->priv->m_command_line = _tmp0_;
#line 73 "emojierapp.vala"
	_tmp1_ = self->priv->m_emojier;
#line 73 "emojierapp.vala"
	ibus_emojier_reset (_tmp1_);
#line 74 "emojierapp.vala"
	_tmp2_ = self->priv->m_emojier;
#line 74 "emojierapp.vala"
	ibus_emojier_set_annotation (_tmp2_, "");
#line 75 "emojierapp.vala"
	_tmp3_ = self->priv->m_emojier;
#line 75 "emojierapp.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 409 "emojierapp.c"
}

void
emoji_application_candidate_clicked_lookup_table (EmojiApplication* self,
                                                  guint index,
                                                  guint button,
                                                  guint state)
{
	GApplicationCommandLine* _tmp0_;
	IBusEmojier* _tmp2_;
	gboolean show_candidate = FALSE;
	guint ncandidates = 0U;
	IBusEmojier* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gchar* emoji = NULL;
	IBusEmojier* _tmp7_;
	gchar* _tmp8_;
	IBusEmojier* _tmp9_;
	const gchar* _tmp10_;
#line 79 "emojierapp.vala"
	g_return_if_fail (self != NULL);
#line 82 "emojierapp.vala"
	_tmp0_ = self->priv->m_command_line;
#line 82 "emojierapp.vala"
	if (_tmp0_ == NULL) {
#line 83 "emojierapp.vala"
		return;
#line 437 "emojierapp.c"
	}
#line 84 "emojierapp.vala"
	if (button == IBUS_EMOJIER_BUTTON_CLOSE_BUTTON) {
#line 441 "emojierapp.c"
		IBusEmojier* _tmp1_;
#line 85 "emojierapp.vala"
		_tmp1_ = self->priv->m_emojier;
#line 85 "emojierapp.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 86 "emojierapp.vala"
		emoji_application_save_selected_string (self, NULL, TRUE);
#line 87 "emojierapp.vala"
		_g_object_unref0 (self->priv->m_command_line);
#line 87 "emojierapp.vala"
		self->priv->m_command_line = NULL;
#line 88 "emojierapp.vala"
		return;
#line 455 "emojierapp.c"
	}
#line 90 "emojierapp.vala"
	_tmp2_ = self->priv->m_emojier;
#line 90 "emojierapp.vala"
	if (_tmp2_ == NULL) {
#line 91 "emojierapp.vala"
		return;
#line 463 "emojierapp.c"
	}
#line 92 "emojierapp.vala"
	show_candidate = FALSE;
#line 93 "emojierapp.vala"
	_tmp3_ = self->priv->m_emojier;
#line 93 "emojierapp.vala"
	ncandidates = ibus_emojier_get_number_of_candidates (_tmp3_);
#line 94 "emojierapp.vala"
	if (ncandidates > ((guint) 0)) {
#line 94 "emojierapp.vala"
		_tmp4_ = ncandidates >= index;
#line 475 "emojierapp.c"
	} else {
#line 94 "emojierapp.vala"
		_tmp4_ = FALSE;
#line 479 "emojierapp.c"
	}
#line 94 "emojierapp.vala"
	if (_tmp4_) {
#line 483 "emojierapp.c"
		IBusEmojier* _tmp5_;
		IBusEmojier* _tmp6_;
#line 95 "emojierapp.vala"
		_tmp5_ = self->priv->m_emojier;
#line 95 "emojierapp.vala"
		ibus_emojier_set_cursor_pos (_tmp5_, index);
#line 96 "emojierapp.vala"
		_tmp6_ = self->priv->m_emojier;
#line 96 "emojierapp.vala"
		show_candidate = ibus_emojier_has_variants (_tmp6_, index, FALSE);
#line 494 "emojierapp.c"
	} else {
#line 98 "emojierapp.vala"
		return;
#line 498 "emojierapp.c"
	}
#line 100 "emojierapp.vala"
	if (show_candidate) {
#line 101 "emojierapp.vala"
		return;
#line 504 "emojierapp.c"
	}
#line 103 "emojierapp.vala"
	_tmp7_ = self->priv->m_emojier;
#line 103 "emojierapp.vala"
	_tmp8_ = ibus_emojier_get_current_candidate (_tmp7_);
#line 103 "emojierapp.vala"
	emoji = _tmp8_;
#line 104 "emojierapp.vala"
	_tmp9_ = self->priv->m_emojier;
#line 104 "emojierapp.vala"
	gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 105 "emojierapp.vala"
	_tmp10_ = emoji;
#line 105 "emojierapp.vala"
	emoji_application_save_selected_string (self, _tmp10_, FALSE);
#line 106 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_command_line);
#line 106 "emojierapp.vala"
	self->priv->m_command_line = NULL;
#line 79 "emojierapp.vala"
	_g_free0 (emoji);
#line 526 "emojierapp.c"
}

void
emoji_application_activate_dialog (EmojiApplication* self,
                                   GApplicationCommandLine* command_line)
{
#line 110 "emojierapp.vala"
	g_return_if_fail (self != NULL);
#line 110 "emojierapp.vala"
	g_return_if_fail (command_line != NULL);
#line 111 "emojierapp.vala"
	g_application_hold ((GApplication*) self);
#line 112 "emojierapp.vala"
	emoji_application_show_dialog (self, command_line);
#line 113 "emojierapp.vala"
	g_application_release ((GApplication*) self);
#line 543 "emojierapp.c"
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 176 "emojierapp.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 551 "emojierapp.c"
}

static void
___lambda26_ (EmojiApplication* self,
              guint i,
              guint b,
              guint s)
{
#line 223 "emojierapp.vala"
	emoji_application_candidate_clicked_lookup_table (self, i, b, s);
#line 562 "emojierapp.c"
}

static void
____lambda26__ibus_emojier_candidate_clicked (IBusEmojier* _sender,
                                              guint index,
                                              guint button,
                                              guint state,
                                              gpointer self)
{
#line 222 "emojierapp.vala"
	___lambda26_ ((EmojiApplication*) self, index, button, state);
#line 574 "emojierapp.c"
}

static void
___lambda27_ (EmojiApplication* self)
{
	GApplicationCommandLine* _tmp0_;
	IBusEmojier* _tmp1_;
#line 226 "emojierapp.vala"
	_tmp0_ = self->priv->m_command_line;
#line 226 "emojierapp.vala"
	if (_tmp0_ == NULL) {
#line 227 "emojierapp.vala"
		return;
#line 588 "emojierapp.c"
	}
#line 228 "emojierapp.vala"
	_tmp1_ = self->priv->m_emojier;
#line 228 "emojierapp.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 229 "emojierapp.vala"
	emoji_application_save_selected_string (self, NULL, TRUE);
#line 230 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_command_line);
#line 230 "emojierapp.vala"
	self->priv->m_command_line = NULL;
#line 600 "emojierapp.c"
}

static void
____lambda27__ibus_emojier_cancel (IBusEmojier* _sender,
                                   gpointer self)
{
#line 225 "emojierapp.vala"
	___lambda27_ ((EmojiApplication*) self);
#line 609 "emojierapp.c"
}

static void
___lambda28_ (EmojiApplication* self)
{
	GApplicationCommandLine* _tmp0_;
	IBusEmojier* _tmp1_;
	gchar* selected_string = NULL;
	IBusEmojier* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
#line 233 "emojierapp.vala"
	_tmp0_ = self->priv->m_command_line;
#line 233 "emojierapp.vala"
	if (_tmp0_ == NULL) {
#line 234 "emojierapp.vala"
		return;
#line 627 "emojierapp.c"
	}
#line 235 "emojierapp.vala"
	_tmp1_ = self->priv->m_emojier;
#line 235 "emojierapp.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 236 "emojierapp.vala"
	_tmp2_ = self->priv->m_emojier;
#line 236 "emojierapp.vala"
	_tmp3_ = ibus_emojier_get_selected_string (_tmp2_);
#line 236 "emojierapp.vala"
	selected_string = _tmp3_;
#line 237 "emojierapp.vala"
	_tmp4_ = selected_string;
#line 237 "emojierapp.vala"
	emoji_application_save_selected_string (self, _tmp4_, FALSE);
#line 238 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_command_line);
#line 238 "emojierapp.vala"
	self->priv->m_command_line = NULL;
#line 232 "emojierapp.vala"
	_g_free0 (selected_string);
#line 649 "emojierapp.c"
}

static void
____lambda28__ibus_emojier_commit_text (IBusEmojier* _sender,
                                        const gchar* text,
                                        gpointer self)
{
#line 232 "emojierapp.vala"
	___lambda28_ ((EmojiApplication*) self);
#line 659 "emojierapp.c"
}

static gint
_emoji_application_command_line (EmojiApplication* self,
                                 GApplicationCommandLine* command_line)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 121 "emojierapp.vala"
	static const GOptionEntry options[6] = {{"font", (gchar) 0, (gint) 0, G_OPTION_ARG_STRING, &emoji_font, N_ ("\"FONT\" for emoji characters on emoji dialog"), N_ ("FONT")}, {"lang", (gchar) 0, (gint) 0, G_OPTION_ARG_STRING, &annotation_lang, N_ ("\"LANG\" for annotations on emoji dialog. E.g. \"en\""), N_ ("LANG")}, {"partial-match", (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, &partial_match, N_ ("Emoji annotations can be match partially"), NULL}, {"partial-match-length", (gchar) 0, (gint) 0, G_OPTION_ARG_INT, &partial_match_length, N_ ("Match with the length of the specified integer"), NULL}, {"partial-match-condition", (gchar) 0, (gint) 0, G_OPTION_ARG_INT, &partial_match_condition, N_ ("Match with the condition of the specified integer"), NULL}, {NULL}};
#line 671 "emojierapp.c"
	GOptionContext* option = NULL;
	GOptionContext* _tmp3_;
	GOptionContext* _tmp4_;
	gchar** args = NULL;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint args_length1;
	gint _args_size_;
	const gchar** _args = NULL;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp8_;
	gint _args_length1;
	gint __args_size_;
	gboolean _tmp22_ = FALSE;
	IBusEmojier* _tmp23_;
	const gchar* _tmp31_;
	const gchar* _tmp34_;
	const gchar* _tmp38_;
	GSettings* _tmp40_;
	gchar** _tmp41_;
	gchar** _tmp42_;
	gchar** _tmp43_;
	gint _tmp43__length1;
	GSettings* _tmp44_;
	gchar** _tmp45_;
	gchar** _tmp46_;
	gchar** _tmp47_;
	gint _tmp47__length1;
	IBusEmojier* _tmp48_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 117 "emojierapp.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 117 "emojierapp.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 119 "emojierapp.vala"
	_tmp0_ = self->priv->m_settings_emoji;
#line 119 "emojierapp.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "font");
#line 119 "emojierapp.vala"
	_tmp2_ = _tmp1_;
#line 119 "emojierapp.vala"
	ibus_emojier_set_emoji_font (_tmp2_);
#line 119 "emojierapp.vala"
	_g_free0 (_tmp2_);
#line 148 "emojierapp.vala"
	_tmp3_ = g_option_context_new (NULL);
#line 148 "emojierapp.vala"
	option = _tmp3_;
#line 149 "emojierapp.vala"
	_tmp4_ = option;
#line 149 "emojierapp.vala"
	g_option_context_add_main_entries (_tmp4_, options, GETTEXT_PACKAGE);
#line 154 "emojierapp.vala"
	_tmp6_ = g_application_command_line_get_arguments (command_line, &_tmp5_);
#line 154 "emojierapp.vala"
	args = _tmp6_;
#line 154 "emojierapp.vala"
	args_length1 = _tmp5_;
#line 154 "emojierapp.vala"
	_args_size_ = args_length1;
#line 155 "emojierapp.vala"
	_tmp7_ = args;
#line 155 "emojierapp.vala"
	_tmp7__length1 = args_length1;
#line 155 "emojierapp.vala"
	_tmp8_ = g_new0 (gchar*, _tmp7__length1 + 1);
#line 155 "emojierapp.vala"
	_args = _tmp8_;
#line 155 "emojierapp.vala"
	_args_length1 = _tmp7__length1;
#line 155 "emojierapp.vala"
	__args_size_ = _args_length1;
#line 746 "emojierapp.c"
	{
		gint i = 0;
#line 156 "emojierapp.vala"
		i = 0;
#line 751 "emojierapp.c"
		{
			gboolean _tmp9_ = FALSE;
#line 156 "emojierapp.vala"
			_tmp9_ = TRUE;
#line 156 "emojierapp.vala"
			while (TRUE) {
#line 758 "emojierapp.c"
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar** _tmp12_;
				gint _tmp12__length1;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
#line 156 "emojierapp.vala"
				if (!_tmp9_) {
#line 768 "emojierapp.c"
					gint _tmp10_;
#line 156 "emojierapp.vala"
					_tmp10_ = i;
#line 156 "emojierapp.vala"
					i = _tmp10_ + 1;
#line 774 "emojierapp.c"
				}
#line 156 "emojierapp.vala"
				_tmp9_ = FALSE;
#line 156 "emojierapp.vala"
				_tmp11_ = args;
#line 156 "emojierapp.vala"
				_tmp11__length1 = args_length1;
#line 156 "emojierapp.vala"
				if (!(i < _tmp11__length1)) {
#line 156 "emojierapp.vala"
					break;
#line 786 "emojierapp.c"
				}
#line 157 "emojierapp.vala"
				_tmp12_ = _args;
#line 157 "emojierapp.vala"
				_tmp12__length1 = _args_length1;
#line 157 "emojierapp.vala"
				_tmp13_ = args;
#line 157 "emojierapp.vala"
				_tmp13__length1 = args_length1;
#line 157 "emojierapp.vala"
				_tmp14_ = _tmp13_[i];
#line 157 "emojierapp.vala"
				_tmp12_[i] = _tmp14_;
#line 800 "emojierapp.c"
			}
		}
	}
#line 161 "emojierapp.vala"
	_g_free0 (emoji_font);
#line 161 "emojierapp.vala"
	emoji_font = NULL;
#line 162 "emojierapp.vala"
	_g_free0 (annotation_lang);
#line 162 "emojierapp.vala"
	annotation_lang = NULL;
#line 812 "emojierapp.c"
	{
		gchar** tmp = NULL;
		const gchar** _tmp15_;
		gint _tmp15__length1;
		gint tmp_length1;
		gint _tmp_size_;
		GOptionContext* _tmp16_;
#line 165 "emojierapp.vala"
		_tmp15_ = _args;
#line 165 "emojierapp.vala"
		_tmp15__length1 = _args_length1;
#line 165 "emojierapp.vala"
		tmp = _tmp15_;
#line 165 "emojierapp.vala"
		tmp_length1 = _tmp15__length1;
#line 165 "emojierapp.vala"
		_tmp_size_ = tmp_length1;
#line 166 "emojierapp.vala"
		_tmp16_ = option;
#line 166 "emojierapp.vala"
		g_option_context_parse (_tmp16_, (gint*) (&tmp_length1), &tmp, &_inner_error0_);
#line 166 "emojierapp.vala"
		_tmp_size_ = tmp_length1;
#line 166 "emojierapp.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 838 "emojierapp.c"
			gint _tmp17_ = -1;
#line 166 "emojierapp.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 842 "emojierapp.c"
				goto __catch0_g_option_error;
			}
#line 166 "emojierapp.vala"
			_args = (g_free (_args), NULL);
#line 166 "emojierapp.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 166 "emojierapp.vala"
			_g_option_context_free0 (option);
#line 166 "emojierapp.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "emojierapp.vala"
			g_clear_error (&_inner_error0_);
#line 166 "emojierapp.vala"
			return _tmp17_;
#line 857 "emojierapp.c"
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 164 "emojierapp.vala"
		e = _inner_error0_;
#line 164 "emojierapp.vala"
		_inner_error0_ = NULL;
#line 168 "emojierapp.vala"
		_tmp18_ = stderr;
#line 168 "emojierapp.vala"
		_tmp19_ = e;
#line 168 "emojierapp.vala"
		_tmp20_ = _tmp19_->message;
#line 168 "emojierapp.vala"
		fprintf (_tmp18_, "%s\n", _tmp20_);
#line 169 "emojierapp.vala"
		result = EXIT_FAILURE;
#line 169 "emojierapp.vala"
		_g_error_free0 (e);
#line 169 "emojierapp.vala"
		_args = (g_free (_args), NULL);
#line 169 "emojierapp.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 169 "emojierapp.vala"
		_g_option_context_free0 (option);
#line 169 "emojierapp.vala"
		return result;
#line 891 "emojierapp.c"
	}
	__finally0:
#line 164 "emojierapp.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 896 "emojierapp.c"
		gint _tmp21_ = -1;
#line 164 "emojierapp.vala"
		_args = (g_free (_args), NULL);
#line 164 "emojierapp.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 164 "emojierapp.vala"
		_g_option_context_free0 (option);
#line 164 "emojierapp.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "emojierapp.vala"
		g_clear_error (&_inner_error0_);
#line 164 "emojierapp.vala"
		return _tmp21_;
#line 910 "emojierapp.c"
	}
#line 172 "emojierapp.vala"
	_tmp23_ = self->priv->m_emojier;
#line 172 "emojierapp.vala"
	if (_tmp23_ != NULL) {
#line 916 "emojierapp.c"
		IBusEmojier* _tmp24_;
#line 172 "emojierapp.vala"
		_tmp24_ = self->priv->m_emojier;
#line 172 "emojierapp.vala"
		_tmp22_ = ibus_emojier_is_running (_tmp24_);
#line 922 "emojierapp.c"
	} else {
#line 172 "emojierapp.vala"
		_tmp22_ = FALSE;
#line 926 "emojierapp.c"
	}
#line 172 "emojierapp.vala"
	if (_tmp22_) {
#line 930 "emojierapp.c"
		GdkEvent* event = NULL;
		GdkEvent* _tmp25_;
		GdkEvent* _tmp26_;
		GdkEventKey* _tmp27_;
		GdkEventKey* _tmp28_;
		IBusEmojier* _tmp29_;
		GdkEvent* _tmp30_;
#line 173 "emojierapp.vala"
		_tmp25_ = gdk_event_new (GDK_KEY_PRESS);
#line 173 "emojierapp.vala"
		event = _tmp25_;
#line 174 "emojierapp.vala"
		_tmp26_ = event;
#line 174 "emojierapp.vala"
		_tmp27_ = (GdkEventKey *) (_tmp26_);
#line 174 "emojierapp.vala"
		_tmp28_ = _tmp27_;
#line 174 "emojierapp.vala"
		_tmp28_->time = (guint32) GDK_CURRENT_TIME;
#line 175 "emojierapp.vala"
		_tmp29_ = self->priv->m_emojier;
#line 175 "emojierapp.vala"
		_tmp30_ = event;
#line 175 "emojierapp.vala"
		ibus_emojier_present_centralize (_tmp29_, _tmp30_);
#line 176 "emojierapp.vala"
		result = EXIT_SUCCESS;
#line 176 "emojierapp.vala"
		__vala_GdkEvent_free0 (event);
#line 176 "emojierapp.vala"
		_args = (g_free (_args), NULL);
#line 176 "emojierapp.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 176 "emojierapp.vala"
		_g_option_context_free0 (option);
#line 176 "emojierapp.vala"
		return result;
#line 968 "emojierapp.c"
	}
#line 179 "emojierapp.vala"
	_tmp31_ = annotation_lang;
#line 179 "emojierapp.vala"
	if (_tmp31_ == NULL) {
#line 974 "emojierapp.c"
		GSettings* _tmp32_;
		gchar* _tmp33_;
#line 180 "emojierapp.vala"
		_tmp32_ = self->priv->m_settings_emoji;
#line 180 "emojierapp.vala"
		_tmp33_ = g_settings_get_string (_tmp32_, "lang");
#line 180 "emojierapp.vala"
		_g_free0 (annotation_lang);
#line 180 "emojierapp.vala"
		annotation_lang = _tmp33_;
#line 985 "emojierapp.c"
	}
#line 181 "emojierapp.vala"
	_tmp34_ = annotation_lang;
#line 181 "emojierapp.vala"
	ibus_emojier_set_annotation_lang (_tmp34_);
#line 182 "emojierapp.vala"
	ibus_emojier_set_partial_match (partial_match);
#line 183 "emojierapp.vala"
	if (partial_match_length > 0) {
#line 184 "emojierapp.vala"
		ibus_emojier_set_partial_match_length (partial_match_length);
#line 997 "emojierapp.c"
	} else {
		GSettings* _tmp35_;
#line 186 "emojierapp.vala"
		_tmp35_ = self->priv->m_settings_emoji;
#line 186 "emojierapp.vala"
		ibus_emojier_set_partial_match_length (g_settings_get_int (_tmp35_, "partial-match-length"));
#line 1004 "emojierapp.c"
	}
#line 189 "emojierapp.vala"
	if (partial_match_condition > 2) {
#line 1008 "emojierapp.c"
		GSettings* _tmp36_;
#line 190 "emojierapp.vala"
		g_warning ("emojierapp.vala:190: Need condition between 0 and 2.");
#line 191 "emojierapp.vala"
		_tmp36_ = self->priv->m_settings_emoji;
#line 191 "emojierapp.vala"
		ibus_emojier_set_partial_match_condition (g_settings_get_int (_tmp36_, "partial-match-condition"));
#line 1016 "emojierapp.c"
	} else {
#line 194 "emojierapp.vala"
		if (partial_match_condition >= 0) {
#line 195 "emojierapp.vala"
			ibus_emojier_set_partial_match_condition (partial_match_condition);
#line 1022 "emojierapp.c"
		} else {
			GSettings* _tmp37_;
#line 197 "emojierapp.vala"
			_tmp37_ = self->priv->m_settings_emoji;
#line 197 "emojierapp.vala"
			ibus_emojier_set_partial_match_condition (g_settings_get_int (_tmp37_, "partial-match-condition"));
#line 1029 "emojierapp.c"
		}
	}
#line 201 "emojierapp.vala"
	_tmp38_ = emoji_font;
#line 201 "emojierapp.vala"
	if (_tmp38_ != NULL) {
#line 1036 "emojierapp.c"
		const gchar* _tmp39_;
#line 202 "emojierapp.vala"
		_tmp39_ = emoji_font;
#line 202 "emojierapp.vala"
		ibus_emojier_set_emoji_font (_tmp39_);
#line 1042 "emojierapp.c"
	}
#line 204 "emojierapp.vala"
	_tmp40_ = self->priv->m_settings_emoji;
#line 204 "emojierapp.vala"
	_tmp42_ = _tmp41_ = g_settings_get_strv (_tmp40_, "favorites");
#line 204 "emojierapp.vala"
	_tmp43_ = _tmp42_;
#line 204 "emojierapp.vala"
	_tmp43__length1 = _vala_array_length (_tmp41_);
#line 204 "emojierapp.vala"
	_tmp44_ = self->priv->m_settings_emoji;
#line 204 "emojierapp.vala"
	_tmp46_ = _tmp45_ = g_settings_get_strv (_tmp44_, "favorite-annotations");
#line 204 "emojierapp.vala"
	_tmp47_ = _tmp46_;
#line 204 "emojierapp.vala"
	_tmp47__length1 = _vala_array_length (_tmp45_);
#line 204 "emojierapp.vala"
	ibus_emojier_set_favorites (_tmp43_, (gint) _vala_array_length (_tmp41_), _tmp47_, (gint) _vala_array_length (_tmp45_));
#line 204 "emojierapp.vala"
	_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
#line 204 "emojierapp.vala"
	_tmp43_ = (_vala_array_free (_tmp43_, _tmp43__length1, (GDestroyNotify) g_free), NULL);
#line 208 "emojierapp.vala"
	ibus_emojier_load_unicode_dict ();
#line 210 "emojierapp.vala"
	_tmp48_ = self->priv->m_emojier;
#line 210 "emojierapp.vala"
	if (_tmp48_ == NULL) {
#line 1072 "emojierapp.c"
		gboolean is_wayland = FALSE;
		GType instance_type = 0UL;
		GdkDisplay* _tmp49_;
		GType wayland_type = 0UL;
		IBusEmojier* _tmp50_;
		IBusEmojier* _tmp51_;
		IBusEmojier* _tmp52_;
		IBusEmojier* _tmp53_;
		IBusEmojier* _tmp54_;
#line 211 "emojierapp.vala"
		is_wayland = FALSE;
#line 213 "emojierapp.vala"
		_tmp49_ = gdk_display_get_default ();
#line 213 "emojierapp.vala"
		instance_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp49_);
#line 214 "emojierapp.vala"
		wayland_type = gdk_wayland_display_get_type ();
#line 215 "emojierapp.vala"
		is_wayland = g_type_is_a (instance_type, wayland_type);
#line 219 "emojierapp.vala"
		_tmp50_ = ibus_emojier_new (is_wayland);
#line 219 "emojierapp.vala"
		g_object_ref_sink (_tmp50_);
#line 219 "emojierapp.vala"
		_g_object_unref0 (self->priv->m_emojier);
#line 219 "emojierapp.vala"
		self->priv->m_emojier = _tmp50_;
#line 221 "emojierapp.vala"
		_tmp51_ = self->priv->m_emojier;
#line 221 "emojierapp.vala"
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp51_);
#line 222 "emojierapp.vala"
		_tmp52_ = self->priv->m_emojier;
#line 222 "emojierapp.vala"
		g_signal_connect_object (_tmp52_, "candidate-clicked", (GCallback) ____lambda26__ibus_emojier_candidate_clicked, self, 0);
#line 225 "emojierapp.vala"
		_tmp53_ = self->priv->m_emojier;
#line 225 "emojierapp.vala"
		g_signal_connect_object (_tmp53_, "cancel", (GCallback) ____lambda27__ibus_emojier_cancel, self, 0);
#line 232 "emojierapp.vala"
		_tmp54_ = self->priv->m_emojier;
#line 232 "emojierapp.vala"
		g_signal_connect_object (_tmp54_, "commit-text", (GCallback) ____lambda28__ibus_emojier_commit_text, self, 0);
#line 1116 "emojierapp.c"
	}
#line 242 "emojierapp.vala"
	emoji_application_activate_dialog (self, command_line);
#line 244 "emojierapp.vala"
	result = EXIT_SUCCESS;
#line 244 "emojierapp.vala"
	_args = (g_free (_args), NULL);
#line 244 "emojierapp.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 244 "emojierapp.vala"
	_g_option_context_free0 (option);
#line 244 "emojierapp.vala"
	return result;
#line 1130 "emojierapp.c"
}

static gint
emoji_application_real_command_line (GApplication* base,
                                     GApplicationCommandLine* command_line)
{
	EmojiApplication * self;
	gint _result_ = 0;
	gint result;
#line 248 "emojierapp.vala"
	self = (EmojiApplication*) base;
#line 248 "emojierapp.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 250 "emojierapp.vala"
	g_application_hold ((GApplication*) self);
#line 251 "emojierapp.vala"
	_result_ = _emoji_application_command_line (self, command_line);
#line 252 "emojierapp.vala"
	g_application_release ((GApplication*) self);
#line 253 "emojierapp.vala"
	result = _result_;
#line 253 "emojierapp.vala"
	return result;
#line 1154 "emojierapp.c"
}

static void
emoji_application_real_shutdown (GApplication* base)
{
	EmojiApplication * self;
	IBusEmojier* _tmp0_;
#line 257 "emojierapp.vala"
	self = (EmojiApplication*) base;
#line 258 "emojierapp.vala"
	G_APPLICATION_CLASS (emoji_application_parent_class)->shutdown ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 259 "emojierapp.vala"
	_tmp0_ = self->priv->m_emojier;
#line 259 "emojierapp.vala"
	gtk_application_remove_window ((GtkApplication*) self, (GtkWindow*) _tmp0_);
#line 260 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_emojier);
#line 260 "emojierapp.vala"
	self->priv->m_emojier = NULL;
#line 1174 "emojierapp.c"
}

static gint
emoji_application_main (gchar** args,
                        gint args_length1)
{
	EmojiApplication* app = NULL;
	EmojiApplication* _tmp0_;
	gint status = 0;
	gint result;
#line 265 "emojierapp.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 266 "emojierapp.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 267 "emojierapp.vala"
	textdomain (GETTEXT_PACKAGE);
#line 269 "emojierapp.vala"
	ibus_init ();
#line 271 "emojierapp.vala"
	gtk_init ((gint*) (&args_length1), &args);
#line 273 "emojierapp.vala"
	_tmp0_ = emoji_application_new ();
#line 273 "emojierapp.vala"
	app = _tmp0_;
#line 274 "emojierapp.vala"
	status = g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 275 "emojierapp.vala"
	result = status;
#line 275 "emojierapp.vala"
	_g_object_unref0 (app);
#line 275 "emojierapp.vala"
	return result;
#line 1207 "emojierapp.c"
}

int
main (int argc,
      char ** argv)
{
#line 264 "emojierapp.vala"
	return emoji_application_main (argv, argc);
#line 1216 "emojierapp.c"
}

static void
emoji_application_class_init (EmojiApplicationClass * klass,
                              gpointer klass_data)
{
#line 30 "emojierapp.vala"
	emoji_application_parent_class = g_type_class_peek_parent (klass);
#line 30 "emojierapp.vala"
	g_type_class_adjust_private_offset (klass, &EmojiApplication_private_offset);
#line 30 "emojierapp.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) emoji_application_real_command_line;
#line 30 "emojierapp.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) emoji_application_real_shutdown;
#line 30 "emojierapp.vala"
	G_OBJECT_CLASS (klass)->finalize = emoji_application_finalize;
#line 1233 "emojierapp.c"
}

static void
emoji_application_instance_init (EmojiApplication * self,
                                 gpointer klass)
{
	GSettings* _tmp0_;
#line 30 "emojierapp.vala"
	self->priv = emoji_application_get_instance_private (self);
#line 32 "emojierapp.vala"
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.panel.emoji");
#line 32 "emojierapp.vala"
	self->priv->m_settings_emoji = _tmp0_;
#line 34 "emojierapp.vala"
	self->priv->m_command_line = NULL;
#line 1249 "emojierapp.c"
}

static void
emoji_application_finalize (GObject * obj)
{
	EmojiApplication * self;
#line 30 "emojierapp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EMOJI_APPLICATION, EmojiApplication);
#line 31 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_emojier);
#line 32 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_settings_emoji);
#line 34 "emojierapp.vala"
	_g_object_unref0 (self->priv->m_command_line);
#line 30 "emojierapp.vala"
	G_OBJECT_CLASS (emoji_application_parent_class)->finalize (obj);
#line 1266 "emojierapp.c"
}

static GType
emoji_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EmojiApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) emoji_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EmojiApplication), 0, (GInstanceInitFunc) emoji_application_instance_init, NULL };
	GType emoji_application_type_id;
	emoji_application_type_id = g_type_register_static (gtk_application_get_type (), "EmojiApplication", &g_define_type_info, 0);
	EmojiApplication_private_offset = g_type_add_instance_private (emoji_application_type_id, sizeof (EmojiApplicationPrivate));
	return emoji_application_type_id;
}

GType
emoji_application_get_type (void)
{
	static volatile gsize emoji_application_type_id__once = 0;
	if (g_once_init_enter (&emoji_application_type_id__once)) {
		GType emoji_application_type_id;
		emoji_application_type_id = emoji_application_get_type_once ();
		g_once_init_leave (&emoji_application_type_id__once, emoji_application_type_id);
	}
	return emoji_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

