/* extension.c generated by valac 0.56.7, the Vala compiler
 * generated from extension.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2018 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2018-2020 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <ibus.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <config.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EXTENSION_GTK (extension_gtk_get_type ())
#define EXTENSION_GTK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTENSION_GTK, ExtensionGtk))
#define EXTENSION_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTENSION_GTK, ExtensionGtkClass))
#define IS_EXTENSION_GTK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTENSION_GTK))
#define IS_EXTENSION_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTENSION_GTK))
#define EXTENSION_GTK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTENSION_GTK, ExtensionGtkClass))

typedef struct _ExtensionGtk ExtensionGtk;
typedef struct _ExtensionGtkClass ExtensionGtkClass;
typedef struct _ExtensionGtkPrivate ExtensionGtkPrivate;

#define TYPE_PANEL_BINDING (panel_binding_get_type ())
#define PANEL_BINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL_BINDING, PanelBinding))
#define PANEL_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL_BINDING, PanelBindingClass))
#define IS_PANEL_BINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL_BINDING))
#define IS_PANEL_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL_BINDING))
#define PANEL_BINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL_BINDING, PanelBindingClass))

typedef struct _PanelBinding PanelBinding;
typedef struct _PanelBindingClass PanelBindingClass;
enum  {
	EXTENSION_GTK_0_PROPERTY,
	EXTENSION_GTK_NUM_PROPERTIES
};
static GParamSpec* extension_gtk_properties[EXTENSION_GTK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ExtensionGtk {
	GtkApplication parent_instance;
	ExtensionGtkPrivate * priv;
};

struct _ExtensionGtkClass {
	GtkApplicationClass parent_class;
};

struct _ExtensionGtkPrivate {
	IBusBus* m_bus;
	PanelBinding* m_panel;
};

static gint ExtensionGtk_private_offset;
static gpointer extension_gtk_parent_class = NULL;

VALA_EXTERN GType extension_gtk_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExtensionGtk, g_object_unref)
VALA_EXTERN GType panel_binding_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PanelBinding, g_object_unref)
VALA_EXTERN ExtensionGtk* extension_gtk_new (gchar** args,
                                 gint args_length1);
VALA_EXTERN ExtensionGtk* extension_gtk_construct (GType object_type,
                                       gchar** args,
                                       gint args_length1);
static void extension_gtk_bus_connected (ExtensionGtk* self,
                                  IBusBus* bus);
static void _extension_gtk_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                                      gpointer self);
static void extension_gtk_bus_disconnected (ExtensionGtk* self,
                                     IBusBus* bus);
static void _extension_gtk_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                            gpointer self);
static void extension_gtk_init (ExtensionGtk* self);
static void extension_gtk_bus_name_acquired_cb (ExtensionGtk* self,
                                         GDBusConnection* connection,
                                         const gchar* sender_name,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* signal_name,
                                         GVariant* parameters);
static void _extension_gtk_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                                 const gchar* sender_name,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* signal_name,
                                                                 GVariant* parameters,
                                                                 gpointer self);
static void extension_gtk_bus_name_lost_cb (ExtensionGtk* self,
                                     GDBusConnection* connection,
                                     const gchar* sender_name,
                                     const gchar* object_path,
                                     const gchar* interface_name,
                                     const gchar* signal_name,
                                     GVariant* parameters);
static void _extension_gtk_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                             const gchar* sender_name,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* signal_name,
                                                             GVariant* parameters,
                                                             gpointer self);
VALA_EXTERN PanelBinding* panel_binding_new (IBusBus* bus,
                                 GtkApplication* application);
VALA_EXTERN PanelBinding* panel_binding_construct (GType object_type,
                                       IBusBus* bus,
                                       GtkApplication* application);
VALA_EXTERN void panel_binding_load_settings (PanelBinding* self);
VALA_EXTERN void panel_binding_disconnect_signals (PanelBinding* self);
static void extension_gtk_real_activate (GApplication* base);
static gint extension_gtk_main (gchar** args,
                         gint args_length1);
static void extension_gtk_finalize (GObject * obj);
static GType extension_gtk_get_type_once (void);

static inline gpointer
extension_gtk_get_instance_private (ExtensionGtk* self)
{
	return G_STRUCT_MEMBER_P (self, ExtensionGtk_private_offset);
}

static void
_extension_gtk_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                                 gpointer self)
{
#line 38 "extension.vala"
	extension_gtk_bus_connected ((ExtensionGtk*) self, _sender);
#line 163 "extension.c"
}

static void
_extension_gtk_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                       gpointer self)
{
#line 39 "extension.vala"
	extension_gtk_bus_disconnected ((ExtensionGtk*) self, _sender);
#line 172 "extension.c"
}

ExtensionGtk*
extension_gtk_construct (GType object_type,
                         gchar** args,
                         gint args_length1)
{
	ExtensionGtk * self = NULL;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	IBusBus* _tmp2_;
	IBusBus* _tmp3_;
#line 29 "extension.vala"
	self = (ExtensionGtk*) g_object_new (object_type, "application-id", "org.freedesktop.IBus.Panel.Extension.Gtk3", "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 31 "extension.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 32 "extension.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 33 "extension.vala"
	ibus_init ();
#line 34 "extension.vala"
	gtk_init ((gint*) (&args_length1), &args);
#line 36 "extension.vala"
	_tmp0_ = ibus_bus_new ();
#line 36 "extension.vala"
	g_object_ref_sink (_tmp0_);
#line 36 "extension.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 36 "extension.vala"
	self->priv->m_bus = _tmp0_;
#line 38 "extension.vala"
	_tmp1_ = self->priv->m_bus;
#line 38 "extension.vala"
	g_signal_connect_object (_tmp1_, "connected", (GCallback) _extension_gtk_bus_connected_ibus_bus_connected, self, 0);
#line 39 "extension.vala"
	_tmp2_ = self->priv->m_bus;
#line 39 "extension.vala"
	g_signal_connect_object (_tmp2_, "disconnected", (GCallback) _extension_gtk_bus_disconnected_ibus_bus_disconnected, self, 0);
#line 41 "extension.vala"
	_tmp3_ = self->priv->m_bus;
#line 41 "extension.vala"
	if (ibus_bus_is_connected (_tmp3_)) {
#line 42 "extension.vala"
		extension_gtk_init (self);
#line 217 "extension.c"
	}
#line 28 "extension.vala"
	return self;
#line 221 "extension.c"
}

ExtensionGtk*
extension_gtk_new (gchar** args,
                   gint args_length1)
{
#line 28 "extension.vala"
	return extension_gtk_construct (TYPE_EXTENSION_GTK, args, args_length1);
#line 230 "extension.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "extension.vala"
	return self ? g_object_ref (self) : NULL;
#line 238 "extension.c"
}

static void
_extension_gtk_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                            const gchar* sender_name,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* signal_name,
                                                            GVariant* parameters,
                                                            gpointer self)
{
#line 48 "extension.vala"
	extension_gtk_bus_name_acquired_cb ((ExtensionGtk*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 252 "extension.c"
}

static void
_extension_gtk_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                        const gchar* sender_name,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* signal_name,
                                                        GVariant* parameters,
                                                        gpointer self)
{
#line 55 "extension.vala"
	extension_gtk_bus_name_lost_cb ((ExtensionGtk*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 266 "extension.c"
}

static void
extension_gtk_init (ExtensionGtk* self)
{
	GDBusConnection* connection = NULL;
	IBusBus* _tmp0_;
	GDBusConnection* _tmp1_;
	GDBusConnection* _tmp2_;
	IBusBusNameFlag flags = 0U;
	IBusBus* _tmp3_;
#line 46 "extension.vala"
	g_return_if_fail (self != NULL);
#line 47 "extension.vala"
	_tmp0_ = self->priv->m_bus;
#line 47 "extension.vala"
	_tmp1_ = ibus_bus_get_connection (_tmp0_);
#line 47 "extension.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 47 "extension.vala"
	connection = _tmp2_;
#line 48 "extension.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameAcquired", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL_EXTENSION_EMOJI, G_DBUS_SIGNAL_FLAGS_NONE, _extension_gtk_bus_name_acquired_cb_gd_bus_signal_callback, g_object_ref (self), g_object_unref);
#line 55 "extension.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameLost", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL_EXTENSION_EMOJI, G_DBUS_SIGNAL_FLAGS_NONE, _extension_gtk_bus_name_lost_cb_gd_bus_signal_callback, g_object_ref (self), g_object_unref);
#line 62 "extension.vala"
	flags = IBUS_BUS_NAME_FLAG_ALLOW_REPLACEMENT | IBUS_BUS_NAME_FLAG_REPLACE_EXISTING;
#line 65 "extension.vala"
	_tmp3_ = self->priv->m_bus;
#line 65 "extension.vala"
	ibus_bus_request_name (_tmp3_, IBUS_SERVICE_PANEL_EXTENSION_EMOJI, (guint32) flags);
#line 46 "extension.vala"
	_g_object_unref0 (connection);
#line 300 "extension.c"
}

static void
extension_gtk_bus_name_acquired_cb (ExtensionGtk* self,
                                    GDBusConnection* connection,
                                    const gchar* sender_name,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* signal_name,
                                    GVariant* parameters)
{
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	PanelBinding* _tmp2_;
	PanelBinding* _tmp3_;
#line 69 "extension.vala"
	g_return_if_fail (self != NULL);
#line 69 "extension.vala"
	g_return_if_fail (connection != NULL);
#line 69 "extension.vala"
	g_return_if_fail (object_path != NULL);
#line 69 "extension.vala"
	g_return_if_fail (interface_name != NULL);
#line 69 "extension.vala"
	g_return_if_fail (signal_name != NULL);
#line 69 "extension.vala"
	g_return_if_fail (parameters != NULL);
#line 75 "extension.vala"
	g_debug ("extension.vala:75: signal_name = %s", signal_name);
#line 79 "extension.vala"
	_tmp0_ = self->priv->m_bus;
#line 79 "extension.vala"
	g_return_if_fail (ibus_bus_is_connected (_tmp0_));
#line 80 "extension.vala"
	_tmp1_ = self->priv->m_bus;
#line 80 "extension.vala"
	_tmp2_ = panel_binding_new (_tmp1_, (GtkApplication*) self);
#line 80 "extension.vala"
	g_object_ref_sink (_tmp2_);
#line 80 "extension.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 80 "extension.vala"
	self->priv->m_panel = _tmp2_;
#line 81 "extension.vala"
	_tmp3_ = self->priv->m_panel;
#line 81 "extension.vala"
	panel_binding_load_settings (_tmp3_);
#line 348 "extension.c"
}

static void
extension_gtk_bus_name_lost_cb (ExtensionGtk* self,
                                GDBusConnection* connection,
                                const gchar* sender_name,
                                const gchar* object_path,
                                const gchar* interface_name,
                                const gchar* signal_name,
                                GVariant* parameters)
{
	PanelBinding* _tmp0_;
#line 84 "extension.vala"
	g_return_if_fail (self != NULL);
#line 84 "extension.vala"
	g_return_if_fail (connection != NULL);
#line 84 "extension.vala"
	g_return_if_fail (object_path != NULL);
#line 84 "extension.vala"
	g_return_if_fail (interface_name != NULL);
#line 84 "extension.vala"
	g_return_if_fail (signal_name != NULL);
#line 84 "extension.vala"
	g_return_if_fail (parameters != NULL);
#line 96 "extension.vala"
	g_debug ("extension.vala:96: signal_name = %s", signal_name);
#line 99 "extension.vala"
	_tmp0_ = self->priv->m_panel;
#line 99 "extension.vala"
	panel_binding_disconnect_signals (_tmp0_);
#line 100 "extension.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 100 "extension.vala"
	self->priv->m_panel = NULL;
#line 383 "extension.c"
}

static void
extension_gtk_bus_disconnected (ExtensionGtk* self,
                                IBusBus* bus)
{
#line 103 "extension.vala"
	g_return_if_fail (self != NULL);
#line 103 "extension.vala"
	g_return_if_fail (bus != NULL);
#line 104 "extension.vala"
	g_debug ("extension.vala:104: connection is lost.");
#line 105 "extension.vala"
	gtk_main_quit ();
#line 398 "extension.c"
}

static void
extension_gtk_bus_connected (ExtensionGtk* self,
                             IBusBus* bus)
{
#line 108 "extension.vala"
	g_return_if_fail (self != NULL);
#line 108 "extension.vala"
	g_return_if_fail (bus != NULL);
#line 109 "extension.vala"
	extension_gtk_init (self);
#line 411 "extension.c"
}

static void
extension_gtk_real_activate (GApplication* base)
{
	ExtensionGtk * self;
#line 113 "extension.vala"
	self = (ExtensionGtk*) base;
#line 114 "extension.vala"
	gtk_main ();
#line 422 "extension.c"
}

static gint
extension_gtk_main (gchar** args,
                    gint args_length1)
{
	ExtensionGtk* extension = NULL;
	ExtensionGtk* _tmp0_;
	gint status = 0;
	gint result;
#line 124 "extension.vala"
	g_unsetenv ("GDK_CORE_DEVICE_EVENTS");
#line 129 "extension.vala"
	_tmp0_ = extension_gtk_new (args, args_length1);
#line 129 "extension.vala"
	extension = _tmp0_;
#line 130 "extension.vala"
	status = g_application_run ((GApplication*) extension, (gint) args_length1, args);
#line 131 "extension.vala"
	result = status;
#line 131 "extension.vala"
	_g_object_unref0 (extension);
#line 131 "extension.vala"
	return result;
#line 447 "extension.c"
}

int
main (int argc,
      char ** argv)
{
#line 118 "extension.vala"
	return extension_gtk_main (argv, argc);
#line 456 "extension.c"
}

static void
extension_gtk_class_init (ExtensionGtkClass * klass,
                          gpointer klass_data)
{
#line 24 "extension.vala"
	extension_gtk_parent_class = g_type_class_peek_parent (klass);
#line 24 "extension.vala"
	g_type_class_adjust_private_offset (klass, &ExtensionGtk_private_offset);
#line 24 "extension.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) extension_gtk_real_activate;
#line 24 "extension.vala"
	G_OBJECT_CLASS (klass)->finalize = extension_gtk_finalize;
#line 471 "extension.c"
}

static void
extension_gtk_instance_init (ExtensionGtk * self,
                             gpointer klass)
{
#line 24 "extension.vala"
	self->priv = extension_gtk_get_instance_private (self);
#line 480 "extension.c"
}

static void
extension_gtk_finalize (GObject * obj)
{
	ExtensionGtk * self;
#line 24 "extension.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTENSION_GTK, ExtensionGtk);
#line 25 "extension.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 26 "extension.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 24 "extension.vala"
	G_OBJECT_CLASS (extension_gtk_parent_class)->finalize (obj);
#line 495 "extension.c"
}

static GType
extension_gtk_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExtensionGtkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) extension_gtk_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExtensionGtk), 0, (GInstanceInitFunc) extension_gtk_instance_init, NULL };
	GType extension_gtk_type_id;
	extension_gtk_type_id = g_type_register_static (gtk_application_get_type (), "ExtensionGtk", &g_define_type_info, 0);
	ExtensionGtk_private_offset = g_type_add_instance_private (extension_gtk_type_id, sizeof (ExtensionGtkPrivate));
	return extension_gtk_type_id;
}

GType
extension_gtk_get_type (void)
{
	static volatile gsize extension_gtk_type_id__once = 0;
	if (g_once_init_enter (&extension_gtk_type_id__once)) {
		GType extension_gtk_type_id;
		extension_gtk_type_id = extension_gtk_get_type_once ();
		g_once_init_leave (&extension_gtk_type_id__once, extension_gtk_type_id);
	}
	return extension_gtk_type_id__once;
}

