/* handle.c generated by valac 0.56.7, the Vala compiler
 * generated from handle.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2016 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2016-2017 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HANDLE (handle_get_type ())
#define HANDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HANDLE, Handle))
#define HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HANDLE, HandleClass))
#define IS_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HANDLE))
#define IS_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HANDLE))
#define HANDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HANDLE, HandleClass))

typedef struct _Handle Handle;
typedef struct _HandleClass HandleClass;
typedef struct _HandlePrivate HandlePrivate;
enum  {
	HANDLE_0_PROPERTY,
	HANDLE_NUM_PROPERTIES
};
static GParamSpec* handle_properties[HANDLE_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	HANDLE_MOVE_BEGIN_SIGNAL,
	HANDLE_MOVE_END_SIGNAL,
	HANDLE_NUM_SIGNALS
};
static guint handle_signals[HANDLE_NUM_SIGNALS] = {0};

struct _Handle {
	GtkEventBox parent_instance;
	HandlePrivate * priv;
};

struct _HandleClass {
	GtkEventBoxClass parent_class;
};

struct _HandlePrivate {
	gboolean m_move_begined;
	GdkRectangle m_workarea;
	GdkPoint m_press_pos;
};

static gint Handle_private_offset;
static gpointer handle_parent_class = NULL;

VALA_EXTERN GType handle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Handle, g_object_unref)
VALA_EXTERN Handle* handle_new (void);
VALA_EXTERN Handle* handle_construct (GType object_type);
static void handle_real_realize (GtkWidget* base);
static gboolean handle_real_button_press_event (GtkWidget* base,
                                         GdkEventButton* event);
static gboolean handle_real_button_release_event (GtkWidget* base,
                                           GdkEventButton* event);
static gboolean handle_real_motion_notify_event (GtkWidget* base,
                                          GdkEventMotion* event);
static gboolean handle_real_draw (GtkWidget* base,
                           cairo_t* cr);
static void handle_finalize (GObject * obj);
static GType handle_get_type_once (void);

static inline gpointer
handle_get_instance_private (Handle* self)
{
	return G_STRUCT_MEMBER_P (self, Handle_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "handle.vala"
	return self ? g_object_ref (self) : NULL;
#line 117 "handle.c"
}

Handle*
handle_construct (GType object_type)
{
	Handle * self = NULL;
	GdkEventMask mask = 0U;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 34 "handle.vala"
	self = (Handle*) g_object_new (object_type, "name", "IBusHandle", NULL);
#line 38 "handle.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 6, -1);
#line 39 "handle.vala"
	mask = ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_BUTTON1_MOTION_MASK;
#line 43 "handle.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) mask);
#line 44 "handle.vala"
	self->priv->m_move_begined = FALSE;
#line 48 "handle.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 48 "handle.vala"
	css_provider = _tmp0_;
#line 145 "handle.c"
	{
#line 50 "handle.vala"
		gtk_css_provider_load_from_data (css_provider, "#IBusHandle { background-color: gray }", (gssize) -1, &_inner_error0_);
#line 50 "handle.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "handle.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 49 "handle.vala"
		_error_ = _inner_error0_;
#line 49 "handle.vala"
		_inner_error0_ = NULL;
#line 53 "handle.vala"
		_tmp1_ = _error_;
#line 53 "handle.vala"
		_tmp2_ = _tmp1_->message;
#line 53 "handle.vala"
		g_warning ("handle.vala:53: Parse error in Handle: %s", _tmp2_);
#line 49 "handle.vala"
		_g_error_free0 (_error_);
#line 173 "handle.c"
	}
	__finally0:
#line 49 "handle.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "handle.vala"
		_g_object_unref0 (css_provider);
#line 49 "handle.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "handle.vala"
		g_clear_error (&_inner_error0_);
#line 49 "handle.vala"
		return NULL;
#line 186 "handle.c"
	}
#line 55 "handle.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 55 "handle.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 55 "handle.vala"
	context = _tmp4_;
#line 56 "handle.vala"
	gtk_style_context_add_provider (context, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 32 "handle.vala"
	_g_object_unref0 (context);
#line 32 "handle.vala"
	_g_object_unref0 (css_provider);
#line 32 "handle.vala"
	return self;
#line 202 "handle.c"
}

Handle*
handle_new (void)
{
#line 32 "handle.vala"
	return handle_construct (TYPE_HANDLE);
#line 210 "handle.c"
}

static void
handle_real_realize (GtkWidget* base)
{
	Handle * self;
#line 60 "handle.vala"
	self = (Handle*) base;
#line 61 "handle.vala"
	GTK_WIDGET_CLASS (handle_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
#line 221 "handle.c"
}

static gboolean
handle_real_button_press_event (GtkWidget* base,
                                GdkEventButton* event)
{
	Handle * self;
	GdkRectangle _tmp0_ = {0};
	gint x = 0;
	gint y = 0;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp64_;
	GtkWindow* _tmp65_;
	GtkWindow* _tmp66_;
	gint _tmp67_ = 0;
	gint _tmp68_ = 0;
	gboolean result;
#line 64 "handle.vala"
	self = (Handle*) base;
#line 64 "handle.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 65 "handle.vala"
	if (event->button != ((guint) 1)) {
#line 66 "handle.vala"
		result = FALSE;
#line 66 "handle.vala"
		return result;
#line 249 "handle.c"
	}
#line 67 "handle.vala"
	memset (&_tmp0_, 0, sizeof (GdkRectangle));
#line 67 "handle.vala"
	_tmp0_.x = 0;
#line 67 "handle.vala"
	_tmp0_.y = 0;
#line 67 "handle.vala"
	_tmp0_.width = G_MAXINT;
#line 67 "handle.vala"
	_tmp0_.height = G_MAXINT;
#line 67 "handle.vala"
	self->priv->m_workarea = _tmp0_;
#line 263 "handle.c"
	{
		gboolean _tmp1_ = FALSE;
#line 69 "handle.vala"
		_tmp1_ = TRUE;
#line 69 "handle.vala"
		while (TRUE) {
#line 270 "handle.c"
			GdkWindow* root = NULL;
			GdkWindow* _tmp2_;
			GdkWindow* _tmp3_;
			GdkAtom property = (GdkAtom) 0U;
			GdkAtom type = (GdkAtom) 0U;
			GdkAtom actual_type = (GdkAtom) 0U;
			gint format = 0;
			guchar* data = NULL;
			gint data_length1 = 0;
			gint _data_size_ = 0;
			gboolean _result_ = FALSE;
			GdkWindow* _tmp4_;
			GdkAtom _tmp5_ = (GdkAtom) 0U;
			gint _tmp6_ = 0;
			guint8* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			gboolean _tmp9_;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gint index = 0;
			guchar* _tmp14_;
			gint _tmp14__length1;
			guchar _tmp15_;
			guchar* _tmp16_;
			gint _tmp16__length1;
			guchar _tmp17_;
			guchar* _tmp18_;
			gint _tmp18__length1;
			guchar _tmp19_;
			guchar* _tmp20_;
			gint _tmp20__length1;
			guchar _tmp21_;
			GdkWindow* _tmp22_;
			GdkAtom _tmp23_ = (GdkAtom) 0U;
			gint _tmp24_ = 0;
			guint8* _tmp25_ = NULL;
			gint _tmp26_ = 0;
			gboolean _tmp27_;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_ = FALSE;
			gboolean _tmp30_ = FALSE;
			gint i = 0;
			guchar* _tmp32_;
			gint _tmp32__length1;
			guchar _tmp33_;
			guchar* _tmp34_;
			gint _tmp34__length1;
			guchar _tmp35_;
			guchar* _tmp36_;
			gint _tmp36__length1;
			guchar _tmp37_;
			guchar* _tmp38_;
			gint _tmp38__length1;
			guchar _tmp39_;
			guchar* _tmp40_;
			gint _tmp40__length1;
			guchar _tmp41_;
			guchar* _tmp42_;
			gint _tmp42__length1;
			guchar _tmp43_;
			guchar* _tmp44_;
			gint _tmp44__length1;
			guchar _tmp45_;
			guchar* _tmp46_;
			gint _tmp46__length1;
			guchar _tmp47_;
			guchar* _tmp48_;
			gint _tmp48__length1;
			guchar _tmp49_;
			guchar* _tmp50_;
			gint _tmp50__length1;
			guchar _tmp51_;
			guchar* _tmp52_;
			gint _tmp52__length1;
			guchar _tmp53_;
			guchar* _tmp54_;
			gint _tmp54__length1;
			guchar _tmp55_;
			guchar* _tmp56_;
			gint _tmp56__length1;
			guchar _tmp57_;
			guchar* _tmp58_;
			gint _tmp58__length1;
			guchar _tmp59_;
			guchar* _tmp60_;
			gint _tmp60__length1;
			guchar _tmp61_;
			guchar* _tmp62_;
			gint _tmp62__length1;
			guchar _tmp63_;
#line 69 "handle.vala"
			if (!_tmp1_) {
#line 123 "handle.vala"
				if (!FALSE) {
#line 123 "handle.vala"
					break;
#line 368 "handle.c"
				}
			}
#line 69 "handle.vala"
			_tmp1_ = FALSE;
#line 70 "handle.vala"
			_tmp2_ = gdk_get_default_root_window ();
#line 70 "handle.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 70 "handle.vala"
			root = _tmp3_;
#line 71 "handle.vala"
			property = gdk_atom_intern ("_NET_CURRENT_DESKTOP", FALSE);
#line 72 "handle.vala"
			type = gdk_atom_intern ("CARDINAL", FALSE);
#line 77 "handle.vala"
			_tmp4_ = root;
#line 77 "handle.vala"
			_tmp9_ = gdk_property_get (_tmp4_, property, type, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp5_, &_tmp6_, &_tmp8_, &_tmp7_);
#line 77 "handle.vala"
			actual_type = _tmp5_;
#line 77 "handle.vala"
			format = _tmp6_;
#line 77 "handle.vala"
			data = (g_free (data), NULL);
#line 77 "handle.vala"
			data = _tmp7_;
#line 77 "handle.vala"
			data_length1 = _tmp8_;
#line 77 "handle.vala"
			_data_size_ = data_length1;
#line 77 "handle.vala"
			_result_ = _tmp9_;
#line 85 "handle.vala"
			if (!_result_) {
#line 85 "handle.vala"
				_tmp12_ = TRUE;
#line 405 "handle.c"
			} else {
#line 85 "handle.vala"
				_tmp12_ = actual_type != type;
#line 409 "handle.c"
			}
#line 85 "handle.vala"
			if (_tmp12_) {
#line 85 "handle.vala"
				_tmp11_ = TRUE;
#line 415 "handle.c"
			} else {
#line 85 "handle.vala"
				_tmp11_ = format != 32;
#line 419 "handle.c"
			}
#line 85 "handle.vala"
			if (_tmp11_) {
#line 85 "handle.vala"
				_tmp10_ = TRUE;
#line 425 "handle.c"
			} else {
				guchar* _tmp13_;
				gint _tmp13__length1;
#line 85 "handle.vala"
				_tmp13_ = data;
#line 85 "handle.vala"
				_tmp13__length1 = data_length1;
#line 85 "handle.vala"
				_tmp10_ = _tmp13__length1 != 4;
#line 435 "handle.c"
			}
#line 85 "handle.vala"
			if (_tmp10_) {
#line 86 "handle.vala"
				data = (g_free (data), NULL);
#line 86 "handle.vala"
				_g_object_unref0 (root);
#line 86 "handle.vala"
				break;
#line 445 "handle.c"
			}
#line 87 "handle.vala"
			_tmp14_ = data;
#line 87 "handle.vala"
			_tmp14__length1 = data_length1;
#line 87 "handle.vala"
			_tmp15_ = _tmp14_[0];
#line 87 "handle.vala"
			_tmp16_ = data;
#line 87 "handle.vala"
			_tmp16__length1 = data_length1;
#line 87 "handle.vala"
			_tmp17_ = _tmp16_[1];
#line 87 "handle.vala"
			_tmp18_ = data;
#line 87 "handle.vala"
			_tmp18__length1 = data_length1;
#line 87 "handle.vala"
			_tmp19_ = _tmp18_[2];
#line 87 "handle.vala"
			_tmp20_ = data;
#line 87 "handle.vala"
			_tmp20__length1 = data_length1;
#line 87 "handle.vala"
			_tmp21_ = _tmp20_[3];
#line 87 "handle.vala"
			index = (gint) (((_tmp15_ | (_tmp17_ << 8)) | (_tmp19_ << 16)) | (_tmp21_ << 24));
#line 91 "handle.vala"
			property = gdk_atom_intern ("_NET_WORKAREA", FALSE);
#line 92 "handle.vala"
			type = gdk_atom_intern ("CARDINAL", FALSE);
#line 93 "handle.vala"
			_tmp22_ = root;
#line 93 "handle.vala"
			_tmp27_ = gdk_property_get (_tmp22_, property, type, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp23_, &_tmp24_, &_tmp26_, &_tmp25_);
#line 93 "handle.vala"
			actual_type = _tmp23_;
#line 93 "handle.vala"
			format = _tmp24_;
#line 93 "handle.vala"
			data = (g_free (data), NULL);
#line 93 "handle.vala"
			data = _tmp25_;
#line 93 "handle.vala"
			data_length1 = _tmp26_;
#line 93 "handle.vala"
			_data_size_ = data_length1;
#line 93 "handle.vala"
			_result_ = _tmp27_;
#line 101 "handle.vala"
			if (!_result_) {
#line 101 "handle.vala"
				_tmp30_ = TRUE;
#line 499 "handle.c"
			} else {
#line 101 "handle.vala"
				_tmp30_ = actual_type != type;
#line 503 "handle.c"
			}
#line 101 "handle.vala"
			if (_tmp30_) {
#line 101 "handle.vala"
				_tmp29_ = TRUE;
#line 509 "handle.c"
			} else {
#line 101 "handle.vala"
				_tmp29_ = format != 32;
#line 513 "handle.c"
			}
#line 101 "handle.vala"
			if (_tmp29_) {
#line 101 "handle.vala"
				_tmp28_ = TRUE;
#line 519 "handle.c"
			} else {
				guchar* _tmp31_;
				gint _tmp31__length1;
#line 101 "handle.vala"
				_tmp31_ = data;
#line 101 "handle.vala"
				_tmp31__length1 = data_length1;
#line 101 "handle.vala"
				_tmp28_ = _tmp31__length1 < ((index + 1) * 16);
#line 529 "handle.c"
			}
#line 101 "handle.vala"
			if (_tmp28_) {
#line 102 "handle.vala"
				data = (g_free (data), NULL);
#line 102 "handle.vala"
				_g_object_unref0 (root);
#line 102 "handle.vala"
				break;
#line 539 "handle.c"
			}
#line 103 "handle.vala"
			i = (index * 4) * 4;
#line 104 "handle.vala"
			_tmp32_ = data;
#line 104 "handle.vala"
			_tmp32__length1 = data_length1;
#line 104 "handle.vala"
			_tmp33_ = _tmp32_[i];
#line 104 "handle.vala"
			_tmp34_ = data;
#line 104 "handle.vala"
			_tmp34__length1 = data_length1;
#line 104 "handle.vala"
			_tmp35_ = _tmp34_[i + 1];
#line 104 "handle.vala"
			_tmp36_ = data;
#line 104 "handle.vala"
			_tmp36__length1 = data_length1;
#line 104 "handle.vala"
			_tmp37_ = _tmp36_[i + 2];
#line 104 "handle.vala"
			_tmp38_ = data;
#line 104 "handle.vala"
			_tmp38__length1 = data_length1;
#line 104 "handle.vala"
			_tmp39_ = _tmp38_[i + 3];
#line 104 "handle.vala"
			self->priv->m_workarea.x = (gint) (((_tmp33_ | (_tmp35_ << 8)) | (_tmp37_ << 16)) | (_tmp39_ << 24));
#line 108 "handle.vala"
			i += 4;
#line 109 "handle.vala"
			_tmp40_ = data;
#line 109 "handle.vala"
			_tmp40__length1 = data_length1;
#line 109 "handle.vala"
			_tmp41_ = _tmp40_[i];
#line 109 "handle.vala"
			_tmp42_ = data;
#line 109 "handle.vala"
			_tmp42__length1 = data_length1;
#line 109 "handle.vala"
			_tmp43_ = _tmp42_[i + 1];
#line 109 "handle.vala"
			_tmp44_ = data;
#line 109 "handle.vala"
			_tmp44__length1 = data_length1;
#line 109 "handle.vala"
			_tmp45_ = _tmp44_[i + 2];
#line 109 "handle.vala"
			_tmp46_ = data;
#line 109 "handle.vala"
			_tmp46__length1 = data_length1;
#line 109 "handle.vala"
			_tmp47_ = _tmp46_[i + 3];
#line 109 "handle.vala"
			self->priv->m_workarea.y = (gint) (((_tmp41_ | (_tmp43_ << 8)) | (_tmp45_ << 16)) | (_tmp47_ << 24));
#line 113 "handle.vala"
			i += 4;
#line 114 "handle.vala"
			_tmp48_ = data;
#line 114 "handle.vala"
			_tmp48__length1 = data_length1;
#line 114 "handle.vala"
			_tmp49_ = _tmp48_[i];
#line 114 "handle.vala"
			_tmp50_ = data;
#line 114 "handle.vala"
			_tmp50__length1 = data_length1;
#line 114 "handle.vala"
			_tmp51_ = _tmp50_[i + 1];
#line 114 "handle.vala"
			_tmp52_ = data;
#line 114 "handle.vala"
			_tmp52__length1 = data_length1;
#line 114 "handle.vala"
			_tmp53_ = _tmp52_[i + 2];
#line 114 "handle.vala"
			_tmp54_ = data;
#line 114 "handle.vala"
			_tmp54__length1 = data_length1;
#line 114 "handle.vala"
			_tmp55_ = _tmp54_[i + 3];
#line 114 "handle.vala"
			self->priv->m_workarea.width = (gint) (((_tmp49_ | (_tmp51_ << 8)) | (_tmp53_ << 16)) | (_tmp55_ << 24));
#line 118 "handle.vala"
			i += 4;
#line 119 "handle.vala"
			_tmp56_ = data;
#line 119 "handle.vala"
			_tmp56__length1 = data_length1;
#line 119 "handle.vala"
			_tmp57_ = _tmp56_[i];
#line 119 "handle.vala"
			_tmp58_ = data;
#line 119 "handle.vala"
			_tmp58__length1 = data_length1;
#line 119 "handle.vala"
			_tmp59_ = _tmp58_[i + 1];
#line 119 "handle.vala"
			_tmp60_ = data;
#line 119 "handle.vala"
			_tmp60__length1 = data_length1;
#line 119 "handle.vala"
			_tmp61_ = _tmp60_[i + 2];
#line 119 "handle.vala"
			_tmp62_ = data;
#line 119 "handle.vala"
			_tmp62__length1 = data_length1;
#line 119 "handle.vala"
			_tmp63_ = _tmp62_[i + 3];
#line 119 "handle.vala"
			self->priv->m_workarea.height = (gint) (((_tmp57_ | (_tmp59_ << 8)) | (_tmp61_ << 16)) | (_tmp63_ << 24));
#line 69 "handle.vala"
			data = (g_free (data), NULL);
#line 69 "handle.vala"
			_g_object_unref0 (root);
#line 657 "handle.c"
		}
	}
#line 124 "handle.vala"
	self->priv->m_move_begined = TRUE;
#line 126 "handle.vala"
	_tmp64_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 126 "handle.vala"
	_tmp65_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_window_get_type (), GtkWindow));
#line 126 "handle.vala"
	toplevel = _tmp65_;
#line 127 "handle.vala"
	_tmp66_ = toplevel;
#line 127 "handle.vala"
	gtk_window_get_position (_tmp66_, &_tmp67_, &_tmp68_);
#line 127 "handle.vala"
	x = _tmp67_;
#line 127 "handle.vala"
	y = _tmp68_;
#line 128 "handle.vala"
	self->priv->m_press_pos.x = ((gint) event->x_root) - x;
#line 129 "handle.vala"
	self->priv->m_press_pos.y = ((gint) event->y_root) - y;
#line 130 "handle.vala"
	g_signal_emit (self, handle_signals[HANDLE_MOVE_BEGIN_SIGNAL], 0);
#line 131 "handle.vala"
	result = TRUE;
#line 131 "handle.vala"
	_g_object_unref0 (toplevel);
#line 131 "handle.vala"
	return result;
#line 688 "handle.c"
}

static gboolean
handle_real_button_release_event (GtkWidget* base,
                                  GdkEventButton* event)
{
	Handle * self;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkCursor* _tmp3_;
	gboolean result;
#line 134 "handle.vala"
	self = (Handle*) base;
#line 134 "handle.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 135 "handle.vala"
	if (event->button != ((guint) 1)) {
#line 136 "handle.vala"
		result = FALSE;
#line 136 "handle.vala"
		return result;
#line 711 "handle.c"
	}
#line 137 "handle.vala"
	self->priv->m_move_begined = FALSE;
#line 138 "handle.vala"
	self->priv->m_press_pos.x = 0;
#line 139 "handle.vala"
	self->priv->m_press_pos.y = 0;
#line 140 "handle.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 140 "handle.vala"
	_tmp1_ = gdk_display_get_default ();
#line 140 "handle.vala"
	_tmp2_ = gdk_cursor_new_for_display (_tmp1_, GDK_FLEUR);
#line 140 "handle.vala"
	_tmp3_ = _tmp2_;
#line 140 "handle.vala"
	gdk_window_set_cursor (_tmp0_, _tmp3_);
#line 140 "handle.vala"
	_g_object_unref0 (_tmp3_);
#line 143 "handle.vala"
	g_signal_emit (self, handle_signals[HANDLE_MOVE_END_SIGNAL], 0);
#line 144 "handle.vala"
	result = TRUE;
#line 144 "handle.vala"
	return result;
#line 737 "handle.c"
}

static gboolean
handle_real_motion_notify_event (GtkWidget* base,
                                 GdkEventMotion* event)
{
	Handle * self;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	gint x = 0;
	GdkPoint _tmp2_;
	gint y = 0;
	GdkPoint _tmp3_;
	gboolean _tmp4_ = FALSE;
	GdkRectangle _tmp5_;
	gboolean _tmp8_ = FALSE;
	GdkRectangle _tmp9_;
	gint w = 0;
	gint h = 0;
	GtkWindow* _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gboolean _tmp15_ = FALSE;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
	gboolean _tmp22_ = FALSE;
	GdkRectangle _tmp23_;
	GdkRectangle _tmp24_;
	GtkWindow* _tmp29_;
	gboolean result;
#line 147 "handle.vala"
	self = (Handle*) base;
#line 147 "handle.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 148 "handle.vala"
	if (!self->priv->m_move_begined) {
#line 149 "handle.vala"
		result = FALSE;
#line 149 "handle.vala"
		return result;
#line 779 "handle.c"
	}
#line 150 "handle.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 150 "handle.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow));
#line 150 "handle.vala"
	toplevel = _tmp1_;
#line 151 "handle.vala"
	_tmp2_ = self->priv->m_press_pos;
#line 151 "handle.vala"
	x = (gint) (event->x_root - _tmp2_.x);
#line 152 "handle.vala"
	_tmp3_ = self->priv->m_press_pos;
#line 152 "handle.vala"
	y = (gint) (event->y_root - _tmp3_.y);
#line 154 "handle.vala"
	_tmp5_ = self->priv->m_workarea;
#line 154 "handle.vala"
	if (x < _tmp5_.x) {
#line 799 "handle.c"
		GdkRectangle _tmp6_;
#line 154 "handle.vala"
		_tmp6_ = self->priv->m_workarea;
#line 154 "handle.vala"
		_tmp4_ = x > (_tmp6_.x - 16);
#line 805 "handle.c"
	} else {
#line 154 "handle.vala"
		_tmp4_ = FALSE;
#line 809 "handle.c"
	}
#line 154 "handle.vala"
	if (_tmp4_) {
#line 813 "handle.c"
		GdkRectangle _tmp7_;
#line 155 "handle.vala"
		_tmp7_ = self->priv->m_workarea;
#line 155 "handle.vala"
		x = _tmp7_.x;
#line 819 "handle.c"
	}
#line 156 "handle.vala"
	_tmp9_ = self->priv->m_workarea;
#line 156 "handle.vala"
	if (y < _tmp9_.y) {
#line 825 "handle.c"
		GdkRectangle _tmp10_;
#line 156 "handle.vala"
		_tmp10_ = self->priv->m_workarea;
#line 156 "handle.vala"
		_tmp8_ = y > (_tmp10_.y - 16);
#line 831 "handle.c"
	} else {
#line 156 "handle.vala"
		_tmp8_ = FALSE;
#line 835 "handle.c"
	}
#line 156 "handle.vala"
	if (_tmp8_) {
#line 839 "handle.c"
		GdkRectangle _tmp11_;
#line 157 "handle.vala"
		_tmp11_ = self->priv->m_workarea;
#line 157 "handle.vala"
		y = _tmp11_.y;
#line 845 "handle.c"
	}
#line 159 "handle.vala"
	_tmp12_ = toplevel;
#line 159 "handle.vala"
	gtk_window_get_size (_tmp12_, &_tmp13_, &_tmp14_);
#line 159 "handle.vala"
	w = _tmp13_;
#line 159 "handle.vala"
	h = _tmp14_;
#line 160 "handle.vala"
	_tmp16_ = self->priv->m_workarea;
#line 160 "handle.vala"
	_tmp17_ = self->priv->m_workarea;
#line 160 "handle.vala"
	if ((x + w) > (_tmp16_.x + _tmp17_.width)) {
#line 861 "handle.c"
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
#line 161 "handle.vala"
		_tmp18_ = self->priv->m_workarea;
#line 161 "handle.vala"
		_tmp19_ = self->priv->m_workarea;
#line 161 "handle.vala"
		_tmp15_ = (x + w) < ((_tmp18_.x + _tmp19_.width) + 16);
#line 870 "handle.c"
	} else {
#line 160 "handle.vala"
		_tmp15_ = FALSE;
#line 874 "handle.c"
	}
#line 160 "handle.vala"
	if (_tmp15_) {
#line 878 "handle.c"
		GdkRectangle _tmp20_;
		GdkRectangle _tmp21_;
#line 162 "handle.vala"
		_tmp20_ = self->priv->m_workarea;
#line 162 "handle.vala"
		_tmp21_ = self->priv->m_workarea;
#line 162 "handle.vala"
		x = (_tmp20_.x + _tmp21_.width) - w;
#line 887 "handle.c"
	}
#line 163 "handle.vala"
	_tmp23_ = self->priv->m_workarea;
#line 163 "handle.vala"
	_tmp24_ = self->priv->m_workarea;
#line 163 "handle.vala"
	if ((y + h) > (_tmp23_.y + _tmp24_.height)) {
#line 895 "handle.c"
		GdkRectangle _tmp25_;
		GdkRectangle _tmp26_;
#line 164 "handle.vala"
		_tmp25_ = self->priv->m_workarea;
#line 164 "handle.vala"
		_tmp26_ = self->priv->m_workarea;
#line 164 "handle.vala"
		_tmp22_ = (y + h) < ((_tmp25_.y + _tmp26_.height) + 16);
#line 904 "handle.c"
	} else {
#line 163 "handle.vala"
		_tmp22_ = FALSE;
#line 908 "handle.c"
	}
#line 163 "handle.vala"
	if (_tmp22_) {
#line 912 "handle.c"
		GdkRectangle _tmp27_;
		GdkRectangle _tmp28_;
#line 165 "handle.vala"
		_tmp27_ = self->priv->m_workarea;
#line 165 "handle.vala"
		_tmp28_ = self->priv->m_workarea;
#line 165 "handle.vala"
		y = (_tmp27_.y + _tmp28_.height) - w;
#line 921 "handle.c"
	}
#line 166 "handle.vala"
	_tmp29_ = toplevel;
#line 166 "handle.vala"
	gtk_window_move (_tmp29_, x, y);
#line 167 "handle.vala"
	result = TRUE;
#line 167 "handle.vala"
	_g_object_unref0 (toplevel);
#line 167 "handle.vala"
	return result;
#line 933 "handle.c"
}

static gboolean
handle_real_draw (GtkWidget* base,
                  cairo_t* cr)
{
	Handle * self;
	GdkWindow* _tmp0_;
	gboolean result;
#line 170 "handle.vala"
	self = (Handle*) base;
#line 170 "handle.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 171 "handle.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 171 "handle.vala"
	if (gtk_cairo_should_draw_window (cr, _tmp0_)) {
#line 951 "handle.c"
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp1_;
		GtkStyleContext* _tmp2_;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp3_ = {0};
		GtkStyleContext* _tmp4_;
		GtkAllocation _tmp5_;
		GtkAllocation _tmp6_;
		GtkAllocation _tmp7_;
		GtkAllocation _tmp8_;
#line 172 "handle.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 172 "handle.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 172 "handle.vala"
		context = _tmp2_;
#line 174 "handle.vala"
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
#line 174 "handle.vala"
		allocation = _tmp3_;
#line 175 "handle.vala"
		_tmp4_ = context;
#line 175 "handle.vala"
		_tmp5_ = allocation;
#line 175 "handle.vala"
		_tmp6_ = allocation;
#line 175 "handle.vala"
		_tmp7_ = allocation;
#line 175 "handle.vala"
		_tmp8_ = allocation;
#line 175 "handle.vala"
		gtk_render_handle (_tmp4_, cr, (gdouble) _tmp5_.x, (gdouble) (_tmp6_.y + ((_tmp7_.height - 40) / 2)), (gdouble) _tmp8_.width, 40.0);
#line 171 "handle.vala"
		_g_object_unref0 (context);
#line 986 "handle.c"
	}
#line 178 "handle.vala"
	result = FALSE;
#line 178 "handle.vala"
	return result;
#line 992 "handle.c"
}

static void
handle_class_init (HandleClass * klass,
                   gpointer klass_data)
{
#line 24 "handle.vala"
	handle_parent_class = g_type_class_peek_parent (klass);
#line 24 "handle.vala"
	g_type_class_adjust_private_offset (klass, &Handle_private_offset);
#line 24 "handle.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) handle_real_realize;
#line 24 "handle.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) handle_real_button_press_event;
#line 24 "handle.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) handle_real_button_release_event;
#line 24 "handle.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) handle_real_motion_notify_event;
#line 24 "handle.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) handle_real_draw;
#line 24 "handle.vala"
	G_OBJECT_CLASS (klass)->finalize = handle_finalize;
#line 24 "handle.vala"
	handle_signals[HANDLE_MOVE_BEGIN_SIGNAL] = g_signal_new ("move-begin", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "handle.vala"
	handle_signals[HANDLE_MOVE_END_SIGNAL] = g_signal_new ("move-end", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1019 "handle.c"
}

static void
handle_instance_init (Handle * self,
                      gpointer klass)
{
#line 24 "handle.vala"
	self->priv = handle_get_instance_private (self);
#line 1028 "handle.c"
}

static void
handle_finalize (GObject * obj)
{
	Handle * self;
#line 24 "handle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HANDLE, Handle);
#line 24 "handle.vala"
	G_OBJECT_CLASS (handle_parent_class)->finalize (obj);
#line 1039 "handle.c"
}

static GType
handle_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HandleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) handle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Handle), 0, (GInstanceInitFunc) handle_instance_init, NULL };
	GType handle_type_id;
	handle_type_id = g_type_register_static (gtk_event_box_get_type (), "Handle", &g_define_type_info, 0);
	Handle_private_offset = g_type_add_instance_private (handle_type_id, sizeof (HandlePrivate));
	return handle_type_id;
}

GType
handle_get_type (void)
{
	static volatile gsize handle_type_id__once = 0;
	if (g_once_init_enter (&handle_type_id__once)) {
		GType handle_type_id;
		handle_type_id = handle_get_type_once ();
		g_once_init_leave (&handle_type_id__once, handle_type_id);
	}
	return handle_type_id__once;
}

