/* indicator.c generated by valac 0.56.7, the Vala compiler
 * generated from indicator.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2015-2017 Takao Fujiwara <takao.fujiwara1@gmail.com>
 * Copyright(c) 2015 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */
/* This class extends AppIndicator because
 * AppIndicator misses "Activate" dbus method in the definition
 * for left click on the indicator.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>

#define INDICATOR_DEFAULT_ITEM_PATH "/org/ayatana/NotificationItem"
#define INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE "org.kde.StatusNotifierItem"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE "org.kde.StatusNotifierWatcher"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_ADDR "org.kde.StatusNotifierWatcher"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_OBJ "/StatusNotifierWatcher"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;
typedef struct _IndicatorPrivate IndicatorPrivate;
enum  {
	INDICATOR_0_PROPERTY,
	INDICATOR_ID_PROPERTY,
	INDICATOR_CATEGORY_S_PROPERTY,
	INDICATOR_STATUS_S_PROPERTY,
	INDICATOR_ICON_NAME_PROPERTY,
	INDICATOR_ICON_DESC_PROPERTY,
	INDICATOR_ATTENTION_ICON_NAME_PROPERTY,
	INDICATOR_ATTENTION_ICON_DESC_PROPERTY,
	INDICATOR_TITLE_PROPERTY,
	INDICATOR_ICON_THEME_PATH_PROPERTY,
	INDICATOR_CONNECTED_PROPERTY,
	INDICATOR_LABEL_S_PROPERTY,
	INDICATOR_LABEL_GUIDE_S_PROPERTY,
	INDICATOR_ORDERING_INDEX_PROPERTY,
	INDICATOR_ICON_VECTOR_PROPERTY,
	INDICATOR_NUM_PROPERTIES
};
static GParamSpec* indicator_properties[INDICATOR_NUM_PROPERTIES];
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_dbus_node_info_unref0(var) ((var == NULL) ? NULL : (var = (g_dbus_node_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
enum  {
	INDICATOR_CONTEXT_MENU_SIGNAL,
	INDICATOR_ACTIVATE_SIGNAL,
	INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL,
	INDICATOR_NUM_SIGNALS
};
static guint indicator_signals[INDICATOR_NUM_SIGNALS] = {0};

struct _Indicator {
	IBusService parent_instance;
	IndicatorPrivate * priv;
};

struct _IndicatorClass {
	IBusServiceClass parent_class;
};

struct _IndicatorPrivate {
	gchar* _id;
	gchar* _category_s;
	gchar* _status_s;
	gchar* _icon_name;
	gchar* _icon_desc;
	gchar* _attention_icon_name;
	gchar* _attention_icon_desc;
	gchar* _title;
	gchar* _icon_theme_path;
	gboolean _connected;
	gchar* _label_s;
	gchar* _label_guide_s;
	guint32 _ordering_index;
	GVariant* _icon_vector;
	GDBusNodeInfo* m_watcher_node_info;
	GDBusInterfaceInfo* m_watcher_interface_info;
	GDBusProxy* m_proxy;
	gint m_context_menu_x;
	gint m_context_menu_y;
	gint m_activate_menu_x;
	gint m_activate_menu_y;
	GdkWindow* m_indicator_window;
};

VALA_EXTERN gchar* _notification_item;
VALA_EXTERN gchar* _notification_watcher;
static gint Indicator_private_offset;
static gpointer indicator_parent_class = NULL;

VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* indicator_category_to_nick (IndicatorCategory self);
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* indicator_status_to_nick (IndicatorStatus self);
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          GDBusConnection* connection,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                GDBusConnection* connection,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_status_s (Indicator* self,
                             const gchar* value);
VALA_EXTERN void indicator_set_icon_name (Indicator* self,
                              const gchar* value);
VALA_EXTERN void indicator_set_icon_desc (Indicator* self,
                              const gchar* value);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
VALA_EXTERN void indicator_set_icon_theme_path (Indicator* self,
                                    const gchar* value);
VALA_EXTERN void indicator_set_attention_icon_name (Indicator* self,
                                        const gchar* value);
VALA_EXTERN void indicator_set_attention_icon_desc (Indicator* self,
                                        const gchar* value);
VALA_EXTERN void indicator_set_label_s (Indicator* self,
                            const gchar* value);
VALA_EXTERN void indicator_set_label_guide_s (Indicator* self,
                                  const gchar* value);
static void indicator_check_connect (Indicator* self);
static void ___lambda4_ (Indicator* self,
                  GObject* obj,
                  GAsyncResult* res);
static void indicator_bus_watcher_ready (Indicator* self,
                                  GObject* obj,
                                  GAsyncResult* res);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda5_ (Indicator* self,
                  GObject* obj,
                  GParamSpec* pspec);
static void ____lambda5__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda6_ (Indicator* self,
                 GObject* p_obj,
                 GAsyncResult* p_res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void _indicator_context_menu_cb (Indicator* self,
                                 GDBusConnection* connection,
                                 GVariant* parameters,
                                 GDBusMethodInvocation* invocation);
static GdkWindow* indicator_query_gdk_window (Indicator* self);
static void _indicator_activate_menu_cb (Indicator* self,
                                  GDBusConnection* connection,
                                  GVariant* parameters,
                                  GDBusMethodInvocation* invocation);
static GVariant* _indicator_get_id (Indicator* self,
                             GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_id (Indicator* self);
static GVariant* _indicator_get_category (Indicator* self,
                                   GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_category_s (Indicator* self);
static GVariant* _indicator_get_status (Indicator* self,
                                 GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_status_s (Indicator* self);
static GVariant* _indicator_get_icon_name (Indicator* self,
                                    GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_name (Indicator* self);
static GVariant* _indicator_get_icon_vector (Indicator* self,
                                      GDBusConnection* connection);
VALA_EXTERN GVariant* indicator_get_icon_vector (Indicator* self);
static GVariant* _indicator_get_icon_desc (Indicator* self,
                                    GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_desc (Indicator* self);
static GVariant* _indicator_get_attention_icon_name (Indicator* self,
                                              GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_attention_icon_name (Indicator* self);
static GVariant* _indicator_get_attention_icon_desc (Indicator* self,
                                              GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_attention_icon_desc (Indicator* self);
static GVariant* _indicator_get_title (Indicator* self,
                                GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_title (Indicator* self);
static GVariant* _indicator_get_icon_theme_path (Indicator* self,
                                          GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_theme_path (Indicator* self);
static GVariant* _indicator_get_menu (Indicator* self,
                               GDBusConnection* connection);
static GVariant* _indicator_get_xayatana_label (Indicator* self,
                                         GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_label_s (Indicator* self);
static GVariant* _indicator_get_xayatana_label_guide (Indicator* self,
                                               GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_label_guide_s (Indicator* self);
static GVariant* _indicator_get_xayatana_ordering_index (Indicator* self,
                                                  GDBusConnection* connection);
VALA_EXTERN guint32 indicator_get_ordering_index (Indicator* self);
static void indicator_real_service_method_call (IBusService* base,
                                         GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* method_name,
                                         GVariant* parameters,
                                         GDBusMethodInvocation* invocation);
static GVariant* indicator_real_service_get_property (IBusService* base,
                                               GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GError** error);
static gboolean indicator_real_service_set_property (IBusService* base,
                                              GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GVariant* value,
                                              GError** error);
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN void indicator_set_icon_vector (Indicator* self,
                                GVariant* value);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
VALA_EXTERN void indicator_position_context_menu (Indicator* self,
                                      GtkMenu* menu,
                                      gint* x,
                                      gint* y,
                                      gboolean* push_in);
VALA_EXTERN void indicator_position_activate_menu (Indicator* self,
                                       GtkMenu* menu,
                                       gint* x,
                                       gint* y,
                                       gboolean* push_in);
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
static void indicator_set_id (Indicator* self,
                       const gchar* value);
static void indicator_set_category_s (Indicator* self,
                               const gchar* value);
VALA_EXTERN gboolean indicator_get_connected (Indicator* self);
VALA_EXTERN void indicator_set_connected (Indicator* self,
                              gboolean value);
VALA_EXTERN void indicator_set_ordering_index (Indicator* self,
                                   guint32 value);
static void g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT (GClosure * closure,
                                                             GValue * return_value,
                                                             guint n_param_values,
                                                             const GValue * param_values,
                                                             gpointer invocation_hint,
                                                             gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT_OBJECT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void indicator_finalize (GObject * obj);
static GType indicator_get_type_once (void);
static void _vala_indicator_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_indicator_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
indicator_get_instance_private (Indicator* self)
{
	return G_STRUCT_MEMBER_P (self, Indicator_private_offset);
}

gchar*
indicator_category_to_nick (IndicatorCategory self)
{
	gchar* result;
#line 57 "indicator.vala"
	switch (self) {
#line 57 "indicator.vala"
		case INDICATOR_CATEGORY_APPLICATION_STATUS:
#line 355 "indicator.c"
		{
			gchar* _tmp0_;
#line 58 "indicator.vala"
			_tmp0_ = g_strdup ("ApplicationStatus");
#line 58 "indicator.vala"
			result = _tmp0_;
#line 58 "indicator.vala"
			return result;
#line 364 "indicator.c"
		}
#line 57 "indicator.vala"
		case INDICATOR_CATEGORY_COMMUNICATIONS:
#line 368 "indicator.c"
		{
			gchar* _tmp1_;
#line 59 "indicator.vala"
			_tmp1_ = g_strdup ("Communications");
#line 59 "indicator.vala"
			result = _tmp1_;
#line 59 "indicator.vala"
			return result;
#line 377 "indicator.c"
		}
#line 57 "indicator.vala"
		case INDICATOR_CATEGORY_SYSTEM_SERVICES:
#line 381 "indicator.c"
		{
			gchar* _tmp2_;
#line 60 "indicator.vala"
			_tmp2_ = g_strdup ("SystemServices");
#line 60 "indicator.vala"
			result = _tmp2_;
#line 60 "indicator.vala"
			return result;
#line 390 "indicator.c"
		}
#line 57 "indicator.vala"
		case INDICATOR_CATEGORY_HARDWARE:
#line 394 "indicator.c"
		{
			gchar* _tmp3_;
#line 61 "indicator.vala"
			_tmp3_ = g_strdup ("Hardware");
#line 61 "indicator.vala"
			result = _tmp3_;
#line 61 "indicator.vala"
			return result;
#line 403 "indicator.c"
		}
#line 57 "indicator.vala"
		case INDICATOR_CATEGORY_OTHER:
#line 407 "indicator.c"
		{
			gchar* _tmp4_;
#line 62 "indicator.vala"
			_tmp4_ = g_strdup ("Other");
#line 62 "indicator.vala"
			result = _tmp4_;
#line 62 "indicator.vala"
			return result;
#line 416 "indicator.c"
		}
		default:
		{
#line 63 "indicator.vala"
			g_assert_not_reached ();
#line 422 "indicator.c"
		}
	}
}

static GType
indicator_category_get_type_once (void)
{
	static const GEnumValue values[] = {{INDICATOR_CATEGORY_APPLICATION_STATUS, "INDICATOR_CATEGORY_APPLICATION_STATUS", "application-status"}, {INDICATOR_CATEGORY_COMMUNICATIONS, "INDICATOR_CATEGORY_COMMUNICATIONS", "communications"}, {INDICATOR_CATEGORY_SYSTEM_SERVICES, "INDICATOR_CATEGORY_SYSTEM_SERVICES", "system-services"}, {INDICATOR_CATEGORY_HARDWARE, "INDICATOR_CATEGORY_HARDWARE", "hardware"}, {INDICATOR_CATEGORY_OTHER, "INDICATOR_CATEGORY_OTHER", "other"}, {0, NULL, NULL}};
	GType indicator_category_type_id;
	indicator_category_type_id = g_enum_register_static ("IndicatorCategory", values);
	return indicator_category_type_id;
}

GType
indicator_category_get_type (void)
{
	static volatile gsize indicator_category_type_id__once = 0;
	if (g_once_init_enter (&indicator_category_type_id__once)) {
		GType indicator_category_type_id;
		indicator_category_type_id = indicator_category_get_type_once ();
		g_once_init_leave (&indicator_category_type_id__once, indicator_category_type_id);
	}
	return indicator_category_type_id__once;
}

gchar*
indicator_status_to_nick (IndicatorStatus self)
{
	gchar* result;
#line 74 "indicator.vala"
	switch (self) {
#line 74 "indicator.vala"
		case INDICATOR_STATUS_PASSIVE:
#line 456 "indicator.c"
		{
			gchar* _tmp0_;
#line 75 "indicator.vala"
			_tmp0_ = g_strdup ("Passive");
#line 75 "indicator.vala"
			result = _tmp0_;
#line 75 "indicator.vala"
			return result;
#line 465 "indicator.c"
		}
#line 74 "indicator.vala"
		case INDICATOR_STATUS_ACTIVE:
#line 469 "indicator.c"
		{
			gchar* _tmp1_;
#line 76 "indicator.vala"
			_tmp1_ = g_strdup ("Active");
#line 76 "indicator.vala"
			result = _tmp1_;
#line 76 "indicator.vala"
			return result;
#line 478 "indicator.c"
		}
#line 74 "indicator.vala"
		case INDICATOR_STATUS_ATTENTION:
#line 482 "indicator.c"
		{
			gchar* _tmp2_;
#line 77 "indicator.vala"
			_tmp2_ = g_strdup ("NeedsAttention");
#line 77 "indicator.vala"
			result = _tmp2_;
#line 77 "indicator.vala"
			return result;
#line 491 "indicator.c"
		}
		default:
		{
#line 78 "indicator.vala"
			g_assert_not_reached ();
#line 497 "indicator.c"
		}
	}
}

static GType
indicator_status_get_type_once (void)
{
	static const GEnumValue values[] = {{INDICATOR_STATUS_PASSIVE, "INDICATOR_STATUS_PASSIVE", "passive"}, {INDICATOR_STATUS_ACTIVE, "INDICATOR_STATUS_ACTIVE", "active"}, {INDICATOR_STATUS_ATTENTION, "INDICATOR_STATUS_ATTENTION", "attention"}, {0, NULL, NULL}};
	GType indicator_status_type_id;
	indicator_status_type_id = g_enum_register_static ("IndicatorStatus", values);
	return indicator_status_type_id;
}

GType
indicator_status_get_type (void)
{
	static volatile gsize indicator_status_type_id__once = 0;
	if (g_once_init_enter (&indicator_status_type_id__once)) {
		GType indicator_status_type_id;
		indicator_status_type_id = indicator_status_get_type_once ();
		g_once_init_leave (&indicator_status_type_id__once, indicator_status_type_id);
	}
	return indicator_status_type_id__once;
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1375 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1375 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1376 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1376 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1377 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1378 "glib-2.0.vapi"
	result = _result_;
#line 1378 "glib-2.0.vapi"
	return result;
#line 545 "indicator.c"
}

Indicator*
indicator_construct (GType object_type,
                     const gchar* id,
                     GDBusConnection* connection,
                     IndicatorCategory category)
{
	Indicator * self = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GDBusNodeInfo* _tmp22_;
	GDBusInterfaceInfo* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 103 "indicator.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 103 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 106 "indicator.vala"
	_tmp0_ = g_strconcat (INDICATOR_DEFAULT_ITEM_PATH "/", id, NULL);
#line 106 "indicator.vala"
	path = _tmp0_;
#line 107 "indicator.vala"
	_tmp1_ = path;
#line 107 "indicator.vala"
	_tmp2_ = string_delimit (_tmp1_, "-", '_');
#line 107 "indicator.vala"
	_g_free0 (path);
#line 107 "indicator.vala"
	path = _tmp2_;
#line 110 "indicator.vala"
	_tmp3_ = path;
#line 110 "indicator.vala"
	_tmp4_ = indicator_category_to_nick (category);
#line 110 "indicator.vala"
	_tmp5_ = _tmp4_;
#line 110 "indicator.vala"
	self = (Indicator*) g_object_new (object_type, "object-path", _tmp3_, "id", id, "connection", connection, "category-s", _tmp5_, NULL);
#line 110 "indicator.vala"
	_g_free0 (_tmp5_);
#line 114 "indicator.vala"
	_tmp6_ = indicator_status_to_nick (INDICATOR_STATUS_PASSIVE);
#line 114 "indicator.vala"
	_tmp7_ = _tmp6_;
#line 114 "indicator.vala"
	indicator_set_status_s (self, _tmp7_);
#line 114 "indicator.vala"
	_g_free0 (_tmp7_);
#line 115 "indicator.vala"
	indicator_set_icon_name (self, "");
#line 116 "indicator.vala"
	indicator_set_icon_desc (self, "");
#line 117 "indicator.vala"
	indicator_set_title (self, "");
#line 118 "indicator.vala"
	indicator_set_icon_theme_path (self, "");
#line 119 "indicator.vala"
	indicator_set_attention_icon_name (self, "");
#line 120 "indicator.vala"
	indicator_set_attention_icon_desc (self, "");
#line 121 "indicator.vala"
	indicator_set_label_s (self, "");
#line 122 "indicator.vala"
	indicator_set_label_guide_s (self, "");
#line 123 "indicator.vala"
	ibus_service_unregister ((IBusService*) self, connection);
#line 124 "indicator.vala"
	_tmp8_ = _notification_item;
#line 124 "indicator.vala"
	ibus_service_class_add_interfaces (G_TYPE_INSTANCE_GET_CLASS (self, ibus_service_get_type (), IBusServiceClass), _tmp8_);
#line 624 "indicator.c"
	{
		gboolean _tmp9_ = FALSE;
#line 126 "indicator.vala"
		_tmp9_ = ibus_service_register ((IBusService*) self, connection, &_inner_error0_);
#line 126 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 631 "indicator.c"
			goto __catch0_g_error;
		}
#line 126 "indicator.vala"
		if (!_tmp9_) {
#line 127 "indicator.vala"
			_g_free0 (path);
#line 127 "indicator.vala"
			return self;
#line 640 "indicator.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 125 "indicator.vala"
		e = _inner_error0_;
#line 125 "indicator.vala"
		_inner_error0_ = NULL;
#line 129 "indicator.vala"
		_tmp10_ = e;
#line 129 "indicator.vala"
		_tmp11_ = _tmp10_->message;
#line 129 "indicator.vala"
		_tmp12_ = g_strconcat ("Failed to register the application indicator xml: ", _tmp11_, NULL);
#line 129 "indicator.vala"
		_tmp13_ = _tmp12_;
#line 129 "indicator.vala"
		g_warning ("indicator.vala:129: %s", _tmp13_);
#line 129 "indicator.vala"
		_g_free0 (_tmp13_);
#line 131 "indicator.vala"
		_g_error_free0 (e);
#line 131 "indicator.vala"
		_g_free0 (path);
#line 131 "indicator.vala"
		return self;
#line 673 "indicator.c"
	}
	__finally0:
#line 125 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "indicator.vala"
		_g_free0 (path);
#line 125 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 125 "indicator.vala"
		return NULL;
#line 686 "indicator.c"
	}
	{
		GDBusNodeInfo* _tmp14_ = NULL;
		const gchar* _tmp15_;
		GDBusNodeInfo* _tmp16_;
		GDBusNodeInfo* _tmp17_;
#line 136 "indicator.vala"
		_tmp15_ = _notification_watcher;
#line 136 "indicator.vala"
		_tmp16_ = g_dbus_node_info_new_for_xml (_tmp15_, &_inner_error0_);
#line 136 "indicator.vala"
		_tmp14_ = _tmp16_;
#line 136 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 701 "indicator.c"
			goto __catch1_g_error;
		}
#line 135 "indicator.vala"
		_tmp17_ = _tmp14_;
#line 135 "indicator.vala"
		_tmp14_ = NULL;
#line 135 "indicator.vala"
		_g_dbus_node_info_unref0 (self->priv->m_watcher_node_info);
#line 135 "indicator.vala"
		self->priv->m_watcher_node_info = _tmp17_;
#line 134 "indicator.vala"
		_g_dbus_node_info_unref0 (_tmp14_);
#line 714 "indicator.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 134 "indicator.vala"
		e = _inner_error0_;
#line 134 "indicator.vala"
		_inner_error0_ = NULL;
#line 138 "indicator.vala"
		_tmp18_ = e;
#line 138 "indicator.vala"
		_tmp19_ = _tmp18_->message;
#line 138 "indicator.vala"
		_tmp20_ = g_strconcat ("Failed to create dbus node info: ", _tmp19_, NULL);
#line 138 "indicator.vala"
		_tmp21_ = _tmp20_;
#line 138 "indicator.vala"
		g_warning ("indicator.vala:138: %s", _tmp21_);
#line 138 "indicator.vala"
		_g_free0 (_tmp21_);
#line 139 "indicator.vala"
		_g_error_free0 (e);
#line 139 "indicator.vala"
		_g_free0 (path);
#line 139 "indicator.vala"
		return self;
#line 746 "indicator.c"
	}
	__finally1:
#line 134 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "indicator.vala"
		_g_free0 (path);
#line 134 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 134 "indicator.vala"
		return NULL;
#line 759 "indicator.c"
	}
#line 141 "indicator.vala"
	_tmp22_ = self->priv->m_watcher_node_info;
#line 141 "indicator.vala"
	_tmp23_ = g_dbus_node_info_lookup_interface (_tmp22_, INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE);
#line 141 "indicator.vala"
	self->priv->m_watcher_interface_info = _tmp23_;
#line 144 "indicator.vala"
	indicator_check_connect (self);
#line 103 "indicator.vala"
	_g_free0 (path);
#line 103 "indicator.vala"
	return self;
#line 773 "indicator.c"
}

Indicator*
indicator_new (const gchar* id,
               GDBusConnection* connection,
               IndicatorCategory category)
{
#line 103 "indicator.vala"
	return indicator_construct (TYPE_INDICATOR, id, connection, category);
#line 783 "indicator.c"
}

static void
___lambda4_ (Indicator* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 159 "indicator.vala"
	g_return_if_fail (res != NULL);
#line 160 "indicator.vala"
	indicator_bus_watcher_ready (self, obj, res);
#line 795 "indicator.c"
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 150 "indicator.vala"
	___lambda4_ ((Indicator*) self, source_object, res);
#line 150 "indicator.vala"
	g_object_unref (self);
#line 807 "indicator.c"
}

static void
indicator_check_connect (Indicator* self)
{
	GDBusProxy* _tmp0_;
#line 148 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 149 "indicator.vala"
	_tmp0_ = self->priv->m_proxy;
#line 149 "indicator.vala"
	if (_tmp0_ == NULL) {
#line 820 "indicator.c"
		GDBusConnection* _tmp1_;
		GDBusConnection* _tmp2_;
		GDBusInterfaceInfo* _tmp3_;
#line 150 "indicator.vala"
		_tmp1_ = ibus_service_get_connection ((IBusService*) self);
#line 150 "indicator.vala"
		_tmp2_ = _tmp1_;
#line 150 "indicator.vala"
		_tmp3_ = self->priv->m_watcher_interface_info;
#line 150 "indicator.vala"
		g_dbus_proxy_new (_tmp2_, G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, _tmp3_, INDICATOR_NOTIFICATION_WATCHER_DBUS_ADDR, INDICATOR_NOTIFICATION_WATCHER_DBUS_OBJ, INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE, NULL, ____lambda4__gasync_ready_callback, g_object_ref (self));
#line 832 "indicator.c"
	} else {
#line 163 "indicator.vala"
		indicator_bus_watcher_ready (self, NULL, NULL);
#line 836 "indicator.c"
	}
}

static void
___lambda5_ (Indicator* self,
             GObject* obj,
             GParamSpec* pspec)
{
	gchar* name = NULL;
	GDBusProxy* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 177 "indicator.vala"
	g_return_if_fail (obj != NULL);
#line 177 "indicator.vala"
	g_return_if_fail (pspec != NULL);
#line 178 "indicator.vala"
	_tmp0_ = self->priv->m_proxy;
#line 178 "indicator.vala"
	_tmp1_ = g_dbus_proxy_get_name_owner (_tmp0_);
#line 178 "indicator.vala"
	name = _tmp1_;
#line 179 "indicator.vala"
	_tmp2_ = name;
#line 179 "indicator.vala"
	if (_tmp2_ != NULL) {
#line 180 "indicator.vala"
		indicator_check_connect (self);
#line 865 "indicator.c"
	}
#line 177 "indicator.vala"
	_g_free0 (name);
#line 869 "indicator.c"
}

static void
____lambda5__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 177 "indicator.vala"
	___lambda5_ ((Indicator*) self, _sender, pspec);
#line 879 "indicator.c"
}

static void
__lambda6_ (Indicator* self,
            GObject* p_obj,
            GAsyncResult* p_res)
{
	GError* _inner_error0_ = NULL;
#line 194 "indicator.vala"
	g_return_if_fail (p_res != NULL);
#line 890 "indicator.c"
	{
		GDBusProxy* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
#line 196 "indicator.vala"
		_tmp0_ = self->priv->m_proxy;
#line 196 "indicator.vala"
		_tmp1_ = g_dbus_proxy_call_finish (_tmp0_, p_res, &_inner_error0_);
#line 196 "indicator.vala"
		_tmp2_ = _tmp1_;
#line 196 "indicator.vala"
		_g_variant_unref0 (_tmp2_);
#line 196 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 905 "indicator.c"
			goto __catch0_g_error;
		}
#line 197 "indicator.vala"
		g_signal_emit (self, indicator_signals[INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL], 0);
#line 910 "indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 195 "indicator.vala"
		e = _inner_error0_;
#line 195 "indicator.vala"
		_inner_error0_ = NULL;
#line 199 "indicator.vala"
		_tmp3_ = e;
#line 199 "indicator.vala"
		_tmp4_ = _tmp3_->message;
#line 199 "indicator.vala"
		_tmp5_ = g_strconcat ("Failed to call " "RegisterStatusNotifierItem: ", _tmp4_, NULL);
#line 199 "indicator.vala"
		_tmp6_ = _tmp5_;
#line 199 "indicator.vala"
		g_warning ("indicator.vala:199: %s", _tmp6_);
#line 199 "indicator.vala"
		_g_free0 (_tmp6_);
#line 195 "indicator.vala"
		_g_error_free0 (e);
#line 938 "indicator.c"
	}
	__finally0:
#line 195 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 195 "indicator.vala"
		return;
#line 949 "indicator.c"
	}
}

static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 189 "indicator.vala"
	__lambda6_ ((Indicator*) self, source_object, res);
#line 189 "indicator.vala"
	g_object_unref (self);
#line 962 "indicator.c"
}

static void
indicator_bus_watcher_ready (Indicator* self,
                             GObject* obj,
                             GAsyncResult* res)
{
	gchar* name = NULL;
	GDBusProxy* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GDBusProxy* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 168 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 169 "indicator.vala"
	if (res != NULL) {
#line 984 "indicator.c"
		GDBusProxy* _tmp7_;
		{
			GDBusProxy* _tmp0_ = NULL;
			GDBusProxy* _tmp1_;
			GDBusProxy* _tmp2_;
#line 171 "indicator.vala"
			_tmp1_ = g_dbus_proxy_new_finish (res, &_inner_error0_);
#line 171 "indicator.vala"
			_tmp0_ = _tmp1_;
#line 171 "indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "indicator.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 998 "indicator.c"
					goto __catch0_g_io_error;
				}
#line 171 "indicator.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "indicator.vala"
				g_clear_error (&_inner_error0_);
#line 171 "indicator.vala"
				return;
#line 1007 "indicator.c"
			}
#line 171 "indicator.vala"
			_tmp2_ = _tmp0_;
#line 171 "indicator.vala"
			_tmp0_ = NULL;
#line 171 "indicator.vala"
			_g_object_unref0 (self->priv->m_proxy);
#line 171 "indicator.vala"
			self->priv->m_proxy = _tmp2_;
#line 170 "indicator.vala"
			_g_object_unref0 (_tmp0_);
#line 1019 "indicator.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 170 "indicator.vala"
			e = _inner_error0_;
#line 170 "indicator.vala"
			_inner_error0_ = NULL;
#line 173 "indicator.vala"
			_tmp3_ = e;
#line 173 "indicator.vala"
			_tmp4_ = _tmp3_->message;
#line 173 "indicator.vala"
			_tmp5_ = g_strconcat ("Failed to call dbus proxy: ", _tmp4_, NULL);
#line 173 "indicator.vala"
			_tmp6_ = _tmp5_;
#line 173 "indicator.vala"
			g_warning ("indicator.vala:173: %s", _tmp6_);
#line 173 "indicator.vala"
			_g_free0 (_tmp6_);
#line 174 "indicator.vala"
			_g_error_free0 (e);
#line 174 "indicator.vala"
			return;
#line 1049 "indicator.c"
		}
		__finally0:
#line 170 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "indicator.vala"
			g_clear_error (&_inner_error0_);
#line 170 "indicator.vala"
			return;
#line 1060 "indicator.c"
		}
#line 177 "indicator.vala"
		_tmp7_ = self->priv->m_proxy;
#line 177 "indicator.vala"
		g_signal_connect_object ((GObject*) _tmp7_, "notify::g-name-owner", (GCallback) ____lambda5__g_object_notify, self, 0);
#line 1066 "indicator.c"
	}
#line 184 "indicator.vala"
	_tmp8_ = self->priv->m_proxy;
#line 184 "indicator.vala"
	_tmp9_ = g_dbus_proxy_get_name_owner (_tmp8_);
#line 184 "indicator.vala"
	name = _tmp9_;
#line 186 "indicator.vala"
	_tmp10_ = name;
#line 186 "indicator.vala"
	if (_tmp10_ == NULL) {
#line 187 "indicator.vala"
		_g_free0 (name);
#line 187 "indicator.vala"
		return;
#line 1082 "indicator.c"
	}
#line 189 "indicator.vala"
	_tmp11_ = self->priv->m_proxy;
#line 189 "indicator.vala"
	_tmp12_ = ibus_service_get_object_path ((IBusService*) self);
#line 189 "indicator.vala"
	_tmp13_ = _tmp12_;
#line 189 "indicator.vala"
	_tmp14_ = g_variant_new ("(s)", _tmp13_, NULL);
#line 189 "indicator.vala"
	g_variant_ref_sink (_tmp14_);
#line 189 "indicator.vala"
	_tmp15_ = _tmp14_;
#line 189 "indicator.vala"
	g_dbus_proxy_call (_tmp11_, "RegisterStatusNotifierItem", _tmp15_, G_DBUS_CALL_FLAGS_NONE, -1, NULL, ___lambda6__gasync_ready_callback, g_object_ref (self));
#line 189 "indicator.vala"
	_g_variant_unref0 (_tmp15_);
#line 168 "indicator.vala"
	_g_free0 (name);
#line 1102 "indicator.c"
}

static void
_indicator_context_menu_cb (Indicator* self,
                            GDBusConnection* connection,
                            GVariant* parameters,
                            GDBusMethodInvocation* invocation)
{
	GVariant* var_x = NULL;
	GVariant* _tmp0_;
	GVariant* var_y = NULL;
	GVariant* _tmp1_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
#line 207 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 207 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 207 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 207 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 210 "indicator.vala"
	_tmp0_ = g_variant_get_child_value (parameters, (gsize) 0);
#line 210 "indicator.vala"
	var_x = _tmp0_;
#line 211 "indicator.vala"
	_tmp1_ = g_variant_get_child_value (parameters, (gsize) 1);
#line 211 "indicator.vala"
	var_y = _tmp1_;
#line 212 "indicator.vala"
	self->priv->m_context_menu_x = (gint) g_variant_get_int32 (var_x);
#line 213 "indicator.vala"
	self->priv->m_context_menu_y = (gint) g_variant_get_int32 (var_y);
#line 214 "indicator.vala"
	_tmp2_ = indicator_query_gdk_window (self);
#line 214 "indicator.vala"
	window = _tmp2_;
#line 215 "indicator.vala"
	g_signal_emit (self, indicator_signals[INDICATOR_CONTEXT_MENU_SIGNAL], 0, self->priv->m_context_menu_x, self->priv->m_context_menu_y, window, (guint) 2, (guint) 0);
#line 207 "indicator.vala"
	_g_object_unref0 (window);
#line 207 "indicator.vala"
	_g_variant_unref0 (var_y);
#line 207 "indicator.vala"
	_g_variant_unref0 (var_x);
#line 1149 "indicator.c"
}

static void
_indicator_activate_menu_cb (Indicator* self,
                             GDBusConnection* connection,
                             GVariant* parameters,
                             GDBusMethodInvocation* invocation)
{
	GVariant* var_x = NULL;
	GVariant* _tmp0_;
	GVariant* var_y = NULL;
	GVariant* _tmp1_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
#line 219 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 219 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 219 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 219 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 222 "indicator.vala"
	_tmp0_ = g_variant_get_child_value (parameters, (gsize) 0);
#line 222 "indicator.vala"
	var_x = _tmp0_;
#line 223 "indicator.vala"
	_tmp1_ = g_variant_get_child_value (parameters, (gsize) 1);
#line 223 "indicator.vala"
	var_y = _tmp1_;
#line 224 "indicator.vala"
	self->priv->m_activate_menu_x = (gint) g_variant_get_int32 (var_x);
#line 225 "indicator.vala"
	self->priv->m_activate_menu_y = (gint) g_variant_get_int32 (var_y);
#line 226 "indicator.vala"
	_tmp2_ = indicator_query_gdk_window (self);
#line 226 "indicator.vala"
	window = _tmp2_;
#line 227 "indicator.vala"
	g_signal_emit (self, indicator_signals[INDICATOR_ACTIVATE_SIGNAL], 0, self->priv->m_activate_menu_x, self->priv->m_activate_menu_y, window);
#line 219 "indicator.vala"
	_g_object_unref0 (window);
#line 219 "indicator.vala"
	_g_variant_unref0 (var_y);
#line 219 "indicator.vala"
	_g_variant_unref0 (var_x);
#line 1196 "indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 233 "indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 1204 "indicator.c"
}

static GdkWindow*
indicator_query_gdk_window (Indicator* self)
{
	GdkWindow* _tmp0_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	Display* xdisplay = NULL;
	GdkDisplay* _tmp5_;
	Display* _tmp6_;
	Window current = 0;
	Display* _tmp7_;
	Window parent = 0;
	Window child = 0;
	gint root_x = 0;
	gint root_y = 0;
	gint win_x = 0;
	gint win_y = 0;
	guint mask = 0U;
	gboolean retval = FALSE;
	Display* _tmp22_;
	GdkDisplay* _tmp23_;
	GdkX11Window* _tmp24_;
	GdkWindow* _tmp25_;
	GdkWindow* _tmp26_;
	GdkDisplay* _tmp29_;
	GdkX11Window* _tmp30_;
	GdkWindow* _tmp31_;
	GdkWindow* _tmp32_;
	GdkWindow* result;
#line 231 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "indicator.vala"
	_tmp0_ = self->priv->m_indicator_window;
#line 232 "indicator.vala"
	if (_tmp0_ != NULL) {
#line 1243 "indicator.c"
		GdkWindow* _tmp1_;
		GdkWindow* _tmp2_;
#line 233 "indicator.vala"
		_tmp1_ = self->priv->m_indicator_window;
#line 233 "indicator.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 233 "indicator.vala"
		result = _tmp2_;
#line 233 "indicator.vala"
		return result;
#line 1254 "indicator.c"
	}
#line 235 "indicator.vala"
	_tmp3_ = gdk_display_get_default ();
#line 235 "indicator.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 235 "indicator.vala"
	display = _tmp4_;
#line 236 "indicator.vala"
	_tmp5_ = display;
#line 236 "indicator.vala"
	_tmp6_ = gdk_x11_display_get_xdisplay (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp5_) : NULL);
#line 236 "indicator.vala"
	xdisplay = _tmp6_;
#line 238 "indicator.vala"
	_tmp7_ = xdisplay;
#line 238 "indicator.vala"
	current = DefaultRootWindow (_tmp7_);
#line 239 "indicator.vala"
	parent = (Window) 0;
#line 240 "indicator.vala"
	child = (Window) 0;
#line 242 "indicator.vala"
	mask = (guint) 0;
#line 243 "indicator.vala"
	win_y = 0;
#line 243 "indicator.vala"
	win_x = win_y;
#line 243 "indicator.vala"
	root_y = win_x;
#line 243 "indicator.vala"
	root_x = root_y;
#line 246 "indicator.vala"
	while (TRUE) {
#line 1288 "indicator.c"
		Display* _tmp8_;
		Window _tmp9_ = 0;
		Window _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		guint _tmp15_ = 0U;
		gboolean _tmp16_;
#line 246 "indicator.vala"
		_tmp8_ = xdisplay;
#line 246 "indicator.vala"
		_tmp16_ = XQueryPointer (_tmp8_, current, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 246 "indicator.vala"
		parent = _tmp9_;
#line 246 "indicator.vala"
		child = _tmp10_;
#line 246 "indicator.vala"
		root_x = _tmp11_;
#line 246 "indicator.vala"
		root_y = _tmp12_;
#line 246 "indicator.vala"
		win_x = _tmp13_;
#line 246 "indicator.vala"
		win_y = _tmp14_;
#line 246 "indicator.vala"
		mask = _tmp15_;
#line 246 "indicator.vala"
		retval = _tmp16_;
#line 246 "indicator.vala"
		if (!retval) {
#line 246 "indicator.vala"
			break;
#line 1322 "indicator.c"
		}
#line 251 "indicator.vala"
		if (child == ((Window) 0)) {
#line 252 "indicator.vala"
			break;
#line 1328 "indicator.c"
		}
#line 253 "indicator.vala"
		current = child;
#line 1332 "indicator.c"
	}
#line 255 "indicator.vala"
	if (!retval) {
#line 1336 "indicator.c"
		gchar* format = NULL;
		gchar* _tmp17_;
		gchar* message = NULL;
		const gchar* _tmp18_;
		Display* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
#line 256 "indicator.vala"
		_tmp17_ = g_strdup ("XQueryPointer is failed: current: %x root: %x " "child: %x (%d, %d), (%d, %d), %u");
#line 256 "indicator.vala"
		format = _tmp17_;
#line 259 "indicator.vala"
		_tmp18_ = format;
#line 259 "indicator.vala"
		_tmp19_ = xdisplay;
#line 259 "indicator.vala"
		_tmp20_ = g_strdup_printf (_tmp18_, (guint) current, (guint) DefaultRootWindow (_tmp19_), (guint) child, root_x, root_y, win_x, win_y, mask);
#line 259 "indicator.vala"
		message = _tmp20_;
#line 264 "indicator.vala"
		_tmp21_ = message;
#line 264 "indicator.vala"
		g_warning ("indicator.vala:264: XQueryPointer is failed: %s", _tmp21_);
#line 265 "indicator.vala"
		result = NULL;
#line 265 "indicator.vala"
		_g_free0 (message);
#line 265 "indicator.vala"
		_g_free0 (format);
#line 265 "indicator.vala"
		_g_object_unref0 (display);
#line 265 "indicator.vala"
		return result;
#line 1370 "indicator.c"
	}
#line 267 "indicator.vala"
	_tmp22_ = xdisplay;
#line 267 "indicator.vala"
	if (current == DefaultRootWindow (_tmp22_)) {
#line 268 "indicator.vala"
		g_warning ("indicator.vala:268: The query window is root window");
#line 1378 "indicator.c"
	}
#line 269 "indicator.vala"
	_tmp23_ = display;
#line 269 "indicator.vala"
	_tmp24_ = gdk_x11_window_lookup_for_display (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp23_) : NULL, current);
#line 269 "indicator.vala"
	_tmp25_ = _g_object_ref0 ((GdkWindow*) _tmp24_);
#line 269 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 269 "indicator.vala"
	self->priv->m_indicator_window = _tmp25_;
#line 272 "indicator.vala"
	_tmp26_ = self->priv->m_indicator_window;
#line 272 "indicator.vala"
	if (_tmp26_ != NULL) {
#line 1394 "indicator.c"
		GdkWindow* _tmp27_;
		GdkWindow* _tmp28_;
#line 273 "indicator.vala"
		_tmp27_ = self->priv->m_indicator_window;
#line 273 "indicator.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 273 "indicator.vala"
		result = _tmp28_;
#line 273 "indicator.vala"
		_g_object_unref0 (display);
#line 273 "indicator.vala"
		return result;
#line 1407 "indicator.c"
	}
#line 274 "indicator.vala"
	_tmp29_ = display;
#line 274 "indicator.vala"
	_tmp30_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp29_) : NULL, current);
#line 274 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 274 "indicator.vala"
	self->priv->m_indicator_window = (GdkWindow*) _tmp30_;
#line 277 "indicator.vala"
	_tmp31_ = self->priv->m_indicator_window;
#line 277 "indicator.vala"
	_tmp32_ = _g_object_ref0 (_tmp31_);
#line 277 "indicator.vala"
	result = _tmp32_;
#line 277 "indicator.vala"
	_g_object_unref0 (display);
#line 277 "indicator.vala"
	return result;
#line 1427 "indicator.c"
}

static GVariant*
_indicator_get_id (Indicator* self,
                   GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 281 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 282 "indicator.vala"
	_tmp0_ = self->priv->_id;
#line 282 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 282 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 282 "indicator.vala"
	result = _tmp1_;
#line 282 "indicator.vala"
	return result;
#line 1451 "indicator.c"
}

static GVariant*
_indicator_get_category (Indicator* self,
                         GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 286 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 286 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 287 "indicator.vala"
	_tmp0_ = self->priv->_category_s;
#line 287 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 287 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 287 "indicator.vala"
	result = _tmp1_;
#line 287 "indicator.vala"
	return result;
#line 1475 "indicator.c"
}

static GVariant*
_indicator_get_status (Indicator* self,
                       GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 291 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 292 "indicator.vala"
	_tmp0_ = self->priv->_status_s;
#line 292 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 292 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 292 "indicator.vala"
	result = _tmp1_;
#line 292 "indicator.vala"
	return result;
#line 1499 "indicator.c"
}

static GVariant*
_indicator_get_icon_name (Indicator* self,
                          GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 296 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 297 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 297 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 297 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 297 "indicator.vala"
	result = _tmp1_;
#line 297 "indicator.vala"
	return result;
#line 1523 "indicator.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 302 "indicator.vala"
	return self ? g_variant_ref (self) : NULL;
#line 1531 "indicator.c"
}

static GVariant*
_indicator_get_icon_vector (Indicator* self,
                            GDBusConnection* connection)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 301 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 302 "indicator.vala"
	_tmp0_ = self->priv->_icon_vector;
#line 302 "indicator.vala"
	_tmp1_ = _g_variant_ref0 (_tmp0_);
#line 302 "indicator.vala"
	result = _tmp1_;
#line 302 "indicator.vala"
	return result;
#line 1553 "indicator.c"
}

static GVariant*
_indicator_get_icon_desc (Indicator* self,
                          GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 306 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 306 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 307 "indicator.vala"
	_tmp0_ = self->priv->_icon_desc;
#line 307 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 307 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 307 "indicator.vala"
	result = _tmp1_;
#line 307 "indicator.vala"
	return result;
#line 1577 "indicator.c"
}

static GVariant*
_indicator_get_attention_icon_name (Indicator* self,
                                    GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 311 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 311 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 313 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_name;
#line 313 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 313 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 313 "indicator.vala"
	result = _tmp1_;
#line 313 "indicator.vala"
	return result;
#line 1601 "indicator.c"
}

static GVariant*
_indicator_get_attention_icon_desc (Indicator* self,
                                    GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 317 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 317 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 319 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_desc;
#line 319 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 319 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 319 "indicator.vala"
	result = _tmp1_;
#line 319 "indicator.vala"
	return result;
#line 1625 "indicator.c"
}

static GVariant*
_indicator_get_title (Indicator* self,
                      GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 323 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 324 "indicator.vala"
	_tmp0_ = self->priv->_title;
#line 324 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 324 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 324 "indicator.vala"
	result = _tmp1_;
#line 324 "indicator.vala"
	return result;
#line 1649 "indicator.c"
}

static GVariant*
_indicator_get_icon_theme_path (Indicator* self,
                                GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 328 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 328 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 329 "indicator.vala"
	_tmp0_ = self->priv->_icon_theme_path;
#line 329 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 329 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 329 "indicator.vala"
	result = _tmp1_;
#line 329 "indicator.vala"
	return result;
#line 1673 "indicator.c"
}

static GVariant*
_indicator_get_menu (Indicator* self,
                     GDBusConnection* connection)
{
	GVariant* result;
#line 333 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 334 "indicator.vala"
	result = NULL;
#line 334 "indicator.vala"
	return result;
#line 1689 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_label (Indicator* self,
                               GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 338 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 338 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 339 "indicator.vala"
	_tmp0_ = self->priv->_label_s;
#line 339 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 339 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 339 "indicator.vala"
	result = _tmp1_;
#line 339 "indicator.vala"
	return result;
#line 1713 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_label_guide (Indicator* self,
                                     GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 343 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 343 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 345 "indicator.vala"
	_tmp0_ = self->priv->_label_guide_s;
#line 345 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 345 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 345 "indicator.vala"
	result = _tmp1_;
#line 345 "indicator.vala"
	return result;
#line 1737 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_ordering_index (Indicator* self,
                                        GDBusConnection* connection)
{
	guint32 _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 349 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 351 "indicator.vala"
	_tmp0_ = self->priv->_ordering_index;
#line 351 "indicator.vala"
	_tmp1_ = g_variant_new_uint32 (_tmp0_);
#line 351 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 351 "indicator.vala"
	result = _tmp1_;
#line 351 "indicator.vala"
	return result;
#line 1761 "indicator.c"
}

static void
indicator_real_service_method_call (IBusService* base,
                                    GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* method_name,
                                    GVariant* parameters,
                                    GDBusMethodInvocation* invocation)
{
	Indicator * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 355 "indicator.vala"
	self = (Indicator*) base;
#line 355 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (sender != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (object_path != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (interface_name != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (method_name != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 355 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 364 "indicator.vala"
	_tmp0_ = ibus_service_get_object_path ((IBusService*) self);
#line 364 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 364 "indicator.vala"
	g_return_if_fail (g_strcmp0 (object_path, _tmp1_) == 0);
#line 365 "indicator.vala"
	g_return_if_fail (g_strcmp0 (interface_name, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE) == 0);
#line 367 "indicator.vala"
	if (g_strcmp0 (method_name, "Activate") == 0) {
#line 368 "indicator.vala"
		_indicator_activate_menu_cb (self, connection, parameters, invocation);
#line 369 "indicator.vala"
		return;
#line 1809 "indicator.c"
	}
#line 371 "indicator.vala"
	if (g_strcmp0 (method_name, "ContextMenu") == 0) {
#line 372 "indicator.vala"
		_indicator_context_menu_cb (self, connection, parameters, invocation);
#line 373 "indicator.vala"
		return;
#line 1817 "indicator.c"
	}
#line 376 "indicator.vala"
	_tmp2_ = g_strconcat ("service_method_call() does not handle the method: ", method_name, NULL);
#line 376 "indicator.vala"
	_tmp3_ = _tmp2_;
#line 376 "indicator.vala"
	g_warning ("indicator.vala:376: %s", _tmp3_);
#line 376 "indicator.vala"
	_g_free0 (_tmp3_);
#line 1827 "indicator.c"
}

static GVariant*
indicator_real_service_get_property (IBusService* base,
                                     GDBusConnection* connection,
                                     const gchar* sender,
                                     const gchar* object_path,
                                     const gchar* interface_name,
                                     const gchar* property_name,
                                     GError** error)
{
	Indicator * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GVariant* result;
#line 381 "indicator.vala"
	self = (Indicator*) base;
#line 381 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 381 "indicator.vala"
	g_return_val_if_fail (sender != NULL, NULL);
#line 381 "indicator.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 381 "indicator.vala"
	g_return_val_if_fail (interface_name != NULL, NULL);
#line 381 "indicator.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 387 "indicator.vala"
	_tmp0_ = ibus_service_get_object_path ((IBusService*) self);
#line 387 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 387 "indicator.vala"
	g_return_val_if_fail (g_strcmp0 (object_path, _tmp1_) == 0, NULL);
#line 388 "indicator.vala"
	g_return_val_if_fail (g_strcmp0 (interface_name, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE) == 0, NULL);
#line 392 "indicator.vala"
	if (g_strcmp0 (property_name, "Id") == 0) {
#line 1867 "indicator.c"
		GVariant* _tmp2_;
#line 393 "indicator.vala"
		_tmp2_ = _indicator_get_id (self, connection);
#line 393 "indicator.vala"
		result = _tmp2_;
#line 393 "indicator.vala"
		return result;
#line 1875 "indicator.c"
	}
#line 394 "indicator.vala"
	if (g_strcmp0 (property_name, "Category") == 0) {
#line 1879 "indicator.c"
		GVariant* _tmp3_;
#line 395 "indicator.vala"
		_tmp3_ = _indicator_get_category (self, connection);
#line 395 "indicator.vala"
		result = _tmp3_;
#line 395 "indicator.vala"
		return result;
#line 1887 "indicator.c"
	}
#line 396 "indicator.vala"
	if (g_strcmp0 (property_name, "Status") == 0) {
#line 1891 "indicator.c"
		GVariant* _tmp4_;
#line 397 "indicator.vala"
		_tmp4_ = _indicator_get_status (self, connection);
#line 397 "indicator.vala"
		result = _tmp4_;
#line 397 "indicator.vala"
		return result;
#line 1899 "indicator.c"
	}
#line 398 "indicator.vala"
	if (g_strcmp0 (property_name, "IconName") == 0) {
#line 1903 "indicator.c"
		GVariant* _tmp5_;
#line 399 "indicator.vala"
		_tmp5_ = _indicator_get_icon_name (self, connection);
#line 399 "indicator.vala"
		result = _tmp5_;
#line 399 "indicator.vala"
		return result;
#line 1911 "indicator.c"
	}
#line 400 "indicator.vala"
	if (g_strcmp0 (property_name, "IconPixmap") == 0) {
#line 1915 "indicator.c"
		GVariant* _tmp6_;
#line 401 "indicator.vala"
		_tmp6_ = _indicator_get_icon_vector (self, connection);
#line 401 "indicator.vala"
		result = _tmp6_;
#line 401 "indicator.vala"
		return result;
#line 1923 "indicator.c"
	}
#line 402 "indicator.vala"
	if (g_strcmp0 (property_name, "IconAccessibleDesc") == 0) {
#line 1927 "indicator.c"
		GVariant* _tmp7_;
#line 403 "indicator.vala"
		_tmp7_ = _indicator_get_icon_desc (self, connection);
#line 403 "indicator.vala"
		result = _tmp7_;
#line 403 "indicator.vala"
		return result;
#line 1935 "indicator.c"
	}
#line 404 "indicator.vala"
	if (g_strcmp0 (property_name, "AttentionIconName") == 0) {
#line 1939 "indicator.c"
		GVariant* _tmp8_;
#line 405 "indicator.vala"
		_tmp8_ = _indicator_get_attention_icon_name (self, connection);
#line 405 "indicator.vala"
		result = _tmp8_;
#line 405 "indicator.vala"
		return result;
#line 1947 "indicator.c"
	}
#line 406 "indicator.vala"
	if (g_strcmp0 (property_name, "AttentionAccessibleDesc") == 0) {
#line 1951 "indicator.c"
		GVariant* _tmp9_;
#line 407 "indicator.vala"
		_tmp9_ = _indicator_get_attention_icon_desc (self, connection);
#line 407 "indicator.vala"
		result = _tmp9_;
#line 407 "indicator.vala"
		return result;
#line 1959 "indicator.c"
	}
#line 408 "indicator.vala"
	if (g_strcmp0 (property_name, "Title") == 0) {
#line 1963 "indicator.c"
		GVariant* _tmp10_;
#line 409 "indicator.vala"
		_tmp10_ = _indicator_get_title (self, connection);
#line 409 "indicator.vala"
		result = _tmp10_;
#line 409 "indicator.vala"
		return result;
#line 1971 "indicator.c"
	}
#line 410 "indicator.vala"
	if (g_strcmp0 (property_name, "IconThemePath") == 0) {
#line 1975 "indicator.c"
		GVariant* _tmp11_;
#line 411 "indicator.vala"
		_tmp11_ = _indicator_get_icon_theme_path (self, connection);
#line 411 "indicator.vala"
		result = _tmp11_;
#line 411 "indicator.vala"
		return result;
#line 1983 "indicator.c"
	}
#line 412 "indicator.vala"
	if (g_strcmp0 (property_name, "Menu") == 0) {
#line 1987 "indicator.c"
		GVariant* _tmp12_;
#line 413 "indicator.vala"
		_tmp12_ = _indicator_get_menu (self, connection);
#line 413 "indicator.vala"
		result = _tmp12_;
#line 413 "indicator.vala"
		return result;
#line 1995 "indicator.c"
	}
#line 414 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaLabel") == 0) {
#line 1999 "indicator.c"
		GVariant* _tmp13_;
#line 415 "indicator.vala"
		_tmp13_ = _indicator_get_xayatana_label (self, connection);
#line 415 "indicator.vala"
		result = _tmp13_;
#line 415 "indicator.vala"
		return result;
#line 2007 "indicator.c"
	}
#line 416 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaLabelGuide") == 0) {
#line 2011 "indicator.c"
		GVariant* _tmp14_;
#line 417 "indicator.vala"
		_tmp14_ = _indicator_get_xayatana_label_guide (self, connection);
#line 417 "indicator.vala"
		result = _tmp14_;
#line 417 "indicator.vala"
		return result;
#line 2019 "indicator.c"
	}
#line 418 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaOrderingIndex") == 0) {
#line 2023 "indicator.c"
		GVariant* _tmp15_;
#line 419 "indicator.vala"
		_tmp15_ = _indicator_get_xayatana_ordering_index (self, connection);
#line 419 "indicator.vala"
		result = _tmp15_;
#line 419 "indicator.vala"
		return result;
#line 2031 "indicator.c"
	}
#line 421 "indicator.vala"
	_tmp16_ = g_strconcat ("service_get_property() does not handle the property: ", property_name, NULL);
#line 421 "indicator.vala"
	_tmp17_ = _tmp16_;
#line 421 "indicator.vala"
	g_warning ("indicator.vala:421: %s", _tmp17_);
#line 421 "indicator.vala"
	_g_free0 (_tmp17_);
#line 424 "indicator.vala"
	result = NULL;
#line 424 "indicator.vala"
	return result;
#line 2045 "indicator.c"
}

static gboolean
indicator_real_service_set_property (IBusService* base,
                                     GDBusConnection* connection,
                                     const gchar* sender,
                                     const gchar* object_path,
                                     const gchar* interface_name,
                                     const gchar* property_name,
                                     GVariant* value,
                                     GError** error)
{
	Indicator * self;
	gboolean result;
#line 428 "indicator.vala"
	self = (Indicator*) base;
#line 428 "indicator.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 428 "indicator.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 428 "indicator.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 428 "indicator.vala"
	g_return_val_if_fail (interface_name != NULL, FALSE);
#line 428 "indicator.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 428 "indicator.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 435 "indicator.vala"
	result = FALSE;
#line 435 "indicator.vala"
	return result;
#line 2078 "indicator.c"
}

void
indicator_set_status (Indicator* self,
                      IndicatorStatus status)
{
	gchar* status_s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GDBusConnection* _tmp4_;
	GDBusConnection* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 440 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 441 "indicator.vala"
	_tmp0_ = indicator_status_to_nick (status);
#line 441 "indicator.vala"
	status_s = _tmp0_;
#line 442 "indicator.vala"
	_tmp1_ = self->priv->_status_s;
#line 442 "indicator.vala"
	_tmp2_ = status_s;
#line 442 "indicator.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) == 0) {
#line 443 "indicator.vala"
		_g_free0 (status_s);
#line 443 "indicator.vala"
		return;
#line 2109 "indicator.c"
	}
#line 444 "indicator.vala"
	_tmp3_ = status_s;
#line 444 "indicator.vala"
	indicator_set_status_s (self, _tmp3_);
#line 451 "indicator.vala"
	_tmp4_ = ibus_service_get_connection ((IBusService*) self);
#line 451 "indicator.vala"
	_tmp5_ = _tmp4_;
#line 451 "indicator.vala"
	if (_tmp5_ == NULL) {
#line 452 "indicator.vala"
		_g_free0 (status_s);
#line 452 "indicator.vala"
		return;
#line 2125 "indicator.c"
	}
	{
		GDBusConnection* _tmp6_;
		GDBusConnection* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GVariant* _tmp11_;
		GVariant* _tmp12_;
#line 454 "indicator.vala"
		_tmp6_ = ibus_service_get_connection ((IBusService*) self);
#line 454 "indicator.vala"
		_tmp7_ = _tmp6_;
#line 454 "indicator.vala"
		_tmp8_ = ibus_service_get_object_path ((IBusService*) self);
#line 454 "indicator.vala"
		_tmp9_ = _tmp8_;
#line 454 "indicator.vala"
		_tmp10_ = status_s;
#line 454 "indicator.vala"
		_tmp11_ = g_variant_new ("(s)", _tmp10_, NULL);
#line 454 "indicator.vala"
		g_variant_ref_sink (_tmp11_);
#line 454 "indicator.vala"
		_tmp12_ = _tmp11_;
#line 454 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp7_, NULL, _tmp9_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewStatus", _tmp12_, &_inner_error0_);
#line 454 "indicator.vala"
		_g_variant_unref0 (_tmp12_);
#line 454 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2157 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 453 "indicator.vala"
		e = _inner_error0_;
#line 453 "indicator.vala"
		_inner_error0_ = NULL;
#line 460 "indicator.vala"
		_tmp13_ = e;
#line 460 "indicator.vala"
		_tmp14_ = _tmp13_->message;
#line 460 "indicator.vala"
		g_warning ("indicator.vala:460: Unable to send signal for NewIcon: %s", _tmp14_);
#line 453 "indicator.vala"
		_g_error_free0 (e);
#line 2179 "indicator.c"
	}
	__finally0:
#line 453 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 453 "indicator.vala"
		_g_free0 (status_s);
#line 453 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 453 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 453 "indicator.vala"
		return;
#line 2192 "indicator.c"
	}
#line 440 "indicator.vala"
	_g_free0 (status_s);
#line 2196 "indicator.c"
}

void
indicator_set_icon_full (Indicator* self,
                         const gchar* icon_name,
                         const gchar* icon_desc)
{
	gboolean changed = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GDBusConnection* _tmp2_;
	GDBusConnection* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 466 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 466 "indicator.vala"
	g_return_if_fail (icon_name != NULL);
#line 467 "indicator.vala"
	changed = FALSE;
#line 468 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 468 "indicator.vala"
	if (g_strcmp0 (_tmp0_, icon_name) != 0) {
#line 469 "indicator.vala"
		indicator_set_icon_name (self, icon_name);
#line 470 "indicator.vala"
		indicator_set_icon_vector (self, NULL);
#line 471 "indicator.vala"
		changed = TRUE;
#line 2226 "indicator.c"
	}
#line 473 "indicator.vala"
	_tmp1_ = self->priv->_icon_desc;
#line 473 "indicator.vala"
	if (g_strcmp0 (_tmp1_, icon_desc) != 0) {
#line 474 "indicator.vala"
		indicator_set_icon_desc (self, icon_desc);
#line 475 "indicator.vala"
		changed = TRUE;
#line 2236 "indicator.c"
	}
#line 477 "indicator.vala"
	if (!changed) {
#line 478 "indicator.vala"
		return;
#line 2242 "indicator.c"
	}
#line 485 "indicator.vala"
	_tmp2_ = ibus_service_get_connection ((IBusService*) self);
#line 485 "indicator.vala"
	_tmp3_ = _tmp2_;
#line 485 "indicator.vala"
	if (_tmp3_ == NULL) {
#line 486 "indicator.vala"
		return;
#line 2252 "indicator.c"
	}
	{
		GDBusConnection* _tmp4_;
		GDBusConnection* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 488 "indicator.vala"
		_tmp4_ = ibus_service_get_connection ((IBusService*) self);
#line 488 "indicator.vala"
		_tmp5_ = _tmp4_;
#line 488 "indicator.vala"
		_tmp6_ = ibus_service_get_object_path ((IBusService*) self);
#line 488 "indicator.vala"
		_tmp7_ = _tmp6_;
#line 488 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp5_, NULL, _tmp7_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewIcon", NULL, &_inner_error0_);
#line 488 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2271 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 487 "indicator.vala"
		e = _inner_error0_;
#line 487 "indicator.vala"
		_inner_error0_ = NULL;
#line 494 "indicator.vala"
		_tmp8_ = e;
#line 494 "indicator.vala"
		_tmp9_ = _tmp8_->message;
#line 494 "indicator.vala"
		g_warning ("indicator.vala:494: Unable to send signal for NewIcon: %s", _tmp9_);
#line 487 "indicator.vala"
		_g_error_free0 (e);
#line 2293 "indicator.c"
	}
	__finally0:
#line 487 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 487 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 487 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 487 "indicator.vala"
		return;
#line 2304 "indicator.c"
	}
}

void
indicator_set_cairo_image_surface_full (Indicator* self,
                                        cairo_surface_t* image,
                                        const gchar* icon_desc)
{
	gint width = 0;
	gint height = 0;
	gint stride = 0;
	guint8* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	GBytes* bytes = NULL;
	guint8* _tmp1_;
	gint _tmp1__length1;
	GBytes* _tmp2_;
	GVariant* bs = NULL;
	const GVariantType* _tmp3_;
	GBytes* _tmp4_;
	GVariant* _tmp5_;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariantBuilder* _tmp8_;
	GVariantBuilder* _tmp9_;
	GVariantBuilder* _tmp10_;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariantBuilder* _tmp13_;
	GVariantBuilder* _tmp14_;
	GVariantBuilder* _tmp15_;
	GVariant* _tmp16_;
	GVariantBuilder* _tmp17_;
	GVariantBuilder* _tmp18_;
	GVariant* _tmp19_;
	GVariant* _tmp20_;
	const gchar* _tmp21_;
	GDBusConnection* _tmp22_;
	GDBusConnection* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 499 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 499 "indicator.vala"
	g_return_if_fail (image != NULL);
#line 501 "indicator.vala"
	width = cairo_image_surface_get_width (image);
#line 502 "indicator.vala"
	height = cairo_image_surface_get_height (image);
#line 503 "indicator.vala"
	stride = cairo_image_surface_get_stride (image);
#line 504 "indicator.vala"
	_tmp0_ = cairo_image_surface_get_data (image);
#line 504 "indicator.vala"
	data = (guint8*) _tmp0_;
#line 504 "indicator.vala"
	data_length1 = (-1 * sizeof (guchar)) / sizeof (guint8);
#line 504 "indicator.vala"
	_data_size_ = data_length1;
#line 505 "indicator.vala"
	data_length1 = stride * height;
#line 506 "indicator.vala"
	_tmp1_ = data;
#line 506 "indicator.vala"
	_tmp1__length1 = data_length1;
#line 506 "indicator.vala"
	_tmp2_ = g_bytes_new (_tmp1_, _tmp1__length1);
#line 506 "indicator.vala"
	bytes = _tmp2_;
#line 507 "indicator.vala"
	_tmp3_ = G_VARIANT_TYPE_BYTESTRING;
#line 507 "indicator.vala"
	_tmp4_ = bytes;
#line 507 "indicator.vala"
	_tmp5_ = g_variant_new_from_bytes (_tmp3_, _tmp4_, TRUE);
#line 507 "indicator.vala"
	g_variant_ref_sink (_tmp5_);
#line 507 "indicator.vala"
	bs = _tmp5_;
#line 511 "indicator.vala"
	_tmp6_ = g_variant_type_new ("a(iiay)");
#line 511 "indicator.vala"
	_tmp7_ = _tmp6_;
#line 511 "indicator.vala"
	_tmp8_ = g_variant_builder_new (_tmp7_);
#line 511 "indicator.vala"
	_tmp9_ = _tmp8_;
#line 511 "indicator.vala"
	_g_variant_type_free0 (_tmp7_);
#line 511 "indicator.vala"
	builder = _tmp9_;
#line 513 "indicator.vala"
	_tmp10_ = builder;
#line 513 "indicator.vala"
	_tmp11_ = g_variant_type_new ("(iiay)");
#line 513 "indicator.vala"
	_tmp12_ = _tmp11_;
#line 513 "indicator.vala"
	g_variant_builder_open (_tmp10_, _tmp12_);
#line 513 "indicator.vala"
	_g_variant_type_free0 (_tmp12_);
#line 514 "indicator.vala"
	_tmp13_ = builder;
#line 514 "indicator.vala"
	g_variant_builder_add (_tmp13_, "i", width, NULL);
#line 515 "indicator.vala"
	_tmp14_ = builder;
#line 515 "indicator.vala"
	g_variant_builder_add (_tmp14_, "i", height, NULL);
#line 516 "indicator.vala"
	_tmp15_ = builder;
#line 516 "indicator.vala"
	_tmp16_ = bs;
#line 516 "indicator.vala"
	g_variant_builder_add_value (_tmp15_, _tmp16_);
#line 517 "indicator.vala"
	_tmp17_ = builder;
#line 517 "indicator.vala"
	g_variant_builder_close (_tmp17_);
#line 518 "indicator.vala"
	_tmp18_ = builder;
#line 518 "indicator.vala"
	_tmp19_ = g_variant_new ("a(iiay)", _tmp18_, NULL);
#line 518 "indicator.vala"
	g_variant_ref_sink (_tmp19_);
#line 518 "indicator.vala"
	_tmp20_ = _tmp19_;
#line 518 "indicator.vala"
	indicator_set_icon_vector (self, _tmp20_);
#line 518 "indicator.vala"
	_g_variant_unref0 (_tmp20_);
#line 519 "indicator.vala"
	indicator_set_icon_name (self, "");
#line 521 "indicator.vala"
	_tmp21_ = self->priv->_icon_desc;
#line 521 "indicator.vala"
	if (g_strcmp0 (_tmp21_, icon_desc) != 0) {
#line 522 "indicator.vala"
		indicator_set_icon_desc (self, icon_desc);
#line 2446 "indicator.c"
	}
#line 529 "indicator.vala"
	_tmp22_ = ibus_service_get_connection ((IBusService*) self);
#line 529 "indicator.vala"
	_tmp23_ = _tmp22_;
#line 529 "indicator.vala"
	if (_tmp23_ == NULL) {
#line 530 "indicator.vala"
		_g_variant_builder_unref0 (builder);
#line 530 "indicator.vala"
		_g_variant_unref0 (bs);
#line 530 "indicator.vala"
		_g_bytes_unref0 (bytes);
#line 530 "indicator.vala"
		return;
#line 2462 "indicator.c"
	}
	{
		GDBusConnection* _tmp24_;
		GDBusConnection* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 532 "indicator.vala"
		_tmp24_ = ibus_service_get_connection ((IBusService*) self);
#line 532 "indicator.vala"
		_tmp25_ = _tmp24_;
#line 532 "indicator.vala"
		_tmp26_ = ibus_service_get_object_path ((IBusService*) self);
#line 532 "indicator.vala"
		_tmp27_ = _tmp26_;
#line 532 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp25_, NULL, _tmp27_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewIcon", NULL, &_inner_error0_);
#line 532 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2481 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 531 "indicator.vala"
		e = _inner_error0_;
#line 531 "indicator.vala"
		_inner_error0_ = NULL;
#line 538 "indicator.vala"
		_tmp28_ = e;
#line 538 "indicator.vala"
		_tmp29_ = _tmp28_->message;
#line 538 "indicator.vala"
		g_warning ("indicator.vala:538: Unable to send signal for NewIcon: %s", _tmp29_);
#line 531 "indicator.vala"
		_g_error_free0 (e);
#line 2503 "indicator.c"
	}
	__finally0:
#line 531 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 531 "indicator.vala"
		_g_variant_builder_unref0 (builder);
#line 531 "indicator.vala"
		_g_variant_unref0 (bs);
#line 531 "indicator.vala"
		_g_bytes_unref0 (bytes);
#line 531 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 531 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 531 "indicator.vala"
		return;
#line 2520 "indicator.c"
	}
#line 499 "indicator.vala"
	_g_variant_builder_unref0 (builder);
#line 499 "indicator.vala"
	_g_variant_unref0 (bs);
#line 499 "indicator.vala"
	_g_bytes_unref0 (bytes);
#line 2528 "indicator.c"
}

void
indicator_position_context_menu (Indicator* self,
                                 GtkMenu* menu,
                                 gint* x,
                                 gint* y,
                                 gboolean* push_in)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
#line 543 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 543 "indicator.vala"
	g_return_if_fail (menu != NULL);
#line 547 "indicator.vala"
	_vala_x = self->priv->m_context_menu_x;
#line 548 "indicator.vala"
	_vala_y = self->priv->m_context_menu_y;
#line 549 "indicator.vala"
	_vala_push_in = FALSE;
#line 543 "indicator.vala"
	if (x) {
#line 543 "indicator.vala"
		*x = _vala_x;
#line 2555 "indicator.c"
	}
#line 543 "indicator.vala"
	if (y) {
#line 543 "indicator.vala"
		*y = _vala_y;
#line 2561 "indicator.c"
	}
#line 543 "indicator.vala"
	if (push_in) {
#line 543 "indicator.vala"
		*push_in = _vala_push_in;
#line 2567 "indicator.c"
	}
}

void
indicator_position_activate_menu (Indicator* self,
                                  GtkMenu* menu,
                                  gint* x,
                                  gint* y,
                                  gboolean* push_in)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
#line 553 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 553 "indicator.vala"
	g_return_if_fail (menu != NULL);
#line 557 "indicator.vala"
	_vala_x = self->priv->m_activate_menu_x;
#line 558 "indicator.vala"
	_vala_y = self->priv->m_activate_menu_y;
#line 559 "indicator.vala"
	_vala_push_in = FALSE;
#line 553 "indicator.vala"
	if (x) {
#line 553 "indicator.vala"
		*x = _vala_x;
#line 2595 "indicator.c"
	}
#line 553 "indicator.vala"
	if (y) {
#line 553 "indicator.vala"
		*y = _vala_y;
#line 2601 "indicator.c"
	}
#line 553 "indicator.vala"
	if (push_in) {
#line 553 "indicator.vala"
		*push_in = _vala_push_in;
#line 2607 "indicator.c"
	}
}

/**
     * unregister_connection:
     *
     * "Destroy" dbus method is not called for the indicator's connection
     * when panel's connection is disconnected because the dbus connection
     * is a shared session bus so need to call
     * g_dbus_connection_unregister_object() by manual here
     * so that g_object_unref(m_panel) will be called later with an idle method,
     * which was assigned in the arguments of
     * g_dbus_connection_register_object()
     */
void
indicator_unregister_connection (Indicator* self)
{
	GDBusConnection* _tmp0_;
#line 574 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 575 "indicator.vala"
	_tmp0_ = ibus_service_get_connection ((IBusService*) self);
#line 575 "indicator.vala"
	ibus_service_unregister ((IBusService*) self, _tmp0_);
#line 2632 "indicator.c"
}

const gchar*
indicator_get_id (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "indicator.vala"
	_tmp0_ = self->priv->_id;
#line 34 "indicator.vala"
	result = _tmp0_;
#line 34 "indicator.vala"
	return result;
#line 2648 "indicator.c"
}

static void
indicator_set_id (Indicator* self,
                  const gchar* value)
{
	gchar* old_value;
#line 34 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 34 "indicator.vala"
	old_value = indicator_get_id (self);
#line 34 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2662 "indicator.c"
		gchar* _tmp0_;
#line 34 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 34 "indicator.vala"
		_g_free0 (self->priv->_id);
#line 34 "indicator.vala"
		self->priv->_id = _tmp0_;
#line 34 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ID_PROPERTY]);
#line 2672 "indicator.c"
	}
}

const gchar*
indicator_get_category_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "indicator.vala"
	_tmp0_ = self->priv->_category_s;
#line 35 "indicator.vala"
	result = _tmp0_;
#line 35 "indicator.vala"
	return result;
#line 2689 "indicator.c"
}

static void
indicator_set_category_s (Indicator* self,
                          const gchar* value)
{
	gchar* old_value;
#line 35 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 35 "indicator.vala"
	old_value = indicator_get_category_s (self);
#line 35 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2703 "indicator.c"
		gchar* _tmp0_;
#line 35 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 35 "indicator.vala"
		_g_free0 (self->priv->_category_s);
#line 35 "indicator.vala"
		self->priv->_category_s = _tmp0_;
#line 35 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_CATEGORY_S_PROPERTY]);
#line 2713 "indicator.c"
	}
}

const gchar*
indicator_get_status_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "indicator.vala"
	_tmp0_ = self->priv->_status_s;
#line 36 "indicator.vala"
	result = _tmp0_;
#line 36 "indicator.vala"
	return result;
#line 2730 "indicator.c"
}

void
indicator_set_status_s (Indicator* self,
                        const gchar* value)
{
	gchar* old_value;
#line 36 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 36 "indicator.vala"
	old_value = indicator_get_status_s (self);
#line 36 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2744 "indicator.c"
		gchar* _tmp0_;
#line 36 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 36 "indicator.vala"
		_g_free0 (self->priv->_status_s);
#line 36 "indicator.vala"
		self->priv->_status_s = _tmp0_;
#line 36 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_STATUS_S_PROPERTY]);
#line 2754 "indicator.c"
	}
}

const gchar*
indicator_get_icon_name (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 37 "indicator.vala"
	result = _tmp0_;
#line 37 "indicator.vala"
	return result;
#line 2771 "indicator.c"
}

void
indicator_set_icon_name (Indicator* self,
                         const gchar* value)
{
	gchar* old_value;
#line 37 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 37 "indicator.vala"
	old_value = indicator_get_icon_name (self);
#line 37 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2785 "indicator.c"
		gchar* _tmp0_;
#line 37 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 37 "indicator.vala"
		_g_free0 (self->priv->_icon_name);
#line 37 "indicator.vala"
		self->priv->_icon_name = _tmp0_;
#line 37 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_NAME_PROPERTY]);
#line 2795 "indicator.c"
	}
}

const gchar*
indicator_get_icon_desc (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "indicator.vala"
	_tmp0_ = self->priv->_icon_desc;
#line 38 "indicator.vala"
	result = _tmp0_;
#line 38 "indicator.vala"
	return result;
#line 2812 "indicator.c"
}

void
indicator_set_icon_desc (Indicator* self,
                         const gchar* value)
{
	gchar* old_value;
#line 38 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 38 "indicator.vala"
	old_value = indicator_get_icon_desc (self);
#line 38 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2826 "indicator.c"
		gchar* _tmp0_;
#line 38 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 38 "indicator.vala"
		_g_free0 (self->priv->_icon_desc);
#line 38 "indicator.vala"
		self->priv->_icon_desc = _tmp0_;
#line 38 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_DESC_PROPERTY]);
#line 2836 "indicator.c"
	}
}

const gchar*
indicator_get_attention_icon_name (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_name;
#line 39 "indicator.vala"
	result = _tmp0_;
#line 39 "indicator.vala"
	return result;
#line 2853 "indicator.c"
}

void
indicator_set_attention_icon_name (Indicator* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 39 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 39 "indicator.vala"
	old_value = indicator_get_attention_icon_name (self);
#line 39 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2867 "indicator.c"
		gchar* _tmp0_;
#line 39 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 39 "indicator.vala"
		_g_free0 (self->priv->_attention_icon_name);
#line 39 "indicator.vala"
		self->priv->_attention_icon_name = _tmp0_;
#line 39 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ATTENTION_ICON_NAME_PROPERTY]);
#line 2877 "indicator.c"
	}
}

const gchar*
indicator_get_attention_icon_desc (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_desc;
#line 40 "indicator.vala"
	result = _tmp0_;
#line 40 "indicator.vala"
	return result;
#line 2894 "indicator.c"
}

void
indicator_set_attention_icon_desc (Indicator* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 40 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 40 "indicator.vala"
	old_value = indicator_get_attention_icon_desc (self);
#line 40 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2908 "indicator.c"
		gchar* _tmp0_;
#line 40 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 40 "indicator.vala"
		_g_free0 (self->priv->_attention_icon_desc);
#line 40 "indicator.vala"
		self->priv->_attention_icon_desc = _tmp0_;
#line 40 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ATTENTION_ICON_DESC_PROPERTY]);
#line 2918 "indicator.c"
	}
}

const gchar*
indicator_get_title (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "indicator.vala"
	_tmp0_ = self->priv->_title;
#line 41 "indicator.vala"
	result = _tmp0_;
#line 41 "indicator.vala"
	return result;
#line 2935 "indicator.c"
}

void
indicator_set_title (Indicator* self,
                     const gchar* value)
{
	gchar* old_value;
#line 41 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 41 "indicator.vala"
	old_value = indicator_get_title (self);
#line 41 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2949 "indicator.c"
		gchar* _tmp0_;
#line 41 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 41 "indicator.vala"
		_g_free0 (self->priv->_title);
#line 41 "indicator.vala"
		self->priv->_title = _tmp0_;
#line 41 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_TITLE_PROPERTY]);
#line 2959 "indicator.c"
	}
}

const gchar*
indicator_get_icon_theme_path (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "indicator.vala"
	_tmp0_ = self->priv->_icon_theme_path;
#line 42 "indicator.vala"
	result = _tmp0_;
#line 42 "indicator.vala"
	return result;
#line 2976 "indicator.c"
}

void
indicator_set_icon_theme_path (Indicator* self,
                               const gchar* value)
{
	gchar* old_value;
#line 42 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 42 "indicator.vala"
	old_value = indicator_get_icon_theme_path (self);
#line 42 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2990 "indicator.c"
		gchar* _tmp0_;
#line 42 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 42 "indicator.vala"
		_g_free0 (self->priv->_icon_theme_path);
#line 42 "indicator.vala"
		self->priv->_icon_theme_path = _tmp0_;
#line 42 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_THEME_PATH_PROPERTY]);
#line 3000 "indicator.c"
	}
}

gboolean
indicator_get_connected (Indicator* self)
{
	gboolean result;
#line 43 "indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "indicator.vala"
	result = self->priv->_connected;
#line 43 "indicator.vala"
	return result;
#line 3014 "indicator.c"
}

void
indicator_set_connected (Indicator* self,
                         gboolean value)
{
	gboolean old_value;
#line 43 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 43 "indicator.vala"
	old_value = indicator_get_connected (self);
#line 43 "indicator.vala"
	if (old_value != value) {
#line 43 "indicator.vala"
		self->priv->_connected = value;
#line 43 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_CONNECTED_PROPERTY]);
#line 3032 "indicator.c"
	}
}

const gchar*
indicator_get_label_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "indicator.vala"
	_tmp0_ = self->priv->_label_s;
#line 44 "indicator.vala"
	result = _tmp0_;
#line 44 "indicator.vala"
	return result;
#line 3049 "indicator.c"
}

void
indicator_set_label_s (Indicator* self,
                       const gchar* value)
{
	gchar* old_value;
#line 44 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 44 "indicator.vala"
	old_value = indicator_get_label_s (self);
#line 44 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3063 "indicator.c"
		gchar* _tmp0_;
#line 44 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 44 "indicator.vala"
		_g_free0 (self->priv->_label_s);
#line 44 "indicator.vala"
		self->priv->_label_s = _tmp0_;
#line 44 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_LABEL_S_PROPERTY]);
#line 3073 "indicator.c"
	}
}

const gchar*
indicator_get_label_guide_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "indicator.vala"
	_tmp0_ = self->priv->_label_guide_s;
#line 45 "indicator.vala"
	result = _tmp0_;
#line 45 "indicator.vala"
	return result;
#line 3090 "indicator.c"
}

void
indicator_set_label_guide_s (Indicator* self,
                             const gchar* value)
{
	gchar* old_value;
#line 45 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 45 "indicator.vala"
	old_value = indicator_get_label_guide_s (self);
#line 45 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3104 "indicator.c"
		gchar* _tmp0_;
#line 45 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 45 "indicator.vala"
		_g_free0 (self->priv->_label_guide_s);
#line 45 "indicator.vala"
		self->priv->_label_guide_s = _tmp0_;
#line 45 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_LABEL_GUIDE_S_PROPERTY]);
#line 3114 "indicator.c"
	}
}

guint32
indicator_get_ordering_index (Indicator* self)
{
	guint32 result;
#line 46 "indicator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "indicator.vala"
	result = self->priv->_ordering_index;
#line 46 "indicator.vala"
	return result;
#line 3128 "indicator.c"
}

void
indicator_set_ordering_index (Indicator* self,
                              guint32 value)
{
	guint32 old_value;
#line 46 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 46 "indicator.vala"
	old_value = indicator_get_ordering_index (self);
#line 46 "indicator.vala"
	if (old_value != value) {
#line 46 "indicator.vala"
		self->priv->_ordering_index = value;
#line 46 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ORDERING_INDEX_PROPERTY]);
#line 3146 "indicator.c"
	}
}

GVariant*
indicator_get_icon_vector (Indicator* self)
{
	GVariant* result;
	GVariant* _tmp0_;
#line 47 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "indicator.vala"
	_tmp0_ = self->priv->_icon_vector;
#line 47 "indicator.vala"
	result = _tmp0_;
#line 47 "indicator.vala"
	return result;
#line 3163 "indicator.c"
}

void
indicator_set_icon_vector (Indicator* self,
                           GVariant* value)
{
	GVariant* old_value;
#line 47 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 47 "indicator.vala"
	old_value = indicator_get_icon_vector (self);
#line 47 "indicator.vala"
	if (old_value != value) {
#line 3177 "indicator.c"
		GVariant* _tmp0_;
#line 47 "indicator.vala"
		_tmp0_ = _g_variant_ref0 (value);
#line 47 "indicator.vala"
		_g_variant_unref0 (self->priv->_icon_vector);
#line 47 "indicator.vala"
		self->priv->_icon_vector = _tmp0_;
#line 47 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_VECTOR_PROPERTY]);
#line 3187 "indicator.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT) (gpointer data1, gint arg_1, gint arg_2, gpointer arg_3, guint arg_4, guint arg_5, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "indicator.vala"
	g_return_if_fail (n_param_values == 6);
#line 32 "indicator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "indicator.vala"
		data1 = closure->data;
#line 32 "indicator.vala"
		data2 = param_values->data[0].v_pointer;
#line 3213 "indicator.c"
	} else {
#line 32 "indicator.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "indicator.vala"
		data2 = closure->data;
#line 3219 "indicator.c"
	}
#line 32 "indicator.vala"
	callback = (GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 32 "indicator.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_object (param_values + 3), g_value_get_uint (param_values + 4), g_value_get_uint (param_values + 5), data2);
#line 3225 "indicator.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_OBJECT) (gpointer data1, gint arg_1, gint arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "indicator.vala"
	g_return_if_fail (n_param_values == 4);
#line 32 "indicator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "indicator.vala"
		data1 = closure->data;
#line 32 "indicator.vala"
		data2 = param_values->data[0].v_pointer;
#line 3250 "indicator.c"
	} else {
#line 32 "indicator.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "indicator.vala"
		data2 = closure->data;
#line 3256 "indicator.c"
	}
#line 32 "indicator.vala"
	callback = (GMarshalFunc_VOID__INT_INT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 32 "indicator.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 3262 "indicator.c"
}

static void
indicator_class_init (IndicatorClass * klass,
                      gpointer klass_data)
{
#line 32 "indicator.vala"
	indicator_parent_class = g_type_class_peek_parent (klass);
#line 32 "indicator.vala"
	g_type_class_adjust_private_offset (klass, &Indicator_private_offset);
#line 32 "indicator.vala"
	((IBusServiceClass *) klass)->service_method_call = (void (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GVariant*, GDBusMethodInvocation*)) indicator_real_service_method_call;
#line 32 "indicator.vala"
	((IBusServiceClass *) klass)->service_get_property = (GVariant* (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GError**)) indicator_real_service_get_property;
#line 32 "indicator.vala"
	((IBusServiceClass *) klass)->service_set_property = (gboolean (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GVariant*, GError**)) indicator_real_service_set_property;
#line 32 "indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_indicator_get_property;
#line 32 "indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_indicator_set_property;
#line 32 "indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = indicator_finalize;
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ID_PROPERTY, indicator_properties[INDICATOR_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_CATEGORY_S_PROPERTY, indicator_properties[INDICATOR_CATEGORY_S_PROPERTY] = g_param_spec_string ("category-s", "category-s", "category-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_STATUS_S_PROPERTY, indicator_properties[INDICATOR_STATUS_S_PROPERTY] = g_param_spec_string ("status-s", "status-s", "status-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_NAME_PROPERTY, indicator_properties[INDICATOR_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_DESC_PROPERTY, indicator_properties[INDICATOR_ICON_DESC_PROPERTY] = g_param_spec_string ("icon-desc", "icon-desc", "icon-desc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ATTENTION_ICON_NAME_PROPERTY, indicator_properties[INDICATOR_ATTENTION_ICON_NAME_PROPERTY] = g_param_spec_string ("attention-icon-name", "attention-icon-name", "attention-icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ATTENTION_ICON_DESC_PROPERTY, indicator_properties[INDICATOR_ATTENTION_ICON_DESC_PROPERTY] = g_param_spec_string ("attention-icon-desc", "attention-icon-desc", "attention-icon-desc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_TITLE_PROPERTY, indicator_properties[INDICATOR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_THEME_PATH_PROPERTY, indicator_properties[INDICATOR_ICON_THEME_PATH_PROPERTY] = g_param_spec_string ("icon-theme-path", "icon-theme-path", "icon-theme-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_CONNECTED_PROPERTY, indicator_properties[INDICATOR_CONNECTED_PROPERTY] = g_param_spec_boolean ("connected", "connected", "connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_LABEL_S_PROPERTY, indicator_properties[INDICATOR_LABEL_S_PROPERTY] = g_param_spec_string ("label-s", "label-s", "label-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_LABEL_GUIDE_S_PROPERTY, indicator_properties[INDICATOR_LABEL_GUIDE_S_PROPERTY] = g_param_spec_string ("label-guide-s", "label-guide-s", "label-guide-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ORDERING_INDEX_PROPERTY, indicator_properties[INDICATOR_ORDERING_INDEX_PROPERTY] = g_param_spec_uint ("ordering-index", "ordering-index", "ordering-index", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_VECTOR_PROPERTY, indicator_properties[INDICATOR_ICON_VECTOR_PROPERTY] = g_param_spec_variant ("icon-vector", "icon-vector", "icon-vector", G_VARIANT_TYPE_ANY, NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "indicator.vala"
	indicator_signals[INDICATOR_CONTEXT_MENU_SIGNAL] = g_signal_new ("context-menu", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT, G_TYPE_NONE, 5, G_TYPE_INT, G_TYPE_INT, gdk_window_get_type (), G_TYPE_UINT, G_TYPE_UINT);
#line 32 "indicator.vala"
	indicator_signals[INDICATOR_ACTIVATE_SIGNAL] = g_signal_new ("activate", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_OBJECT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_INT, gdk_window_get_type ());
#line 32 "indicator.vala"
	indicator_signals[INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL] = g_signal_new ("registered-status-notifier-item", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3319 "indicator.c"
}

static void
indicator_instance_init (Indicator * self,
                         gpointer klass)
{
#line 32 "indicator.vala"
	self->priv = indicator_get_instance_private (self);
#line 3328 "indicator.c"
}

static void
indicator_finalize (GObject * obj)
{
	Indicator * self;
#line 32 "indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INDICATOR, Indicator);
#line 34 "indicator.vala"
	_g_free0 (self->priv->_id);
#line 35 "indicator.vala"
	_g_free0 (self->priv->_category_s);
#line 36 "indicator.vala"
	_g_free0 (self->priv->_status_s);
#line 37 "indicator.vala"
	_g_free0 (self->priv->_icon_name);
#line 38 "indicator.vala"
	_g_free0 (self->priv->_icon_desc);
#line 39 "indicator.vala"
	_g_free0 (self->priv->_attention_icon_name);
#line 40 "indicator.vala"
	_g_free0 (self->priv->_attention_icon_desc);
#line 41 "indicator.vala"
	_g_free0 (self->priv->_title);
#line 42 "indicator.vala"
	_g_free0 (self->priv->_icon_theme_path);
#line 44 "indicator.vala"
	_g_free0 (self->priv->_label_s);
#line 45 "indicator.vala"
	_g_free0 (self->priv->_label_guide_s);
#line 47 "indicator.vala"
	_g_variant_unref0 (self->priv->_icon_vector);
#line 93 "indicator.vala"
	_g_dbus_node_info_unref0 (self->priv->m_watcher_node_info);
#line 95 "indicator.vala"
	_g_object_unref0 (self->priv->m_proxy);
#line 100 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 32 "indicator.vala"
	G_OBJECT_CLASS (indicator_parent_class)->finalize (obj);
#line 3369 "indicator.c"
}

static GType
indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Indicator), 0, (GInstanceInitFunc) indicator_instance_init, NULL };
	GType indicator_type_id;
	indicator_type_id = g_type_register_static (ibus_service_get_type (), "Indicator", &g_define_type_info, 0);
	Indicator_private_offset = g_type_add_instance_private (indicator_type_id, sizeof (IndicatorPrivate));
	return indicator_type_id;
}

GType
indicator_get_type (void)
{
	static volatile gsize indicator_type_id__once = 0;
	if (g_once_init_enter (&indicator_type_id__once)) {
		GType indicator_type_id;
		indicator_type_id = indicator_get_type_once ();
		g_once_init_leave (&indicator_type_id__once, indicator_type_id);
	}
	return indicator_type_id__once;
}

static void
_vala_indicator_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Indicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR, Indicator);
#line 32 "indicator.vala"
	switch (property_id) {
#line 32 "indicator.vala"
		case INDICATOR_ID_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_id (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_CATEGORY_S_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_category_s (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_STATUS_S_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_status_s (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_NAME_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_name (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_DESC_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_desc (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_NAME_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_attention_icon_name (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_DESC_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_attention_icon_desc (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_TITLE_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_title (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_THEME_PATH_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_theme_path (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_CONNECTED_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_boolean (value, indicator_get_connected (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_LABEL_S_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_label_s (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_LABEL_GUIDE_S_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_string (value, indicator_get_label_guide_s (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ORDERING_INDEX_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_uint (value, indicator_get_ordering_index (self));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_VECTOR_PROPERTY:
#line 32 "indicator.vala"
		g_value_set_variant (value, indicator_get_icon_vector (self));
#line 32 "indicator.vala"
		break;
#line 3488 "indicator.c"
		default:
#line 32 "indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "indicator.vala"
		break;
#line 3494 "indicator.c"
	}
}

static void
_vala_indicator_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Indicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR, Indicator);
#line 32 "indicator.vala"
	switch (property_id) {
#line 32 "indicator.vala"
		case INDICATOR_ID_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_id (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_CATEGORY_S_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_category_s (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_STATUS_S_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_status_s (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_NAME_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_icon_name (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_DESC_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_icon_desc (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_NAME_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_attention_icon_name (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_DESC_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_attention_icon_desc (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_TITLE_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_title (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_THEME_PATH_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_icon_theme_path (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_CONNECTED_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_connected (self, g_value_get_boolean (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_LABEL_S_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_label_s (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_LABEL_GUIDE_S_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_label_guide_s (self, g_value_get_string (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ORDERING_INDEX_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_ordering_index (self, g_value_get_uint (value));
#line 32 "indicator.vala"
		break;
#line 32 "indicator.vala"
		case INDICATOR_ICON_VECTOR_PROPERTY:
#line 32 "indicator.vala"
		indicator_set_icon_vector (self, g_value_get_variant (value));
#line 32 "indicator.vala"
		break;
#line 3592 "indicator.c"
		default:
#line 32 "indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "indicator.vala"
		break;
#line 3598 "indicator.c"
	}
}

