/* xkblayout.c generated by valac 0.56.7, the Vala compiler
 * generated from xkblayout.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2014 Red Hat, Inc.
 * Copyright(c) 2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2014 Takao Fujiwara <tfujiwar@redhat.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <ibus.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define XKB_LAYOUT_XKB_COMMAND "setxkbmap"
#define XKB_LAYOUT_XKB_QUERY_ARG "-query"
#define XKB_LAYOUT_XKB_LAYOUT_ARG "-layout"
#define XKB_LAYOUT_XMODMAP_COMMAND "xmodmap"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;
typedef struct _XKBLayoutPrivate XKBLayoutPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecXKBLayout ParamSpecXKBLayout;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _XKBLayout {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XKBLayoutPrivate * priv;
};

struct _XKBLayoutClass {
	GTypeClass parent_class;
	void (*finalize) (XKBLayout *self);
};

struct _XKBLayoutPrivate {
	gchar** m_xkb_latin_layouts;
	gint m_xkb_latin_layouts_length1;
	gint _m_xkb_latin_layouts_size_;
	gchar* m_default_layout;
	gchar* m_default_variant;
	gchar* m_default_option;
	gboolean m_use_xmodmap;
};

struct _ParamSpecXKBLayout {
	GParamSpec parent_instance;
};

static gint XKBLayout_private_offset;
static gpointer xkb_layout_parent_class = NULL;

VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
VALA_EXTERN void xkb_layout_get_layout (gchar** layout,
                            gchar** variant,
                            gchar** option);
static void _vala_array_add26 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add27 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add28 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add29 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add30 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add31 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add32 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add33 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add34 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add35 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_run_xmodmap (XKBLayout* self);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
static void xkb_layout_finalize (XKBLayout * obj);
static GType xkb_layout_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const gchar* XKB_LAYOUT_XMODMAP_KNOWN_FILES[4] = {".xmodmap", ".xmodmaprc", ".Xmodmap", ".Xmodmaprc"};

static inline gpointer
xkb_layout_get_instance_private (XKBLayout* self)
{
	return G_STRUCT_MEMBER_P (self, XKBLayout_private_offset);
}

XKBLayout*
xkb_layout_construct (GType object_type)
{
	XKBLayout* self = NULL;
#line 39 "xkblayout.vala"
	self = (XKBLayout*) g_type_create_instance (object_type);
#line 39 "xkblayout.vala"
	return self;
#line 196 "xkblayout.c"
}

XKBLayout*
xkb_layout_new (void)
{
#line 39 "xkblayout.vala"
	return xkb_layout_construct (TYPE_XKB_LAYOUT);
#line 204 "xkblayout.c"
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 43 "xkblayout.vala"
	if (length >= 0) {
#line 213 "xkblayout.c"
		gchar** result;
		gssize i;
#line 43 "xkblayout.vala"
		result = g_new0 (gchar*, length + 1);
#line 43 "xkblayout.vala"
		for (i = 0; i < length; i++) {
#line 220 "xkblayout.c"
			gchar* _tmp0_;
#line 43 "xkblayout.vala"
			_tmp0_ = g_strdup (self[i]);
#line 43 "xkblayout.vala"
			result[i] = _tmp0_;
#line 226 "xkblayout.c"
		}
#line 43 "xkblayout.vala"
		return result;
#line 230 "xkblayout.c"
	}
#line 43 "xkblayout.vala"
	return NULL;
#line 234 "xkblayout.c"
}

void
xkb_layout_set_latin_layouts (XKBLayout* self,
                              gchar** xkb_latin_layouts,
                              gint xkb_latin_layouts_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 42 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 43 "xkblayout.vala"
	_tmp0_ = (xkb_latin_layouts != NULL) ? _vala_array_dup6 (xkb_latin_layouts, xkb_latin_layouts_length1) : xkb_latin_layouts;
#line 43 "xkblayout.vala"
	_tmp0__length1 = xkb_latin_layouts_length1;
#line 43 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = (_vala_array_free (self->priv->m_xkb_latin_layouts, self->priv->m_xkb_latin_layouts_length1, (GDestroyNotify) g_free), NULL);
#line 43 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = _tmp0_;
#line 43 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts_length1 = _tmp0__length1;
#line 43 "xkblayout.vala"
	self->priv->_m_xkb_latin_layouts_size_ = self->priv->m_xkb_latin_layouts_length1;
#line 258 "xkblayout.c"
}

static void
_vala_array_add26 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 50 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 50 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 50 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 273 "xkblayout.c"
	}
#line 50 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 50 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 279 "xkblayout.c"
}

static void
_vala_array_add27 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 51 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 51 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 51 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 294 "xkblayout.c"
	}
#line 51 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 51 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 300 "xkblayout.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 327 "xkblayout.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 333 "xkblayout.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 339 "xkblayout.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 343 "xkblayout.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 351 "xkblayout.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 355 "xkblayout.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 367 "xkblayout.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 388 "xkblayout.c"
}

void
xkb_layout_get_layout (gchar** layout,
                       gchar** variant,
                       gchar** option)
{
	gchar* _vala_layout = NULL;
	gchar* _vala_variant = NULL;
	gchar* _vala_option = NULL;
	gchar** exec_command = NULL;
	gchar** _tmp0_;
	gint exec_command_length1;
	gint _exec_command_size_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* standard_output = NULL;
	gchar* standard_error = NULL;
	gint exit_status = 0;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	GError* _inner_error0_ = NULL;
#line 49 "xkblayout.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 49 "xkblayout.vala"
	exec_command = _tmp0_;
#line 49 "xkblayout.vala"
	exec_command_length1 = 0;
#line 49 "xkblayout.vala"
	_exec_command_size_ = exec_command_length1;
#line 50 "xkblayout.vala"
	_tmp1_ = g_strdup (XKB_LAYOUT_XKB_COMMAND);
#line 50 "xkblayout.vala"
	_vala_array_add26 (&exec_command, &exec_command_length1, &_exec_command_size_, _tmp1_);
#line 51 "xkblayout.vala"
	_tmp2_ = g_strdup (XKB_LAYOUT_XKB_QUERY_ARG);
#line 51 "xkblayout.vala"
	_vala_array_add27 (&exec_command, &exec_command_length1, &_exec_command_size_, _tmp2_);
#line 52 "xkblayout.vala"
	standard_output = NULL;
#line 53 "xkblayout.vala"
	standard_error = NULL;
#line 54 "xkblayout.vala"
	exit_status = 0;
#line 56 "xkblayout.vala"
	_tmp3_ = g_strdup ("");
#line 56 "xkblayout.vala"
	_g_free0 (_vala_layout);
#line 56 "xkblayout.vala"
	_vala_layout = _tmp3_;
#line 57 "xkblayout.vala"
	_tmp4_ = g_strdup ("");
#line 57 "xkblayout.vala"
	_g_free0 (_vala_variant);
#line 57 "xkblayout.vala"
	_vala_variant = _tmp4_;
#line 58 "xkblayout.vala"
	_tmp5_ = g_strdup ("");
#line 58 "xkblayout.vala"
	_g_free0 (_vala_option);
#line 58 "xkblayout.vala"
	_vala_option = _tmp5_;
#line 456 "xkblayout.c"
	{
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gint _tmp9_ = 0;
#line 61 "xkblayout.vala"
		_tmp6_ = exec_command;
#line 61 "xkblayout.vala"
		_tmp6__length1 = exec_command_length1;
#line 61 "xkblayout.vala"
		g_spawn_sync (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, &_tmp8_, &_tmp9_, &_inner_error0_);
#line 61 "xkblayout.vala"
		_g_free0 (standard_output);
#line 61 "xkblayout.vala"
		standard_output = _tmp7_;
#line 61 "xkblayout.vala"
		_g_free0 (standard_error);
#line 61 "xkblayout.vala"
		standard_error = _tmp8_;
#line 61 "xkblayout.vala"
		exit_status = _tmp9_;
#line 61 "xkblayout.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "xkblayout.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 483 "xkblayout.c"
				goto __catch0_g_spawn_error;
			}
#line 61 "xkblayout.vala"
			_g_free0 (standard_error);
#line 61 "xkblayout.vala"
			_g_free0 (standard_output);
#line 61 "xkblayout.vala"
			exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 61 "xkblayout.vala"
			_g_free0 (_vala_layout);
#line 61 "xkblayout.vala"
			_g_free0 (_vala_variant);
#line 61 "xkblayout.vala"
			_g_free0 (_vala_option);
#line 61 "xkblayout.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "xkblayout.vala"
			g_clear_error (&_inner_error0_);
#line 61 "xkblayout.vala"
			return;
#line 504 "xkblayout.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* err = NULL;
		FILE* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 60 "xkblayout.vala"
		err = _inner_error0_;
#line 60 "xkblayout.vala"
		_inner_error0_ = NULL;
#line 70 "xkblayout.vala"
		_tmp10_ = stderr;
#line 70 "xkblayout.vala"
		_tmp11_ = err;
#line 70 "xkblayout.vala"
		_tmp12_ = _tmp11_->message;
#line 70 "xkblayout.vala"
		fprintf (_tmp10_, "IBUS_ERROR: %s\n", _tmp12_);
#line 60 "xkblayout.vala"
		_g_error_free0 (err);
#line 528 "xkblayout.c"
	}
	__finally0:
#line 60 "xkblayout.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "xkblayout.vala"
		_g_free0 (standard_error);
#line 60 "xkblayout.vala"
		_g_free0 (standard_output);
#line 60 "xkblayout.vala"
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 60 "xkblayout.vala"
		_g_free0 (_vala_layout);
#line 60 "xkblayout.vala"
		_g_free0 (_vala_variant);
#line 60 "xkblayout.vala"
		_g_free0 (_vala_option);
#line 60 "xkblayout.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "xkblayout.vala"
		g_clear_error (&_inner_error0_);
#line 60 "xkblayout.vala"
		return;
#line 551 "xkblayout.c"
	}
#line 72 "xkblayout.vala"
	if (exit_status != 0) {
#line 555 "xkblayout.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		FILE* _tmp15_;
#line 73 "xkblayout.vala"
		_tmp14_ = standard_error;
#line 73 "xkblayout.vala"
		_tmp13_ = _tmp14_;
#line 73 "xkblayout.vala"
		if (_tmp13_ == NULL) {
#line 73 "xkblayout.vala"
			_tmp13_ = "";
#line 567 "xkblayout.c"
		}
#line 73 "xkblayout.vala"
		_tmp15_ = stderr;
#line 73 "xkblayout.vala"
		fprintf (_tmp15_, "IBUS_ERROR: %s\n", _tmp13_);
#line 573 "xkblayout.c"
	}
#line 75 "xkblayout.vala"
	_tmp16_ = standard_output;
#line 75 "xkblayout.vala"
	if (_tmp16_ == NULL) {
#line 76 "xkblayout.vala"
		_g_free0 (standard_error);
#line 76 "xkblayout.vala"
		_g_free0 (standard_output);
#line 76 "xkblayout.vala"
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 76 "xkblayout.vala"
		if (layout) {
#line 76 "xkblayout.vala"
			*layout = _vala_layout;
#line 589 "xkblayout.c"
		} else {
#line 76 "xkblayout.vala"
			_g_free0 (_vala_layout);
#line 593 "xkblayout.c"
		}
#line 76 "xkblayout.vala"
		if (variant) {
#line 76 "xkblayout.vala"
			*variant = _vala_variant;
#line 599 "xkblayout.c"
		} else {
#line 76 "xkblayout.vala"
			_g_free0 (_vala_variant);
#line 603 "xkblayout.c"
		}
#line 76 "xkblayout.vala"
		if (option) {
#line 76 "xkblayout.vala"
			*option = _vala_option;
#line 609 "xkblayout.c"
		} else {
#line 76 "xkblayout.vala"
			_g_free0 (_vala_option);
#line 613 "xkblayout.c"
		}
#line 76 "xkblayout.vala"
		return;
#line 617 "xkblayout.c"
	}
#line 79 "xkblayout.vala"
	_tmp17_ = standard_output;
#line 79 "xkblayout.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "\n", 0);
#line 623 "xkblayout.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 79 "xkblayout.vala"
		line_collection = _tmp19_;
#line 79 "xkblayout.vala"
		line_collection_length1 = _vala_array_length (_tmp18_);
#line 79 "xkblayout.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 635 "xkblayout.c"
			gchar* _tmp20_;
			gchar* line = NULL;
#line 79 "xkblayout.vala"
			_tmp20_ = g_strdup (line_collection[line_it]);
#line 79 "xkblayout.vala"
			line = _tmp20_;
#line 642 "xkblayout.c"
			{
				gchar* element = NULL;
				gchar* _tmp21_;
				gchar* retval = NULL;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				const gchar* _tmp57_;
				const gchar* _tmp58_;
#line 80 "xkblayout.vala"
				_tmp21_ = g_strdup ("layout:");
#line 80 "xkblayout.vala"
				element = _tmp21_;
#line 81 "xkblayout.vala"
				_tmp22_ = g_strdup ("");
#line 81 "xkblayout.vala"
				retval = _tmp22_;
#line 82 "xkblayout.vala"
				_tmp23_ = line;
#line 82 "xkblayout.vala"
				_tmp24_ = element;
#line 82 "xkblayout.vala"
				if (g_str_has_prefix (_tmp23_, _tmp24_)) {
#line 672 "xkblayout.c"
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					const gchar* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					gchar* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
#line 83 "xkblayout.vala"
					_tmp25_ = line;
#line 83 "xkblayout.vala"
					_tmp26_ = element;
#line 83 "xkblayout.vala"
					_tmp27_ = strlen (_tmp26_);
#line 83 "xkblayout.vala"
					_tmp28_ = _tmp27_;
#line 83 "xkblayout.vala"
					_tmp29_ = line;
#line 83 "xkblayout.vala"
					_tmp30_ = strlen (_tmp29_);
#line 83 "xkblayout.vala"
					_tmp31_ = _tmp30_;
#line 83 "xkblayout.vala"
					_tmp32_ = string_slice (_tmp25_, (glong) _tmp28_, (glong) _tmp31_);
#line 83 "xkblayout.vala"
					_g_free0 (retval);
#line 83 "xkblayout.vala"
					retval = _tmp32_;
#line 84 "xkblayout.vala"
					_tmp33_ = retval;
#line 84 "xkblayout.vala"
					if (_tmp33_ != NULL) {
#line 708 "xkblayout.c"
						const gchar* _tmp34_;
						gchar* _tmp35_;
#line 85 "xkblayout.vala"
						_tmp34_ = retval;
#line 85 "xkblayout.vala"
						_tmp35_ = string_strip (_tmp34_);
#line 85 "xkblayout.vala"
						_g_free0 (retval);
#line 85 "xkblayout.vala"
						retval = _tmp35_;
#line 719 "xkblayout.c"
					}
#line 87 "xkblayout.vala"
					_tmp36_ = retval;
#line 87 "xkblayout.vala"
					_tmp37_ = g_strdup (_tmp36_);
#line 87 "xkblayout.vala"
					_g_free0 (_vala_layout);
#line 87 "xkblayout.vala"
					_vala_layout = _tmp37_;
#line 729 "xkblayout.c"
				}
#line 90 "xkblayout.vala"
				_tmp38_ = g_strdup ("variant:");
#line 90 "xkblayout.vala"
				_g_free0 (element);
#line 90 "xkblayout.vala"
				element = _tmp38_;
#line 91 "xkblayout.vala"
				_tmp39_ = g_strdup ("");
#line 91 "xkblayout.vala"
				_g_free0 (retval);
#line 91 "xkblayout.vala"
				retval = _tmp39_;
#line 92 "xkblayout.vala"
				_tmp40_ = line;
#line 92 "xkblayout.vala"
				_tmp41_ = element;
#line 92 "xkblayout.vala"
				if (g_str_has_prefix (_tmp40_, _tmp41_)) {
#line 749 "xkblayout.c"
					const gchar* _tmp42_;
					const gchar* _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
					const gchar* _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					gchar* _tmp49_;
					const gchar* _tmp50_;
					const gchar* _tmp53_;
					gchar* _tmp54_;
#line 93 "xkblayout.vala"
					_tmp42_ = line;
#line 93 "xkblayout.vala"
					_tmp43_ = element;
#line 93 "xkblayout.vala"
					_tmp44_ = strlen (_tmp43_);
#line 93 "xkblayout.vala"
					_tmp45_ = _tmp44_;
#line 93 "xkblayout.vala"
					_tmp46_ = line;
#line 93 "xkblayout.vala"
					_tmp47_ = strlen (_tmp46_);
#line 93 "xkblayout.vala"
					_tmp48_ = _tmp47_;
#line 93 "xkblayout.vala"
					_tmp49_ = string_slice (_tmp42_, (glong) _tmp45_, (glong) _tmp48_);
#line 93 "xkblayout.vala"
					_g_free0 (retval);
#line 93 "xkblayout.vala"
					retval = _tmp49_;
#line 94 "xkblayout.vala"
					_tmp50_ = retval;
#line 94 "xkblayout.vala"
					if (_tmp50_ != NULL) {
#line 785 "xkblayout.c"
						const gchar* _tmp51_;
						gchar* _tmp52_;
#line 95 "xkblayout.vala"
						_tmp51_ = retval;
#line 95 "xkblayout.vala"
						_tmp52_ = string_strip (_tmp51_);
#line 95 "xkblayout.vala"
						_g_free0 (retval);
#line 95 "xkblayout.vala"
						retval = _tmp52_;
#line 796 "xkblayout.c"
					}
#line 97 "xkblayout.vala"
					_tmp53_ = retval;
#line 97 "xkblayout.vala"
					_tmp54_ = g_strdup (_tmp53_);
#line 97 "xkblayout.vala"
					_g_free0 (_vala_variant);
#line 97 "xkblayout.vala"
					_vala_variant = _tmp54_;
#line 806 "xkblayout.c"
				}
#line 100 "xkblayout.vala"
				_tmp55_ = g_strdup ("options:");
#line 100 "xkblayout.vala"
				_g_free0 (element);
#line 100 "xkblayout.vala"
				element = _tmp55_;
#line 101 "xkblayout.vala"
				_tmp56_ = g_strdup ("");
#line 101 "xkblayout.vala"
				_g_free0 (retval);
#line 101 "xkblayout.vala"
				retval = _tmp56_;
#line 102 "xkblayout.vala"
				_tmp57_ = line;
#line 102 "xkblayout.vala"
				_tmp58_ = element;
#line 102 "xkblayout.vala"
				if (g_str_has_prefix (_tmp57_, _tmp58_)) {
#line 826 "xkblayout.c"
					const gchar* _tmp59_;
					const gchar* _tmp60_;
					gint _tmp61_;
					gint _tmp62_;
					const gchar* _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					gchar* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp70_;
					gchar* _tmp71_;
#line 103 "xkblayout.vala"
					_tmp59_ = line;
#line 103 "xkblayout.vala"
					_tmp60_ = element;
#line 103 "xkblayout.vala"
					_tmp61_ = strlen (_tmp60_);
#line 103 "xkblayout.vala"
					_tmp62_ = _tmp61_;
#line 103 "xkblayout.vala"
					_tmp63_ = line;
#line 103 "xkblayout.vala"
					_tmp64_ = strlen (_tmp63_);
#line 103 "xkblayout.vala"
					_tmp65_ = _tmp64_;
#line 103 "xkblayout.vala"
					_tmp66_ = string_slice (_tmp59_, (glong) _tmp62_, (glong) _tmp65_);
#line 103 "xkblayout.vala"
					_g_free0 (retval);
#line 103 "xkblayout.vala"
					retval = _tmp66_;
#line 104 "xkblayout.vala"
					_tmp67_ = retval;
#line 104 "xkblayout.vala"
					if (_tmp67_ != NULL) {
#line 862 "xkblayout.c"
						const gchar* _tmp68_;
						gchar* _tmp69_;
#line 105 "xkblayout.vala"
						_tmp68_ = retval;
#line 105 "xkblayout.vala"
						_tmp69_ = string_strip (_tmp68_);
#line 105 "xkblayout.vala"
						_g_free0 (retval);
#line 105 "xkblayout.vala"
						retval = _tmp69_;
#line 873 "xkblayout.c"
					}
#line 107 "xkblayout.vala"
					_tmp70_ = retval;
#line 107 "xkblayout.vala"
					_tmp71_ = g_strdup (_tmp70_);
#line 107 "xkblayout.vala"
					_g_free0 (_vala_option);
#line 107 "xkblayout.vala"
					_vala_option = _tmp71_;
#line 883 "xkblayout.c"
				}
#line 79 "xkblayout.vala"
				_g_free0 (retval);
#line 79 "xkblayout.vala"
				_g_free0 (element);
#line 79 "xkblayout.vala"
				_g_free0 (line);
#line 891 "xkblayout.c"
			}
		}
#line 79 "xkblayout.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 896 "xkblayout.c"
	}
#line 46 "xkblayout.vala"
	_g_free0 (standard_error);
#line 46 "xkblayout.vala"
	_g_free0 (standard_output);
#line 46 "xkblayout.vala"
	exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 46 "xkblayout.vala"
	if (layout) {
#line 46 "xkblayout.vala"
		*layout = _vala_layout;
#line 908 "xkblayout.c"
	} else {
#line 46 "xkblayout.vala"
		_g_free0 (_vala_layout);
#line 912 "xkblayout.c"
	}
#line 46 "xkblayout.vala"
	if (variant) {
#line 46 "xkblayout.vala"
		*variant = _vala_variant;
#line 918 "xkblayout.c"
	} else {
#line 46 "xkblayout.vala"
		_g_free0 (_vala_variant);
#line 922 "xkblayout.c"
	}
#line 46 "xkblayout.vala"
	if (option) {
#line 46 "xkblayout.vala"
		*option = _vala_option;
#line 928 "xkblayout.c"
	} else {
#line 46 "xkblayout.vala"
		_g_free0 (_vala_option);
#line 932 "xkblayout.c"
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 131 "xkblayout.vala"
	for (i = 0; i < stack_length; i++) {
#line 131 "xkblayout.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 131 "xkblayout.vala"
			return TRUE;
#line 948 "xkblayout.c"
		}
	}
#line 131 "xkblayout.vala"
	return FALSE;
#line 953 "xkblayout.c"
}

static void
_vala_array_add28 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 170 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 170 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 170 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 968 "xkblayout.c"
	}
#line 170 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 170 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 974 "xkblayout.c"
}

static void
_vala_array_add29 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 171 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 171 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 171 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 989 "xkblayout.c"
	}
#line 171 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 171 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 995 "xkblayout.c"
}

static void
_vala_array_add30 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 172 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 172 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 172 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1010 "xkblayout.c"
	}
#line 172 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 172 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1016 "xkblayout.c"
}

static void
_vala_array_add31 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 174 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 174 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 174 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1031 "xkblayout.c"
	}
#line 174 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 174 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1037 "xkblayout.c"
}

static void
_vala_array_add32 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 175 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 175 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 175 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1052 "xkblayout.c"
	}
#line 175 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 175 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1058 "xkblayout.c"
}

static void
_vala_array_add33 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 179 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 179 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 179 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1073 "xkblayout.c"
	}
#line 179 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 179 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1079 "xkblayout.c"
}

static void
_vala_array_add34 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 180 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 180 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 180 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1094 "xkblayout.c"
	}
#line 180 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 180 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1100 "xkblayout.c"
}

static void
_vala_array_add35 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 181 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 181 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 181 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1115 "xkblayout.c"
	}
#line 181 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 181 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1121 "xkblayout.c"
}

void
xkb_layout_set_layout (XKBLayout* self,
                       IBusEngineDesc* engine)
{
	gchar* layout = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* variant = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* option = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gboolean need_us_layout = FALSE;
	const gchar* _tmp16_;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp26_;
	gboolean _tmp30_ = FALSE;
	const gchar* _tmp31_;
	const gchar* _tmp37_;
	gboolean _tmp38_ = FALSE;
	const gchar* _tmp39_;
	gchar** args = NULL;
	gchar** _tmp59_;
	gint args_length1;
	gint _args_size_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	const gchar* _tmp66_;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_ = FALSE;
	const gchar* _tmp74_;
	gchar* standard_error = NULL;
	gint exit_status = 0;
	GError* _inner_error0_ = NULL;
#line 112 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 112 "xkblayout.vala"
	g_return_if_fail (engine != NULL);
#line 113 "xkblayout.vala"
	_tmp0_ = ibus_engine_desc_get_layout (engine);
#line 113 "xkblayout.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 113 "xkblayout.vala"
	layout = _tmp1_;
#line 114 "xkblayout.vala"
	_tmp2_ = ibus_engine_desc_get_layout_variant (engine);
#line 114 "xkblayout.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 114 "xkblayout.vala"
	variant = _tmp3_;
#line 115 "xkblayout.vala"
	_tmp4_ = ibus_engine_desc_get_layout_option (engine);
#line 115 "xkblayout.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 115 "xkblayout.vala"
	option = _tmp5_;
#line 117 "xkblayout.vala"
	_tmp6_ = layout;
#line 117 "xkblayout.vala"
	_vala_assert (_tmp6_ != NULL, "layout != null");
#line 123 "xkblayout.vala"
	_tmp9_ = layout;
#line 123 "xkblayout.vala"
	if (g_strcmp0 (_tmp9_, "default") == 0) {
#line 1197 "xkblayout.c"
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 124 "xkblayout.vala"
		_tmp11_ = variant;
#line 124 "xkblayout.vala"
		if (g_strcmp0 (_tmp11_, "default") == 0) {
#line 124 "xkblayout.vala"
			_tmp10_ = TRUE;
#line 1206 "xkblayout.c"
		} else {
			const gchar* _tmp12_;
#line 124 "xkblayout.vala"
			_tmp12_ = variant;
#line 124 "xkblayout.vala"
			_tmp10_ = g_strcmp0 (_tmp12_, "") == 0;
#line 1213 "xkblayout.c"
		}
#line 124 "xkblayout.vala"
		_tmp8_ = _tmp10_;
#line 1217 "xkblayout.c"
	} else {
#line 123 "xkblayout.vala"
		_tmp8_ = FALSE;
#line 1221 "xkblayout.c"
	}
#line 123 "xkblayout.vala"
	if (_tmp8_) {
#line 1225 "xkblayout.c"
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 125 "xkblayout.vala"
		_tmp14_ = option;
#line 125 "xkblayout.vala"
		if (g_strcmp0 (_tmp14_, "default") == 0) {
#line 125 "xkblayout.vala"
			_tmp13_ = TRUE;
#line 1234 "xkblayout.c"
		} else {
			const gchar* _tmp15_;
#line 125 "xkblayout.vala"
			_tmp15_ = option;
#line 125 "xkblayout.vala"
			_tmp13_ = g_strcmp0 (_tmp15_, "") == 0;
#line 1241 "xkblayout.c"
		}
#line 125 "xkblayout.vala"
		_tmp7_ = _tmp13_;
#line 1245 "xkblayout.c"
	} else {
#line 123 "xkblayout.vala"
		_tmp7_ = FALSE;
#line 1249 "xkblayout.c"
	}
#line 123 "xkblayout.vala"
	if (_tmp7_) {
#line 126 "xkblayout.vala"
		_g_free0 (option);
#line 126 "xkblayout.vala"
		_g_free0 (variant);
#line 126 "xkblayout.vala"
		_g_free0 (layout);
#line 126 "xkblayout.vala"
		return;
#line 1261 "xkblayout.c"
	}
#line 129 "xkblayout.vala"
	need_us_layout = FALSE;
#line 130 "xkblayout.vala"
	_tmp16_ = variant;
#line 130 "xkblayout.vala"
	if (g_strcmp0 (_tmp16_, "eng") != 0) {
#line 1269 "xkblayout.c"
		const gchar* _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 131 "xkblayout.vala"
		_tmp17_ = layout;
#line 131 "xkblayout.vala"
		_tmp18_ = self->priv->m_xkb_latin_layouts;
#line 131 "xkblayout.vala"
		_tmp18__length1 = self->priv->m_xkb_latin_layouts_length1;
#line 131 "xkblayout.vala"
		need_us_layout = _vala_string_array_contains (_tmp18_, _tmp18__length1, _tmp17_);
#line 1281 "xkblayout.c"
	}
#line 132 "xkblayout.vala"
	if (!need_us_layout) {
#line 1285 "xkblayout.c"
		const gchar* _tmp20_;
#line 132 "xkblayout.vala"
		_tmp20_ = variant;
#line 132 "xkblayout.vala"
		_tmp19_ = _tmp20_ != NULL;
#line 1291 "xkblayout.c"
	} else {
#line 132 "xkblayout.vala"
		_tmp19_ = FALSE;
#line 1295 "xkblayout.c"
	}
#line 132 "xkblayout.vala"
	if (_tmp19_) {
#line 1299 "xkblayout.c"
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar** _tmp25_;
		gint _tmp25__length1;
#line 133 "xkblayout.vala"
		_tmp21_ = layout;
#line 133 "xkblayout.vala"
		_tmp22_ = variant;
#line 133 "xkblayout.vala"
		_tmp23_ = g_strdup_printf ("%s(%s)", _tmp21_, _tmp22_);
#line 133 "xkblayout.vala"
		_tmp24_ = _tmp23_;
#line 133 "xkblayout.vala"
		_tmp25_ = self->priv->m_xkb_latin_layouts;
#line 133 "xkblayout.vala"
		_tmp25__length1 = self->priv->m_xkb_latin_layouts_length1;
#line 133 "xkblayout.vala"
		need_us_layout = _vala_string_array_contains (_tmp25_, _tmp25__length1, _tmp24_);
#line 133 "xkblayout.vala"
		_g_free0 (_tmp24_);
#line 1322 "xkblayout.c"
	}
#line 136 "xkblayout.vala"
	_tmp26_ = self->priv->m_default_layout;
#line 136 "xkblayout.vala"
	if (g_strcmp0 (_tmp26_, "") == 0) {
#line 1328 "xkblayout.c"
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
#line 137 "xkblayout.vala"
		xkb_layout_get_layout (&_tmp27_, &_tmp28_, &_tmp29_);
#line 137 "xkblayout.vala"
		_g_free0 (self->priv->m_default_layout);
#line 137 "xkblayout.vala"
		self->priv->m_default_layout = _tmp27_;
#line 137 "xkblayout.vala"
		_g_free0 (self->priv->m_default_variant);
#line 137 "xkblayout.vala"
		self->priv->m_default_variant = _tmp28_;
#line 137 "xkblayout.vala"
		_g_free0 (self->priv->m_default_option);
#line 137 "xkblayout.vala"
		self->priv->m_default_option = _tmp29_;
#line 1346 "xkblayout.c"
	}
#line 142 "xkblayout.vala"
	_tmp31_ = layout;
#line 142 "xkblayout.vala"
	if (g_strcmp0 (_tmp31_, "default") == 0) {
#line 142 "xkblayout.vala"
		_tmp30_ = TRUE;
#line 1354 "xkblayout.c"
	} else {
		const gchar* _tmp32_;
#line 142 "xkblayout.vala"
		_tmp32_ = layout;
#line 142 "xkblayout.vala"
		_tmp30_ = g_strcmp0 (_tmp32_, "") == 0;
#line 1361 "xkblayout.c"
	}
#line 142 "xkblayout.vala"
	if (_tmp30_) {
#line 1365 "xkblayout.c"
		const gchar* _tmp33_;
		gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 143 "xkblayout.vala"
		_tmp33_ = self->priv->m_default_layout;
#line 143 "xkblayout.vala"
		_tmp34_ = g_strdup (_tmp33_);
#line 143 "xkblayout.vala"
		_g_free0 (layout);
#line 143 "xkblayout.vala"
		layout = _tmp34_;
#line 144 "xkblayout.vala"
		_tmp35_ = self->priv->m_default_variant;
#line 144 "xkblayout.vala"
		_tmp36_ = g_strdup (_tmp35_);
#line 144 "xkblayout.vala"
		_g_free0 (variant);
#line 144 "xkblayout.vala"
		variant = _tmp36_;
#line 1386 "xkblayout.c"
	}
#line 147 "xkblayout.vala"
	_tmp37_ = layout;
#line 147 "xkblayout.vala"
	if (g_strcmp0 (_tmp37_, "") == 0) {
#line 148 "xkblayout.vala"
		g_warning ("xkblayout.vala:148: Could not get the correct layout");
#line 149 "xkblayout.vala"
		_g_free0 (option);
#line 149 "xkblayout.vala"
		_g_free0 (variant);
#line 149 "xkblayout.vala"
		_g_free0 (layout);
#line 149 "xkblayout.vala"
		return;
#line 1402 "xkblayout.c"
	}
#line 152 "xkblayout.vala"
	_tmp39_ = option;
#line 152 "xkblayout.vala"
	if (g_strcmp0 (_tmp39_, "default") == 0) {
#line 152 "xkblayout.vala"
		_tmp38_ = TRUE;
#line 1410 "xkblayout.c"
	} else {
		const gchar* _tmp40_;
#line 152 "xkblayout.vala"
		_tmp40_ = option;
#line 152 "xkblayout.vala"
		_tmp38_ = g_strcmp0 (_tmp40_, "") == 0;
#line 1417 "xkblayout.c"
	}
#line 152 "xkblayout.vala"
	if (_tmp38_) {
#line 1421 "xkblayout.c"
		const gchar* _tmp41_;
		gchar* _tmp42_;
#line 153 "xkblayout.vala"
		_tmp41_ = self->priv->m_default_option;
#line 153 "xkblayout.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 153 "xkblayout.vala"
		_g_free0 (option);
#line 153 "xkblayout.vala"
		option = _tmp42_;
#line 1432 "xkblayout.c"
	} else {
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		gchar** _tmp45_;
		gchar** _tmp46_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		gboolean _tmp48_;
#line 155 "xkblayout.vala"
		_tmp43_ = option;
#line 155 "xkblayout.vala"
		_tmp44_ = self->priv->m_default_option;
#line 155 "xkblayout.vala"
		_tmp46_ = _tmp45_ = g_strsplit (_tmp44_, ",", 0);
#line 155 "xkblayout.vala"
		_tmp47_ = _tmp46_;
#line 155 "xkblayout.vala"
		_tmp47__length1 = _vala_array_length (_tmp45_);
#line 155 "xkblayout.vala"
		_tmp48_ = !_vala_string_array_contains (_tmp47_, _vala_array_length (_tmp45_), _tmp43_);
#line 155 "xkblayout.vala"
		_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
#line 155 "xkblayout.vala"
		if (_tmp48_) {
#line 1457 "xkblayout.c"
			const gchar* _tmp49_;
			const gchar* _tmp50_;
			gchar* _tmp51_;
#line 156 "xkblayout.vala"
			_tmp49_ = self->priv->m_default_option;
#line 156 "xkblayout.vala"
			_tmp50_ = option;
#line 156 "xkblayout.vala"
			_tmp51_ = g_strdup_printf ("%s,%s", _tmp49_, _tmp50_);
#line 156 "xkblayout.vala"
			_g_free0 (option);
#line 156 "xkblayout.vala"
			option = _tmp51_;
#line 1471 "xkblayout.c"
		} else {
			const gchar* _tmp52_;
			gchar* _tmp53_;
#line 158 "xkblayout.vala"
			_tmp52_ = self->priv->m_default_option;
#line 158 "xkblayout.vala"
			_tmp53_ = g_strdup (_tmp52_);
#line 158 "xkblayout.vala"
			_g_free0 (option);
#line 158 "xkblayout.vala"
			option = _tmp53_;
#line 1483 "xkblayout.c"
		}
	}
#line 162 "xkblayout.vala"
	if (need_us_layout) {
#line 1488 "xkblayout.c"
		const gchar* _tmp54_;
		gchar* _tmp55_;
		const gchar* _tmp56_;
#line 163 "xkblayout.vala"
		_tmp54_ = layout;
#line 163 "xkblayout.vala"
		_tmp55_ = g_strconcat (_tmp54_, ",us", NULL);
#line 163 "xkblayout.vala"
		_g_free0 (layout);
#line 163 "xkblayout.vala"
		layout = _tmp55_;
#line 164 "xkblayout.vala"
		_tmp56_ = variant;
#line 164 "xkblayout.vala"
		if (_tmp56_ != NULL) {
#line 1504 "xkblayout.c"
			const gchar* _tmp57_;
			gchar* _tmp58_;
#line 165 "xkblayout.vala"
			_tmp57_ = variant;
#line 165 "xkblayout.vala"
			_tmp58_ = g_strconcat (_tmp57_, ",", NULL);
#line 165 "xkblayout.vala"
			_g_free0 (variant);
#line 165 "xkblayout.vala"
			variant = _tmp58_;
#line 1515 "xkblayout.c"
		}
	}
#line 169 "xkblayout.vala"
	_tmp59_ = g_new0 (gchar*, 0 + 1);
#line 169 "xkblayout.vala"
	args = _tmp59_;
#line 169 "xkblayout.vala"
	args_length1 = 0;
#line 169 "xkblayout.vala"
	_args_size_ = args_length1;
#line 170 "xkblayout.vala"
	_tmp60_ = g_strdup (XKB_LAYOUT_XKB_COMMAND);
#line 170 "xkblayout.vala"
	_vala_array_add28 (&args, &args_length1, &_args_size_, _tmp60_);
#line 171 "xkblayout.vala"
	_tmp61_ = g_strdup (XKB_LAYOUT_XKB_LAYOUT_ARG);
#line 171 "xkblayout.vala"
	_vala_array_add29 (&args, &args_length1, &_args_size_, _tmp61_);
#line 172 "xkblayout.vala"
	_tmp62_ = layout;
#line 172 "xkblayout.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 172 "xkblayout.vala"
	_vala_array_add30 (&args, &args_length1, &_args_size_, _tmp63_);
#line 173 "xkblayout.vala"
	_tmp66_ = variant;
#line 173 "xkblayout.vala"
	if (_tmp66_ != NULL) {
#line 1544 "xkblayout.c"
		const gchar* _tmp67_;
#line 173 "xkblayout.vala"
		_tmp67_ = variant;
#line 173 "xkblayout.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1550 "xkblayout.c"
	} else {
#line 173 "xkblayout.vala"
		_tmp65_ = FALSE;
#line 1554 "xkblayout.c"
	}
#line 173 "xkblayout.vala"
	if (_tmp65_) {
#line 1558 "xkblayout.c"
		const gchar* _tmp68_;
#line 173 "xkblayout.vala"
		_tmp68_ = variant;
#line 173 "xkblayout.vala"
		_tmp64_ = g_strcmp0 (_tmp68_, "default") != 0;
#line 1564 "xkblayout.c"
	} else {
#line 173 "xkblayout.vala"
		_tmp64_ = FALSE;
#line 1568 "xkblayout.c"
	}
#line 173 "xkblayout.vala"
	if (_tmp64_) {
#line 1572 "xkblayout.c"
		gchar* _tmp69_;
		const gchar* _tmp70_;
		gchar* _tmp71_;
#line 174 "xkblayout.vala"
		_tmp69_ = g_strdup ("-variant");
#line 174 "xkblayout.vala"
		_vala_array_add31 (&args, &args_length1, &_args_size_, _tmp69_);
#line 175 "xkblayout.vala"
		_tmp70_ = variant;
#line 175 "xkblayout.vala"
		_tmp71_ = g_strdup (_tmp70_);
#line 175 "xkblayout.vala"
		_vala_array_add32 (&args, &args_length1, &_args_size_, _tmp71_);
#line 1586 "xkblayout.c"
	}
#line 177 "xkblayout.vala"
	_tmp74_ = option;
#line 177 "xkblayout.vala"
	if (_tmp74_ != NULL) {
#line 1592 "xkblayout.c"
		const gchar* _tmp75_;
#line 177 "xkblayout.vala"
		_tmp75_ = option;
#line 177 "xkblayout.vala"
		_tmp73_ = g_strcmp0 (_tmp75_, "") != 0;
#line 1598 "xkblayout.c"
	} else {
#line 177 "xkblayout.vala"
		_tmp73_ = FALSE;
#line 1602 "xkblayout.c"
	}
#line 177 "xkblayout.vala"
	if (_tmp73_) {
#line 1606 "xkblayout.c"
		const gchar* _tmp76_;
#line 177 "xkblayout.vala"
		_tmp76_ = option;
#line 177 "xkblayout.vala"
		_tmp72_ = g_strcmp0 (_tmp76_, "default") != 0;
#line 1612 "xkblayout.c"
	} else {
#line 177 "xkblayout.vala"
		_tmp72_ = FALSE;
#line 1616 "xkblayout.c"
	}
#line 177 "xkblayout.vala"
	if (_tmp72_) {
#line 1620 "xkblayout.c"
		gchar* _tmp77_;
		gchar* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
#line 179 "xkblayout.vala"
		_tmp77_ = g_strdup ("-option");
#line 179 "xkblayout.vala"
		_vala_array_add33 (&args, &args_length1, &_args_size_, _tmp77_);
#line 180 "xkblayout.vala"
		_tmp78_ = g_strdup ("-option");
#line 180 "xkblayout.vala"
		_vala_array_add34 (&args, &args_length1, &_args_size_, _tmp78_);
#line 181 "xkblayout.vala"
		_tmp79_ = option;
#line 181 "xkblayout.vala"
		_tmp80_ = g_strdup (_tmp79_);
#line 181 "xkblayout.vala"
		_vala_array_add35 (&args, &args_length1, &_args_size_, _tmp80_);
#line 1639 "xkblayout.c"
	}
#line 184 "xkblayout.vala"
	standard_error = NULL;
#line 185 "xkblayout.vala"
	exit_status = 0;
#line 1645 "xkblayout.c"
	{
		gboolean _tmp81_ = FALSE;
		gchar** _tmp82_;
		gint _tmp82__length1;
		gchar* _tmp83_ = NULL;
		gint _tmp84_ = 0;
		gboolean _tmp85_;
#line 187 "xkblayout.vala"
		_tmp82_ = args;
#line 187 "xkblayout.vala"
		_tmp82__length1 = args_length1;
#line 187 "xkblayout.vala"
		_tmp85_ = g_spawn_sync (NULL, _tmp82_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_tmp83_, &_tmp84_, &_inner_error0_);
#line 187 "xkblayout.vala"
		_g_free0 (standard_error);
#line 187 "xkblayout.vala"
		standard_error = _tmp83_;
#line 187 "xkblayout.vala"
		exit_status = _tmp84_;
#line 187 "xkblayout.vala"
		_tmp81_ = _tmp85_;
#line 187 "xkblayout.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "xkblayout.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1671 "xkblayout.c"
				goto __catch0_g_spawn_error;
			}
#line 187 "xkblayout.vala"
			_g_free0 (standard_error);
#line 187 "xkblayout.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 187 "xkblayout.vala"
			_g_free0 (option);
#line 187 "xkblayout.vala"
			_g_free0 (variant);
#line 187 "xkblayout.vala"
			_g_free0 (layout);
#line 187 "xkblayout.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "xkblayout.vala"
			g_clear_error (&_inner_error0_);
#line 187 "xkblayout.vala"
			return;
#line 1690 "xkblayout.c"
		}
#line 187 "xkblayout.vala"
		if (!_tmp81_) {
#line 1694 "xkblayout.c"
			const gchar* _tmp86_;
#line 195 "xkblayout.vala"
			_tmp86_ = ibus_engine_desc_get_layout (engine);
#line 195 "xkblayout.vala"
			g_warning ("xkblayout.vala:195: Switch xkb layout to %s failed.", _tmp86_);
#line 1700 "xkblayout.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp87_;
		const gchar* _tmp88_;
#line 186 "xkblayout.vala"
		e = _inner_error0_;
#line 186 "xkblayout.vala"
		_inner_error0_ = NULL;
#line 198 "xkblayout.vala"
		_tmp87_ = e;
#line 198 "xkblayout.vala"
		_tmp88_ = _tmp87_->message;
#line 198 "xkblayout.vala"
		g_warning ("xkblayout.vala:198: Execute setxkbmap failed: %s", _tmp88_);
#line 199 "xkblayout.vala"
		_g_error_free0 (e);
#line 199 "xkblayout.vala"
		_g_free0 (standard_error);
#line 199 "xkblayout.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 199 "xkblayout.vala"
		_g_free0 (option);
#line 199 "xkblayout.vala"
		_g_free0 (variant);
#line 199 "xkblayout.vala"
		_g_free0 (layout);
#line 199 "xkblayout.vala"
		return;
#line 1733 "xkblayout.c"
	}
	__finally0:
#line 186 "xkblayout.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 186 "xkblayout.vala"
		_g_free0 (standard_error);
#line 186 "xkblayout.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 186 "xkblayout.vala"
		_g_free0 (option);
#line 186 "xkblayout.vala"
		_g_free0 (variant);
#line 186 "xkblayout.vala"
		_g_free0 (layout);
#line 186 "xkblayout.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "xkblayout.vala"
		g_clear_error (&_inner_error0_);
#line 186 "xkblayout.vala"
		return;
#line 1754 "xkblayout.c"
	}
#line 202 "xkblayout.vala"
	if (exit_status != 0) {
#line 1758 "xkblayout.c"
		const gchar* _tmp89_ = NULL;
		const gchar* _tmp90_;
#line 204 "xkblayout.vala"
		_tmp90_ = standard_error;
#line 204 "xkblayout.vala"
		_tmp89_ = _tmp90_;
#line 204 "xkblayout.vala"
		if (_tmp89_ == NULL) {
#line 204 "xkblayout.vala"
			_tmp89_ = "(null)";
#line 1769 "xkblayout.c"
		}
#line 203 "xkblayout.vala"
		g_warning ("xkblayout.vala:203: Execute setxkbmap failed: %s", _tmp89_);
#line 1773 "xkblayout.c"
	}
#line 206 "xkblayout.vala"
	xkb_layout_run_xmodmap (self);
#line 112 "xkblayout.vala"
	_g_free0 (standard_error);
#line 112 "xkblayout.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 112 "xkblayout.vala"
	_g_free0 (option);
#line 112 "xkblayout.vala"
	_g_free0 (variant);
#line 112 "xkblayout.vala"
	_g_free0 (layout);
#line 1787 "xkblayout.c"
}

void
xkb_layout_run_xmodmap (XKBLayout* self)
{
	gchar* homedir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 209 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 210 "xkblayout.vala"
	if (!self->priv->m_use_xmodmap) {
#line 211 "xkblayout.vala"
		return;
#line 1803 "xkblayout.c"
	}
#line 214 "xkblayout.vala"
	_tmp0_ = g_get_home_dir ();
#line 214 "xkblayout.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 214 "xkblayout.vala"
	homedir = _tmp1_;
#line 1811 "xkblayout.c"
	{
		const gchar** xmodmap_file_collection = NULL;
		gint xmodmap_file_collection_length1 = 0;
		gint _xmodmap_file_collection_size_ = 0;
		gint xmodmap_file_it = 0;
#line 215 "xkblayout.vala"
		xmodmap_file_collection = XKB_LAYOUT_XMODMAP_KNOWN_FILES;
#line 215 "xkblayout.vala"
		xmodmap_file_collection_length1 = G_N_ELEMENTS (XKB_LAYOUT_XMODMAP_KNOWN_FILES);
#line 215 "xkblayout.vala"
		for (xmodmap_file_it = 0; xmodmap_file_it < xmodmap_file_collection_length1; xmodmap_file_it = xmodmap_file_it + 1) {
#line 1823 "xkblayout.c"
			gchar* _tmp2_;
			gchar* xmodmap_file = NULL;
#line 215 "xkblayout.vala"
			_tmp2_ = g_strdup (xmodmap_file_collection[xmodmap_file_it]);
#line 215 "xkblayout.vala"
			xmodmap_file = _tmp2_;
#line 1830 "xkblayout.c"
			{
				gchar* xmodmap_filepath = NULL;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar** args = NULL;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar** _tmp10_;
				gint args_length1;
				gint _args_size_;
#line 216 "xkblayout.vala"
				_tmp3_ = homedir;
#line 216 "xkblayout.vala"
				_tmp4_ = xmodmap_file;
#line 216 "xkblayout.vala"
				_tmp5_ = g_build_filename (_tmp3_, _tmp4_, NULL);
#line 216 "xkblayout.vala"
				xmodmap_filepath = _tmp5_;
#line 219 "xkblayout.vala"
				_tmp6_ = xmodmap_filepath;
#line 219 "xkblayout.vala"
				if (!g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 220 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 220 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 220 "xkblayout.vala"
					continue;
#line 1862 "xkblayout.c"
				}
#line 223 "xkblayout.vala"
				_tmp7_ = g_strdup (XKB_LAYOUT_XMODMAP_COMMAND);
#line 223 "xkblayout.vala"
				_tmp8_ = xmodmap_filepath;
#line 223 "xkblayout.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 223 "xkblayout.vala"
				_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 223 "xkblayout.vala"
				_tmp10_[0] = _tmp7_;
#line 223 "xkblayout.vala"
				_tmp10_[1] = _tmp9_;
#line 223 "xkblayout.vala"
				args = _tmp10_;
#line 223 "xkblayout.vala"
				args_length1 = 2;
#line 223 "xkblayout.vala"
				_args_size_ = args_length1;
#line 1882 "xkblayout.c"
				{
					gchar** _tmp11_;
					gint _tmp11__length1;
#line 234 "xkblayout.vala"
					_tmp11_ = args;
#line 234 "xkblayout.vala"
					_tmp11__length1 = args_length1;
#line 234 "xkblayout.vala"
					g_spawn_async (NULL, _tmp11_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error0_);
#line 234 "xkblayout.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "xkblayout.vala"
						if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1896 "xkblayout.c"
							goto __catch0_g_spawn_error;
						}
#line 234 "xkblayout.vala"
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 234 "xkblayout.vala"
						_g_free0 (xmodmap_filepath);
#line 234 "xkblayout.vala"
						_g_free0 (xmodmap_file);
#line 234 "xkblayout.vala"
						_g_free0 (homedir);
#line 234 "xkblayout.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "xkblayout.vala"
						g_clear_error (&_inner_error0_);
#line 234 "xkblayout.vala"
						return;
#line 1913 "xkblayout.c"
					}
				}
				goto __finally0;
				__catch0_g_spawn_error:
				{
					GError* e = NULL;
					GError* _tmp12_;
					const gchar* _tmp13_;
#line 233 "xkblayout.vala"
					e = _inner_error0_;
#line 233 "xkblayout.vala"
					_inner_error0_ = NULL;
#line 241 "xkblayout.vala"
					_tmp12_ = e;
#line 241 "xkblayout.vala"
					_tmp13_ = _tmp12_->message;
#line 241 "xkblayout.vala"
					g_warning ("xkblayout.vala:241: Execute xmodmap is failed: %s\n", _tmp13_);
#line 242 "xkblayout.vala"
					_g_error_free0 (e);
#line 242 "xkblayout.vala"
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 242 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 242 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 242 "xkblayout.vala"
					_g_free0 (homedir);
#line 242 "xkblayout.vala"
					return;
#line 1944 "xkblayout.c"
				}
				__finally0:
#line 233 "xkblayout.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "xkblayout.vala"
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 233 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 233 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 233 "xkblayout.vala"
					_g_free0 (homedir);
#line 233 "xkblayout.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "xkblayout.vala"
					g_clear_error (&_inner_error0_);
#line 233 "xkblayout.vala"
					return;
#line 1963 "xkblayout.c"
				}
#line 245 "xkblayout.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 245 "xkblayout.vala"
				_g_free0 (xmodmap_filepath);
#line 245 "xkblayout.vala"
				_g_free0 (xmodmap_file);
#line 245 "xkblayout.vala"
				break;
#line 1973 "xkblayout.c"
			}
		}
	}
#line 209 "xkblayout.vala"
	_g_free0 (homedir);
#line 1979 "xkblayout.c"
}

void
xkb_layout_set_use_xmodmap (XKBLayout* self,
                            gboolean use_xmodmap)
{
#line 249 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 250 "xkblayout.vala"
	self->priv->m_use_xmodmap = use_xmodmap;
#line 1990 "xkblayout.c"
}

static void
value_xkb_layout_init (GValue* value)
{
#line 25 "xkblayout.vala"
	value->data[0].v_pointer = NULL;
#line 1998 "xkblayout.c"
}

static void
value_xkb_layout_free_value (GValue* value)
{
#line 25 "xkblayout.vala"
	if (value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (value->data[0].v_pointer);
#line 2008 "xkblayout.c"
	}
}

static void
value_xkb_layout_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 25 "xkblayout.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		dest_value->data[0].v_pointer = xkb_layout_ref (src_value->data[0].v_pointer);
#line 2020 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2024 "xkblayout.c"
	}
}

static gpointer
value_xkb_layout_peek_pointer (const GValue* value)
{
#line 25 "xkblayout.vala"
	return value->data[0].v_pointer;
#line 2033 "xkblayout.c"
}

static gchar*
value_xkb_layout_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 25 "xkblayout.vala"
	if (collect_values[0].v_pointer) {
#line 2044 "xkblayout.c"
		XKBLayout * object;
		object = collect_values[0].v_pointer;
#line 25 "xkblayout.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "xkblayout.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2051 "xkblayout.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "xkblayout.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2055 "xkblayout.c"
		}
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = xkb_layout_ref (object);
#line 2059 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2063 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	return NULL;
#line 2067 "xkblayout.c"
}

static gchar*
value_xkb_layout_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	XKBLayout ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "xkblayout.vala"
	if (!object_p) {
#line 25 "xkblayout.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2082 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (!value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		*object_p = NULL;
#line 2088 "xkblayout.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "xkblayout.vala"
		*object_p = value->data[0].v_pointer;
#line 2092 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		*object_p = xkb_layout_ref (value->data[0].v_pointer);
#line 2096 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	return NULL;
#line 2100 "xkblayout.c"
}

GParamSpec*
param_spec_xkb_layout (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecXKBLayout* spec;
#line 25 "xkblayout.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_XKB_LAYOUT), NULL);
#line 25 "xkblayout.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "xkblayout.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "xkblayout.vala"
	return G_PARAM_SPEC (spec);
#line 2119 "xkblayout.c"
}

gpointer
value_get_xkb_layout (const GValue* value)
{
#line 25 "xkblayout.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT), NULL);
#line 25 "xkblayout.vala"
	return value->data[0].v_pointer;
#line 2129 "xkblayout.c"
}

void
value_set_xkb_layout (GValue* value,
                      gpointer v_object)
{
	XKBLayout * old;
#line 25 "xkblayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
	old = value->data[0].v_pointer;
#line 25 "xkblayout.vala"
	if (v_object) {
#line 25 "xkblayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = v_object;
#line 25 "xkblayout.vala"
		xkb_layout_ref (value->data[0].v_pointer);
#line 2151 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2155 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (old) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (old);
#line 2161 "xkblayout.c"
	}
}

void
value_take_xkb_layout (GValue* value,
                       gpointer v_object)
{
	XKBLayout * old;
#line 25 "xkblayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
	old = value->data[0].v_pointer;
#line 25 "xkblayout.vala"
	if (v_object) {
#line 25 "xkblayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = v_object;
#line 2182 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2186 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (old) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (old);
#line 2192 "xkblayout.c"
	}
}

static void
xkb_layout_class_init (XKBLayoutClass * klass,
                       gpointer klass_data)
{
#line 25 "xkblayout.vala"
	xkb_layout_parent_class = g_type_class_peek_parent (klass);
#line 25 "xkblayout.vala"
	((XKBLayoutClass *) klass)->finalize = xkb_layout_finalize;
#line 25 "xkblayout.vala"
	g_type_class_adjust_private_offset (klass, &XKBLayout_private_offset);
#line 2206 "xkblayout.c"
}

static void
xkb_layout_instance_init (XKBLayout * self,
                          gpointer klass)
{
	gchar** _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 25 "xkblayout.vala"
	self->priv = xkb_layout_get_instance_private (self);
#line 33 "xkblayout.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = _tmp0_;
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts_length1 = 0;
#line 33 "xkblayout.vala"
	self->priv->_m_xkb_latin_layouts_size_ = self->priv->m_xkb_latin_layouts_length1;
#line 34 "xkblayout.vala"
	_tmp1_ = g_strdup ("");
#line 34 "xkblayout.vala"
	self->priv->m_default_layout = _tmp1_;
#line 35 "xkblayout.vala"
	_tmp2_ = g_strdup ("");
#line 35 "xkblayout.vala"
	self->priv->m_default_variant = _tmp2_;
#line 36 "xkblayout.vala"
	_tmp3_ = g_strdup ("");
#line 36 "xkblayout.vala"
	self->priv->m_default_option = _tmp3_;
#line 37 "xkblayout.vala"
	self->priv->m_use_xmodmap = TRUE;
#line 25 "xkblayout.vala"
	self->ref_count = 1;
#line 2243 "xkblayout.c"
}

static void
xkb_layout_finalize (XKBLayout * obj)
{
	XKBLayout * self;
#line 25 "xkblayout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_XKB_LAYOUT, XKBLayout);
#line 25 "xkblayout.vala"
	g_signal_handlers_destroy (self);
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = (_vala_array_free (self->priv->m_xkb_latin_layouts, self->priv->m_xkb_latin_layouts_length1, (GDestroyNotify) g_free), NULL);
#line 34 "xkblayout.vala"
	_g_free0 (self->priv->m_default_layout);
#line 35 "xkblayout.vala"
	_g_free0 (self->priv->m_default_variant);
#line 36 "xkblayout.vala"
	_g_free0 (self->priv->m_default_option);
#line 2262 "xkblayout.c"
}

static GType
xkb_layout_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_xkb_layout_init, value_xkb_layout_free_value, value_xkb_layout_copy_value, value_xkb_layout_peek_pointer, "p", value_xkb_layout_collect_value, "p", value_xkb_layout_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (XKBLayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xkb_layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XKBLayout), 0, (GInstanceInitFunc) xkb_layout_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType xkb_layout_type_id;
	xkb_layout_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XKBLayout", &g_define_type_info, &g_define_type_fundamental_info, 0);
	XKBLayout_private_offset = g_type_add_instance_private (xkb_layout_type_id, sizeof (XKBLayoutPrivate));
	return xkb_layout_type_id;
}

GType
xkb_layout_get_type (void)
{
	static volatile gsize xkb_layout_type_id__once = 0;
	if (g_once_init_enter (&xkb_layout_type_id__once)) {
		GType xkb_layout_type_id;
		xkb_layout_type_id = xkb_layout_get_type_once ();
		g_once_init_leave (&xkb_layout_type_id__once, xkb_layout_type_id);
	}
	return xkb_layout_type_id__once;
}

gpointer
xkb_layout_ref (gpointer instance)
{
	XKBLayout * self;
	self = instance;
#line 25 "xkblayout.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "xkblayout.vala"
	return instance;
#line 2298 "xkblayout.c"
}

void
xkb_layout_unref (gpointer instance)
{
	XKBLayout * self;
	self = instance;
#line 25 "xkblayout.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "xkblayout.vala"
		XKB_LAYOUT_GET_CLASS (self)->finalize (self);
#line 25 "xkblayout.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2312 "xkblayout.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2323 "xkblayout.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2331 "xkblayout.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 2346 "xkblayout.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 2360 "xkblayout.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 2365 "xkblayout.c"
}

