/* panel.c generated by valac 0.56.7, the Vala compiler
 * generated from panel.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2015-2022 Takao Fujwiara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <gdk/gdkwayland.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <locale.h>
#include <float.h>
#include <math.h>
#include <libnotify/notify.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <signal.h>
#include <sys/types.h>
#include <config.h>

#define PANEL_PRELOAD_ENGINES_DELAY_TIME ((guint) 30000)
#define KEYBINDING_MANAGER_MODIFIER_FILTER ((guint) (GDK_MODIFIER_MASK & (~(((((((((GDK_LOCK_MASK | GDK_MOD2_MASK) | GDK_BUTTON1_MASK) | GDK_BUTTON2_MASK) | GDK_BUTTON3_MASK) | GDK_BUTTON4_MASK) | GDK_BUTTON5_MASK) | GDK_SUPER_MASK) | GDK_HYPER_MASK) | GDK_META_MASK))))
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
typedef struct _PanelPrivate PanelPrivate;
typedef enum  {
	PANEL_ICON_TYPE_STATUS_ICON,
	PANEL_ICON_TYPE_INDICATOR
} PanelIconType;

#define PANEL_TYPE_ICON_TYPE (panel_icon_type_get_type ())

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;

#define TYPE_CANDIDATE_PANEL (candidate_panel_get_type ())
#define CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANDIDATE_PANEL, CandidatePanel))
#define CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANDIDATE_PANEL, CandidatePanelClass))
#define IS_CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANDIDATE_PANEL))
#define IS_CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANDIDATE_PANEL))
#define CANDIDATE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANDIDATE_PANEL, CandidatePanelClass))

typedef struct _CandidatePanel CandidatePanel;
typedef struct _CandidatePanelClass CandidatePanelClass;

#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;

#define TYPE_PROPERTY_MANAGER (property_manager_get_type ())
#define PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_MANAGER, PropertyManager))
#define PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_MANAGER, PropertyManagerClass))
#define IS_PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_MANAGER))
#define IS_PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_MANAGER))
#define PROPERTY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_MANAGER, PropertyManagerClass))

typedef struct _PropertyManager PropertyManager;
typedef struct _PropertyManagerClass PropertyManagerClass;

#define TYPE_PROPERTY_PANEL (property_panel_get_type ())
#define PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_PANEL, PropertyPanel))
#define PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_PANEL, PropertyPanelClass))
#define IS_PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_PANEL))
#define IS_PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_PANEL))
#define PROPERTY_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_PANEL, PropertyPanelClass))

typedef struct _PropertyPanel PropertyPanel;
typedef struct _PropertyPanelClass PropertyPanelClass;

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;

#define BINDING_COMMON_TYPE_KEYBINDING (binding_common_keybinding_get_type ())
#define BINDING_COMMON_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybinding))
#define BINDING_COMMON_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))
#define BINDING_COMMON_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))

typedef struct _BindingCommonKeybinding BindingCommonKeybinding;
typedef struct _BindingCommonKeybindingClass BindingCommonKeybindingClass;
enum  {
	PANEL_0_PROPERTY,
	PANEL_NUM_PROPERTIES
};
static GParamSpec* panel_properties[PANEL_NUM_PROPERTIES];
typedef enum  {
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_EMOJI_TYPING
} BindingCommonKeyEventFuncType;

#define BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE (binding_common_key_event_func_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _property_manager_unref0(var) ((var == NULL) ? NULL : (var = (property_manager_unref (var), NULL)))
#define _xkb_layout_unref0(var) ((var == NULL) ? NULL : (var = (xkb_layout_unref (var), NULL)))
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;

#define TYPE_KEYBINDING_MANAGER (keybinding_manager_get_type ())
#define KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManager))
#define KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))
#define IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYBINDING_MANAGER))
#define IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYBINDING_MANAGER))
#define KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))

typedef struct _KeybindingManager KeybindingManager;
typedef struct _KeybindingManagerClass KeybindingManagerClass;
typedef void (*KeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Panel {
	IBusPanelService parent_instance;
	PanelPrivate * priv;
};

struct _PanelClass {
	IBusPanelServiceClass parent_class;
};

struct _PanelPrivate {
	IBusBus* m_bus;
	GSettings* m_settings_general;
	GSettings* m_settings_hotkey;
	GSettings* m_settings_panel;
	PanelIconType m_icon_type;
	Indicator* m_indicator;
	GDBusConnection* m_session_bus_connection;
	GtkStatusIcon* m_status_icon;
	GtkMenu* m_ime_menu;
	GtkMenu* m_sys_menu;
	IBusEngineDesc** m_engines;
	gint m_engines_length1;
	gint _m_engines_size_;
	IBusEngineDesc* m_en_engine;
	GHashTable* m_engine_contexts;
	gchar* m_current_context_path;
	gchar* m_real_current_context_path;
	gboolean m_use_global_engine;
	gboolean m_use_engine_lang;
	CandidatePanel* m_candidate_panel;
	Switcher* m_switcher;
	guint m_switcher_focus_set_engine_id;
	PropertyManager* m_property_manager;
	PropertyPanel* m_property_panel;
	GPid m_setup_pid;
	GtkAboutDialog* m_about_dialog;
	GtkCssProvider* m_css_provider;
	gint m_switcher_delay_time;
	gboolean m_use_system_keyboard_layout;
	GHashTable* m_xkb_icon_pixbufs;
	GHashTable* m_xkb_icon_image;
	GdkRGBA m_xkb_icon_rgba;
	XKBLayout* m_xkblayout;
	gboolean inited_engines_order;
	guint m_preload_engines_id;
	gchar* m_icon_prop_key;
	gint m_property_icon_delay_time;
	guint m_property_icon_delay_time_id;
	gboolean m_is_wayland;
	gboolean m_is_kde;
	gulong m_popup_menu_id;
	gulong m_activate_id;
	gulong m_registered_status_notifier_item_id;
	GList* m_keybindings;
};

struct _Block6Data {
	int _ref_count_;
	Panel* self;
	GdkRectangle area;
	GdkWindow* window;
	GtkMenuPositionFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block7Data {
	int _ref_count_;
	Panel* self;
	gchar** names;
	gint names_length1;
	gint _names_size_;
};

struct _Block8Data {
	int _ref_count_;
	Panel* self;
	GtkMessageDialog* dialog;
};

struct _Block9Data {
	int _ref_count_;
	Panel* self;
	IBusEngineDesc* e;
};

struct _Block10Data {
	int _ref_count_;
	Panel* self;
	gchar* symbol;
};

static gint Panel_private_offset;
static gpointer panel_parent_class = NULL;

VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
static GType panel_icon_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType candidate_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CandidatePanel, g_object_unref)
VALA_EXTERN GType switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Switcher, g_object_unref)
VALA_EXTERN gpointer property_manager_ref (gpointer instance);
VALA_EXTERN void property_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_property_manager (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_property_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_property_manager (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_property_manager (const GValue* value);
VALA_EXTERN GType property_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyManager, property_manager_unref)
VALA_EXTERN GType property_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyPanel, g_object_unref)
VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN GType binding_common_keybinding_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BindingCommonKeybinding, g_object_unref)
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
VALA_EXTERN GType binding_common_key_event_func_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void binding_common_unbind_switch_shortcut (BindingCommonKeyEventFuncType ftype,
                                            GList* keybindings);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _g_free0_ (gpointer var);
static void _cairo_surface_destroy0_ (gpointer var);
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
static gboolean panel_is_kde (void);
VALA_EXTERN Panel* panel_new (IBusBus* bus);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus);
static void panel_init_settings (Panel* self);
static void panel_init_indicator (Panel* self);
static void panel_init_status_icon (Panel* self);
VALA_EXTERN CandidatePanel* candidate_panel_new (void);
VALA_EXTERN CandidatePanel* candidate_panel_construct (GType object_type);
static void __lambda90_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda90__candidate_panel_page_up (CandidatePanel* _sender,
                                           gpointer self);
static void __lambda91_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda91__candidate_panel_page_down (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda92_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda92__candidate_panel_cursor_up (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda93_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda93__candidate_panel_cursor_down (CandidatePanel* _sender,
                                               gpointer self);
static void __lambda94_ (Panel* self,
                  CandidatePanel* w,
                  guint i,
                  guint b,
                  guint s);
static void ___lambda94__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                     guint index,
                                                     guint button,
                                                     guint state,
                                                     gpointer self);
VALA_EXTERN Switcher* switcher_new (void);
VALA_EXTERN Switcher* switcher_construct (GType object_type);
static void panel_bind_switch_shortcut (Panel* self);
VALA_EXTERN void switcher_set_popup_delay_time (Switcher* self,
                                    guint popup_delay_time);
VALA_EXTERN PropertyManager* property_manager_new (void);
VALA_EXTERN PropertyManager* property_manager_construct (GType object_type);
static void __lambda95_ (Panel* self,
                  PropertyManager* w,
                  const gchar* k,
                  gint s);
static void ___lambda95__property_manager_property_activate (PropertyManager* _sender,
                                                      const gchar* key,
                                                      gint state,
                                                      gpointer self);
VALA_EXTERN PropertyPanel* property_panel_new (void);
VALA_EXTERN PropertyPanel* property_panel_construct (GType object_type);
static void __lambda96_ (Panel* self,
                  PropertyPanel* w,
                  const gchar* k,
                  gint s);
static void ___lambda96__property_panel_property_activate (PropertyPanel* _sender,
                                                    const gchar* key,
                                                    gint state,
                                                    gpointer self);
static void __lambda32_ (Panel* self,
                  const gchar* key);
static void panel_update_engines (Panel* self,
                           gchar** unowned_engine_names,
                           gint unowned_engine_names_length1,
                           gchar** order_names,
                           gint order_names_length1);
static void ___lambda32__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda35_ (Panel* self,
                  const gchar* key);
static void panel_set_switcher_delay_time (Panel* self);
static void ___lambda35__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda36_ (Panel* self,
                  const gchar* key);
static void panel_set_use_system_keyboard_layout (Panel* self);
static void ___lambda36__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda37_ (Panel* self,
                  const gchar* key);
static void panel_set_embed_preedit_text (Panel* self);
static void ___lambda37__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda38_ (Panel* self,
                  const gchar* key);
static void panel_set_use_global_engine (Panel* self);
static void ___lambda38__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda39_ (Panel* self,
                  const gchar* key);
static void panel_set_use_xmodmap (Panel* self);
static void ___lambda39__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda40_ (Panel* self,
                  const gchar* key);
static void ___lambda40__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda63_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_font (GSettings* settings_panel,
                                     GSettings* settings_emoji,
                                     GtkCssProvider** css_provider);
static void ___lambda63__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda64_ (Panel* self,
                  const gchar* key);
static void ___lambda64__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda65_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_theme (GSettings* settings_panel);
static void ___lambda65__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda66_ (Panel* self,
                  const gchar* key);
static void ___lambda66__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda67_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_icon (GSettings* settings_panel);
static void ___lambda67__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda68_ (Panel* self,
                  const gchar* key);
static void ___lambda68__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda69_ (Panel* self,
                  const gchar* key);
static void panel_set_language_from_engine (Panel* self,
                                     IBusEngineDesc* engine);
static void ___lambda69__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda70_ (Panel* self,
                  const gchar* key);
static void panel_set_show_icon_on_systray (Panel* self);
static void ___lambda70__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda71_ (Panel* self,
                  const gchar* key);
static void panel_set_lookup_table_orientation (Panel* self);
static void ___lambda71__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda72_ (Panel* self,
                  const gchar* key);
static void panel_set_show_property_panel (Panel* self);
static void ___lambda72__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda73_ (Panel* self,
                  const gchar* key);
static void panel_set_timeout_property_panel (Panel* self);
static void ___lambda73__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda74_ (Panel* self,
                  const gchar* key);
static void panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self);
static void ___lambda74__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda75_ (Panel* self,
                  const gchar* key);
static void panel_set_xkb_icon_rgba (Panel* self);
static void ___lambda75__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda76_ (Panel* self,
                  const gchar* key);
static void panel_set_property_icon_delay_time (Panel* self);
static void ___lambda76__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void panel_popup_menu_at_area_window (Panel* self,
                                      GtkMenu* menu,
                                      GdkRectangle* area,
                                      GdkWindow* window,
                                      GtkMenuPositionFunc func,
                                      gpointer func_target);
static void panel_popup_menu_at_pointer_window (Panel* self,
                                         GtkMenu* menu,
                                         gint x,
                                         gint y,
                                         GdkWindow* window,
                                         GtkMenuPositionFunc func,
                                         gpointer func_target);
static void __lambda77_ (Panel* self,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          GDBusConnection* connection,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                GDBusConnection* connection,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
static void ___lambda78_ (Panel* self);
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
static void ____lambda78__indicator_registered_status_notifier_item (Indicator* _sender,
                                                              gpointer self);
static void ___lambda79_ (Panel* self,
                   gint x,
                   gint y,
                   GdkWindow* w,
                   guint b,
                   guint t);
static GtkMenu* panel_create_context_menu (Panel* self);
VALA_EXTERN void indicator_position_context_menu (Indicator* self,
                                      GtkMenu* menu,
                                      gint* x,
                                      gint* y,
                                      gboolean* push_in);
static void _indicator_position_context_menu_gtk_menu_position_func (GtkMenu* menu,
                                                              gint* x,
                                                              gint* y,
                                                              gboolean* push_in,
                                                              gpointer self);
static void ____lambda79__indicator_context_menu (Indicator* _sender,
                                           gint x,
                                           gint y,
                                           GdkWindow* window,
                                           guint button,
                                           guint activate_time,
                                           gpointer self);
static void ___lambda86_ (Panel* self,
                   gint x,
                   gint y,
                   GdkWindow* w);
static GtkMenu* panel_create_activate_menu (Panel* self);
VALA_EXTERN void indicator_position_activate_menu (Indicator* self,
                                       GtkMenu* menu,
                                       gint* x,
                                       gint* y,
                                       gboolean* push_in);
static void _indicator_position_activate_menu_gtk_menu_position_func (GtkMenu* menu,
                                                               gint* x,
                                                               gint* y,
                                                               gboolean* push_in,
                                                               gpointer self);
static void ____lambda86__indicator_activate (Indicator* _sender,
                                       gint x,
                                       gint y,
                                       GdkWindow* window,
                                       gpointer self);
static void ___lambda77__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void panel_init_status_icon_menu (Panel* self);
static void _panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda88_ (Block6Data* _data6_,
                  guint b,
                  guint t);
static void ___lambda88__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                              guint button,
                                              guint activate_time,
                                              gpointer self);
static void __lambda89_ (Block6Data* _data6_);
static void ___lambda89__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                            gpointer self);
VALA_EXTERN GType keybinding_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManager, g_object_unref)
VALA_EXTERN KeybindingManager* keybinding_manager_get_instance (void);
VALA_EXTERN void binding_common_keybinding_manager_bind (KeybindingManager* keybinding_manager,
                                             GList** keybindings,
                                             const gchar* accelerator,
                                             BindingCommonKeyEventFuncType ftype,
                                             KeybindingManagerKeybindingHandlerFunc handler_normal,
                                             gpointer handler_normal_target,
                                             KeybindingManagerKeybindingHandlerFunc handler_reverse,
                                             gpointer handler_reverse_target);
static void panel_handle_engine_switch_normal (Panel* self,
                                        GdkEvent* event);
static void _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                    gpointer self);
static void panel_handle_engine_switch_reverse (Panel* self,
                                         GdkEvent* event);
static void _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                     gpointer self);
static GList* panel_get_engines_from_xkb (Panel* self,
                                   GList* engines);
VALA_EXTERN void xkb_layout_get_layout (gchar** layout,
                            gchar** variant,
                            gchar** option);
static GList* panel_get_engines_from_locale (Panel* self,
                                      GList* engines);
static gint __lambda97_ (IBusEngineDesc* a,
                  IBusEngineDesc* b);
static gint ___lambda97__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static void panel_init_engines_order (Panel* self);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
VALA_EXTERN void candidate_panel_set_vertical (CandidatePanel* self,
                                   gboolean vertical);
VALA_EXTERN void property_panel_set_show (PropertyPanel* self,
                              gint _show);
VALA_EXTERN void property_panel_set_auto_hide_timeout (PropertyPanel* self,
                                           guint timeout);
VALA_EXTERN void property_panel_set_follow_input_cursor_when_always_shown (PropertyPanel* self,
                                                               gboolean is_follow);
static gint panel_compare_versions (Panel* self,
                             const gchar* version1,
                             const gchar* version2);
static void panel_update_version_1_5_8 (Panel* self);
static void panel_update_version_1_5_26 (Panel* self);
static void panel_set_version (Panel* self);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
static void panel_engine_contexts_insert (Panel* self,
                                   IBusEngineDesc* engine);
VALA_EXTERN void candidate_panel_set_language (CandidatePanel* self,
                                   PangoAttribute* language_attribute);
static void panel_set_engine (Panel* self,
                       IBusEngineDesc* engine);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static void panel_switch_engine (Panel* self,
                          gint i,
                          gboolean force);
static void panel_handle_engine_switch (Panel* self,
                                 GdkEvent* event,
                                 gboolean reverse);
VALA_EXTERN GdkModifierType keybinding_manager_get_primary_modifier (guint binding_mask);
VALA_EXTERN gboolean keybinding_manager_primary_modifier_still_pressed (GdkEvent* event,
                                                            guint primary_modifier);
VALA_EXTERN gint switcher_run (Switcher* self,
                   guint keyval,
                   guint state,
                   GdkEvent* event,
                   IBusEngineDesc** engines,
                   gint engines_length1,
                   gint index,
                   const gchar* input_context_path);
static void panel_switcher_focus_set_engine (Panel* self);
static void panel_run_preload_engines (Panel* self,
                                IBusEngineDesc** engines,
                                gint engines_length1,
                                gint index);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean __lambda34_ (Block7Data* _data7_);
static gboolean ___lambda34__gsource_func (gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda33_ (Block8Data* _data8_,
                   gint id);
static void ____lambda33__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static IBusEngineDesc** _vala_array_dup3 (IBusEngineDesc** self,
                                   gssize length);
static IBusEngineDesc** _vala_array_dup4 (IBusEngineDesc** self,
                                   gssize length);
static void panel_context_render_string (Panel* self,
                                  cairo_t* cr,
                                  const gchar* symbol,
                                  gint image_width,
                                  gint image_height);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static cairo_surface_t* panel_create_cairo_image_surface_with_string (Panel* self,
                                                               const gchar* symbol,
                                                               gboolean cache);
static GdkPixbuf* panel_create_icon_pixbuf_with_string (Panel* self,
                                                 const gchar* symbol);
static void panel_show_setup_dialog (Panel* self);
static void __lambda81_ (Panel* self,
                  GPid pid,
                  gint state);
static void ___lambda81__gchild_watch_func (GPid pid,
                                     gint wait_status,
                                     gpointer self);
static void panel_show_about_dialog (Panel* self);
static void ___lambda80_ (Panel* self,
                   GtkMenuItem* i);
static void ____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda82_ (Panel* self,
                   GtkMenuItem* i);
static void ____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda83_ (Panel* self,
                   GtkMenuItem* i);
static void ____lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda84_ (Panel* self,
                   GtkMenuItem* i);
static void ____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda85_ (Panel* self,
                   GtkMenuItem* i);
static void ____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
VALA_EXTERN gint property_manager_create_menu_items (PropertyManager* self,
                                         GtkMenu* menu);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ____lambda87_ (Block9Data* _data9_,
                    GtkMenuItem* item);
static void _____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void panel_set_properties (Panel* self,
                           IBusPropList* props);
static void panel_set_property (Panel* self,
                         IBusProperty* prop,
                         gboolean all_update);
static void panel_animate_icon (Panel* self,
                         const gchar* symbol,
                         gboolean all_update);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean __lambda98_ (Block10Data* _data10_);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
static gboolean ___lambda98__gsource_func (gpointer self);
static void panel_real_set_cursor_location (IBusPanelService* base,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height);
VALA_EXTERN void candidate_panel_set_cursor_location (CandidatePanel* self,
                                          gint x,
                                          gint y,
                                          gint width,
                                          gint height);
VALA_EXTERN void property_panel_set_cursor_location (PropertyPanel* self,
                                         gint x,
                                         gint y,
                                         gint width,
                                         gint height);
static gboolean panel_switcher_focus_set_engine_real (Panel* self);
VALA_EXTERN IBusEngineDesc* switcher_get_selected_engine (Switcher* self);
VALA_EXTERN gchar* switcher_get_input_context_path (Switcher* self);
VALA_EXTERN void switcher_reset (Switcher* self);
VALA_EXTERN gboolean switcher_is_running (Switcher* self);
static gboolean ___lambda62_ (Panel* self);
static gboolean ____lambda62__gsource_func (gpointer self);
static void panel_real_focus_in (IBusPanelService* base,
                          const gchar* input_context_path);
VALA_EXTERN void property_panel_focus_in (PropertyPanel* self);
static void panel_real_focus_out (IBusPanelService* base,
                           const gchar* input_context_path);
static void panel_real_destroy_context (IBusPanelService* base,
                                 const gchar* input_context_path);
static void panel_real_register_properties (IBusPanelService* base,
                                     IBusPropList* props);
VALA_EXTERN void property_manager_set_properties (PropertyManager* self,
                                      IBusPropList* props);
VALA_EXTERN void property_panel_set_properties (PropertyPanel* self,
                                    IBusPropList* props);
static void panel_real_update_property (IBusPanelService* base,
                                 IBusProperty* prop);
VALA_EXTERN void property_manager_update_property (PropertyManager* self,
                                       IBusProperty* prop);
VALA_EXTERN void property_panel_update_property (PropertyPanel* self,
                                     IBusProperty* prop);
static void panel_real_update_preedit_text (IBusPanelService* base,
                                     IBusText* text,
                                     guint cursor_pos,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_preedit_text (CandidatePanel* self,
                                       IBusText* text,
                                       guint cursor);
VALA_EXTERN void property_panel_set_preedit_text (PropertyPanel* self,
                                      IBusText* text,
                                      guint cursor);
static void panel_real_hide_preedit_text (IBusPanelService* base);
static void panel_real_update_auxiliary_text (IBusPanelService* base,
                                       IBusText* text,
                                       gboolean visible);
VALA_EXTERN void candidate_panel_set_auxiliary_text (CandidatePanel* self,
                                         IBusText* text);
VALA_EXTERN void property_panel_set_auxiliary_text (PropertyPanel* self,
                                        IBusText* text);
static void panel_real_hide_auxiliary_text (IBusPanelService* base);
static void panel_real_update_lookup_table (IBusPanelService* base,
                                     IBusLookupTable* table,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_lookup_table (CandidatePanel* self,
                                       IBusLookupTable* table);
VALA_EXTERN void property_panel_set_lookup_table (PropertyPanel* self,
                                      IBusLookupTable* table);
static void panel_real_hide_lookup_table (IBusPanelService* base);
static void panel_real_set_content_type (IBusPanelService* base,
                                  guint purpose,
                                  guint hints);
VALA_EXTERN void candidate_panel_set_content_type (CandidatePanel* self,
                                       guint purpose,
                                       guint hints);
static void panel_real_state_changed (IBusPanelService* base);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN gchar* switcher_get_xkb_language (Switcher* self,
                                  IBusEngineDesc* engine);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void panel_finalize (GObject * obj);
static GType panel_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
panel_get_instance_private (Panel* self)
{
	return G_STRUCT_MEMBER_P (self, Panel_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 160 "panel.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 933 "panel.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 160 "panel.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 941 "panel.c"
}

static GType
panel_icon_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PANEL_ICON_TYPE_STATUS_ICON, "PANEL_ICON_TYPE_STATUS_ICON", "status-icon"}, {PANEL_ICON_TYPE_INDICATOR, "PANEL_ICON_TYPE_INDICATOR", "indicator"}, {0, NULL, NULL}};
	GType panel_icon_type_type_id;
	panel_icon_type_type_id = g_enum_register_static ("PanelIconType", values);
	return panel_icon_type_type_id;
}

static GType
panel_icon_type_get_type (void)
{
	static volatile gsize panel_icon_type_type_id__once = 0;
	if (g_once_init_enter (&panel_icon_type_type_id__once)) {
		GType panel_icon_type_type_id;
		panel_icon_type_type_id = panel_icon_type_get_type_once ();
		g_once_init_leave (&panel_icon_type_type_id__once, panel_icon_type_type_id);
	}
	return panel_icon_type_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 45 "panel.vala"
	var = (g_free (var), NULL);
#line 970 "panel.c"
}

static void
_cairo_surface_destroy0_ (gpointer var)
{
#line 65 "panel.vala"
	(var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL));
#line 978 "panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 96 "panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 986 "panel.c"
}

static void
__lambda90_ (Panel* self,
             CandidatePanel* w)
{
#line 124 "panel.vala"
	g_return_if_fail (w != NULL);
#line 124 "panel.vala"
	ibus_panel_service_page_up ((IBusPanelService*) self);
#line 997 "panel.c"
}

static void
___lambda90__candidate_panel_page_up (CandidatePanel* _sender,
                                      gpointer self)
{
#line 124 "panel.vala"
	__lambda90_ ((Panel*) self, _sender);
#line 1006 "panel.c"
}

static void
__lambda91_ (Panel* self,
             CandidatePanel* w)
{
#line 125 "panel.vala"
	g_return_if_fail (w != NULL);
#line 125 "panel.vala"
	ibus_panel_service_page_down ((IBusPanelService*) self);
#line 1017 "panel.c"
}

static void
___lambda91__candidate_panel_page_down (CandidatePanel* _sender,
                                        gpointer self)
{
#line 125 "panel.vala"
	__lambda91_ ((Panel*) self, _sender);
#line 1026 "panel.c"
}

static void
__lambda92_ (Panel* self,
             CandidatePanel* w)
{
#line 126 "panel.vala"
	g_return_if_fail (w != NULL);
#line 126 "panel.vala"
	ibus_panel_service_cursor_up ((IBusPanelService*) self);
#line 1037 "panel.c"
}

static void
___lambda92__candidate_panel_cursor_up (CandidatePanel* _sender,
                                        gpointer self)
{
#line 126 "panel.vala"
	__lambda92_ ((Panel*) self, _sender);
#line 1046 "panel.c"
}

static void
__lambda93_ (Panel* self,
             CandidatePanel* w)
{
#line 127 "panel.vala"
	g_return_if_fail (w != NULL);
#line 127 "panel.vala"
	ibus_panel_service_cursor_down ((IBusPanelService*) self);
#line 1057 "panel.c"
}

static void
___lambda93__candidate_panel_cursor_down (CandidatePanel* _sender,
                                          gpointer self)
{
#line 127 "panel.vala"
	__lambda93_ ((Panel*) self, _sender);
#line 1066 "panel.c"
}

static void
__lambda94_ (Panel* self,
             CandidatePanel* w,
             guint i,
             guint b,
             guint s)
{
#line 129 "panel.vala"
	g_return_if_fail (w != NULL);
#line 129 "panel.vala"
	ibus_panel_service_candidate_clicked ((IBusPanelService*) self, i, b, s);
#line 1080 "panel.c"
}

static void
___lambda94__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                guint index,
                                                guint button,
                                                guint state,
                                                gpointer self)
{
#line 128 "panel.vala"
	__lambda94_ ((Panel*) self, _sender, index, button, state);
#line 1092 "panel.c"
}

static void
__lambda95_ (Panel* self,
             PropertyManager* w,
             const gchar* k,
             gint s)
{
#line 140 "panel.vala"
	g_return_if_fail (w != NULL);
#line 140 "panel.vala"
	g_return_if_fail (k != NULL);
#line 141 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1107 "panel.c"
}

static void
___lambda95__property_manager_property_activate (PropertyManager* _sender,
                                                 const gchar* key,
                                                 gint state,
                                                 gpointer self)
{
#line 140 "panel.vala"
	__lambda95_ ((Panel*) self, _sender, key, state);
#line 1118 "panel.c"
}

static void
__lambda96_ (Panel* self,
             PropertyPanel* w,
             const gchar* k,
             gint s)
{
#line 145 "panel.vala"
	g_return_if_fail (w != NULL);
#line 145 "panel.vala"
	g_return_if_fail (k != NULL);
#line 146 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1133 "panel.c"
}

static void
___lambda96__property_panel_property_activate (PropertyPanel* _sender,
                                               const gchar* key,
                                               gint state,
                                               gpointer self)
{
#line 145 "panel.vala"
	__lambda96_ ((Panel*) self, _sender, key, state);
#line 1144 "panel.c"
}

Panel*
panel_construct (GType object_type,
                 IBusBus* bus)
{
	Panel * self = NULL;
	GDBusConnection* _tmp0_;
	IBusBus* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplayManager* _tmp2_;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GType instance_type = 0UL;
	GdkDisplay* _tmp5_;
	GType wayland_type = 0UL;
	CandidatePanel* _tmp6_;
	CandidatePanel* _tmp7_;
	CandidatePanel* _tmp8_;
	CandidatePanel* _tmp9_;
	CandidatePanel* _tmp10_;
	CandidatePanel* _tmp11_;
	Switcher* _tmp12_;
	PropertyManager* _tmp14_;
	PropertyManager* _tmp15_;
	PropertyPanel* _tmp16_;
	PropertyPanel* _tmp17_;
#line 90 "panel.vala"
	g_return_val_if_fail (bus != NULL, NULL);
#line 91 "panel.vala"
	_vala_assert (ibus_bus_is_connected (bus), "bus.is_connected()");
#line 93 "panel.vala"
	_tmp0_ = ibus_bus_get_connection (bus);
#line 93 "panel.vala"
	self = (Panel*) g_object_new (object_type, "connection", _tmp0_, "object-path", "/org/freedesktop/IBus/Panel", NULL);
#line 96 "panel.vala"
	_tmp1_ = _g_object_ref0 (bus);
#line 96 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 96 "panel.vala"
	self->priv->m_bus = _tmp1_;
#line 99 "panel.vala"
	gdk_set_allowed_backends ("*");
#line 100 "panel.vala"
	_tmp2_ = gdk_display_manager_get ();
#line 100 "panel.vala"
	_tmp3_ = gdk_display_manager_open_display (_tmp2_, NULL);
#line 100 "panel.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 100 "panel.vala"
	display = _tmp4_;
#line 101 "panel.vala"
	_tmp5_ = display;
#line 101 "panel.vala"
	instance_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp5_);
#line 102 "panel.vala"
	wayland_type = gdk_wayland_display_get_type ();
#line 103 "panel.vala"
	self->priv->m_is_wayland = g_type_is_a (instance_type, wayland_type);
#line 104 "panel.vala"
	gdk_set_allowed_backends ("x11");
#line 110 "panel.vala"
	panel_init_settings (self);
#line 114 "panel.vala"
	if (self->priv->m_is_kde) {
#line 115 "panel.vala"
		panel_init_indicator (self);
#line 1212 "panel.c"
	} else {
#line 117 "panel.vala"
		panel_init_status_icon (self);
#line 1216 "panel.c"
	}
#line 123 "panel.vala"
	_tmp6_ = candidate_panel_new ();
#line 123 "panel.vala"
	g_object_ref_sink (_tmp6_);
#line 123 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 123 "panel.vala"
	self->priv->m_candidate_panel = _tmp6_;
#line 124 "panel.vala"
	_tmp7_ = self->priv->m_candidate_panel;
#line 124 "panel.vala"
	g_signal_connect_object (_tmp7_, "page-up", (GCallback) ___lambda90__candidate_panel_page_up, self, 0);
#line 125 "panel.vala"
	_tmp8_ = self->priv->m_candidate_panel;
#line 125 "panel.vala"
	g_signal_connect_object (_tmp8_, "page-down", (GCallback) ___lambda91__candidate_panel_page_down, self, 0);
#line 126 "panel.vala"
	_tmp9_ = self->priv->m_candidate_panel;
#line 126 "panel.vala"
	g_signal_connect_object (_tmp9_, "cursor-up", (GCallback) ___lambda92__candidate_panel_cursor_up, self, 0);
#line 127 "panel.vala"
	_tmp10_ = self->priv->m_candidate_panel;
#line 127 "panel.vala"
	g_signal_connect_object (_tmp10_, "cursor-down", (GCallback) ___lambda93__candidate_panel_cursor_down, self, 0);
#line 128 "panel.vala"
	_tmp11_ = self->priv->m_candidate_panel;
#line 128 "panel.vala"
	g_signal_connect_object (_tmp11_, "candidate-clicked", (GCallback) ___lambda94__candidate_panel_candidate_clicked, self, 0);
#line 131 "panel.vala"
	_tmp12_ = switcher_new ();
#line 131 "panel.vala"
	g_object_ref_sink (_tmp12_);
#line 131 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 131 "panel.vala"
	self->priv->m_switcher = _tmp12_;
#line 133 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 135 "panel.vala"
	if (self->priv->m_switcher_delay_time >= 0) {
#line 1258 "panel.c"
		Switcher* _tmp13_;
#line 136 "panel.vala"
		_tmp13_ = self->priv->m_switcher;
#line 136 "panel.vala"
		switcher_set_popup_delay_time (_tmp13_, (guint) self->priv->m_switcher_delay_time);
#line 1264 "panel.c"
	}
#line 139 "panel.vala"
	_tmp14_ = property_manager_new ();
#line 139 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 139 "panel.vala"
	self->priv->m_property_manager = _tmp14_;
#line 140 "panel.vala"
	_tmp15_ = self->priv->m_property_manager;
#line 140 "panel.vala"
	g_signal_connect_object (_tmp15_, "property-activate", (GCallback) ___lambda95__property_manager_property_activate, self, 0);
#line 144 "panel.vala"
	_tmp16_ = property_panel_new ();
#line 144 "panel.vala"
	g_object_ref_sink (_tmp16_);
#line 144 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 144 "panel.vala"
	self->priv->m_property_panel = _tmp16_;
#line 145 "panel.vala"
	_tmp17_ = self->priv->m_property_panel;
#line 145 "panel.vala"
	g_signal_connect_object (_tmp17_, "property-activate", (GCallback) ___lambda96__property_panel_property_activate, self, 0);
#line 149 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 90 "panel.vala"
	_g_object_unref0 (display);
#line 90 "panel.vala"
	return self;
#line 1294 "panel.c"
}

Panel*
panel_new (IBusBus* bus)
{
#line 90 "panel.vala"
	return panel_construct (TYPE_PANEL, bus);
#line 1302 "panel.c"
}

static void
__lambda32_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 169 "panel.vala"
	g_return_if_fail (key != NULL);
#line 170 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 170 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, key);
#line 170 "panel.vala"
	_tmp3_ = _tmp2_;
#line 170 "panel.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 170 "panel.vala"
	panel_update_engines (self, _tmp3_, (gint) _vala_array_length (_tmp1_), NULL, (gint) 0);
#line 170 "panel.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 1328 "panel.c"
}

static void
___lambda32__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 169 "panel.vala"
	__lambda32_ ((Panel*) self, key);
#line 1338 "panel.c"
}

static void
__lambda35_ (Panel* self,
             const gchar* key)
{
#line 174 "panel.vala"
	g_return_if_fail (key != NULL);
#line 175 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 1349 "panel.c"
}

static void
___lambda35__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 174 "panel.vala"
	__lambda35_ ((Panel*) self, key);
#line 1359 "panel.c"
}

static void
__lambda36_ (Panel* self,
             const gchar* key)
{
#line 179 "panel.vala"
	g_return_if_fail (key != NULL);
#line 180 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 1370 "panel.c"
}

static void
___lambda36__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 178 "panel.vala"
	__lambda36_ ((Panel*) self, key);
#line 1380 "panel.c"
}

static void
__lambda37_ (Panel* self,
             const gchar* key)
{
#line 183 "panel.vala"
	g_return_if_fail (key != NULL);
#line 184 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 1391 "panel.c"
}

static void
___lambda37__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 183 "panel.vala"
	__lambda37_ ((Panel*) self, key);
#line 1401 "panel.c"
}

static void
__lambda38_ (Panel* self,
             const gchar* key)
{
#line 187 "panel.vala"
	g_return_if_fail (key != NULL);
#line 188 "panel.vala"
	panel_set_use_global_engine (self);
#line 1412 "panel.c"
}

static void
___lambda38__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 187 "panel.vala"
	__lambda38_ ((Panel*) self, key);
#line 1422 "panel.c"
}

static void
__lambda39_ (Panel* self,
             const gchar* key)
{
#line 191 "panel.vala"
	g_return_if_fail (key != NULL);
#line 192 "panel.vala"
	panel_set_use_xmodmap (self);
#line 1433 "panel.c"
}

static void
___lambda39__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 191 "panel.vala"
	__lambda39_ ((Panel*) self, key);
#line 1443 "panel.c"
}

static void
__lambda40_ (Panel* self,
             const gchar* key)
{
	GList* _tmp0_;
#line 195 "panel.vala"
	g_return_if_fail (key != NULL);
#line 196 "panel.vala"
	_tmp0_ = self->priv->m_keybindings;
#line 196 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER, _tmp0_);
#line 199 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 199 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 200 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 1463 "panel.c"
}

static void
___lambda40__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 195 "panel.vala"
	__lambda40_ ((Panel*) self, key);
#line 1473 "panel.c"
}

static void
__lambda63_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 203 "panel.vala"
	g_return_if_fail (key != NULL);
#line 204 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 204 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1487 "panel.c"
}

static void
___lambda63__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 203 "panel.vala"
	__lambda63_ ((Panel*) self, key);
#line 1497 "panel.c"
}

static void
__lambda64_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 209 "panel.vala"
	g_return_if_fail (key != NULL);
#line 210 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 210 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1511 "panel.c"
}

static void
___lambda64__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 209 "panel.vala"
	__lambda64_ ((Panel*) self, key);
#line 1521 "panel.c"
}

static void
__lambda65_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 215 "panel.vala"
	g_return_if_fail (key != NULL);
#line 216 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 216 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1535 "panel.c"
}

static void
___lambda65__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 215 "panel.vala"
	__lambda65_ ((Panel*) self, key);
#line 1545 "panel.c"
}

static void
__lambda66_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 219 "panel.vala"
	g_return_if_fail (key != NULL);
#line 220 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 220 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1559 "panel.c"
}

static void
___lambda66__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 219 "panel.vala"
	__lambda66_ ((Panel*) self, key);
#line 1569 "panel.c"
}

static void
__lambda67_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 223 "panel.vala"
	g_return_if_fail (key != NULL);
#line 224 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 224 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1583 "panel.c"
}

static void
___lambda67__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 223 "panel.vala"
	__lambda67_ ((Panel*) self, key);
#line 1593 "panel.c"
}

static void
__lambda68_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 227 "panel.vala"
	g_return_if_fail (key != NULL);
#line 228 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 228 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1607 "panel.c"
}

static void
___lambda68__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 227 "panel.vala"
	__lambda68_ ((Panel*) self, key);
#line 1617 "panel.c"
}

static void
__lambda69_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
#line 231 "panel.vala"
	g_return_if_fail (key != NULL);
#line 233 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 233 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 235 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 235 "panel.vala"
	_tmp2_ = ibus_bus_get_global_engine (_tmp1_);
#line 235 "panel.vala"
	engine = _tmp2_;
#line 236 "panel.vala"
	_tmp3_ = engine;
#line 236 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1645 "panel.c"
		IBusEngineDesc* _tmp4_;
#line 237 "panel.vala"
		_tmp4_ = engine;
#line 237 "panel.vala"
		panel_set_language_from_engine (self, _tmp4_);
#line 1651 "panel.c"
	}
#line 231 "panel.vala"
	_g_object_unref0 (engine);
#line 1655 "panel.c"
}

static void
___lambda69__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 231 "panel.vala"
	__lambda69_ ((Panel*) self, key);
#line 1665 "panel.c"
}

static void
__lambda70_ (Panel* self,
             const gchar* key)
{
#line 240 "panel.vala"
	g_return_if_fail (key != NULL);
#line 241 "panel.vala"
	panel_set_show_icon_on_systray (self);
#line 1676 "panel.c"
}

static void
___lambda70__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 240 "panel.vala"
	__lambda70_ ((Panel*) self, key);
#line 1686 "panel.c"
}

static void
__lambda71_ (Panel* self,
             const gchar* key)
{
#line 244 "panel.vala"
	g_return_if_fail (key != NULL);
#line 245 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 1697 "panel.c"
}

static void
___lambda71__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 244 "panel.vala"
	__lambda71_ ((Panel*) self, key);
#line 1707 "panel.c"
}

static void
__lambda72_ (Panel* self,
             const gchar* key)
{
#line 248 "panel.vala"
	g_return_if_fail (key != NULL);
#line 249 "panel.vala"
	panel_set_show_property_panel (self);
#line 1718 "panel.c"
}

static void
___lambda72__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 248 "panel.vala"
	__lambda72_ ((Panel*) self, key);
#line 1728 "panel.c"
}

static void
__lambda73_ (Panel* self,
             const gchar* key)
{
#line 252 "panel.vala"
	g_return_if_fail (key != NULL);
#line 253 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 1739 "panel.c"
}

static void
___lambda73__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 252 "panel.vala"
	__lambda73_ ((Panel*) self, key);
#line 1749 "panel.c"
}

static void
__lambda74_ (Panel* self,
             const gchar* key)
{
#line 257 "panel.vala"
	g_return_if_fail (key != NULL);
#line 258 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 1760 "panel.c"
}

static void
___lambda74__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 256 "panel.vala"
	__lambda74_ ((Panel*) self, key);
#line 1770 "panel.c"
}

static void
__lambda75_ (Panel* self,
             const gchar* key)
{
#line 261 "panel.vala"
	g_return_if_fail (key != NULL);
#line 262 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 1781 "panel.c"
}

static void
___lambda75__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 261 "panel.vala"
	__lambda75_ ((Panel*) self, key);
#line 1791 "panel.c"
}

static void
__lambda76_ (Panel* self,
             const gchar* key)
{
#line 265 "panel.vala"
	g_return_if_fail (key != NULL);
#line 266 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 1802 "panel.c"
}

static void
___lambda76__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 265 "panel.vala"
	__lambda76_ ((Panel*) self, key);
#line 1812 "panel.c"
}

static void
panel_init_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
#line 163 "panel.vala"
	g_return_if_fail (self != NULL);
#line 164 "panel.vala"
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
#line 164 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 164 "panel.vala"
	self->priv->m_settings_general = _tmp0_;
#line 165 "panel.vala"
	_tmp1_ = g_settings_new ("org.freedesktop.ibus.general.hotkey");
#line 165 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 165 "panel.vala"
	self->priv->m_settings_hotkey = _tmp1_;
#line 167 "panel.vala"
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
#line 167 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 167 "panel.vala"
	self->priv->m_settings_panel = _tmp2_;
#line 169 "panel.vala"
	_tmp3_ = self->priv->m_settings_general;
#line 169 "panel.vala"
	g_signal_connect_object (_tmp3_, "changed::preload-engines", (GCallback) ___lambda32__g_settings_changed, self, 0);
#line 174 "panel.vala"
	_tmp4_ = self->priv->m_settings_general;
#line 174 "panel.vala"
	g_signal_connect_object (_tmp4_, "changed::switcher-delay-time", (GCallback) ___lambda35__g_settings_changed, self, 0);
#line 178 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 178 "panel.vala"
	g_signal_connect_object (_tmp5_, "changed::use-system-keyboard-layout", (GCallback) ___lambda36__g_settings_changed, self, 0);
#line 183 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 183 "panel.vala"
	g_signal_connect_object (_tmp6_, "changed::embed-preedit-text", (GCallback) ___lambda37__g_settings_changed, self, 0);
#line 187 "panel.vala"
	_tmp7_ = self->priv->m_settings_general;
#line 187 "panel.vala"
	g_signal_connect_object (_tmp7_, "changed::use-global-engine", (GCallback) ___lambda38__g_settings_changed, self, 0);
#line 191 "panel.vala"
	_tmp8_ = self->priv->m_settings_general;
#line 191 "panel.vala"
	g_signal_connect_object (_tmp8_, "changed::use-xmodmap", (GCallback) ___lambda39__g_settings_changed, self, 0);
#line 195 "panel.vala"
	_tmp9_ = self->priv->m_settings_hotkey;
#line 195 "panel.vala"
	g_signal_connect_object (_tmp9_, "changed::triggers", (GCallback) ___lambda40__g_settings_changed, self, 0);
#line 203 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 203 "panel.vala"
	g_signal_connect_object (_tmp10_, "changed::custom-font", (GCallback) ___lambda63__g_settings_changed, self, 0);
#line 209 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 209 "panel.vala"
	g_signal_connect_object (_tmp11_, "changed::use-custom-font", (GCallback) ___lambda64__g_settings_changed, self, 0);
#line 215 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 215 "panel.vala"
	g_signal_connect_object (_tmp12_, "changed::custom-theme", (GCallback) ___lambda65__g_settings_changed, self, 0);
#line 219 "panel.vala"
	_tmp13_ = self->priv->m_settings_panel;
#line 219 "panel.vala"
	g_signal_connect_object (_tmp13_, "changed::use-custom-theme", (GCallback) ___lambda66__g_settings_changed, self, 0);
#line 223 "panel.vala"
	_tmp14_ = self->priv->m_settings_panel;
#line 223 "panel.vala"
	g_signal_connect_object (_tmp14_, "changed::custom-icon", (GCallback) ___lambda67__g_settings_changed, self, 0);
#line 227 "panel.vala"
	_tmp15_ = self->priv->m_settings_panel;
#line 227 "panel.vala"
	g_signal_connect_object (_tmp15_, "changed::use-custom-icon", (GCallback) ___lambda68__g_settings_changed, self, 0);
#line 231 "panel.vala"
	_tmp16_ = self->priv->m_settings_panel;
#line 231 "panel.vala"
	g_signal_connect_object (_tmp16_, "changed::use-glyph-from-engine-lang", (GCallback) ___lambda69__g_settings_changed, self, 0);
#line 240 "panel.vala"
	_tmp17_ = self->priv->m_settings_panel;
#line 240 "panel.vala"
	g_signal_connect_object (_tmp17_, "changed::show-icon-on-systray", (GCallback) ___lambda70__g_settings_changed, self, 0);
#line 244 "panel.vala"
	_tmp18_ = self->priv->m_settings_panel;
#line 244 "panel.vala"
	g_signal_connect_object (_tmp18_, "changed::lookup-table-orientation", (GCallback) ___lambda71__g_settings_changed, self, 0);
#line 248 "panel.vala"
	_tmp19_ = self->priv->m_settings_panel;
#line 248 "panel.vala"
	g_signal_connect_object (_tmp19_, "changed::show", (GCallback) ___lambda72__g_settings_changed, self, 0);
#line 252 "panel.vala"
	_tmp20_ = self->priv->m_settings_panel;
#line 252 "panel.vala"
	g_signal_connect_object (_tmp20_, "changed::timeout", (GCallback) ___lambda73__g_settings_changed, self, 0);
#line 256 "panel.vala"
	_tmp21_ = self->priv->m_settings_panel;
#line 256 "panel.vala"
	g_signal_connect_object (_tmp21_, "changed::follow-input-cursor-when-always-shown", (GCallback) ___lambda74__g_settings_changed, self, 0);
#line 261 "panel.vala"
	_tmp22_ = self->priv->m_settings_panel;
#line 261 "panel.vala"
	g_signal_connect_object (_tmp22_, "changed::xkb-icon-rgba", (GCallback) ___lambda75__g_settings_changed, self, 0);
#line 265 "panel.vala"
	_tmp23_ = self->priv->m_settings_panel;
#line 265 "panel.vala"
	g_signal_connect_object (_tmp23_, "changed::property-icon-delay-time", (GCallback) ___lambda76__g_settings_changed, self, 0);
#line 1946 "panel.c"
}

static void
panel_popup_menu_at_area_window (Panel* self,
                                 GtkMenu* menu,
                                 GdkRectangle* area,
                                 GdkWindow* window,
                                 GtkMenuPositionFunc func,
                                 gpointer func_target)
{
	GdkGravity rect_anchor = 0;
	GdkGravity menu_anchor = 0;
	GdkRectangle _tmp0_;
#line 270 "panel.vala"
	g_return_if_fail (self != NULL);
#line 270 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 270 "panel.vala"
	g_return_if_fail (area != NULL);
#line 275 "panel.vala"
	rect_anchor = GDK_GRAVITY_SOUTH_WEST;
#line 276 "panel.vala"
	menu_anchor = GDK_GRAVITY_NORTH_WEST;
#line 285 "panel.vala"
	_tmp0_ = *area;
#line 285 "panel.vala"
	gtk_menu_popup_at_rect (menu, window, &_tmp0_, rect_anchor, menu_anchor, NULL);
#line 1974 "panel.c"
}

static gboolean
panel_is_kde (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp9_;
	gboolean result;
#line 293 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 293 "panel.vala"
	desktop = _tmp0_;
#line 295 "panel.vala"
	_tmp1_ = desktop;
#line 295 "panel.vala"
	if (g_strcmp0 (_tmp1_, "KDE") == 0) {
#line 296 "panel.vala"
		result = TRUE;
#line 296 "panel.vala"
		return result;
#line 2001 "panel.c"
	}
#line 302 "panel.vala"
	_tmp3_ = desktop;
#line 302 "panel.vala"
	if (_tmp3_ == NULL) {
#line 302 "panel.vala"
		_tmp2_ = TRUE;
#line 2009 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 302 "panel.vala"
		_tmp4_ = desktop;
#line 302 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2016 "panel.c"
	}
#line 302 "panel.vala"
	if (_tmp2_) {
#line 2020 "panel.c"
		const gchar* _tmp5_;
#line 303 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 303 "panel.vala"
		desktop = _tmp5_;
#line 2026 "panel.c"
	}
#line 304 "panel.vala"
	_tmp7_ = desktop;
#line 304 "panel.vala"
	if (g_strcmp0 (_tmp7_, "plasma") == 0) {
#line 304 "panel.vala"
		_tmp6_ = TRUE;
#line 2034 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 304 "panel.vala"
		_tmp8_ = desktop;
#line 304 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "KDE-wayland") == 0;
#line 2041 "panel.c"
	}
#line 304 "panel.vala"
	if (_tmp6_) {
#line 305 "panel.vala"
		result = TRUE;
#line 305 "panel.vala"
		return result;
#line 2049 "panel.c"
	}
#line 306 "panel.vala"
	_tmp9_ = desktop;
#line 306 "panel.vala"
	if (_tmp9_ == NULL) {
#line 307 "panel.vala"
		g_warning ("panel.vala:307: %s", "XDG_CURRENT_DESKTOP is not exported in your desktop " "session.");
#line 2057 "panel.c"
	}
#line 310 "panel.vala"
	g_warning ("panel.vala:310: %s", "If you launch KDE5 on xterm, " "export XDG_CURRENT_DESKTOP=KDE before launch KDE5.");
#line 312 "panel.vala"
	result = FALSE;
#line 312 "panel.vala"
	return result;
#line 2065 "panel.c"
}

static void
panel_popup_menu_at_pointer_window (Panel* self,
                                    GtkMenu* menu,
                                    gint x,
                                    gint y,
                                    GdkWindow* window,
                                    GtkMenuPositionFunc func,
                                    gpointer func_target)
{
	gint win_x = 0;
	gint win_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkRectangle area = {0};
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 315 "panel.vala"
	g_return_if_fail (self != NULL);
#line 315 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 320 "panel.vala"
	win_x = 0;
#line 321 "panel.vala"
	win_y = 0;
#line 322 "panel.vala"
	gdk_window_get_origin (window, &_tmp0_, &_tmp1_);
#line 322 "panel.vala"
	win_x = _tmp0_;
#line 322 "panel.vala"
	win_y = _tmp1_;
#line 323 "panel.vala"
	_tmp2_.x = x - win_x;
#line 323 "panel.vala"
	_tmp2_.y = y - win_y;
#line 323 "panel.vala"
	_tmp2_.width = 1;
#line 323 "panel.vala"
	_tmp2_.height = 1;
#line 323 "panel.vala"
	area = _tmp2_;
#line 325 "panel.vala"
	_tmp3_ = area;
#line 325 "panel.vala"
	panel_popup_menu_at_area_window (self, menu, &_tmp3_, window, func, func_target);
#line 2112 "panel.c"
}

static void
___lambda78_ (Panel* self)
{
	Indicator* _tmp0_;
#line 341 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 341 "panel.vala"
	indicator_set_status (_tmp0_, INDICATOR_STATUS_ACTIVE);
#line 342 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 2125 "panel.c"
}

static void
____lambda78__indicator_registered_status_notifier_item (Indicator* _sender,
                                                         gpointer self)
{
#line 338 "panel.vala"
	___lambda78_ ((Panel*) self);
#line 2134 "panel.c"
}

static void
_indicator_position_context_menu_gtk_menu_position_func (GtkMenu* menu,
                                                         gint* x,
                                                         gint* y,
                                                         gboolean* push_in,
                                                         gpointer self)
{
#line 346 "panel.vala"
	indicator_position_context_menu ((Indicator*) self, menu, x, y, push_in);
#line 2146 "panel.c"
}

static void
___lambda79_ (Panel* self,
              gint x,
              gint y,
              GdkWindow* w,
              guint b,
              guint t)
{
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	Indicator* _tmp2_;
#line 345 "panel.vala"
	g_return_if_fail (w != NULL);
#line 346 "panel.vala"
	_tmp0_ = panel_create_context_menu (self);
#line 346 "panel.vala"
	_tmp1_ = _tmp0_;
#line 346 "panel.vala"
	_tmp2_ = self->priv->m_indicator;
#line 346 "panel.vala"
	panel_popup_menu_at_pointer_window (self, _tmp1_, x, y, w, _indicator_position_context_menu_gtk_menu_position_func, _tmp2_);
#line 346 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2172 "panel.c"
}

static void
____lambda79__indicator_context_menu (Indicator* _sender,
                                      gint x,
                                      gint y,
                                      GdkWindow* window,
                                      guint button,
                                      guint activate_time,
                                      gpointer self)
{
#line 344 "panel.vala"
	___lambda79_ ((Panel*) self, x, y, window, button, activate_time);
#line 2186 "panel.c"
}

static void
_indicator_position_activate_menu_gtk_menu_position_func (GtkMenu* menu,
                                                          gint* x,
                                                          gint* y,
                                                          gboolean* push_in,
                                                          gpointer self)
{
#line 353 "panel.vala"
	indicator_position_activate_menu ((Indicator*) self, menu, x, y, push_in);
#line 2198 "panel.c"
}

static void
___lambda86_ (Panel* self,
              gint x,
              gint y,
              GdkWindow* w)
{
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	Indicator* _tmp2_;
#line 352 "panel.vala"
	g_return_if_fail (w != NULL);
#line 353 "panel.vala"
	_tmp0_ = panel_create_activate_menu (self);
#line 353 "panel.vala"
	_tmp1_ = _tmp0_;
#line 353 "panel.vala"
	_tmp2_ = self->priv->m_indicator;
#line 353 "panel.vala"
	panel_popup_menu_at_pointer_window (self, _tmp1_, x, y, w, _indicator_position_activate_menu_gtk_menu_position_func, _tmp2_);
#line 353 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2222 "panel.c"
}

static void
____lambda86__indicator_activate (Indicator* _sender,
                                  gint x,
                                  gint y,
                                  GdkWindow* window,
                                  gpointer self)
{
#line 351 "panel.vala"
	___lambda86_ ((Panel*) self, x, y, window);
#line 2234 "panel.c"
}

static void
__lambda77_ (Panel* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 330 "panel.vala"
	g_return_if_fail (res != NULL);
#line 2245 "panel.c"
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
		GDBusConnection* _tmp2_;
		GDBusConnection* _tmp3_;
		Indicator* _tmp4_;
		Indicator* _tmp5_;
		Indicator* _tmp6_;
		gulong _tmp7_;
		Indicator* _tmp8_;
		gulong _tmp9_;
		Indicator* _tmp10_;
		gulong _tmp11_;
#line 332 "panel.vala"
		_tmp1_ = g_bus_get_finish (res, &_inner_error0_);
#line 332 "panel.vala"
		_tmp0_ = _tmp1_;
#line 332 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "panel.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 2267 "panel.c"
				goto __catch0_g_io_error;
			}
#line 332 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 332 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 332 "panel.vala"
			return;
#line 2276 "panel.c"
		}
#line 332 "panel.vala"
		_tmp2_ = _tmp0_;
#line 332 "panel.vala"
		_tmp0_ = NULL;
#line 332 "panel.vala"
		_g_object_unref0 (self->priv->m_session_bus_connection);
#line 332 "panel.vala"
		self->priv->m_session_bus_connection = _tmp2_;
#line 333 "panel.vala"
		_tmp3_ = self->priv->m_session_bus_connection;
#line 333 "panel.vala"
		_tmp4_ = indicator_new ("ibus-ui-gtk3", _tmp3_, INDICATOR_CATEGORY_APPLICATION_STATUS);
#line 333 "panel.vala"
		g_object_ref_sink (_tmp4_);
#line 333 "panel.vala"
		_g_object_unref0 (self->priv->m_indicator);
#line 333 "panel.vala"
		self->priv->m_indicator = _tmp4_;
#line 337 "panel.vala"
		_tmp5_ = self->priv->m_indicator;
#line 337 "panel.vala"
		indicator_set_title (_tmp5_, _ ("IBus Panel"));
#line 338 "panel.vala"
		_tmp6_ = self->priv->m_indicator;
#line 338 "panel.vala"
		_tmp7_ = g_signal_connect_object (_tmp6_, "registered-status-notifier-item", (GCallback) ____lambda78__indicator_registered_status_notifier_item, self, 0);
#line 338 "panel.vala"
		self->priv->m_registered_status_notifier_item_id = _tmp7_;
#line 344 "panel.vala"
		_tmp8_ = self->priv->m_indicator;
#line 344 "panel.vala"
		_tmp9_ = g_signal_connect_object (_tmp8_, "context-menu", (GCallback) ____lambda79__indicator_context_menu, self, 0);
#line 344 "panel.vala"
		self->priv->m_popup_menu_id = _tmp9_;
#line 351 "panel.vala"
		_tmp10_ = self->priv->m_indicator;
#line 351 "panel.vala"
		_tmp11_ = g_signal_connect_object (_tmp10_, "activate", (GCallback) ____lambda86__indicator_activate, self, 0);
#line 351 "panel.vala"
		self->priv->m_activate_id = _tmp11_;
#line 331 "panel.vala"
		_g_object_unref0 (_tmp0_);
#line 2320 "panel.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 331 "panel.vala"
		e = _inner_error0_;
#line 331 "panel.vala"
		_inner_error0_ = NULL;
#line 359 "panel.vala"
		_tmp12_ = e;
#line 359 "panel.vala"
		_tmp13_ = _tmp12_->message;
#line 359 "panel.vala"
		g_warning ("panel.vala:359: Failed to get the session bus: %s", _tmp13_);
#line 331 "panel.vala"
		_g_error_free0 (e);
#line 2340 "panel.c"
	}
	__finally0:
#line 331 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 331 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 331 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 331 "panel.vala"
		return;
#line 2351 "panel.c"
	}
}

static void
___lambda77__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 330 "panel.vala"
	__lambda77_ ((Panel*) self, source_object, res);
#line 330 "panel.vala"
	g_object_unref (self);
#line 2364 "panel.c"
}

static void
panel_init_indicator (Panel* self)
{
#line 328 "panel.vala"
	g_return_if_fail (self != NULL);
#line 329 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_INDICATOR;
#line 330 "panel.vala"
	g_bus_get (G_BUS_TYPE_SESSION, NULL, ___lambda77__gasync_ready_callback, g_object_ref (self));
#line 2376 "panel.c"
}

static void
_panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 374 "panel.vala"
	panel_init_status_icon_menu ((Panel*) self);
#line 2386 "panel.c"
}

static void
panel_init_status_icon (Panel* self)
{
	GtkStatusIcon* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkStatusIcon* _tmp2_;
	GtkStatusIcon* _tmp3_;
#line 365 "panel.vala"
	g_return_if_fail (self != NULL);
#line 366 "panel.vala"
	_tmp0_ = gtk_status_icon_new ();
#line 366 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 366 "panel.vala"
	self->priv->m_status_icon = _tmp0_;
#line 367 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 367 "panel.vala"
	gtk_status_icon_set_name (_tmp1_, "ibus-ui-gtk");
#line 368 "panel.vala"
	_tmp2_ = self->priv->m_status_icon;
#line 368 "panel.vala"
	gtk_status_icon_set_title (_tmp2_, _ ("IBus Panel"));
#line 371 "panel.vala"
	_tmp3_ = self->priv->m_status_icon;
#line 371 "panel.vala"
	if (gtk_status_icon_get_size (_tmp3_) > 0) {
#line 372 "panel.vala"
		panel_init_status_icon_menu (self);
#line 2418 "panel.c"
	} else {
		GtkStatusIcon* _tmp4_;
#line 374 "panel.vala"
		_tmp4_ = self->priv->m_status_icon;
#line 374 "panel.vala"
		g_signal_connect_object ((GObject*) _tmp4_, "notify::size", (GCallback) _panel_init_status_icon_menu_g_object_notify, self, 0);
#line 2425 "panel.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 377 "panel.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 377 "panel.vala"
	return _data6_;
#line 2436 "panel.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 377 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2446 "panel.c"
		Panel* self;
#line 377 "panel.vala"
		self = _data6_->self;
#line 377 "panel.vala"
		(_data6_->func_target_destroy_notify == NULL) ? NULL : (_data6_->func_target_destroy_notify (_data6_->func_target), NULL);
#line 377 "panel.vala"
		_data6_->func = NULL;
#line 377 "panel.vala"
		_data6_->func_target = NULL;
#line 377 "panel.vala"
		_data6_->func_target_destroy_notify = NULL;
#line 377 "panel.vala"
		_g_object_unref0 (_data6_->window);
#line 377 "panel.vala"
		_g_object_unref0 (self);
#line 377 "panel.vala"
		g_slice_free (Block6Data, _data6_);
#line 2464 "panel.c"
	}
}

static void
__lambda88_ (Block6Data* _data6_,
             guint b,
             guint t)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 401 "panel.vala"
	self = _data6_->self;
#line 402 "panel.vala"
	_tmp0_ = panel_create_context_menu (self);
#line 402 "panel.vala"
	_tmp1_ = _tmp0_;
#line 402 "panel.vala"
	_tmp2_ = _data6_->area;
#line 402 "panel.vala"
	_tmp3_ = _data6_->window;
#line 402 "panel.vala"
	_tmp4_ = _data6_->func;
#line 402 "panel.vala"
	_tmp4__target = _data6_->func_target;
#line 402 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 402 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2498 "panel.c"
}

static void
___lambda88__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                         guint button,
                                         guint activate_time,
                                         gpointer self)
{
#line 401 "panel.vala"
	__lambda88_ (self, button, activate_time);
#line 2509 "panel.c"
}

static void
__lambda89_ (Block6Data* _data6_)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 406 "panel.vala"
	self = _data6_->self;
#line 407 "panel.vala"
	_tmp0_ = panel_create_activate_menu (self);
#line 407 "panel.vala"
	_tmp1_ = _tmp0_;
#line 407 "panel.vala"
	_tmp2_ = _data6_->area;
#line 407 "panel.vala"
	_tmp3_ = _data6_->window;
#line 407 "panel.vala"
	_tmp4_ = _data6_->func;
#line 407 "panel.vala"
	_tmp4__target = _data6_->func_target;
#line 407 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 407 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2540 "panel.c"
}

static void
___lambda89__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                       gpointer self)
{
#line 406 "panel.vala"
	__lambda89_ (self);
#line 2549 "panel.c"
}

static void
panel_init_status_icon_menu (Panel* self)
{
	Block6Data* _data6_;
	GdkRectangle _tmp0_ = {0};
	GdkDisplay* _tmp1_;
	GtkStatusIcon* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GtkOrientation orient = 0;
	GtkStatusIcon* _tmp6_;
	GdkRectangle _tmp7_ = {0};
	GtkOrientation _tmp8_ = 0;
	gint win_x = 0;
	gint win_y = 0;
	GdkWindow* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	GtkStatusIcon* _tmp12_;
	gulong _tmp13_;
	GtkStatusIcon* _tmp14_;
	gulong _tmp15_;
	GtkStatusIcon* _tmp16_;
#line 377 "panel.vala"
	g_return_if_fail (self != NULL);
#line 377 "panel.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 377 "panel.vala"
	_data6_->_ref_count_ = 1;
#line 377 "panel.vala"
	_data6_->self = g_object_ref (self);
#line 378 "panel.vala"
	_tmp0_.x = 0;
#line 378 "panel.vala"
	_tmp0_.y = 0;
#line 378 "panel.vala"
	_tmp0_.width = 0;
#line 378 "panel.vala"
	_tmp0_.height = 0;
#line 378 "panel.vala"
	_data6_->area = _tmp0_;
#line 379 "panel.vala"
	_data6_->window = NULL;
#line 380 "panel.vala"
	_data6_->func = NULL;
#line 380 "panel.vala"
	_data6_->func_target = NULL;
#line 380 "panel.vala"
	_data6_->func_target_destroy_notify = NULL;
#line 382 "panel.vala"
	_tmp1_ = gdk_display_get_default ();
#line 382 "panel.vala"
	_tmp2_ = self->priv->m_status_icon;
#line 382 "panel.vala"
	_tmp3_ = gdk_x11_window_lookup_for_display (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp1_) : NULL, (Window) gtk_status_icon_get_x11_window_id (_tmp2_));
#line 382 "panel.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_window_get_type ()) ? ((GdkWindow*) _tmp3_) : NULL);
#line 382 "panel.vala"
	_g_object_unref0 (_data6_->window);
#line 382 "panel.vala"
	_data6_->window = _tmp4_;
#line 385 "panel.vala"
	_tmp5_ = _data6_->window;
#line 385 "panel.vala"
	if (_tmp5_ == NULL) {
#line 386 "panel.vala"
		g_warning ("panel.vala:386: StatusIcon does not have GdkWindow");
#line 387 "panel.vala"
		block6_data_unref (_data6_);
#line 387 "panel.vala"
		_data6_ = NULL;
#line 387 "panel.vala"
		return;
#line 2626 "panel.c"
	}
#line 390 "panel.vala"
	_tmp6_ = self->priv->m_status_icon;
#line 390 "panel.vala"
	gtk_status_icon_get_geometry (_tmp6_, NULL, &_tmp7_, &_tmp8_);
#line 390 "panel.vala"
	_data6_->area = _tmp7_;
#line 390 "panel.vala"
	orient = _tmp8_;
#line 391 "panel.vala"
	win_x = 0;
#line 392 "panel.vala"
	win_y = 0;
#line 393 "panel.vala"
	_tmp9_ = _data6_->window;
#line 393 "panel.vala"
	gdk_window_get_origin (_tmp9_, &_tmp10_, &_tmp11_);
#line 393 "panel.vala"
	win_x = _tmp10_;
#line 393 "panel.vala"
	win_y = _tmp11_;
#line 396 "panel.vala"
	_data6_->area.x = _data6_->area.x - win_x;
#line 397 "panel.vala"
	_data6_->area.y = _data6_->area.y - win_y;
#line 401 "panel.vala"
	_tmp12_ = self->priv->m_status_icon;
#line 401 "panel.vala"
	_tmp13_ = g_signal_connect_data (_tmp12_, "popup-menu", (GCallback) ___lambda88__gtk_status_icon_popup_menu, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 401 "panel.vala"
	self->priv->m_popup_menu_id = _tmp13_;
#line 406 "panel.vala"
	_tmp14_ = self->priv->m_status_icon;
#line 406 "panel.vala"
	_tmp15_ = g_signal_connect_data (_tmp14_, "activate", (GCallback) ___lambda89__gtk_status_icon_activate, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 406 "panel.vala"
	self->priv->m_activate_id = _tmp15_;
#line 411 "panel.vala"
	_tmp16_ = self->priv->m_status_icon;
#line 411 "panel.vala"
	gtk_status_icon_set_from_icon_name (_tmp16_, "ibus-keyboard");
#line 377 "panel.vala"
	block6_data_unref (_data6_);
#line 377 "panel.vala"
	_data6_ = NULL;
#line 2672 "panel.c"
}

static void
_panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                               gpointer self)
{
#line 420 "panel.vala"
	panel_handle_engine_switch_normal ((Panel*) self, event);
#line 2681 "panel.c"
}

static void
_panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                gpointer self)
{
#line 420 "panel.vala"
	panel_handle_engine_switch_reverse ((Panel*) self, event);
#line 2690 "panel.c"
}

static void
panel_bind_switch_shortcut (Panel* self)
{
	gchar** accelerators = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint accelerators_length1;
	gint _accelerators_size_;
	KeybindingManager* keybinding_manager = NULL;
	KeybindingManager* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 414 "panel.vala"
	g_return_if_fail (self != NULL);
#line 415 "panel.vala"
	_tmp0_ = self->priv->m_settings_hotkey;
#line 415 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "triggers");
#line 415 "panel.vala"
	accelerators = _tmp2_;
#line 415 "panel.vala"
	accelerators_length1 = _vala_array_length (_tmp1_);
#line 415 "panel.vala"
	_accelerators_size_ = accelerators_length1;
#line 417 "panel.vala"
	_tmp3_ = keybinding_manager_get_instance ();
#line 417 "panel.vala"
	keybinding_manager = _tmp3_;
#line 419 "panel.vala"
	_tmp4_ = accelerators;
#line 419 "panel.vala"
	_tmp4__length1 = accelerators_length1;
#line 2726 "panel.c"
	{
		gchar** accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 419 "panel.vala"
		accelerator_collection = _tmp4_;
#line 419 "panel.vala"
		accelerator_collection_length1 = _tmp4__length1;
#line 419 "panel.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 2738 "panel.c"
			gchar* _tmp5_;
			gchar* accelerator = NULL;
#line 419 "panel.vala"
			_tmp5_ = g_strdup (accelerator_collection[accelerator_it]);
#line 419 "panel.vala"
			accelerator = _tmp5_;
#line 2745 "panel.c"
			{
				KeybindingManager* _tmp6_;
				const gchar* _tmp7_;
#line 420 "panel.vala"
				_tmp6_ = keybinding_manager;
#line 420 "panel.vala"
				_tmp7_ = accelerator;
#line 420 "panel.vala"
				binding_common_keybinding_manager_bind (_tmp6_, &self->priv->m_keybindings, _tmp7_, BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER, _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func, self, _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func, self);
#line 419 "panel.vala"
				_g_free0 (accelerator);
#line 2757 "panel.c"
			}
		}
	}
#line 414 "panel.vala"
	_g_object_unref0 (keybinding_manager);
#line 414 "panel.vala"
	accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 2765 "panel.c"
}

/**
     * panel_get_engines_from_xkb:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus xkb engines
     *
     * Made ibus engines from the current XKB keymaps.
     * This returns only XKB engines whose name start with "xkb:".
     */
static GList*
panel_get_engines_from_xkb (Panel* self,
                            GList* engines)
{
	gchar* layouts = NULL;
	gchar* variants = NULL;
	gchar* option = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GList* xkb_engines = NULL;
	IBusEngineDesc* us_engine = NULL;
	IBusEngineDesc* _tmp3_;
	gchar** layout_array = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint layout_array_length1;
	gint _layout_array_size_;
	gchar** variant_array = NULL;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint variant_array_length1;
	gint _variant_array_size_;
	GList* _tmp45_;
	GList* result;
#line 458 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 463 "panel.vala"
	xkb_layout_get_layout (&_tmp0_, &_tmp1_, &_tmp2_);
#line 463 "panel.vala"
	_g_free0 (layouts);
#line 463 "panel.vala"
	layouts = _tmp0_;
#line 463 "panel.vala"
	_g_free0 (variants);
#line 463 "panel.vala"
	variants = _tmp1_;
#line 463 "panel.vala"
	_g_free0 (option);
#line 463 "panel.vala"
	option = _tmp2_;
#line 465 "panel.vala"
	xkb_engines = NULL;
#line 467 "panel.vala"
	_tmp3_ = ibus_engine_desc_new ("xkb:us::eng", "", "", "", "", "", "", "");
#line 467 "panel.vala"
	g_object_ref_sink (_tmp3_);
#line 467 "panel.vala"
	us_engine = _tmp3_;
#line 470 "panel.vala"
	_tmp4_ = layouts;
#line 470 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ",", 0);
#line 470 "panel.vala"
	layout_array = _tmp6_;
#line 470 "panel.vala"
	layout_array_length1 = _vala_array_length (_tmp5_);
#line 470 "panel.vala"
	_layout_array_size_ = layout_array_length1;
#line 471 "panel.vala"
	_tmp7_ = variants;
#line 471 "panel.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ",", 0);
#line 471 "panel.vala"
	variant_array = _tmp9_;
#line 471 "panel.vala"
	variant_array_length1 = _vala_array_length (_tmp8_);
#line 471 "panel.vala"
	_variant_array_size_ = variant_array_length1;
#line 2848 "panel.c"
	{
		gint i = 0;
#line 473 "panel.vala"
		i = 0;
#line 2853 "panel.c"
		{
			gboolean _tmp10_ = FALSE;
#line 473 "panel.vala"
			_tmp10_ = TRUE;
#line 473 "panel.vala"
			while (TRUE) {
#line 2860 "panel.c"
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar* layout = NULL;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* variant = NULL;
				IBusEngineDesc* current_engine = NULL;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp20_;
				IBusEngineDesc* _tmp35_;
#line 473 "panel.vala"
				if (!_tmp10_) {
#line 2876 "panel.c"
					gint _tmp11_;
#line 473 "panel.vala"
					_tmp11_ = i;
#line 473 "panel.vala"
					i = _tmp11_ + 1;
#line 2882 "panel.c"
				}
#line 473 "panel.vala"
				_tmp10_ = FALSE;
#line 473 "panel.vala"
				_tmp12_ = layout_array;
#line 473 "panel.vala"
				_tmp12__length1 = layout_array_length1;
#line 473 "panel.vala"
				if (!(i < _tmp12__length1)) {
#line 473 "panel.vala"
					break;
#line 2894 "panel.c"
				}
#line 474 "panel.vala"
				_tmp13_ = layout_array;
#line 474 "panel.vala"
				_tmp13__length1 = layout_array_length1;
#line 474 "panel.vala"
				_tmp14_ = _tmp13_[i];
#line 474 "panel.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 474 "panel.vala"
				layout = _tmp15_;
#line 475 "panel.vala"
				variant = NULL;
#line 476 "panel.vala"
				current_engine = NULL;
#line 478 "panel.vala"
				_tmp16_ = variant_array;
#line 478 "panel.vala"
				_tmp16__length1 = variant_array_length1;
#line 478 "panel.vala"
				if (i < _tmp16__length1) {
#line 2916 "panel.c"
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 479 "panel.vala"
					_tmp17_ = variant_array;
#line 479 "panel.vala"
					_tmp17__length1 = variant_array_length1;
#line 479 "panel.vala"
					_tmp18_ = _tmp17_[i];
#line 479 "panel.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 479 "panel.vala"
					_g_free0 (variant);
#line 479 "panel.vala"
					variant = _tmp19_;
#line 2933 "panel.c"
				}
#line 485 "panel.vala"
				_tmp20_ = variant;
#line 485 "panel.vala"
				if (_tmp20_ == NULL) {
#line 2939 "panel.c"
					gchar* _tmp21_;
#line 486 "panel.vala"
					_tmp21_ = g_strdup ("");
#line 486 "panel.vala"
					_g_free0 (variant);
#line 486 "panel.vala"
					variant = _tmp21_;
#line 2947 "panel.c"
				}
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
#line 488 "panel.vala"
					engine_collection = engines;
#line 488 "panel.vala"
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 2956 "panel.c"
						IBusEngineDesc* engine = NULL;
#line 488 "panel.vala"
						engine = (IBusEngineDesc*) engine_it->data;
#line 2960 "panel.c"
						{
							gchar* name = NULL;
							IBusEngineDesc* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
							const gchar* _tmp25_;
							gboolean _tmp26_ = FALSE;
							IBusEngineDesc* _tmp27_;
							const gchar* _tmp28_;
							const gchar* _tmp29_;
#line 490 "panel.vala"
							_tmp22_ = engine;
#line 490 "panel.vala"
							_tmp23_ = ibus_engine_desc_get_name (_tmp22_);
#line 490 "panel.vala"
							_tmp24_ = g_strdup (_tmp23_);
#line 490 "panel.vala"
							name = _tmp24_;
#line 491 "panel.vala"
							_tmp25_ = name;
#line 491 "panel.vala"
							if (!g_str_has_prefix (_tmp25_, "xkb:")) {
#line 492 "panel.vala"
								_g_free0 (name);
#line 492 "panel.vala"
								continue;
#line 2987 "panel.c"
							}
#line 494 "panel.vala"
							_tmp27_ = engine;
#line 494 "panel.vala"
							_tmp28_ = ibus_engine_desc_get_layout (_tmp27_);
#line 494 "panel.vala"
							_tmp29_ = layout;
#line 494 "panel.vala"
							if (g_strcmp0 (_tmp28_, _tmp29_) == 0) {
#line 2997 "panel.c"
								IBusEngineDesc* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
#line 495 "panel.vala"
								_tmp30_ = engine;
#line 495 "panel.vala"
								_tmp31_ = ibus_engine_desc_get_layout_variant (_tmp30_);
#line 495 "panel.vala"
								_tmp32_ = variant;
#line 495 "panel.vala"
								_tmp26_ = g_strcmp0 (_tmp31_, _tmp32_) == 0;
#line 3009 "panel.c"
							} else {
#line 494 "panel.vala"
								_tmp26_ = FALSE;
#line 3013 "panel.c"
							}
#line 494 "panel.vala"
							if (_tmp26_) {
#line 3017 "panel.c"
								IBusEngineDesc* _tmp33_;
								IBusEngineDesc* _tmp34_;
#line 496 "panel.vala"
								_tmp33_ = engine;
#line 496 "panel.vala"
								_tmp34_ = _g_object_ref0 (_tmp33_);
#line 496 "panel.vala"
								_g_object_unref0 (current_engine);
#line 496 "panel.vala"
								current_engine = _tmp34_;
#line 497 "panel.vala"
								_g_free0 (name);
#line 497 "panel.vala"
								break;
#line 3032 "panel.c"
							}
#line 488 "panel.vala"
							_g_free0 (name);
#line 3036 "panel.c"
						}
					}
				}
#line 501 "panel.vala"
				_tmp35_ = current_engine;
#line 501 "panel.vala"
				if (_tmp35_ != NULL) {
#line 3044 "panel.c"
					IBusEngineDesc* _tmp36_;
					IBusEngineDesc* _tmp37_;
#line 502 "panel.vala"
					_tmp36_ = current_engine;
#line 502 "panel.vala"
					_tmp37_ = _g_object_ref0 (_tmp36_);
#line 502 "panel.vala"
					xkb_engines = g_list_append (xkb_engines, _tmp37_);
#line 3053 "panel.c"
				} else {
					GList* _tmp38_;
					IBusEngineDesc* _tmp39_;
					GList* _tmp40_;
#line 503 "panel.vala"
					_tmp38_ = xkb_engines;
#line 503 "panel.vala"
					_tmp39_ = us_engine;
#line 503 "panel.vala"
					_tmp40_ = g_list_find (_tmp38_, _tmp39_);
#line 503 "panel.vala"
					if (_tmp40_ == NULL) {
#line 3066 "panel.c"
						const gchar* _tmp41_;
						const gchar* _tmp42_;
						IBusEngineDesc* _tmp43_;
						IBusEngineDesc* _tmp44_;
#line 504 "panel.vala"
						_tmp41_ = layout;
#line 504 "panel.vala"
						_tmp42_ = variant;
#line 504 "panel.vala"
						g_warning ("panel.vala:504: Fallback %s(%s) to us layout.", _tmp41_, _tmp42_);
#line 505 "panel.vala"
						_tmp43_ = us_engine;
#line 505 "panel.vala"
						_tmp44_ = _g_object_ref0 (_tmp43_);
#line 505 "panel.vala"
						xkb_engines = g_list_append (xkb_engines, _tmp44_);
#line 3083 "panel.c"
					}
				}
#line 473 "panel.vala"
				_g_object_unref0 (current_engine);
#line 473 "panel.vala"
				_g_free0 (variant);
#line 473 "panel.vala"
				_g_free0 (layout);
#line 3092 "panel.c"
			}
		}
	}
#line 509 "panel.vala"
	_tmp45_ = xkb_engines;
#line 509 "panel.vala"
	if (g_list_length (_tmp45_) == ((guint) 0)) {
#line 510 "panel.vala"
		g_warning ("panel.vala:510: Not found IBus XKB engines from the session.");
#line 3102 "panel.c"
	}
#line 512 "panel.vala"
	result = xkb_engines;
#line 512 "panel.vala"
	variant_array = (_vala_array_free (variant_array, variant_array_length1, (GDestroyNotify) g_free), NULL);
#line 512 "panel.vala"
	layout_array = (_vala_array_free (layout_array, layout_array_length1, (GDestroyNotify) g_free), NULL);
#line 512 "panel.vala"
	_g_object_unref0 (us_engine);
#line 512 "panel.vala"
	_g_free0 (option);
#line 512 "panel.vala"
	_g_free0 (variants);
#line 512 "panel.vala"
	_g_free0 (layouts);
#line 512 "panel.vala"
	return result;
#line 3120 "panel.c"
}

/**
     * panel_get_engines_from_locale:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus im engines
     *
     * Made ibus engines from the current locale and IBus.EngineDesc.lang .
     * This returns non-XKB engines whose name does not start "xkb:".
     */
static gint
__lambda97_ (IBusEngineDesc* a,
             IBusEngineDesc* b)
{
	gint result;
#line 564 "panel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 564 "panel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 565 "panel.vala"
	result = ((gint) ibus_engine_desc_get_rank (b)) - ((gint) ibus_engine_desc_get_rank (a));
#line 565 "panel.vala"
	return result;
#line 3145 "panel.c"
}

static gint
___lambda97__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda97_ ((IBusEngineDesc*) a, (IBusEngineDesc*) b);
#line 564 "panel.vala"
	return result;
#line 3156 "panel.c"
}

static GList*
panel_get_engines_from_locale (Panel* self,
                               GList* engines)
{
	gchar* locale = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* lang = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GList* im_engines = NULL;
	GList* _tmp22_;
	GList* _tmp40_;
	GList* result;
#line 524 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 526 "panel.vala"
	_tmp0_ = setlocale (LC_CTYPE, NULL);
#line 526 "panel.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 526 "panel.vala"
	locale = _tmp1_;
#line 528 "panel.vala"
	_tmp2_ = locale;
#line 528 "panel.vala"
	if (_tmp2_ == NULL) {
#line 3192 "panel.c"
		gchar* _tmp3_;
#line 529 "panel.vala"
		_tmp3_ = g_strdup ("C");
#line 529 "panel.vala"
		_g_free0 (locale);
#line 529 "panel.vala"
		locale = _tmp3_;
#line 3200 "panel.c"
	}
#line 531 "panel.vala"
	_tmp4_ = locale;
#line 531 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ".", 0);
#line 531 "panel.vala"
	_tmp7_ = _tmp6_;
#line 531 "panel.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 531 "panel.vala"
	_tmp8_ = _tmp7_[0];
#line 531 "panel.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 531 "panel.vala"
	_tmp10_ = _tmp9_;
#line 531 "panel.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 531 "panel.vala"
	lang = _tmp10_;
#line 532 "panel.vala"
	im_engines = NULL;
#line 3222 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 535 "panel.vala"
		engine_collection = engines;
#line 535 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3230 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 535 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3234 "panel.c"
			{
				gchar* name = NULL;
				IBusEngineDesc* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				gboolean _tmp15_ = FALSE;
				IBusEngineDesc* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 536 "panel.vala"
				_tmp11_ = engine;
#line 536 "panel.vala"
				_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
#line 536 "panel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 536 "panel.vala"
				name = _tmp13_;
#line 538 "panel.vala"
				_tmp14_ = name;
#line 538 "panel.vala"
				if (g_str_has_prefix (_tmp14_, "xkb:")) {
#line 539 "panel.vala"
					_g_free0 (name);
#line 539 "panel.vala"
					continue;
#line 3261 "panel.c"
				}
#line 541 "panel.vala"
				_tmp16_ = engine;
#line 541 "panel.vala"
				_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
#line 541 "panel.vala"
				_tmp18_ = lang;
#line 541 "panel.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 3271 "panel.c"
					IBusEngineDesc* _tmp19_;
#line 542 "panel.vala"
					_tmp19_ = engine;
#line 542 "panel.vala"
					_tmp15_ = ibus_engine_desc_get_rank (_tmp19_) > ((guint) 0);
#line 3277 "panel.c"
				} else {
#line 541 "panel.vala"
					_tmp15_ = FALSE;
#line 3281 "panel.c"
				}
#line 541 "panel.vala"
				if (_tmp15_) {
#line 3285 "panel.c"
					IBusEngineDesc* _tmp20_;
					IBusEngineDesc* _tmp21_;
#line 543 "panel.vala"
					_tmp20_ = engine;
#line 543 "panel.vala"
					_tmp21_ = _g_object_ref0 (_tmp20_);
#line 543 "panel.vala"
					im_engines = g_list_append (im_engines, _tmp21_);
#line 3294 "panel.c"
				}
#line 535 "panel.vala"
				_g_free0 (name);
#line 3298 "panel.c"
			}
		}
	}
#line 546 "panel.vala"
	_tmp22_ = im_engines;
#line 546 "panel.vala"
	if (g_list_length (_tmp22_) == ((guint) 0)) {
#line 3306 "panel.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 547 "panel.vala"
		_tmp23_ = lang;
#line 547 "panel.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "_", 0);
#line 547 "panel.vala"
		_tmp26_ = _tmp25_;
#line 547 "panel.vala"
		_tmp26__length1 = _vala_array_length (_tmp24_);
#line 547 "panel.vala"
		_tmp27_ = _tmp26_[0];
#line 547 "panel.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 547 "panel.vala"
		_g_free0 (lang);
#line 547 "panel.vala"
		lang = _tmp28_;
#line 547 "panel.vala"
		_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 3332 "panel.c"
		{
			GList* engine_collection = NULL;
			GList* engine_it = NULL;
#line 549 "panel.vala"
			engine_collection = engines;
#line 549 "panel.vala"
			for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3340 "panel.c"
				IBusEngineDesc* engine = NULL;
#line 549 "panel.vala"
				engine = (IBusEngineDesc*) engine_it->data;
#line 3344 "panel.c"
				{
					gchar* name = NULL;
					IBusEngineDesc* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_ = FALSE;
					IBusEngineDesc* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
#line 550 "panel.vala"
					_tmp29_ = engine;
#line 550 "panel.vala"
					_tmp30_ = ibus_engine_desc_get_name (_tmp29_);
#line 550 "panel.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 550 "panel.vala"
					name = _tmp31_;
#line 552 "panel.vala"
					_tmp32_ = name;
#line 552 "panel.vala"
					if (g_str_has_prefix (_tmp32_, "xkb:")) {
#line 553 "panel.vala"
						_g_free0 (name);
#line 553 "panel.vala"
						continue;
#line 3371 "panel.c"
					}
#line 555 "panel.vala"
					_tmp34_ = engine;
#line 555 "panel.vala"
					_tmp35_ = ibus_engine_desc_get_language (_tmp34_);
#line 555 "panel.vala"
					_tmp36_ = lang;
#line 555 "panel.vala"
					if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 3381 "panel.c"
						IBusEngineDesc* _tmp37_;
#line 556 "panel.vala"
						_tmp37_ = engine;
#line 556 "panel.vala"
						_tmp33_ = ibus_engine_desc_get_rank (_tmp37_) > ((guint) 0);
#line 3387 "panel.c"
					} else {
#line 555 "panel.vala"
						_tmp33_ = FALSE;
#line 3391 "panel.c"
					}
#line 555 "panel.vala"
					if (_tmp33_) {
#line 3395 "panel.c"
						IBusEngineDesc* _tmp38_;
						IBusEngineDesc* _tmp39_;
#line 557 "panel.vala"
						_tmp38_ = engine;
#line 557 "panel.vala"
						_tmp39_ = _g_object_ref0 (_tmp38_);
#line 557 "panel.vala"
						im_engines = g_list_append (im_engines, _tmp39_);
#line 3404 "panel.c"
					}
#line 549 "panel.vala"
					_g_free0 (name);
#line 3408 "panel.c"
				}
			}
		}
	}
#line 561 "panel.vala"
	_tmp40_ = im_engines;
#line 561 "panel.vala"
	if (g_list_length (_tmp40_) == ((guint) 0)) {
#line 562 "panel.vala"
		result = im_engines;
#line 562 "panel.vala"
		_g_free0 (lang);
#line 562 "panel.vala"
		_g_free0 (locale);
#line 562 "panel.vala"
		return result;
#line 3425 "panel.c"
	}
#line 564 "panel.vala"
	im_engines = g_list_sort (im_engines, ___lambda97__gcompare_func);
#line 568 "panel.vala"
	result = im_engines;
#line 568 "panel.vala"
	_g_free0 (lang);
#line 568 "panel.vala"
	_g_free0 (locale);
#line 568 "panel.vala"
	return result;
#line 3437 "panel.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 593 "panel.vala"
	if ((*length) == (*size)) {
#line 593 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 593 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3452 "panel.c"
	}
#line 593 "panel.vala"
	(*array)[(*length)++] = value;
#line 593 "panel.vala"
	(*array)[*length] = NULL;
#line 3458 "panel.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 595 "panel.vala"
	if ((*length) == (*size)) {
#line 595 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 595 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3473 "panel.c"
	}
#line 595 "panel.vala"
	(*array)[(*length)++] = value;
#line 595 "panel.vala"
	(*array)[*length] = NULL;
#line 3479 "panel.c"
}

static void
panel_init_engines_order (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_;
	GList* engines = NULL;
	IBusBus* _tmp10_;
	GList* _tmp11_;
	GList* xkb_engines = NULL;
	GList* _tmp12_;
	GList* _tmp13_;
	GList* im_engines = NULL;
	GList* _tmp14_;
	GList* _tmp15_;
	gchar** names = NULL;
	gchar** _tmp17_;
	gint names_length1;
	gint _names_size_;
	GList* _tmp18_;
	GList* _tmp22_;
	GSettings* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
#line 571 "panel.vala"
	g_return_if_fail (self != NULL);
#line 572 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 572 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 572 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "xkb-latin-layouts");
#line 572 "panel.vala"
	_tmp4_ = _tmp3_;
#line 572 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 572 "panel.vala"
	xkb_layout_set_latin_layouts (_tmp0_, _tmp4_, (gint) _vala_array_length (_tmp2_));
#line 572 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 575 "panel.vala"
	if (self->priv->inited_engines_order) {
#line 576 "panel.vala"
		return;
#line 3535 "panel.c"
	}
#line 578 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 578 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "preload-engines");
#line 578 "panel.vala"
	_tmp8_ = _tmp7_;
#line 578 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 578 "panel.vala"
	_tmp9_ = _vala_array_length (_tmp6_) > 0;
#line 578 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 578 "panel.vala"
	if (_tmp9_) {
#line 579 "panel.vala"
		return;
#line 3553 "panel.c"
	}
#line 581 "panel.vala"
	_tmp10_ = self->priv->m_bus;
#line 581 "panel.vala"
	_tmp11_ = ibus_bus_list_engines (_tmp10_);
#line 581 "panel.vala"
	engines = _tmp11_;
#line 582 "panel.vala"
	_tmp12_ = engines;
#line 582 "panel.vala"
	_tmp13_ = panel_get_engines_from_xkb (self, _tmp12_);
#line 582 "panel.vala"
	xkb_engines = _tmp13_;
#line 583 "panel.vala"
	_tmp14_ = engines;
#line 583 "panel.vala"
	_tmp15_ = panel_get_engines_from_locale (self, _tmp14_);
#line 583 "panel.vala"
	im_engines = _tmp15_;
#line 586 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 3575 "panel.c"
		GList* _tmp16_;
#line 587 "panel.vala"
		_tmp16_ = xkb_engines;
#line 587 "panel.vala"
		if (g_list_length (_tmp16_) > ((guint) 0)) {
#line 588 "panel.vala"
			(xkb_engines == NULL) ? NULL : (xkb_engines = (_g_list_free__g_object_unref0_ (xkb_engines), NULL));
#line 588 "panel.vala"
			xkb_engines = NULL;
#line 3585 "panel.c"
		}
	}
#line 591 "panel.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 591 "panel.vala"
	names = _tmp17_;
#line 591 "panel.vala"
	names_length1 = 0;
#line 591 "panel.vala"
	_names_size_ = names_length1;
#line 592 "panel.vala"
	_tmp18_ = xkb_engines;
#line 3598 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 592 "panel.vala"
		engine_collection = _tmp18_;
#line 592 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3606 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 592 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3610 "panel.c"
			{
				IBusEngineDesc* _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
#line 593 "panel.vala"
				_tmp19_ = engine;
#line 593 "panel.vala"
				_tmp20_ = ibus_engine_desc_get_name (_tmp19_);
#line 593 "panel.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 593 "panel.vala"
				_vala_array_add17 (&names, &names_length1, &_names_size_, _tmp21_);
#line 3623 "panel.c"
			}
		}
	}
#line 594 "panel.vala"
	_tmp22_ = im_engines;
#line 3629 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 594 "panel.vala"
		engine_collection = _tmp22_;
#line 594 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3637 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 594 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3641 "panel.c"
			{
				IBusEngineDesc* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
#line 595 "panel.vala"
				_tmp23_ = engine;
#line 595 "panel.vala"
				_tmp24_ = ibus_engine_desc_get_name (_tmp23_);
#line 595 "panel.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 595 "panel.vala"
				_vala_array_add18 (&names, &names_length1, &_names_size_, _tmp25_);
#line 3654 "panel.c"
			}
		}
	}
#line 597 "panel.vala"
	_tmp26_ = self->priv->m_settings_general;
#line 597 "panel.vala"
	_tmp27_ = names;
#line 597 "panel.vala"
	_tmp27__length1 = names_length1;
#line 597 "panel.vala"
	g_settings_set_strv (_tmp26_, "preload-engines", _tmp27_);
#line 571 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 571 "panel.vala"
	(im_engines == NULL) ? NULL : (im_engines = (_g_list_free__g_object_unref0_ (im_engines), NULL));
#line 571 "panel.vala"
	(xkb_engines == NULL) ? NULL : (xkb_engines = (_g_list_free__g_object_unref0_ (xkb_engines), NULL));
#line 571 "panel.vala"
	(engines == NULL) ? NULL : (engines = (_g_list_free__g_object_unref0_ (engines), NULL));
#line 3674 "panel.c"
}

static void
panel_set_switcher_delay_time (Panel* self)
{
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Switcher* _tmp2_;
#line 601 "panel.vala"
	g_return_if_fail (self != NULL);
#line 602 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 602 "panel.vala"
	self->priv->m_switcher_delay_time = g_settings_get_int (_tmp0_, "switcher-delay-time");
#line 605 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 605 "panel.vala"
	if (_tmp2_ != NULL) {
#line 605 "panel.vala"
		_tmp1_ = self->priv->m_switcher_delay_time >= 0;
#line 3695 "panel.c"
	} else {
#line 605 "panel.vala"
		_tmp1_ = FALSE;
#line 3699 "panel.c"
	}
#line 605 "panel.vala"
	if (_tmp1_) {
#line 3703 "panel.c"
		Switcher* _tmp3_;
#line 606 "panel.vala"
		_tmp3_ = self->priv->m_switcher;
#line 606 "panel.vala"
		switcher_set_popup_delay_time (_tmp3_, (guint) self->priv->m_switcher_delay_time);
#line 3709 "panel.c"
	}
}

static void
panel_set_use_system_keyboard_layout (Panel* self)
{
	GSettings* _tmp0_;
#line 610 "panel.vala"
	g_return_if_fail (self != NULL);
#line 611 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 611 "panel.vala"
	self->priv->m_use_system_keyboard_layout = g_settings_get_boolean (_tmp0_, "use-system-keyboard-layout");
#line 3723 "panel.c"
}

static void
panel_set_embed_preedit_text (Panel* self)
{
	GVariant* variant = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	IBusBus* _tmp3_;
	GVariant* _tmp4_;
#line 615 "panel.vala"
	g_return_if_fail (self != NULL);
#line 616 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 616 "panel.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "embed-preedit-text");
#line 616 "panel.vala"
	variant = _tmp1_;
#line 619 "panel.vala"
	_tmp2_ = variant;
#line 619 "panel.vala"
	if (_tmp2_ == NULL) {
#line 620 "panel.vala"
		_g_variant_unref0 (variant);
#line 620 "panel.vala"
		return;
#line 3751 "panel.c"
	}
#line 623 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 623 "panel.vala"
	_tmp4_ = variant;
#line 623 "panel.vala"
	ibus_bus_set_ibus_property (_tmp3_, "EmbedPreeditText", _tmp4_);
#line 615 "panel.vala"
	_g_variant_unref0 (variant);
#line 3761 "panel.c"
}

static void
panel_set_use_global_engine (Panel* self)
{
	GSettings* _tmp0_;
#line 626 "panel.vala"
	g_return_if_fail (self != NULL);
#line 627 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 627 "panel.vala"
	self->priv->m_use_global_engine = g_settings_get_boolean (_tmp0_, "use-global-engine");
#line 3774 "panel.c"
}

static void
panel_set_use_xmodmap (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
#line 631 "panel.vala"
	g_return_if_fail (self != NULL);
#line 632 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 632 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 632 "panel.vala"
	xkb_layout_set_use_xmodmap (_tmp0_, g_settings_get_boolean (_tmp1_, "use-xmodmap"));
#line 3790 "panel.c"
}

static void
panel_set_show_icon_on_systray (Panel* self)
{
#line 636 "panel.vala"
	g_return_if_fail (self != NULL);
#line 637 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 3800 "panel.c"
		GtkStatusIcon* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GSettings* _tmp2_;
#line 638 "panel.vala"
		_tmp0_ = self->priv->m_status_icon;
#line 638 "panel.vala"
		if (_tmp0_ == NULL) {
#line 639 "panel.vala"
			return;
#line 3810 "panel.c"
		}
#line 641 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 641 "panel.vala"
		_tmp2_ = self->priv->m_settings_panel;
#line 641 "panel.vala"
		gtk_status_icon_set_visible (_tmp1_, g_settings_get_boolean (_tmp2_, "show-icon-on-systray"));
#line 3818 "panel.c"
	} else {
#line 643 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 3822 "panel.c"
			Indicator* _tmp3_;
			GSettings* _tmp4_;
#line 644 "panel.vala"
			_tmp3_ = self->priv->m_indicator;
#line 644 "panel.vala"
			if (_tmp3_ == NULL) {
#line 645 "panel.vala"
				return;
#line 3831 "panel.c"
			}
#line 647 "panel.vala"
			_tmp4_ = self->priv->m_settings_panel;
#line 647 "panel.vala"
			if (g_settings_get_boolean (_tmp4_, "show-icon-on-systray")) {
#line 3837 "panel.c"
				Indicator* _tmp5_;
#line 648 "panel.vala"
				_tmp5_ = self->priv->m_indicator;
#line 648 "panel.vala"
				indicator_set_status (_tmp5_, INDICATOR_STATUS_ACTIVE);
#line 3843 "panel.c"
			} else {
				Indicator* _tmp6_;
#line 650 "panel.vala"
				_tmp6_ = self->priv->m_indicator;
#line 650 "panel.vala"
				indicator_set_status (_tmp6_, INDICATOR_STATUS_PASSIVE);
#line 3850 "panel.c"
			}
		}
	}
}

static void
panel_set_lookup_table_orientation (Panel* self)
{
	CandidatePanel* _tmp0_;
	CandidatePanel* _tmp1_;
	GSettings* _tmp2_;
#line 654 "panel.vala"
	g_return_if_fail (self != NULL);
#line 655 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 655 "panel.vala"
	if (_tmp0_ == NULL) {
#line 656 "panel.vala"
		return;
#line 3870 "panel.c"
	}
#line 658 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 658 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 658 "panel.vala"
	candidate_panel_set_vertical (_tmp1_, g_settings_get_int (_tmp2_, "lookup-table-orientation") == ((gint) IBUS_ORIENTATION_VERTICAL));
#line 3878 "panel.c"
}

static void
panel_set_show_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 663 "panel.vala"
	g_return_if_fail (self != NULL);
#line 664 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 664 "panel.vala"
	if (_tmp0_ == NULL) {
#line 665 "panel.vala"
		return;
#line 3895 "panel.c"
	}
#line 667 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 667 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 667 "panel.vala"
	property_panel_set_show (_tmp1_, g_settings_get_int (_tmp2_, "show"));
#line 3903 "panel.c"
}

static void
panel_set_timeout_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 670 "panel.vala"
	g_return_if_fail (self != NULL);
#line 671 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 671 "panel.vala"
	if (_tmp0_ == NULL) {
#line 672 "panel.vala"
		return;
#line 3920 "panel.c"
	}
#line 674 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 674 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 674 "panel.vala"
	property_panel_set_auto_hide_timeout (_tmp1_, (guint) g_settings_get_int (_tmp2_, "auto-hide-timeout"));
#line 3928 "panel.c"
}

static void
panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 678 "panel.vala"
	g_return_if_fail (self != NULL);
#line 679 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 679 "panel.vala"
	if (_tmp0_ == NULL) {
#line 680 "panel.vala"
		return;
#line 3945 "panel.c"
	}
#line 682 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 682 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 682 "panel.vala"
	property_panel_set_follow_input_cursor_when_always_shown (_tmp1_, g_settings_get_boolean (_tmp2_, "follow-input-cursor-when-always-shown"));
#line 3953 "panel.c"
}

static void
panel_set_xkb_icon_rgba (Panel* self)
{
	gchar* spec = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp2_ = {0};
	const gchar* _tmp3_;
#line 687 "panel.vala"
	g_return_if_fail (self != NULL);
#line 688 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 688 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "xkb-icon-rgba");
#line 688 "panel.vala"
	spec = _tmp1_;
#line 690 "panel.vala"
	_tmp2_.red = (gdouble) 0;
#line 690 "panel.vala"
	rgba = _tmp2_;
#line 692 "panel.vala"
	_tmp3_ = spec;
#line 692 "panel.vala"
	if (!gdk_rgba_parse (&rgba, _tmp3_)) {
#line 3981 "panel.c"
		const gchar* _tmp4_;
		GdkRGBA _tmp5_ = {0};
#line 693 "panel.vala"
		_tmp4_ = spec;
#line 693 "panel.vala"
		g_warning ("panel.vala:693: invalid format of xkb-icon-rgba: %s", _tmp4_);
#line 694 "panel.vala"
		memset (&_tmp5_, 0, sizeof (GdkRGBA));
#line 694 "panel.vala"
		_tmp5_.red = 0.0;
#line 694 "panel.vala"
		_tmp5_.green = 0.0;
#line 694 "panel.vala"
		_tmp5_.blue = 0.0;
#line 694 "panel.vala"
		_tmp5_.alpha = 1.0;
#line 694 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp5_;
#line 4000 "panel.c"
	} else {
		GdkRGBA _tmp6_;
#line 697 "panel.vala"
		_tmp6_ = rgba;
#line 697 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp6_;
#line 4007 "panel.c"
	}
#line 699 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4011 "panel.c"
		GHashTable* _tmp7_;
#line 700 "panel.vala"
		_tmp7_ = self->priv->m_xkb_icon_pixbufs;
#line 700 "panel.vala"
		if (g_hash_table_size (_tmp7_) > ((guint) 0)) {
#line 4017 "panel.c"
			GHashTable* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GtkStatusIcon* _tmp10_;
#line 701 "panel.vala"
			_tmp8_ = self->priv->m_xkb_icon_pixbufs;
#line 701 "panel.vala"
			g_hash_table_remove_all (_tmp8_);
#line 703 "panel.vala"
			_tmp10_ = self->priv->m_status_icon;
#line 703 "panel.vala"
			if (_tmp10_ != NULL) {
#line 4029 "panel.c"
				Switcher* _tmp11_;
#line 703 "panel.vala"
				_tmp11_ = self->priv->m_switcher;
#line 703 "panel.vala"
				_tmp9_ = _tmp11_ != NULL;
#line 4035 "panel.c"
			} else {
#line 703 "panel.vala"
				_tmp9_ = FALSE;
#line 4039 "panel.c"
			}
#line 703 "panel.vala"
			if (_tmp9_) {
#line 704 "panel.vala"
				g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4045 "panel.c"
			}
		}
	} else {
#line 706 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4051 "panel.c"
			GHashTable* _tmp12_;
#line 707 "panel.vala"
			_tmp12_ = self->priv->m_xkb_icon_image;
#line 707 "panel.vala"
			if (g_hash_table_size (_tmp12_) > ((guint) 0)) {
#line 4057 "panel.c"
				GHashTable* _tmp13_;
				gboolean _tmp14_ = FALSE;
				Indicator* _tmp15_;
#line 708 "panel.vala"
				_tmp13_ = self->priv->m_xkb_icon_image;
#line 708 "panel.vala"
				g_hash_table_remove_all (_tmp13_);
#line 710 "panel.vala"
				_tmp15_ = self->priv->m_indicator;
#line 710 "panel.vala"
				if (_tmp15_ != NULL) {
#line 4069 "panel.c"
					Switcher* _tmp16_;
#line 710 "panel.vala"
					_tmp16_ = self->priv->m_switcher;
#line 710 "panel.vala"
					_tmp14_ = _tmp16_ != NULL;
#line 4075 "panel.c"
				} else {
#line 710 "panel.vala"
					_tmp14_ = FALSE;
#line 4079 "panel.c"
				}
#line 710 "panel.vala"
				if (_tmp14_) {
#line 711 "panel.vala"
					g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4085 "panel.c"
				}
			}
		}
	}
#line 687 "panel.vala"
	_g_free0 (spec);
#line 4092 "panel.c"
}

static void
panel_set_property_icon_delay_time (Panel* self)
{
	GSettings* _tmp0_;
#line 716 "panel.vala"
	g_return_if_fail (self != NULL);
#line 717 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 717 "panel.vala"
	self->priv->m_property_icon_delay_time = g_settings_get_int (_tmp0_, "property-icon-delay-time");
#line 4105 "panel.c"
}

static gint
panel_compare_versions (Panel* self,
                        const gchar* version1,
                        const gchar* version2)
{
	gchar** version1_list = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint version1_list_length1;
	gint _version1_list_size_;
	gchar** version2_list = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint version2_list_length1;
	gint _version2_list_size_;
	gint major1 = 0;
	gint minor1 = 0;
	gint micro1 = 0;
	gint major2 = 0;
	gint minor2 = 0;
	gint micro2 = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gint result;
#line 722 "panel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 722 "panel.vala"
	g_return_val_if_fail (version1 != NULL, 0);
#line 722 "panel.vala"
	g_return_val_if_fail (version2 != NULL, 0);
#line 723 "panel.vala"
	_tmp1_ = _tmp0_ = g_strsplit (version1, ".", 0);
#line 723 "panel.vala"
	version1_list = _tmp1_;
#line 723 "panel.vala"
	version1_list_length1 = _vala_array_length (_tmp0_);
#line 723 "panel.vala"
	_version1_list_size_ = version1_list_length1;
#line 724 "panel.vala"
	_tmp3_ = _tmp2_ = g_strsplit (version2, ".", 0);
#line 724 "panel.vala"
	version2_list = _tmp3_;
#line 724 "panel.vala"
	version2_list_length1 = _vala_array_length (_tmp2_);
#line 724 "panel.vala"
	_version2_list_size_ = version2_list_length1;
#line 727 "panel.vala"
	if (g_strcmp0 (version1, version2) == 0) {
#line 728 "panel.vala"
		result = 0;
#line 728 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 728 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 728 "panel.vala"
		return result;
#line 4188 "panel.c"
	}
#line 732 "panel.vala"
	if (g_strcmp0 (version1, "") == 0) {
#line 733 "panel.vala"
		result = -1;
#line 733 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 733 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 733 "panel.vala"
		return result;
#line 4200 "panel.c"
	}
#line 735 "panel.vala"
	if (g_strcmp0 (version2, "") == 0) {
#line 736 "panel.vala"
		result = 1;
#line 736 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 736 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 736 "panel.vala"
		return result;
#line 4212 "panel.c"
	}
#line 739 "panel.vala"
	_tmp4_ = version1_list;
#line 739 "panel.vala"
	_tmp4__length1 = version1_list_length1;
#line 739 "panel.vala"
	_vala_assert (_tmp4__length1 >= 3, "version1_list.length >= 3");
#line 740 "panel.vala"
	_tmp5_ = version2_list;
#line 740 "panel.vala"
	_tmp5__length1 = version2_list_length1;
#line 740 "panel.vala"
	_vala_assert (_tmp5__length1 >= 3, "version2_list.length >= 3");
#line 742 "panel.vala"
	_tmp6_ = version1_list;
#line 742 "panel.vala"
	_tmp6__length1 = version1_list_length1;
#line 742 "panel.vala"
	_tmp7_ = _tmp6_[0];
#line 742 "panel.vala"
	major1 = atoi (_tmp7_);
#line 743 "panel.vala"
	_tmp8_ = version1_list;
#line 743 "panel.vala"
	_tmp8__length1 = version1_list_length1;
#line 743 "panel.vala"
	_tmp9_ = _tmp8_[1];
#line 743 "panel.vala"
	minor1 = atoi (_tmp9_);
#line 744 "panel.vala"
	_tmp10_ = version1_list;
#line 744 "panel.vala"
	_tmp10__length1 = version1_list_length1;
#line 744 "panel.vala"
	_tmp11_ = _tmp10_[2];
#line 744 "panel.vala"
	micro1 = atoi (_tmp11_);
#line 746 "panel.vala"
	_tmp12_ = version2_list;
#line 746 "panel.vala"
	_tmp12__length1 = version2_list_length1;
#line 746 "panel.vala"
	_tmp13_ = _tmp12_[0];
#line 746 "panel.vala"
	major2 = atoi (_tmp13_);
#line 747 "panel.vala"
	_tmp14_ = version2_list;
#line 747 "panel.vala"
	_tmp14__length1 = version2_list_length1;
#line 747 "panel.vala"
	_tmp15_ = _tmp14_[1];
#line 747 "panel.vala"
	minor2 = atoi (_tmp15_);
#line 748 "panel.vala"
	_tmp16_ = version2_list;
#line 748 "panel.vala"
	_tmp16__length1 = version2_list_length1;
#line 748 "panel.vala"
	_tmp17_ = _tmp16_[2];
#line 748 "panel.vala"
	micro2 = atoi (_tmp17_);
#line 750 "panel.vala"
	if (major1 == minor1) {
#line 750 "panel.vala"
		_tmp19_ = minor1 == minor2;
#line 4278 "panel.c"
	} else {
#line 750 "panel.vala"
		_tmp19_ = FALSE;
#line 4282 "panel.c"
	}
#line 750 "panel.vala"
	if (_tmp19_) {
#line 750 "panel.vala"
		_tmp18_ = micro1 == micro2;
#line 4288 "panel.c"
	} else {
#line 750 "panel.vala"
		_tmp18_ = FALSE;
#line 4292 "panel.c"
	}
#line 750 "panel.vala"
	if (_tmp18_) {
#line 751 "panel.vala"
		result = 0;
#line 751 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 751 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 751 "panel.vala"
		return result;
#line 4304 "panel.c"
	}
#line 753 "panel.vala"
	if (major1 > major2) {
#line 753 "panel.vala"
		_tmp21_ = TRUE;
#line 4310 "panel.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 754 "panel.vala"
		if (major1 == major2) {
#line 754 "panel.vala"
			_tmp22_ = minor1 > minor2;
#line 4317 "panel.c"
		} else {
#line 754 "panel.vala"
			_tmp22_ = FALSE;
#line 4321 "panel.c"
		}
#line 754 "panel.vala"
		_tmp21_ = _tmp22_;
#line 4325 "panel.c"
	}
#line 753 "panel.vala"
	if (_tmp21_) {
#line 753 "panel.vala"
		_tmp20_ = TRUE;
#line 4331 "panel.c"
	} else {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 755 "panel.vala"
		if (major1 == major2) {
#line 755 "panel.vala"
			_tmp24_ = minor1 == minor2;
#line 4339 "panel.c"
		} else {
#line 755 "panel.vala"
			_tmp24_ = FALSE;
#line 4343 "panel.c"
		}
#line 755 "panel.vala"
		if (_tmp24_) {
#line 756 "panel.vala"
			_tmp23_ = micro1 > micro2;
#line 4349 "panel.c"
		} else {
#line 755 "panel.vala"
			_tmp23_ = FALSE;
#line 4353 "panel.c"
		}
#line 755 "panel.vala"
		_tmp20_ = _tmp23_;
#line 4357 "panel.c"
	}
#line 753 "panel.vala"
	if (_tmp20_) {
#line 757 "panel.vala"
		result = 1;
#line 757 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 757 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 757 "panel.vala"
		return result;
#line 4369 "panel.c"
	}
#line 759 "panel.vala"
	result = -1;
#line 759 "panel.vala"
	version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 759 "panel.vala"
	version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 759 "panel.vala"
	return result;
#line 4379 "panel.c"
}

static void
panel_update_version_1_5_8 (Panel* self)
{
#line 762 "panel.vala"
	g_return_if_fail (self != NULL);
#line 763 "panel.vala"
	self->priv->inited_engines_order = FALSE;
#line 4389 "panel.c"
}

static void
panel_update_version_1_5_26 (Panel* self)
{
	gchar* message = NULL;
	gchar* _tmp0_;
	NotifyNotification* notification = NULL;
	const gchar* _tmp1_;
	NotifyNotification* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 766 "panel.vala"
	g_return_if_fail (self != NULL);
#line 767 "panel.vala"
	_tmp0_ = g_strdup (_ ("Keymap changes do not work in Plasma Wayland at " "present. Please use systemsettings5 instead."));
#line 767 "panel.vala"
	message = _tmp0_;
#line 770 "panel.vala"
	if (!notify_is_initted ()) {
#line 771 "panel.vala"
		notify_init ("ibus");
#line 4411 "panel.c"
	}
#line 774 "panel.vala"
	_tmp1_ = message;
#line 774 "panel.vala"
	_tmp2_ = notify_notification_new (_ ("IBus Notification"), _tmp1_, "ibus");
#line 774 "panel.vala"
	notification = _tmp2_;
#line 778 "panel.vala"
	notify_notification_set_timeout (notification, 30 * 1000);
#line 779 "panel.vala"
	notify_notification_set_category (notification, "hotkey");
#line 4423 "panel.c"
	{
#line 782 "panel.vala"
		notify_notification_show (notification, &_inner_error0_);
#line 782 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4429 "panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp3_;
#line 781 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 784 "panel.vala"
		_tmp3_ = message;
#line 784 "panel.vala"
		g_warning ("panel.vala:784: %s", _tmp3_);
#line 4443 "panel.c"
	}
	__finally0:
#line 781 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 781 "panel.vala"
		_g_object_unref0 (notification);
#line 781 "panel.vala"
		_g_free0 (message);
#line 781 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 781 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 781 "panel.vala"
		return;
#line 4458 "panel.c"
	}
#line 766 "panel.vala"
	_g_object_unref0 (notification);
#line 766 "panel.vala"
	_g_free0 (message);
#line 4464 "panel.c"
}

static void
panel_set_version (Panel* self)
{
	gchar* prev_version = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* current_version = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GSettings* _tmp7_;
	const gchar* _tmp8_;
#line 791 "panel.vala"
	g_return_if_fail (self != NULL);
#line 792 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 792 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "version");
#line 792 "panel.vala"
	prev_version = _tmp1_;
#line 793 "panel.vala"
	current_version = NULL;
#line 795 "panel.vala"
	_tmp2_ = prev_version;
#line 795 "panel.vala"
	if (panel_compare_versions (self, _tmp2_, "1.5.8") < 0) {
#line 796 "panel.vala"
		panel_update_version_1_5_8 (self);
#line 4497 "panel.c"
	}
#line 798 "panel.vala"
	_tmp3_ = prev_version;
#line 798 "panel.vala"
	if (panel_compare_versions (self, _tmp3_, "1.5.26") < 0) {
#line 799 "panel.vala"
		panel_update_version_1_5_26 (self);
#line 4505 "panel.c"
	}
#line 801 "panel.vala"
	_tmp4_ = g_strdup_printf ("%d.%d.%d", IBUS_MAJOR_VERSION, IBUS_MINOR_VERSION, IBUS_MICRO_VERSION);
#line 801 "panel.vala"
	_g_free0 (current_version);
#line 801 "panel.vala"
	current_version = _tmp4_;
#line 805 "panel.vala"
	_tmp5_ = prev_version;
#line 805 "panel.vala"
	_tmp6_ = current_version;
#line 805 "panel.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
#line 806 "panel.vala"
		_g_free0 (current_version);
#line 806 "panel.vala"
		_g_free0 (prev_version);
#line 806 "panel.vala"
		return;
#line 4525 "panel.c"
	}
#line 809 "panel.vala"
	_tmp7_ = self->priv->m_settings_general;
#line 809 "panel.vala"
	_tmp8_ = current_version;
#line 809 "panel.vala"
	g_settings_set_string (_tmp7_, "version", _tmp8_);
#line 791 "panel.vala"
	_g_free0 (current_version);
#line 791 "panel.vala"
	_g_free0 (prev_version);
#line 4537 "panel.c"
}

void
panel_load_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GList* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
#line 812 "panel.vala"
	g_return_if_fail (self != NULL);
#line 813 "panel.vala"
	panel_set_version (self);
#line 815 "panel.vala"
	panel_init_engines_order (self);
#line 819 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 820 "panel.vala"
	panel_set_use_global_engine (self);
#line 821 "panel.vala"
	panel_set_use_xmodmap (self);
#line 822 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 822 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 824 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 824 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "preload-engines");
#line 824 "panel.vala"
	_tmp4_ = _tmp3_;
#line 824 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 824 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 824 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "engines-order");
#line 824 "panel.vala"
	_tmp8_ = _tmp7_;
#line 824 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 824 "panel.vala"
	panel_update_engines (self, _tmp4_, (gint) _vala_array_length (_tmp2_), _tmp8_, (gint) _vala_array_length (_tmp6_));
#line 824 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 824 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 826 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 826 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp9_);
#line 829 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 829 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 830 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 831 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 832 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 833 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 833 "panel.vala"
	binding_common_set_custom_font (_tmp10_, NULL, &self->priv->m_css_provider);
#line 836 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 836 "panel.vala"
	binding_common_set_custom_theme (_tmp11_);
#line 837 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 837 "panel.vala"
	binding_common_set_custom_icon (_tmp12_);
#line 838 "panel.vala"
	panel_set_show_icon_on_systray (self);
#line 839 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 840 "panel.vala"
	panel_set_show_property_panel (self);
#line 841 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 842 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 843 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 844 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 4636 "panel.c"
}

/**
     * disconnect_signals:
     *
     * Call this API before m_panel = null so that the ref_count becomes 0
     */
void
panel_disconnect_signals (Panel* self)
{
	GObject* object = NULL;
	GtkStatusIcon* _tmp0_;
#line 852 "panel.vala"
	g_return_if_fail (self != NULL);
#line 853 "panel.vala"
	_tmp0_ = self->priv->m_status_icon;
#line 853 "panel.vala"
	object = (GObject*) _tmp0_;
#line 855 "panel.vala"
	if (self->priv->m_is_kde) {
#line 4657 "panel.c"
		Indicator* _tmp1_;
#line 856 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 856 "panel.vala"
		object = (GObject*) _tmp1_;
#line 4663 "panel.c"
	}
#line 858 "panel.vala"
	if (self->priv->m_popup_menu_id > ((gulong) 0)) {
#line 4667 "panel.c"
		GObject* _tmp2_;
#line 860 "panel.vala"
		_tmp2_ = object;
#line 860 "panel.vala"
		if (g_signal_handler_is_connected (_tmp2_, self->priv->m_popup_menu_id)) {
#line 4673 "panel.c"
			GObject* _tmp3_;
#line 861 "panel.vala"
			_tmp3_ = object;
#line 861 "panel.vala"
			g_signal_handler_disconnect (_tmp3_, self->priv->m_popup_menu_id);
#line 4679 "panel.c"
		}
#line 862 "panel.vala"
		self->priv->m_popup_menu_id = (gulong) 0;
#line 4683 "panel.c"
	}
#line 864 "panel.vala"
	if (self->priv->m_activate_id > ((gulong) 0)) {
#line 4687 "panel.c"
		GObject* _tmp4_;
#line 865 "panel.vala"
		_tmp4_ = object;
#line 865 "panel.vala"
		if (g_signal_handler_is_connected (_tmp4_, self->priv->m_activate_id)) {
#line 4693 "panel.c"
			GObject* _tmp5_;
#line 866 "panel.vala"
			_tmp5_ = object;
#line 866 "panel.vala"
			g_signal_handler_disconnect (_tmp5_, self->priv->m_activate_id);
#line 4699 "panel.c"
		}
#line 867 "panel.vala"
		self->priv->m_activate_id = (gulong) 0;
#line 4703 "panel.c"
	}
#line 869 "panel.vala"
	if (self->priv->m_registered_status_notifier_item_id > ((gulong) 0)) {
#line 4707 "panel.c"
		GObject* _tmp6_;
#line 870 "panel.vala"
		_tmp6_ = object;
#line 870 "panel.vala"
		if (g_signal_handler_is_connected (_tmp6_, self->priv->m_registered_status_notifier_item_id)) {
#line 4713 "panel.c"
			GObject* _tmp7_;
#line 873 "panel.vala"
			_tmp7_ = object;
#line 873 "panel.vala"
			g_signal_handler_disconnect (_tmp7_, self->priv->m_registered_status_notifier_item_id);
#line 4719 "panel.c"
		}
#line 875 "panel.vala"
		self->priv->m_registered_status_notifier_item_id = (gulong) 0;
#line 4723 "panel.c"
	}
#line 877 "panel.vala"
	if (self->priv->m_preload_engines_id > ((guint) 0)) {
#line 878 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 879 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 4731 "panel.c"
	}
}

static void
panel_engine_contexts_insert (Panel* self,
                              IBusEngineDesc* engine)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	IBusEngineDesc* _tmp5_;
#line 883 "panel.vala"
	g_return_if_fail (self != NULL);
#line 883 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 884 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 885 "panel.vala"
		return;
#line 4752 "panel.c"
	}
#line 887 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 887 "panel.vala"
	if (g_hash_table_size (_tmp0_) >= ((guint) 200)) {
#line 4758 "panel.c"
		GHashTable* _tmp1_;
#line 888 "panel.vala"
		g_warning ("panel.vala:888: Contexts by windows are too much counted!");
#line 889 "panel.vala"
		_tmp1_ = self->priv->m_engine_contexts;
#line 889 "panel.vala"
		g_hash_table_remove_all (_tmp1_);
#line 4766 "panel.c"
	}
#line 892 "panel.vala"
	_tmp2_ = self->priv->m_engine_contexts;
#line 892 "panel.vala"
	_tmp3_ = self->priv->m_current_context_path;
#line 892 "panel.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 892 "panel.vala"
	_tmp5_ = _g_object_ref0 (engine);
#line 892 "panel.vala"
	g_hash_table_replace (_tmp2_, _tmp4_, _tmp5_);
#line 4778 "panel.c"
}

static void
panel_set_language_from_engine (Panel* self,
                                IBusEngineDesc* engine)
{
#line 895 "panel.vala"
	g_return_if_fail (self != NULL);
#line 895 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 896 "panel.vala"
	if (self->priv->m_use_engine_lang) {
#line 4791 "panel.c"
		CandidatePanel* _tmp0_;
		const gchar* _tmp1_;
		PangoLanguage* _tmp2_;
		PangoAttrLanguage* _tmp3_;
		PangoAttrLanguage* _tmp4_;
#line 897 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 897 "panel.vala"
		_tmp1_ = ibus_engine_desc_get_language (engine);
#line 897 "panel.vala"
		_tmp2_ = pango_language_from_string (_tmp1_);
#line 897 "panel.vala"
		_tmp3_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp2_);
#line 897 "panel.vala"
		_tmp4_ = _tmp3_;
#line 897 "panel.vala"
		candidate_panel_set_language (_tmp0_, (PangoAttribute*) _tmp4_);
#line 897 "panel.vala"
		_pango_attribute_destroy0 (_tmp4_);
#line 4811 "panel.c"
	} else {
		CandidatePanel* _tmp5_;
		PangoLanguage* _tmp6_;
		PangoAttrLanguage* _tmp7_;
		PangoAttrLanguage* _tmp8_;
#line 900 "panel.vala"
		_tmp5_ = self->priv->m_candidate_panel;
#line 900 "panel.vala"
		_tmp6_ = pango_language_from_string (NULL);
#line 900 "panel.vala"
		_tmp7_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp6_);
#line 900 "panel.vala"
		_tmp8_ = _tmp7_;
#line 900 "panel.vala"
		candidate_panel_set_language (_tmp5_, (PangoAttribute*) _tmp8_);
#line 900 "panel.vala"
		_pango_attribute_destroy0 (_tmp8_);
#line 4829 "panel.c"
	}
}

static void
panel_set_engine (Panel* self,
                  IBusEngineDesc* engine)
{
	IBusBus* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 906 "panel.vala"
	g_return_if_fail (self != NULL);
#line 906 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 907 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 908 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 909 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 4851 "panel.c"
	}
#line 912 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 912 "panel.vala"
	_tmp1_ = ibus_engine_desc_get_name (engine);
#line 912 "panel.vala"
	if (!ibus_bus_set_global_engine (_tmp0_, _tmp1_)) {
#line 4859 "panel.c"
		const gchar* _tmp2_;
#line 913 "panel.vala"
		_tmp2_ = ibus_engine_desc_get_name (engine);
#line 913 "panel.vala"
		g_warning ("panel.vala:913: Switch engine to %s failed.", _tmp2_);
#line 914 "panel.vala"
		return;
#line 4867 "panel.c"
	}
#line 921 "panel.vala"
	_tmp3_ = g_strdup ("");
#line 921 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 921 "panel.vala"
	self->priv->m_icon_prop_key = _tmp3_;
#line 924 "panel.vala"
	if (!self->priv->m_use_system_keyboard_layout) {
#line 924 "panel.vala"
		_tmp4_ = !self->priv->m_is_wayland;
#line 4879 "panel.c"
	} else {
#line 924 "panel.vala"
		_tmp4_ = FALSE;
#line 4883 "panel.c"
	}
#line 924 "panel.vala"
	if (_tmp4_) {
#line 4887 "panel.c"
		XKBLayout* _tmp5_;
#line 925 "panel.vala"
		_tmp5_ = self->priv->m_xkblayout;
#line 925 "panel.vala"
		xkb_layout_set_layout (_tmp5_, engine);
#line 4893 "panel.c"
	}
#line 927 "panel.vala"
	panel_set_language_from_engine (self, engine);
#line 928 "panel.vala"
	panel_engine_contexts_insert (self, engine);
#line 4899 "panel.c"
}

static void
panel_switch_engine (Panel* self,
                     gint i,
                     gboolean force)
{
	gboolean _tmp4_ = FALSE;
	IBusEngineDesc* engine = NULL;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp12_;
#line 931 "panel.vala"
	g_return_if_fail (self != NULL);
#line 932 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 4915 "panel.c"
		gboolean _tmp0_ = FALSE;
#line 933 "panel.vala"
		if (i >= 0) {
#line 4919 "panel.c"
			IBusEngineDesc** _tmp1_;
			gint _tmp1__length1;
#line 933 "panel.vala"
			_tmp1_ = self->priv->m_engines;
#line 933 "panel.vala"
			_tmp1__length1 = self->priv->m_engines_length1;
#line 933 "panel.vala"
			_tmp0_ = i <= _tmp1__length1;
#line 4928 "panel.c"
		} else {
#line 933 "panel.vala"
			_tmp0_ = FALSE;
#line 4932 "panel.c"
		}
#line 933 "panel.vala"
		_vala_assert (_tmp0_, "i >= 0 && i <= m_engines.length");
#line 4936 "panel.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 935 "panel.vala"
		if (i >= 0) {
#line 4941 "panel.c"
			IBusEngineDesc** _tmp3_;
			gint _tmp3__length1;
#line 935 "panel.vala"
			_tmp3_ = self->priv->m_engines;
#line 935 "panel.vala"
			_tmp3__length1 = self->priv->m_engines_length1;
#line 935 "panel.vala"
			_tmp2_ = i < _tmp3__length1;
#line 4950 "panel.c"
		} else {
#line 935 "panel.vala"
			_tmp2_ = FALSE;
#line 4954 "panel.c"
		}
#line 935 "panel.vala"
		_vala_assert (_tmp2_, "i >= 0 && i < m_engines.length");
#line 4958 "panel.c"
	}
#line 938 "panel.vala"
	if (i == 0) {
#line 938 "panel.vala"
		_tmp4_ = !force;
#line 4964 "panel.c"
	} else {
#line 938 "panel.vala"
		_tmp4_ = FALSE;
#line 4968 "panel.c"
	}
#line 938 "panel.vala"
	if (_tmp4_) {
#line 939 "panel.vala"
		return;
#line 4974 "panel.c"
	}
#line 942 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 4978 "panel.c"
		IBusEngineDesc** _tmp6_;
		gint _tmp6__length1;
#line 942 "panel.vala"
		_tmp6_ = self->priv->m_engines;
#line 942 "panel.vala"
		_tmp6__length1 = self->priv->m_engines_length1;
#line 942 "panel.vala"
		_tmp5_ = _tmp6__length1 == 0;
#line 4987 "panel.c"
	} else {
#line 942 "panel.vala"
		_tmp5_ = FALSE;
#line 4991 "panel.c"
	}
#line 942 "panel.vala"
	if (_tmp5_) {
#line 4995 "panel.c"
		IBusEngineDesc* _tmp7_;
		IBusEngineDesc* _tmp8_;
#line 943 "panel.vala"
		_tmp7_ = self->priv->m_en_engine;
#line 943 "panel.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 943 "panel.vala"
		_g_object_unref0 (engine);
#line 943 "panel.vala"
		engine = _tmp8_;
#line 5006 "panel.c"
	} else {
		IBusEngineDesc** _tmp9_;
		gint _tmp9__length1;
		IBusEngineDesc* _tmp10_;
		IBusEngineDesc* _tmp11_;
#line 945 "panel.vala"
		_tmp9_ = self->priv->m_engines;
#line 945 "panel.vala"
		_tmp9__length1 = self->priv->m_engines_length1;
#line 945 "panel.vala"
		_tmp10_ = _tmp9_[i];
#line 945 "panel.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 945 "panel.vala"
		_g_object_unref0 (engine);
#line 945 "panel.vala"
		engine = _tmp11_;
#line 5024 "panel.c"
	}
#line 947 "panel.vala"
	_tmp12_ = engine;
#line 947 "panel.vala"
	panel_set_engine (self, _tmp12_);
#line 931 "panel.vala"
	_g_object_unref0 (engine);
#line 5032 "panel.c"
}

static void
panel_handle_engine_switch_normal (Panel* self,
                                   GdkEvent* event)
{
#line 950 "panel.vala"
	g_return_if_fail (self != NULL);
#line 950 "panel.vala"
	g_return_if_fail (event != NULL);
#line 951 "panel.vala"
	panel_handle_engine_switch (self, event, FALSE);
#line 5045 "panel.c"
}

static void
panel_handle_engine_switch_reverse (Panel* self,
                                    GdkEvent* event)
{
#line 954 "panel.vala"
	g_return_if_fail (self != NULL);
#line 954 "panel.vala"
	g_return_if_fail (event != NULL);
#line 955 "panel.vala"
	panel_handle_engine_switch (self, event, TRUE);
#line 5058 "panel.c"
}

static void
panel_handle_engine_switch (Panel* self,
                            GdkEvent* event,
                            gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
	guint keyval = 0U;
	GdkEventKey* _tmp1_;
	GdkEventKey* _tmp2_;
	guint modifiers = 0U;
	GdkEventKey* _tmp3_;
	GdkEventKey* _tmp4_;
	guint primary_modifiers = 0U;
	GdkEventKey* _tmp5_;
	GdkEventKey* _tmp6_;
	gboolean pressed = FALSE;
	gboolean _tmp7_ = FALSE;
#line 958 "panel.vala"
	g_return_if_fail (self != NULL);
#line 958 "panel.vala"
	g_return_if_fail (event != NULL);
#line 960 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 960 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 960 "panel.vala"
	if (_tmp0__length1 <= 1) {
#line 961 "panel.vala"
		return;
#line 5091 "panel.c"
	}
#line 963 "panel.vala"
	_tmp1_ = (GdkEventKey *) (event);
#line 963 "panel.vala"
	_tmp2_ = _tmp1_;
#line 963 "panel.vala"
	keyval = _tmp2_->keyval;
#line 964 "panel.vala"
	_tmp3_ = (GdkEventKey *) (event);
#line 964 "panel.vala"
	_tmp4_ = _tmp3_;
#line 964 "panel.vala"
	modifiers = KEYBINDING_MANAGER_MODIFIER_FILTER & _tmp4_->state;
#line 966 "panel.vala"
	_tmp5_ = (GdkEventKey *) (event);
#line 966 "panel.vala"
	_tmp6_ = _tmp5_;
#line 966 "panel.vala"
	primary_modifiers = (guint) keybinding_manager_get_primary_modifier ((guint) _tmp6_->state);
#line 969 "panel.vala"
	pressed = keybinding_manager_primary_modifier_still_pressed (event, primary_modifiers);
#line 972 "panel.vala"
	if (reverse) {
#line 973 "panel.vala"
		modifiers &= (guint) (~GDK_SHIFT_MASK);
#line 5117 "panel.c"
	}
#line 976 "panel.vala"
	if (pressed) {
#line 976 "panel.vala"
		_tmp7_ = self->priv->m_switcher_delay_time >= 0;
#line 5123 "panel.c"
	} else {
#line 976 "panel.vala"
		_tmp7_ = FALSE;
#line 5127 "panel.c"
	}
#line 976 "panel.vala"
	if (_tmp7_) {
#line 5131 "panel.c"
		gint _tmp8_ = 0;
		gint i = 0;
		Switcher* _tmp10_;
		IBusEngineDesc** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 977 "panel.vala"
		if (reverse) {
#line 5140 "panel.c"
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 977 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 977 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 977 "panel.vala"
			_tmp8_ = _tmp9__length1 - 1;
#line 5149 "panel.c"
		} else {
#line 977 "panel.vala"
			_tmp8_ = 1;
#line 5153 "panel.c"
		}
#line 977 "panel.vala"
		i = _tmp8_;
#line 988 "panel.vala"
		_tmp10_ = self->priv->m_switcher;
#line 988 "panel.vala"
		_tmp11_ = self->priv->m_engines;
#line 988 "panel.vala"
		_tmp11__length1 = self->priv->m_engines_length1;
#line 988 "panel.vala"
		_tmp12_ = self->priv->m_real_current_context_path;
#line 988 "panel.vala"
		i = switcher_run (_tmp10_, keyval, modifiers, event, _tmp11_, (gint) _tmp11__length1, i, _tmp12_);
#line 991 "panel.vala"
		if (i < 0) {
#line 992 "panel.vala"
			g_debug ("panel.vala:992: switch cancelled");
#line 5171 "panel.c"
		} else {
#line 993 "panel.vala"
			if (i == 0) {
#line 994 "panel.vala"
				g_debug ("panel.vala:994: do not have to switch");
#line 5177 "panel.c"
			} else {
#line 996 "panel.vala"
				panel_switcher_focus_set_engine (self);
#line 5181 "panel.c"
			}
		}
	} else {
		gint _tmp13_ = 0;
		gint i = 0;
#line 999 "panel.vala"
		if (reverse) {
#line 5189 "panel.c"
			IBusEngineDesc** _tmp14_;
			gint _tmp14__length1;
#line 999 "panel.vala"
			_tmp14_ = self->priv->m_engines;
#line 999 "panel.vala"
			_tmp14__length1 = self->priv->m_engines_length1;
#line 999 "panel.vala"
			_tmp13_ = _tmp14__length1 - 1;
#line 5198 "panel.c"
		} else {
#line 999 "panel.vala"
			_tmp13_ = 1;
#line 5202 "panel.c"
		}
#line 999 "panel.vala"
		i = _tmp13_;
#line 1000 "panel.vala"
		panel_switch_engine (self, i, FALSE);
#line 5208 "panel.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 1005 "panel.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 1005 "panel.vala"
	return _data7_;
#line 5219 "panel.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 1005 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 5229 "panel.c"
		Panel* self;
#line 1005 "panel.vala"
		self = _data7_->self;
#line 1005 "panel.vala"
		_data7_->names = (_vala_array_free (_data7_->names, _data7_->names_length1, (GDestroyNotify) g_free), NULL);
#line 1005 "panel.vala"
		_g_object_unref0 (self);
#line 1005 "panel.vala"
		g_slice_free (Block7Data, _data7_);
#line 5239 "panel.c"
	}
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1017 "panel.vala"
	if ((*length) == (*size)) {
#line 1017 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1017 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5255 "panel.c"
	}
#line 1017 "panel.vala"
	(*array)[(*length)++] = value;
#line 1017 "panel.vala"
	(*array)[*length] = NULL;
#line 5261 "panel.c"
}

static gboolean
__lambda34_ (Block7Data* _data7_)
{
	Panel* self;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 1021 "panel.vala"
	self = _data7_->self;
#line 1022 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1022 "panel.vala"
	if (!ibus_bus_is_connected (_tmp0_)) {
#line 1023 "panel.vala"
		result = FALSE;
#line 1023 "panel.vala"
		return result;
#line 5283 "panel.c"
	}
#line 1024 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 1024 "panel.vala"
	_tmp2_ = _data7_->names;
#line 1024 "panel.vala"
	_tmp2__length1 = _data7_->names_length1;
#line 1024 "panel.vala"
	ibus_bus_preload_engines_async (_tmp1_, _tmp2_, -1, NULL, NULL, NULL);
#line 1027 "panel.vala"
	result = FALSE;
#line 1027 "panel.vala"
	return result;
#line 5297 "panel.c"
}

static gboolean
___lambda34__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda34_ (self);
#line 1018 "panel.vala"
	return result;
#line 5307 "panel.c"
}

static void
panel_run_preload_engines (Panel* self,
                           IBusEngineDesc** engines,
                           gint engines_length1,
                           gint index)
{
	Block7Data* _data7_;
	gchar** _tmp0_;
	IBusEngineDesc* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 1005 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1005 "panel.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 1005 "panel.vala"
	_data7_->_ref_count_ = 1;
#line 1005 "panel.vala"
	_data7_->self = g_object_ref (self);
#line 1006 "panel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 1006 "panel.vala"
	_data7_->names = _tmp0_;
#line 1006 "panel.vala"
	_data7_->names_length1 = 0;
#line 1006 "panel.vala"
	_data7_->_names_size_ = _data7_->names_length1;
#line 1008 "panel.vala"
	if (engines_length1 <= index) {
#line 1009 "panel.vala"
		block7_data_unref (_data7_);
#line 1009 "panel.vala"
		_data7_ = NULL;
#line 1009 "panel.vala"
		return;
#line 5345 "panel.c"
	}
#line 1012 "panel.vala"
	if (self->priv->m_preload_engines_id != ((guint) 0)) {
#line 1013 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 1014 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 5353 "panel.c"
	}
#line 1017 "panel.vala"
	_tmp1_ = engines[index];
#line 1017 "panel.vala"
	_tmp2_ = ibus_engine_desc_get_name (_tmp1_);
#line 1017 "panel.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1017 "panel.vala"
	_vala_array_add19 (&_data7_->names, &_data7_->names_length1, &_data7_->_names_size_, _tmp3_);
#line 1018 "panel.vala"
	self->priv->m_preload_engines_id = g_timeout_add_full (G_PRIORITY_DEFAULT, PANEL_PRELOAD_ENGINES_DELAY_TIME, ___lambda34__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 1005 "panel.vala"
	block7_data_unref (_data7_);
#line 1005 "panel.vala"
	_data7_ = NULL;
#line 5369 "panel.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 1033 "panel.vala"
	if (length >= 0) {
#line 5378 "panel.c"
		gchar** result;
		gssize i;
#line 1033 "panel.vala"
		result = g_new0 (gchar*, length + 1);
#line 1033 "panel.vala"
		for (i = 0; i < length; i++) {
#line 5385 "panel.c"
			gchar* _tmp0_;
#line 1033 "panel.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1033 "panel.vala"
			result[i] = _tmp0_;
#line 5391 "panel.c"
		}
#line 1033 "panel.vala"
		return result;
#line 5395 "panel.c"
	}
#line 1033 "panel.vala"
	return NULL;
#line 5399 "panel.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 1043 "panel.vala"
	for (i = 0; i < stack_length; i++) {
#line 1043 "panel.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 1043 "panel.vala"
			return TRUE;
#line 5414 "panel.c"
		}
	}
#line 1043 "panel.vala"
	return FALSE;
#line 5419 "panel.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1046 "panel.vala"
	if ((*length) == (*size)) {
#line 1046 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1046 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5434 "panel.c"
	}
#line 1046 "panel.vala"
	(*array)[(*length)++] = value;
#line 1046 "panel.vala"
	(*array)[*length] = NULL;
#line 5440 "panel.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1054 "panel.vala"
	if ((*length) == (*size)) {
#line 1054 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1054 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5455 "panel.c"
	}
#line 1054 "panel.vala"
	(*array)[(*length)++] = value;
#line 1054 "panel.vala"
	(*array)[*length] = NULL;
#line 5461 "panel.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1062 "panel.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1062 "panel.vala"
	return _data8_;
#line 5471 "panel.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1062 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 5481 "panel.c"
		Panel* self;
#line 1062 "panel.vala"
		self = _data8_->self;
#line 1062 "panel.vala"
		_g_object_unref0 (_data8_->dialog);
#line 1062 "panel.vala"
		_g_object_unref0 (self);
#line 1062 "panel.vala"
		g_slice_free (Block8Data, _data8_);
#line 5491 "panel.c"
	}
}

static void
___lambda33_ (Block8Data* _data8_,
              gint id)
{
	Panel* self;
	GtkMessageDialog* _tmp0_;
#line 1085 "panel.vala"
	self = _data8_->self;
#line 1086 "panel.vala"
	_tmp0_ = _data8_->dialog;
#line 1086 "panel.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 5507 "panel.c"
}

static void
____lambda33__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 1085 "panel.vala"
	___lambda33_ (self, response_id);
#line 5517 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup3 (IBusEngineDesc** self,
                  gssize length)
{
#line 1092 "panel.vala"
	if (length >= 0) {
#line 5526 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1092 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1092 "panel.vala"
		for (i = 0; i < length; i++) {
#line 5533 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1092 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1092 "panel.vala"
			result[i] = _tmp0_;
#line 5539 "panel.c"
		}
#line 1092 "panel.vala"
		return result;
#line 5543 "panel.c"
	}
#line 1092 "panel.vala"
	return NULL;
#line 5547 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup4 (IBusEngineDesc** self,
                  gssize length)
{
#line 1108 "panel.vala"
	if (length >= 0) {
#line 5556 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1108 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1108 "panel.vala"
		for (i = 0; i < length; i++) {
#line 5563 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1108 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1108 "panel.vala"
			result[i] = _tmp0_;
#line 5569 "panel.c"
		}
#line 1108 "panel.vala"
		return result;
#line 5573 "panel.c"
	}
#line 1108 "panel.vala"
	return NULL;
#line 5577 "panel.c"
}

static void
panel_update_engines (Panel* self,
                      gchar** unowned_engine_names,
                      gint unowned_engine_names_length1,
                      gchar** order_names,
                      gint order_names_length1)
{
	gchar** engine_names = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint engine_names_length1;
	gint _engine_names_size_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** names = NULL;
	gchar** _tmp6_;
	gint names_length1;
	gint _names_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	IBusEngineDesc** engines = NULL;
	IBusBus* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	IBusEngineDesc** _tmp28_;
	IBusEngineDesc** _tmp29_;
	gint engines_length1;
	gint _engines_size_;
	IBusEngineDesc** _tmp30_;
	gint _tmp30__length1;
	gchar** _tmp31_;
	gint _tmp31__length1;
	IBusEngineDesc** _tmp51_;
	gint _tmp51__length1;
#line 1031 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1033 "panel.vala"
	_tmp0_ = (unowned_engine_names != NULL) ? _vala_array_dup2 (unowned_engine_names, unowned_engine_names_length1) : unowned_engine_names;
#line 1033 "panel.vala"
	_tmp0__length1 = unowned_engine_names_length1;
#line 1033 "panel.vala"
	engine_names = _tmp0_;
#line 1033 "panel.vala"
	engine_names_length1 = _tmp0__length1;
#line 1033 "panel.vala"
	_engine_names_size_ = engine_names_length1;
#line 1035 "panel.vala"
	_tmp2_ = engine_names;
#line 1035 "panel.vala"
	_tmp2__length1 = engine_names_length1;
#line 1035 "panel.vala"
	if (_tmp2_ == NULL) {
#line 1035 "panel.vala"
		_tmp1_ = TRUE;
#line 5635 "panel.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 1035 "panel.vala"
		_tmp3_ = engine_names;
#line 1035 "panel.vala"
		_tmp3__length1 = engine_names_length1;
#line 1035 "panel.vala"
		_tmp1_ = _tmp3__length1 == 0;
#line 5645 "panel.c"
	}
#line 1035 "panel.vala"
	if (_tmp1_) {
#line 5649 "panel.c"
		gchar* _tmp4_;
		gchar** _tmp5_;
#line 1036 "panel.vala"
		_tmp4_ = g_strdup ("xkb:us::eng");
#line 1036 "panel.vala"
		_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 1036 "panel.vala"
		_tmp5_[0] = _tmp4_;
#line 1036 "panel.vala"
		engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1036 "panel.vala"
		engine_names = _tmp5_;
#line 1036 "panel.vala"
		engine_names_length1 = 1;
#line 1036 "panel.vala"
		_engine_names_size_ = engine_names_length1;
#line 5666 "panel.c"
	}
#line 1038 "panel.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 1038 "panel.vala"
	names = _tmp6_;
#line 1038 "panel.vala"
	names_length1 = 0;
#line 1038 "panel.vala"
	_names_size_ = names_length1;
#line 5676 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1040 "panel.vala"
		name_collection = order_names;
#line 1040 "panel.vala"
		name_collection_length1 = order_names_length1;
#line 1040 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 5688 "panel.c"
			gchar* _tmp7_;
			gchar* name = NULL;
#line 1040 "panel.vala"
			_tmp7_ = g_strdup (name_collection[name_it]);
#line 1040 "panel.vala"
			name = _tmp7_;
#line 5695 "panel.c"
			{
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
#line 1041 "panel.vala"
				if (self->priv->m_is_wayland) {
#line 5706 "panel.c"
					const gchar* _tmp9_;
#line 1041 "panel.vala"
					_tmp9_ = name;
#line 1041 "panel.vala"
					_tmp8_ = g_str_has_prefix (_tmp9_, "xkb:");
#line 5712 "panel.c"
				} else {
#line 1041 "panel.vala"
					_tmp8_ = FALSE;
#line 5716 "panel.c"
				}
#line 1041 "panel.vala"
				if (_tmp8_) {
#line 5720 "panel.c"
					gchar* _tmp10_;
#line 1042 "panel.vala"
					_tmp10_ = g_strdup ("xkb:us::eng");
#line 1042 "panel.vala"
					_g_free0 (name);
#line 1042 "panel.vala"
					name = _tmp10_;
#line 5728 "panel.c"
				}
#line 1043 "panel.vala"
				_tmp11_ = name;
#line 1043 "panel.vala"
				_tmp12_ = names;
#line 1043 "panel.vala"
				_tmp12__length1 = names_length1;
#line 1043 "panel.vala"
				if (_vala_string_array_contains (_tmp12_, _tmp12__length1, _tmp11_)) {
#line 1044 "panel.vala"
					_g_free0 (name);
#line 1044 "panel.vala"
					continue;
#line 5742 "panel.c"
				}
#line 1045 "panel.vala"
				_tmp13_ = name;
#line 1045 "panel.vala"
				_tmp14_ = engine_names;
#line 1045 "panel.vala"
				_tmp14__length1 = engine_names_length1;
#line 1045 "panel.vala"
				if (_vala_string_array_contains (_tmp14_, _tmp14__length1, _tmp13_)) {
#line 5752 "panel.c"
					const gchar* _tmp15_;
					gchar* _tmp16_;
#line 1046 "panel.vala"
					_tmp15_ = name;
#line 1046 "panel.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 1046 "panel.vala"
					_vala_array_add20 (&names, &names_length1, &_names_size_, _tmp16_);
#line 5761 "panel.c"
				}
#line 1040 "panel.vala"
				_g_free0 (name);
#line 5765 "panel.c"
			}
		}
	}
#line 1049 "panel.vala"
	_tmp17_ = engine_names;
#line 1049 "panel.vala"
	_tmp17__length1 = engine_names_length1;
#line 5773 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1049 "panel.vala"
		name_collection = _tmp17_;
#line 1049 "panel.vala"
		name_collection_length1 = _tmp17__length1;
#line 1049 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 5785 "panel.c"
			gchar* _tmp18_;
			gchar* name = NULL;
#line 1049 "panel.vala"
			_tmp18_ = g_strdup (name_collection[name_it]);
#line 1049 "panel.vala"
			name = _tmp18_;
#line 5792 "panel.c"
			{
				gboolean _tmp19_ = FALSE;
				const gchar* _tmp22_;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
#line 1050 "panel.vala"
				if (self->priv->m_is_wayland) {
#line 5802 "panel.c"
					const gchar* _tmp20_;
#line 1050 "panel.vala"
					_tmp20_ = name;
#line 1050 "panel.vala"
					_tmp19_ = g_str_has_prefix (_tmp20_, "xkb:");
#line 5808 "panel.c"
				} else {
#line 1050 "panel.vala"
					_tmp19_ = FALSE;
#line 5812 "panel.c"
				}
#line 1050 "panel.vala"
				if (_tmp19_) {
#line 5816 "panel.c"
					gchar* _tmp21_;
#line 1051 "panel.vala"
					_tmp21_ = g_strdup ("xkb:us::eng");
#line 1051 "panel.vala"
					_g_free0 (name);
#line 1051 "panel.vala"
					name = _tmp21_;
#line 5824 "panel.c"
				}
#line 1052 "panel.vala"
				_tmp22_ = name;
#line 1052 "panel.vala"
				_tmp23_ = names;
#line 1052 "panel.vala"
				_tmp23__length1 = names_length1;
#line 1052 "panel.vala"
				if (_vala_string_array_contains (_tmp23_, _tmp23__length1, _tmp22_)) {
#line 1053 "panel.vala"
					_g_free0 (name);
#line 1053 "panel.vala"
					continue;
#line 5838 "panel.c"
				}
#line 1054 "panel.vala"
				_tmp24_ = name;
#line 1054 "panel.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 1054 "panel.vala"
				_vala_array_add21 (&names, &names_length1, &_names_size_, _tmp25_);
#line 1049 "panel.vala"
				_g_free0 (name);
#line 5848 "panel.c"
			}
		}
	}
#line 1057 "panel.vala"
	_tmp26_ = self->priv->m_bus;
#line 1057 "panel.vala"
	_tmp27_ = names;
#line 1057 "panel.vala"
	_tmp27__length1 = names_length1;
#line 1057 "panel.vala"
	_tmp29_ = _tmp28_ = ibus_bus_get_engines_by_names (_tmp26_, _tmp27_);
#line 1057 "panel.vala"
	engines = _tmp29_;
#line 1057 "panel.vala"
	engines_length1 = _vala_array_length (_tmp28_);
#line 1057 "panel.vala"
	_engines_size_ = engines_length1;
#line 1062 "panel.vala"
	_tmp30_ = engines;
#line 1062 "panel.vala"
	_tmp30__length1 = engines_length1;
#line 1062 "panel.vala"
	_tmp31_ = names;
#line 1062 "panel.vala"
	_tmp31__length1 = names_length1;
#line 1062 "panel.vala"
	if (_tmp30__length1 < _tmp31__length1) {
#line 5876 "panel.c"
		Block8Data* _data8_;
		gchar* message1 = NULL;
		IBusEngineDesc** _tmp32_;
		gint _tmp32__length1;
		gchar* message2 = NULL;
		gchar* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		GtkMessageDialog* _tmp48_;
		GtkMessageDialog* _tmp49_;
		GtkMessageDialog* _tmp50_;
#line 1062 "panel.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 1062 "panel.vala"
		_data8_->_ref_count_ = 1;
#line 1062 "panel.vala"
		_data8_->self = g_object_ref (self);
#line 1064 "panel.vala"
		_tmp32_ = engines;
#line 1064 "panel.vala"
		_tmp32__length1 = engines_length1;
#line 1064 "panel.vala"
		if (_tmp32__length1 == 0) {
#line 5900 "panel.c"
			gchar** fallback_names = NULL;
			gchar* _tmp33_;
			gchar** _tmp34_;
			gint fallback_names_length1;
			gint _fallback_names_size_;
			GSettings* _tmp35_;
			gchar** _tmp36_;
			gint _tmp36__length1;
			IBusBus* _tmp37_;
			gchar** _tmp38_;
			gint _tmp38__length1;
			IBusEngineDesc** _tmp39_;
			IBusEngineDesc** _tmp40_;
			gchar** _tmp41_;
			gint _tmp41__length1;
			const gchar* _tmp42_;
			gchar* _tmp43_;
#line 1065 "panel.vala"
			_tmp33_ = g_strdup ("xkb:us::eng");
#line 1065 "panel.vala"
			_tmp34_ = g_new0 (gchar*, 1 + 1);
#line 1065 "panel.vala"
			_tmp34_[0] = _tmp33_;
#line 1065 "panel.vala"
			fallback_names = _tmp34_;
#line 1065 "panel.vala"
			fallback_names_length1 = 1;
#line 1065 "panel.vala"
			_fallback_names_size_ = fallback_names_length1;
#line 1066 "panel.vala"
			_tmp35_ = self->priv->m_settings_general;
#line 1066 "panel.vala"
			_tmp36_ = fallback_names;
#line 1066 "panel.vala"
			_tmp36__length1 = fallback_names_length1;
#line 1066 "panel.vala"
			g_settings_set_strv (_tmp35_, "preload-engines", _tmp36_);
#line 1067 "panel.vala"
			_tmp37_ = self->priv->m_bus;
#line 1067 "panel.vala"
			_tmp38_ = fallback_names;
#line 1067 "panel.vala"
			_tmp38__length1 = fallback_names_length1;
#line 1067 "panel.vala"
			_tmp40_ = _tmp39_ = ibus_bus_get_engines_by_names (_tmp37_, _tmp38_);
#line 1067 "panel.vala"
			engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1067 "panel.vala"
			engines = _tmp40_;
#line 1067 "panel.vala"
			engines_length1 = _vala_array_length (_tmp39_);
#line 1067 "panel.vala"
			_engines_size_ = engines_length1;
#line 1068 "panel.vala"
			_tmp41_ = names;
#line 1068 "panel.vala"
			_tmp41__length1 = names_length1;
#line 1068 "panel.vala"
			_tmp42_ = _tmp41_[0];
#line 1068 "panel.vala"
			_tmp43_ = g_strdup_printf (_ ("Your configured input method %s does not exist " "in IBus input methods so \"US\" layout was " "configured instead of your input method."), _tmp42_);
#line 1068 "panel.vala"
			_g_free0 (message1);
#line 1068 "panel.vala"
			message1 = _tmp43_;
#line 1064 "panel.vala"
			fallback_names = (_vala_array_free (fallback_names, fallback_names_length1, (GDestroyNotify) g_free), NULL);
#line 5968 "panel.c"
		} else {
			gchar* _tmp44_;
#line 1073 "panel.vala"
			_tmp44_ = g_strdup (_ ("At least one of your configured input methods " "does not exist in IBus input methods."));
#line 1073 "panel.vala"
			_g_free0 (message1);
#line 1073 "panel.vala"
			message1 = _tmp44_;
#line 5977 "panel.c"
		}
#line 1076 "panel.vala"
		_tmp45_ = g_strdup (_ ("Please run `ibus-setup` command, open \"Input " "Method\" tab, and configure your input methods " "again."));
#line 1076 "panel.vala"
		message2 = _tmp45_;
#line 1079 "panel.vala"
		_tmp46_ = message1;
#line 1079 "panel.vala"
		_tmp47_ = message2;
#line 1079 "panel.vala"
		_tmp48_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "%s %s", _tmp46_, _tmp47_);
#line 1079 "panel.vala"
		g_object_ref_sink (_tmp48_);
#line 1079 "panel.vala"
		_data8_->dialog = _tmp48_;
#line 1085 "panel.vala"
		_tmp49_ = _data8_->dialog;
#line 1085 "panel.vala"
		g_signal_connect_data ((GtkDialog*) _tmp49_, "response", (GCallback) ____lambda33__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 1088 "panel.vala"
		_tmp50_ = _data8_->dialog;
#line 1088 "panel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp50_);
#line 1062 "panel.vala"
		_g_free0 (message2);
#line 1062 "panel.vala"
		_g_free0 (message1);
#line 1062 "panel.vala"
		block8_data_unref (_data8_);
#line 1062 "panel.vala"
		_data8_ = NULL;
#line 6009 "panel.c"
	}
#line 1091 "panel.vala"
	_tmp51_ = self->priv->m_engines;
#line 1091 "panel.vala"
	_tmp51__length1 = self->priv->m_engines_length1;
#line 1091 "panel.vala"
	if (_tmp51__length1 == 0) {
#line 6017 "panel.c"
		IBusEngineDesc** _tmp52_;
		gint _tmp52__length1;
		IBusEngineDesc** _tmp53_;
		gint _tmp53__length1;
		gboolean _tmp54_ = FALSE;
		gboolean _tmp55_ = FALSE;
		IBusEngineDesc** _tmp71_;
		gint _tmp71__length1;
#line 1092 "panel.vala"
		_tmp52_ = engines;
#line 1092 "panel.vala"
		_tmp52__length1 = engines_length1;
#line 1092 "panel.vala"
		_tmp53_ = (_tmp52_ != NULL) ? _vala_array_dup3 (_tmp52_, _tmp52__length1) : _tmp52_;
#line 1092 "panel.vala"
		_tmp53__length1 = _tmp52__length1;
#line 1092 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1092 "panel.vala"
		self->priv->m_engines = _tmp53_;
#line 1092 "panel.vala"
		self->priv->m_engines_length1 = _tmp53__length1;
#line 1092 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 1095 "panel.vala"
		if (self->priv->m_is_wayland) {
#line 6044 "panel.c"
			IBusEngineDesc** _tmp56_;
			gint _tmp56__length1;
#line 1095 "panel.vala"
			_tmp56_ = self->priv->m_engines;
#line 1095 "panel.vala"
			_tmp56__length1 = self->priv->m_engines_length1;
#line 1095 "panel.vala"
			_tmp55_ = _tmp56__length1 == 1;
#line 6053 "panel.c"
		} else {
#line 1095 "panel.vala"
			_tmp55_ = FALSE;
#line 6057 "panel.c"
		}
#line 1095 "panel.vala"
		if (_tmp55_) {
#line 6061 "panel.c"
			IBusEngineDesc** _tmp57_;
			gint _tmp57__length1;
			IBusEngineDesc* _tmp58_;
			const gchar* _tmp59_;
#line 1096 "panel.vala"
			_tmp57_ = self->priv->m_engines;
#line 1096 "panel.vala"
			_tmp57__length1 = self->priv->m_engines_length1;
#line 1096 "panel.vala"
			_tmp58_ = _tmp57_[0];
#line 1096 "panel.vala"
			_tmp59_ = ibus_engine_desc_get_name (_tmp58_);
#line 1096 "panel.vala"
			_tmp54_ = g_strcmp0 (_tmp59_, "xkb:us::eng") == 0;
#line 6076 "panel.c"
		} else {
#line 1095 "panel.vala"
			_tmp54_ = FALSE;
#line 6080 "panel.c"
		}
#line 1095 "panel.vala"
		if (_tmp54_) {
#line 6084 "panel.c"
			IBusEngineDesc** _tmp60_;
			IBusEngineDesc* _tmp61_;
#line 1097 "panel.vala"
			_tmp60_ = g_new0 (IBusEngineDesc*, 0 + 1);
#line 1097 "panel.vala"
			self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1097 "panel.vala"
			self->priv->m_engines = _tmp60_;
#line 1097 "panel.vala"
			self->priv->m_engines_length1 = 0;
#line 1097 "panel.vala"
			self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 1098 "panel.vala"
			_tmp61_ = self->priv->m_en_engine;
#line 1098 "panel.vala"
			if (_tmp61_ == NULL) {
#line 6101 "panel.c"
				IBusBus* _tmp62_;
				gchar* _tmp63_;
				gchar** _tmp64_;
				gchar** _tmp65_;
				gint _tmp65__length1;
				IBusEngineDesc** _tmp66_;
				IBusEngineDesc** _tmp67_;
				IBusEngineDesc** _tmp68_;
				gint _tmp68__length1;
				IBusEngineDesc* _tmp69_;
				IBusEngineDesc* _tmp70_;
#line 1099 "panel.vala"
				_tmp62_ = self->priv->m_bus;
#line 1099 "panel.vala"
				_tmp63_ = g_strdup ("xkb:us::eng");
#line 1099 "panel.vala"
				_tmp64_ = g_new0 (gchar*, 1 + 1);
#line 1099 "panel.vala"
				_tmp64_[0] = _tmp63_;
#line 1099 "panel.vala"
				_tmp65_ = _tmp64_;
#line 1099 "panel.vala"
				_tmp65__length1 = 1;
#line 1099 "panel.vala"
				_tmp67_ = _tmp66_ = ibus_bus_get_engines_by_names (_tmp62_, _tmp65_);
#line 1099 "panel.vala"
				_tmp68_ = _tmp67_;
#line 1099 "panel.vala"
				_tmp68__length1 = _vala_array_length (_tmp66_);
#line 1099 "panel.vala"
				_tmp69_ = _tmp68_[0];
#line 1099 "panel.vala"
				_tmp70_ = _g_object_ref0 (_tmp69_);
#line 1099 "panel.vala"
				_g_object_unref0 (self->priv->m_en_engine);
#line 1099 "panel.vala"
				self->priv->m_en_engine = _tmp70_;
#line 1099 "panel.vala"
				_tmp68_ = (_vala_array_free (_tmp68_, _tmp68__length1, (GDestroyNotify) g_object_unref), NULL);
#line 1099 "panel.vala"
				_tmp65_ = (_vala_array_free (_tmp65_, _tmp65__length1, (GDestroyNotify) g_free), NULL);
#line 6143 "panel.c"
			}
		}
#line 1103 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1104 "panel.vala"
		_tmp71_ = self->priv->m_engines;
#line 1104 "panel.vala"
		_tmp71__length1 = self->priv->m_engines_length1;
#line 1104 "panel.vala"
		if (_tmp71__length1 > 0) {
#line 6154 "panel.c"
			IBusEngineDesc** _tmp72_;
			gint _tmp72__length1;
#line 1105 "panel.vala"
			_tmp72_ = self->priv->m_engines;
#line 1105 "panel.vala"
			_tmp72__length1 = self->priv->m_engines_length1;
#line 1105 "panel.vala"
			panel_run_preload_engines (self, _tmp72_, (gint) _tmp72__length1, 1);
#line 6163 "panel.c"
		}
	} else {
		IBusEngineDesc* current_engine = NULL;
		IBusEngineDesc** _tmp73_;
		gint _tmp73__length1;
		IBusEngineDesc* _tmp74_;
		IBusEngineDesc* _tmp75_;
		IBusEngineDesc** _tmp76_;
		gint _tmp76__length1;
		IBusEngineDesc** _tmp77_;
		gint _tmp77__length1;
		gint i = 0;
		IBusEngineDesc** _tmp88_;
		gint _tmp88__length1;
#line 1107 "panel.vala"
		_tmp73_ = self->priv->m_engines;
#line 1107 "panel.vala"
		_tmp73__length1 = self->priv->m_engines_length1;
#line 1107 "panel.vala"
		_tmp74_ = _tmp73_[0];
#line 1107 "panel.vala"
		_tmp75_ = _g_object_ref0 (_tmp74_);
#line 1107 "panel.vala"
		current_engine = _tmp75_;
#line 1108 "panel.vala"
		_tmp76_ = engines;
#line 1108 "panel.vala"
		_tmp76__length1 = engines_length1;
#line 1108 "panel.vala"
		_tmp77_ = (_tmp76_ != NULL) ? _vala_array_dup4 (_tmp76_, _tmp76__length1) : _tmp76_;
#line 1108 "panel.vala"
		_tmp77__length1 = _tmp76__length1;
#line 1108 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1108 "panel.vala"
		self->priv->m_engines = _tmp77_;
#line 1108 "panel.vala"
		self->priv->m_engines_length1 = _tmp77__length1;
#line 1108 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 6204 "panel.c"
		{
			gboolean _tmp78_ = FALSE;
#line 1110 "panel.vala"
			i = 0;
#line 1110 "panel.vala"
			_tmp78_ = TRUE;
#line 1110 "panel.vala"
			while (TRUE) {
#line 6213 "panel.c"
				IBusEngineDesc** _tmp80_;
				gint _tmp80__length1;
				IBusEngineDesc* _tmp81_;
				const gchar* _tmp82_;
				IBusEngineDesc** _tmp83_;
				gint _tmp83__length1;
				IBusEngineDesc* _tmp84_;
				const gchar* _tmp85_;
#line 1110 "panel.vala"
				if (!_tmp78_) {
#line 6224 "panel.c"
					gint _tmp79_;
#line 1110 "panel.vala"
					_tmp79_ = i;
#line 1110 "panel.vala"
					i = _tmp79_ + 1;
#line 6230 "panel.c"
				}
#line 1110 "panel.vala"
				_tmp78_ = FALSE;
#line 1110 "panel.vala"
				_tmp80_ = self->priv->m_engines;
#line 1110 "panel.vala"
				_tmp80__length1 = self->priv->m_engines_length1;
#line 1110 "panel.vala"
				if (!(i < _tmp80__length1)) {
#line 1110 "panel.vala"
					break;
#line 6242 "panel.c"
				}
#line 1111 "panel.vala"
				_tmp81_ = current_engine;
#line 1111 "panel.vala"
				_tmp82_ = ibus_engine_desc_get_name (_tmp81_);
#line 1111 "panel.vala"
				_tmp83_ = engines;
#line 1111 "panel.vala"
				_tmp83__length1 = engines_length1;
#line 1111 "panel.vala"
				_tmp84_ = _tmp83_[i];
#line 1111 "panel.vala"
				_tmp85_ = ibus_engine_desc_get_name (_tmp84_);
#line 1111 "panel.vala"
				if (g_strcmp0 (_tmp82_, _tmp85_) == 0) {
#line 1112 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1113 "panel.vala"
					if (i != 0) {
#line 6262 "panel.c"
						IBusEngineDesc** _tmp86_;
						gint _tmp86__length1;
#line 1114 "panel.vala"
						_tmp86_ = engines;
#line 1114 "panel.vala"
						_tmp86__length1 = engines_length1;
#line 1114 "panel.vala"
						panel_run_preload_engines (self, _tmp86_, (gint) _tmp86__length1, 0);
#line 6271 "panel.c"
					} else {
						IBusEngineDesc** _tmp87_;
						gint _tmp87__length1;
#line 1116 "panel.vala"
						_tmp87_ = engines;
#line 1116 "panel.vala"
						_tmp87__length1 = engines_length1;
#line 1116 "panel.vala"
						panel_run_preload_engines (self, _tmp87_, (gint) _tmp87__length1, 1);
#line 6281 "panel.c"
					}
#line 1118 "panel.vala"
					_g_object_unref0 (current_engine);
#line 1118 "panel.vala"
					engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1118 "panel.vala"
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1118 "panel.vala"
					engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1118 "panel.vala"
					return;
#line 6293 "panel.c"
				}
			}
		}
#line 1121 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1122 "panel.vala"
		_tmp88_ = engines;
#line 1122 "panel.vala"
		_tmp88__length1 = engines_length1;
#line 1122 "panel.vala"
		panel_run_preload_engines (self, _tmp88_, (gint) _tmp88__length1, 1);
#line 1091 "panel.vala"
		_g_object_unref0 (current_engine);
#line 6307 "panel.c"
	}
#line 1031 "panel.vala"
	engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1031 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1031 "panel.vala"
	engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 6315 "panel.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 1137 "panel.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 6323 "panel.c"
}

static void
panel_context_render_string (Panel* self,
                             cairo_t* cr,
                             const gchar* symbol,
                             gint image_width,
                             gint image_height)
{
	gint lwidth = 0;
	gint lheight = 0;
	PangoFontDescription* desc = NULL;
	PangoFontDescription* _tmp0_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	PangoLayout* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoLayout* _tmp7_;
	PangoLayout* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	PangoLayout* _tmp15_;
#line 1127 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1127 "panel.vala"
	g_return_if_fail (cr != NULL);
#line 1127 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1131 "panel.vala"
	lwidth = 0;
#line 1132 "panel.vala"
	lheight = 0;
#line 1133 "panel.vala"
	_tmp0_ = pango_font_description_from_string ("Monospace Bold 22");
#line 1133 "panel.vala"
	desc = _tmp0_;
#line 1134 "panel.vala"
	_tmp1_ = pango_cairo_create_layout (cr);
#line 1134 "panel.vala"
	layout = _tmp1_;
#line 1136 "panel.vala"
	_tmp2_ = strlen (symbol);
#line 1136 "panel.vala"
	_tmp3_ = _tmp2_;
#line 1136 "panel.vala"
	if (_tmp3_ >= 3) {
#line 6376 "panel.c"
		PangoFontDescription* _tmp4_;
#line 1137 "panel.vala"
		_tmp4_ = pango_font_description_from_string ("Monospace Bold 18");
#line 1137 "panel.vala"
		__vala_PangoFontDescription_free0 (desc);
#line 1137 "panel.vala"
		desc = _tmp4_;
#line 6384 "panel.c"
	}
#line 1139 "panel.vala"
	_tmp5_ = layout;
#line 1139 "panel.vala"
	_tmp6_ = desc;
#line 1139 "panel.vala"
	pango_layout_set_font_description (_tmp5_, _tmp6_);
#line 1140 "panel.vala"
	_tmp7_ = layout;
#line 1140 "panel.vala"
	pango_layout_set_text (_tmp7_, symbol, -1);
#line 1141 "panel.vala"
	_tmp8_ = layout;
#line 1141 "panel.vala"
	pango_layout_get_size (_tmp8_, &_tmp9_, &_tmp10_);
#line 1141 "panel.vala"
	lwidth = _tmp9_;
#line 1141 "panel.vala"
	lheight = _tmp10_;
#line 1142 "panel.vala"
	cairo_move_to (cr, (gdouble) ((image_width - (lwidth / PANGO_SCALE)) / 2), (gdouble) ((image_height - (lheight / PANGO_SCALE)) / 2));
#line 1144 "panel.vala"
	_tmp11_ = self->priv->m_xkb_icon_rgba;
#line 1144 "panel.vala"
	_tmp12_ = self->priv->m_xkb_icon_rgba;
#line 1144 "panel.vala"
	_tmp13_ = self->priv->m_xkb_icon_rgba;
#line 1144 "panel.vala"
	_tmp14_ = self->priv->m_xkb_icon_rgba;
#line 1144 "panel.vala"
	cairo_set_source_rgba (cr, _tmp11_.red, _tmp12_.green, _tmp13_.blue, _tmp14_.alpha);
#line 1148 "panel.vala"
	_tmp15_ = layout;
#line 1148 "panel.vala"
	pango_cairo_show_layout (cr, _tmp15_);
#line 1127 "panel.vala"
	_g_object_unref0 (layout);
#line 1127 "panel.vala"
	__vala_PangoFontDescription_free0 (desc);
#line 6424 "panel.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 1156 "panel.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 6432 "panel.c"
}

static cairo_surface_t*
panel_create_cairo_image_surface_with_string (Panel* self,
                                              const gchar* symbol,
                                              gboolean cache)
{
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	gint width = 0;
	cairo_surface_t* _tmp7_;
	gint height = 0;
	cairo_surface_t* _tmp8_;
	gint stride = 0;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_surface_t* result;
#line 1151 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1151 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1153 "panel.vala"
	image = NULL;
#line 1155 "panel.vala"
	if (cache) {
#line 6466 "panel.c"
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 1156 "panel.vala"
		_tmp0_ = self->priv->m_xkb_icon_image;
#line 1156 "panel.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1156 "panel.vala"
		_tmp2_ = _cairo_surface_reference0 ((cairo_surface_t*) _tmp1_);
#line 1156 "panel.vala"
		_cairo_surface_destroy0 (image);
#line 1156 "panel.vala"
		image = _tmp2_;
#line 1158 "panel.vala"
		_tmp3_ = image;
#line 1158 "panel.vala"
		if (_tmp3_ != NULL) {
#line 1159 "panel.vala"
			result = image;
#line 1159 "panel.vala"
			return result;
#line 6489 "panel.c"
		}
	}
#line 1162 "panel.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 48, 48);
#line 1162 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1162 "panel.vala"
	image = _tmp4_;
#line 1163 "panel.vala"
	_tmp5_ = image;
#line 1163 "panel.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 1163 "panel.vala"
	cr = _tmp6_;
#line 1164 "panel.vala"
	_tmp7_ = image;
#line 1164 "panel.vala"
	width = cairo_image_surface_get_width (_tmp7_);
#line 1165 "panel.vala"
	_tmp8_ = image;
#line 1165 "panel.vala"
	height = cairo_image_surface_get_height (_tmp8_);
#line 1166 "panel.vala"
	_tmp9_ = image;
#line 1166 "panel.vala"
	stride = cairo_image_surface_get_stride (_tmp9_);
#line 1168 "panel.vala"
	_tmp10_ = cr;
#line 1168 "panel.vala"
	cairo_set_source_rgba (_tmp10_, 0.0, 0.0, 0.0, 0.0);
#line 1169 "panel.vala"
	_tmp11_ = cr;
#line 1169 "panel.vala"
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
#line 1170 "panel.vala"
	_tmp12_ = cr;
#line 1170 "panel.vala"
	cairo_paint (_tmp12_);
#line 1171 "panel.vala"
	_tmp13_ = cr;
#line 1171 "panel.vala"
	cairo_set_operator (_tmp13_, CAIRO_OPERATOR_OVER);
#line 1172 "panel.vala"
	_tmp14_ = cr;
#line 1172 "panel.vala"
	panel_context_render_string (self, _tmp14_, symbol, width, height);
#line 1173 "panel.vala"
	_tmp15_ = image;
#line 1173 "panel.vala"
	cairo_surface_flush (_tmp15_);
#line 1175 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 1176 "panel.vala"
		if (G_BYTE_ORDER == G_LITTLE_ENDIAN) {
#line 6544 "panel.c"
			guint* data = NULL;
			cairo_surface_t* _tmp16_;
			guchar* _tmp17_;
			gint data_length1;
			gint _data_size_;
			gint length = 0;
#line 1177 "panel.vala"
			_tmp16_ = image;
#line 1177 "panel.vala"
			_tmp17_ = cairo_image_surface_get_data (_tmp16_);
#line 1177 "panel.vala"
			data = (guint*) _tmp17_;
#line 1177 "panel.vala"
			data_length1 = (-1 * sizeof (guchar)) / sizeof (guint);
#line 1177 "panel.vala"
			_data_size_ = data_length1;
#line 1178 "panel.vala"
			length = (stride * height) / ((gint) sizeof (guint));
#line 6563 "panel.c"
			{
				gint i = 0;
#line 1179 "panel.vala"
				i = 0;
#line 6568 "panel.c"
				{
					gboolean _tmp18_ = FALSE;
#line 1179 "panel.vala"
					_tmp18_ = TRUE;
#line 1179 "panel.vala"
					while (TRUE) {
#line 6575 "panel.c"
						guint* _tmp20_;
						gint _tmp20__length1;
						guint* _tmp21_;
						gint _tmp21__length1;
						guint _tmp22_;
#line 1179 "panel.vala"
						if (!_tmp18_) {
#line 6583 "panel.c"
							gint _tmp19_;
#line 1179 "panel.vala"
							_tmp19_ = i;
#line 1179 "panel.vala"
							i = _tmp19_ + 1;
#line 6589 "panel.c"
						}
#line 1179 "panel.vala"
						_tmp18_ = FALSE;
#line 1179 "panel.vala"
						if (!(i < length)) {
#line 1179 "panel.vala"
							break;
#line 6597 "panel.c"
						}
#line 1180 "panel.vala"
						_tmp20_ = data;
#line 1180 "panel.vala"
						_tmp20__length1 = data_length1;
#line 1180 "panel.vala"
						_tmp21_ = data;
#line 1180 "panel.vala"
						_tmp21__length1 = data_length1;
#line 1180 "panel.vala"
						_tmp22_ = _tmp21_[i];
#line 1180 "panel.vala"
						_tmp20_[i] = GUINT_TO_BE (_tmp22_);
#line 6611 "panel.c"
					}
				}
			}
		}
	}
#line 1184 "panel.vala"
	if (cache) {
#line 6619 "panel.c"
		GHashTable* _tmp23_;
		gchar* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
#line 1185 "panel.vala"
		_tmp23_ = self->priv->m_xkb_icon_image;
#line 1185 "panel.vala"
		_tmp24_ = g_strdup (symbol);
#line 1185 "panel.vala"
		_tmp25_ = image;
#line 1185 "panel.vala"
		_tmp26_ = _cairo_surface_reference0 (_tmp25_);
#line 1185 "panel.vala"
		g_hash_table_insert (_tmp23_, _tmp24_, _tmp26_);
#line 6634 "panel.c"
	}
#line 1187 "panel.vala"
	result = image;
#line 1187 "panel.vala"
	_cairo_destroy0 (cr);
#line 1187 "panel.vala"
	return result;
#line 6642 "panel.c"
}

static GdkPixbuf*
panel_create_icon_pixbuf_with_string (Panel* self,
                                      const gchar* symbol)
{
	GdkPixbuf* pixbuf = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	gint width = 0;
	cairo_surface_t* _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	GdkPixbuf* _tmp8_;
	GHashTable* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* result;
#line 1190 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1190 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1191 "panel.vala"
	_tmp0_ = self->priv->m_xkb_icon_pixbufs;
#line 1191 "panel.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1191 "panel.vala"
	_tmp2_ = _g_object_ref0 ((GdkPixbuf*) _tmp1_);
#line 1191 "panel.vala"
	pixbuf = _tmp2_;
#line 1193 "panel.vala"
	_tmp3_ = pixbuf;
#line 1193 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1194 "panel.vala"
		result = pixbuf;
#line 1194 "panel.vala"
		return result;
#line 6687 "panel.c"
	}
#line 1196 "panel.vala"
	_tmp4_ = panel_create_cairo_image_surface_with_string (self, symbol, FALSE);
#line 1196 "panel.vala"
	image = _tmp4_;
#line 1197 "panel.vala"
	_tmp5_ = image;
#line 1197 "panel.vala"
	width = cairo_image_surface_get_width (_tmp5_);
#line 1198 "panel.vala"
	_tmp6_ = image;
#line 1198 "panel.vala"
	height = cairo_image_surface_get_height (_tmp6_);
#line 1199 "panel.vala"
	_tmp7_ = image;
#line 1199 "panel.vala"
	_tmp8_ = gdk_pixbuf_get_from_surface (_tmp7_, 0, 0, width, height);
#line 1199 "panel.vala"
	_g_object_unref0 (pixbuf);
#line 1199 "panel.vala"
	pixbuf = _tmp8_;
#line 1200 "panel.vala"
	_tmp9_ = self->priv->m_xkb_icon_pixbufs;
#line 1200 "panel.vala"
	_tmp10_ = g_strdup (symbol);
#line 1200 "panel.vala"
	_tmp11_ = pixbuf;
#line 1200 "panel.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1200 "panel.vala"
	g_hash_table_insert (_tmp9_, _tmp10_, _tmp12_);
#line 1201 "panel.vala"
	result = pixbuf;
#line 1201 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1201 "panel.vala"
	return result;
#line 6725 "panel.c"
}

static void
__lambda81_ (Panel* self,
             GPid pid,
             gint state)
{
#line 1225 "panel.vala"
	if (pid != self->priv->m_setup_pid) {
#line 1226 "panel.vala"
		return;
#line 6737 "panel.c"
	}
#line 1227 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 1228 "panel.vala"
	g_spawn_close_pid (pid);
#line 6743 "panel.c"
}

static void
___lambda81__gchild_watch_func (GPid pid,
                                gint wait_status,
                                gpointer self)
{
#line 1224 "panel.vala"
	__lambda81_ ((Panel*) self, pid, wait_status);
#line 6753 "panel.c"
}

static void
panel_show_setup_dialog (Panel* self)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1204 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1205 "panel.vala"
	if (self->priv->m_setup_pid != ((GPid) 0)) {
#line 1206 "panel.vala"
		if (kill ((pid_t) self->priv->m_setup_pid, (gint) SIGUSR1) == 0) {
#line 1207 "panel.vala"
			return;
#line 6770 "panel.c"
		}
#line 1208 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 6774 "panel.c"
	}
#line 1211 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus-setup", NULL);
#line 1211 "panel.vala"
	binary = _tmp0_;
#line 6780 "panel.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		GPid _tmp6_ = 0;
#line 1213 "panel.vala"
		_tmp1_ = binary;
#line 1213 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1213 "panel.vala"
		_tmp3_ = g_strdup ("ibus-setup");
#line 1213 "panel.vala"
		_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 1213 "panel.vala"
		_tmp4_[0] = _tmp2_;
#line 1213 "panel.vala"
		_tmp4_[1] = _tmp3_;
#line 1213 "panel.vala"
		_tmp5_ = _tmp4_;
#line 1213 "panel.vala"
		_tmp5__length1 = 2;
#line 1213 "panel.vala"
		g_spawn_async (NULL, _tmp5_, NULL, G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp6_, &_inner_error0_);
#line 1213 "panel.vala"
		self->priv->m_setup_pid = _tmp6_;
#line 1213 "panel.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 1213 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1213 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 6815 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1213 "panel.vala"
			_g_free0 (binary);
#line 1213 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1213 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1213 "panel.vala"
			return;
#line 6826 "panel.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1212 "panel.vala"
		e = _inner_error0_;
#line 1212 "panel.vala"
		_inner_error0_ = NULL;
#line 1220 "panel.vala"
		_tmp7_ = binary;
#line 1220 "panel.vala"
		_tmp8_ = e;
#line 1220 "panel.vala"
		_tmp9_ = _tmp8_->message;
#line 1220 "panel.vala"
		g_warning ("panel.vala:1220: Execute %s failed! %s", _tmp7_, _tmp9_);
#line 1221 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 1212 "panel.vala"
		_g_error_free0 (e);
#line 6852 "panel.c"
	}
	__finally0:
#line 1212 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1212 "panel.vala"
		_g_free0 (binary);
#line 1212 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1212 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1212 "panel.vala"
		return;
#line 6865 "panel.c"
	}
#line 1224 "panel.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->m_setup_pid, ___lambda81__gchild_watch_func, g_object_ref (self), g_object_unref);
#line 1204 "panel.vala"
	_g_free0 (binary);
#line 6871 "panel.c"
}

static void
panel_show_about_dialog (Panel* self)
{
	GtkAboutDialog* _tmp0_;
	GtkAboutDialog* _tmp21_;
#line 1232 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1233 "panel.vala"
	_tmp0_ = self->priv->m_about_dialog;
#line 1233 "panel.vala"
	if (_tmp0_ == NULL) {
#line 6885 "panel.c"
		GtkAboutDialog* _tmp1_;
		GtkAboutDialog* _tmp2_;
		GtkAboutDialog* _tmp3_;
		gchar* copyright = NULL;
		gchar* _tmp4_;
		GtkAboutDialog* _tmp5_;
		const gchar* _tmp6_;
		GtkAboutDialog* _tmp7_;
		GtkAboutDialog* _tmp8_;
		GtkAboutDialog* _tmp9_;
		GtkAboutDialog* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GtkAboutDialog* _tmp14_;
		gchar* _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		GtkAboutDialog* _tmp18_;
		GtkAboutDialog* _tmp19_;
		GtkAboutDialog* _tmp20_;
#line 1234 "panel.vala"
		_tmp1_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 1234 "panel.vala"
		g_object_ref_sink (_tmp1_);
#line 1234 "panel.vala"
		_g_object_unref0 (self->priv->m_about_dialog);
#line 1234 "panel.vala"
		self->priv->m_about_dialog = _tmp1_;
#line 1235 "panel.vala"
		_tmp2_ = self->priv->m_about_dialog;
#line 1235 "panel.vala"
		gtk_about_dialog_set_program_name (_tmp2_, "IBus");
#line 1236 "panel.vala"
		_tmp3_ = self->priv->m_about_dialog;
#line 1236 "panel.vala"
		gtk_about_dialog_set_version (_tmp3_, PACKAGE_VERSION);
#line 1238 "panel.vala"
		_tmp4_ = g_strdup ("Copyright © 2007-2015 Peng Huang\n" "Copyright © 2015-2022 Takao Fujiwara\n" "Copyright © 2007-2015 Red Hat, Inc.\n");
#line 1238 "panel.vala"
		copyright = _tmp4_;
#line 1243 "panel.vala"
		_tmp5_ = self->priv->m_about_dialog;
#line 1243 "panel.vala"
		_tmp6_ = copyright;
#line 1243 "panel.vala"
		gtk_about_dialog_set_copyright (_tmp5_, _tmp6_);
#line 1244 "panel.vala"
		_tmp7_ = self->priv->m_about_dialog;
#line 1244 "panel.vala"
		gtk_about_dialog_set_license (_tmp7_, "LGPL");
#line 1245 "panel.vala"
		_tmp8_ = self->priv->m_about_dialog;
#line 1245 "panel.vala"
		gtk_about_dialog_set_comments (_tmp8_, _ ("IBus is an intelligent input bus for Linux/Unix."));
#line 1246 "panel.vala"
		_tmp9_ = self->priv->m_about_dialog;
#line 1246 "panel.vala"
		gtk_about_dialog_set_website (_tmp9_, "https://github.com/ibus/ibus/wiki");
#line 1247 "panel.vala"
		_tmp10_ = self->priv->m_about_dialog;
#line 1247 "panel.vala"
		_tmp11_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1247 "panel.vala"
		_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 1247 "panel.vala"
		_tmp12_[0] = _tmp11_;
#line 1247 "panel.vala"
		_tmp13_ = _tmp12_;
#line 1247 "panel.vala"
		_tmp13__length1 = 1;
#line 1247 "panel.vala"
		gtk_about_dialog_set_authors (_tmp10_, _tmp13_);
#line 1247 "panel.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 1248 "panel.vala"
		_tmp14_ = self->priv->m_about_dialog;
#line 1248 "panel.vala"
		_tmp15_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1248 "panel.vala"
		_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 1248 "panel.vala"
		_tmp16_[0] = _tmp15_;
#line 1248 "panel.vala"
		_tmp17_ = _tmp16_;
#line 1248 "panel.vala"
		_tmp17__length1 = 1;
#line 1248 "panel.vala"
		gtk_about_dialog_set_documenters (_tmp14_, _tmp17_);
#line 1248 "panel.vala"
		_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 1249 "panel.vala"
		_tmp18_ = self->priv->m_about_dialog;
#line 1249 "panel.vala"
		gtk_about_dialog_set_translator_credits (_tmp18_, _ ("translator-credits"));
#line 1250 "panel.vala"
		_tmp19_ = self->priv->m_about_dialog;
#line 1250 "panel.vala"
		gtk_about_dialog_set_logo_icon_name (_tmp19_, "ibus");
#line 1251 "panel.vala"
		_tmp20_ = self->priv->m_about_dialog;
#line 1251 "panel.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp20_, "ibus");
#line 1233 "panel.vala"
		_g_free0 (copyright);
#line 6993 "panel.c"
	}
#line 1254 "panel.vala"
	_tmp21_ = self->priv->m_about_dialog;
#line 1254 "panel.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp21_)) {
#line 6999 "panel.c"
		GtkAboutDialog* _tmp22_;
		GtkAboutDialog* _tmp23_;
#line 1255 "panel.vala"
		_tmp22_ = self->priv->m_about_dialog;
#line 1255 "panel.vala"
		gtk_dialog_run ((GtkDialog*) _tmp22_);
#line 1256 "panel.vala"
		_tmp23_ = self->priv->m_about_dialog;
#line 1256 "panel.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 7010 "panel.c"
	} else {
		GtkAboutDialog* _tmp24_;
#line 1258 "panel.vala"
		_tmp24_ = self->priv->m_about_dialog;
#line 1258 "panel.vala"
		gtk_window_present ((GtkWindow*) _tmp24_);
#line 7017 "panel.c"
	}
}

static void
___lambda80_ (Panel* self,
              GtkMenuItem* i)
{
#line 1269 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1269 "panel.vala"
	panel_show_setup_dialog (self);
#line 7029 "panel.c"
}

static void
____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 1269 "panel.vala"
	___lambda80_ ((Panel*) self, _sender);
#line 7038 "panel.c"
}

static void
___lambda82_ (Panel* self,
              GtkMenuItem* i)
{
	IBusExtensionEvent* event = NULL;
	IBusExtensionEvent* _tmp0_;
	IBusExtensionEvent* _tmp1_;
#line 1274 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1275 "panel.vala"
	_tmp0_ = ibus_extension_event_new ("name", "emoji", "is-enabled", TRUE, "params", "category-list", NULL);
#line 1275 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1275 "panel.vala"
	event = _tmp0_;
#line 1283 "panel.vala"
	_tmp1_ = _g_object_ref0 (event);
#line 1283 "panel.vala"
	ibus_panel_service_panel_extension ((IBusPanelService*) self, _tmp1_);
#line 1274 "panel.vala"
	_g_object_unref0 (event);
#line 7062 "panel.c"
}

static void
____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 1274 "panel.vala"
	___lambda82_ ((Panel*) self, _sender);
#line 7071 "panel.c"
}

static void
___lambda83_ (Panel* self,
              GtkMenuItem* i)
{
#line 1289 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1289 "panel.vala"
	panel_show_about_dialog (self);
#line 7082 "panel.c"
}

static void
____lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 1289 "panel.vala"
	___lambda83_ ((Panel*) self, _sender);
#line 7091 "panel.c"
}

static void
___lambda84_ (Panel* self,
              GtkMenuItem* i)
{
	IBusBus* _tmp0_;
#line 1295 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1295 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1295 "panel.vala"
	ibus_bus_exit (_tmp0_, TRUE);
#line 7105 "panel.c"
}

static void
____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 1295 "panel.vala"
	___lambda84_ ((Panel*) self, _sender);
#line 7114 "panel.c"
}

static void
___lambda85_ (Panel* self,
              GtkMenuItem* i)
{
	IBusBus* _tmp0_;
#line 1299 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1299 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1299 "panel.vala"
	ibus_bus_exit (_tmp0_, FALSE);
#line 7128 "panel.c"
}

static void
____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 1299 "panel.vala"
	___lambda85_ ((Panel*) self, _sender);
#line 7137 "panel.c"
}

static GtkMenu*
panel_create_context_menu (Panel* self)
{
	GtkMenu* _tmp0_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GtkMenu* result;
#line 1262 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1264 "panel.vala"
	_tmp0_ = self->priv->m_sys_menu;
#line 1264 "panel.vala"
	if (_tmp0_ == NULL) {
#line 7153 "panel.c"
		GtkMenuItem* item = NULL;
		GtkMenu* _tmp1_;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* _tmp5_;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp8_;
		GtkMenuItem* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenuItem* _tmp11_;
		GtkMenu* _tmp12_;
		GtkMenuItem* _tmp13_;
		GtkMenu* _tmp14_;
		GtkSeparatorMenuItem* _tmp15_;
		GtkSeparatorMenuItem* _tmp16_;
		GtkMenuItem* _tmp17_;
		GtkMenuItem* _tmp18_;
		GtkMenu* _tmp19_;
		GtkMenuItem* _tmp20_;
		GtkMenuItem* _tmp21_;
		GtkMenuItem* _tmp22_;
		GtkMenu* _tmp23_;
		GtkMenuItem* _tmp24_;
		GtkMenu* _tmp25_;
#line 1266 "panel.vala"
		_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 1266 "panel.vala"
		g_object_ref_sink (_tmp1_);
#line 1266 "panel.vala"
		_g_object_unref0 (self->priv->m_sys_menu);
#line 1266 "panel.vala"
		self->priv->m_sys_menu = _tmp1_;
#line 1268 "panel.vala"
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
#line 1268 "panel.vala"
		g_object_ref_sink (_tmp2_);
#line 1268 "panel.vala"
		_g_object_unref0 (item);
#line 1268 "panel.vala"
		item = _tmp2_;
#line 1269 "panel.vala"
		_tmp3_ = item;
#line 1269 "panel.vala"
		g_signal_connect_object (_tmp3_, "activate", (GCallback) ____lambda80__gtk_menu_item_activate, self, 0);
#line 1270 "panel.vala"
		_tmp4_ = self->priv->m_sys_menu;
#line 1270 "panel.vala"
		_tmp5_ = item;
#line 1270 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 1273 "panel.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Emoji Choice"));
#line 1273 "panel.vala"
		g_object_ref_sink (_tmp6_);
#line 1273 "panel.vala"
		_g_object_unref0 (item);
#line 1273 "panel.vala"
		item = _tmp6_;
#line 1274 "panel.vala"
		_tmp7_ = item;
#line 1274 "panel.vala"
		g_signal_connect_object (_tmp7_, "activate", (GCallback) ____lambda82__gtk_menu_item_activate, self, 0);
#line 1285 "panel.vala"
		_tmp8_ = self->priv->m_sys_menu;
#line 1285 "panel.vala"
		_tmp9_ = item;
#line 1285 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
#line 1288 "panel.vala"
		_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("About"));
#line 1288 "panel.vala"
		g_object_ref_sink (_tmp10_);
#line 1288 "panel.vala"
		_g_object_unref0 (item);
#line 1288 "panel.vala"
		item = _tmp10_;
#line 1289 "panel.vala"
		_tmp11_ = item;
#line 1289 "panel.vala"
		g_signal_connect_object (_tmp11_, "activate", (GCallback) ____lambda83__gtk_menu_item_activate, self, 0);
#line 1290 "panel.vala"
		_tmp12_ = self->priv->m_sys_menu;
#line 1290 "panel.vala"
		_tmp13_ = item;
#line 1290 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp12_, _tmp13_);
#line 1292 "panel.vala"
		_tmp14_ = self->priv->m_sys_menu;
#line 1292 "panel.vala"
		_tmp15_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1292 "panel.vala"
		g_object_ref_sink (_tmp15_);
#line 1292 "panel.vala"
		_tmp16_ = _tmp15_;
#line 1292 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, (GtkMenuItem*) _tmp16_);
#line 1292 "panel.vala"
		_g_object_unref0 (_tmp16_);
#line 1294 "panel.vala"
		_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restart"));
#line 1294 "panel.vala"
		g_object_ref_sink (_tmp17_);
#line 1294 "panel.vala"
		_g_object_unref0 (item);
#line 1294 "panel.vala"
		item = _tmp17_;
#line 1295 "panel.vala"
		_tmp18_ = item;
#line 1295 "panel.vala"
		g_signal_connect_object (_tmp18_, "activate", (GCallback) ____lambda84__gtk_menu_item_activate, self, 0);
#line 1296 "panel.vala"
		_tmp19_ = self->priv->m_sys_menu;
#line 1296 "panel.vala"
		_tmp20_ = item;
#line 1296 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
#line 1298 "panel.vala"
		_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit"));
#line 1298 "panel.vala"
		g_object_ref_sink (_tmp21_);
#line 1298 "panel.vala"
		_g_object_unref0 (item);
#line 1298 "panel.vala"
		item = _tmp21_;
#line 1299 "panel.vala"
		_tmp22_ = item;
#line 1299 "panel.vala"
		g_signal_connect_object (_tmp22_, "activate", (GCallback) ____lambda85__gtk_menu_item_activate, self, 0);
#line 1300 "panel.vala"
		_tmp23_ = self->priv->m_sys_menu;
#line 1300 "panel.vala"
		_tmp24_ = item;
#line 1300 "panel.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
#line 1302 "panel.vala"
		_tmp25_ = self->priv->m_sys_menu;
#line 1302 "panel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp25_);
#line 1264 "panel.vala"
		_g_object_unref0 (item);
#line 7296 "panel.c"
	}
#line 1305 "panel.vala"
	_tmp26_ = self->priv->m_sys_menu;
#line 1305 "panel.vala"
	_tmp27_ = _g_object_ref0 (_tmp26_);
#line 1305 "panel.vala"
	result = _tmp27_;
#line 1305 "panel.vala"
	return result;
#line 7306 "panel.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1317 "panel.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1317 "panel.vala"
	return _data9_;
#line 7316 "panel.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1317 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 7326 "panel.c"
		Panel* self;
#line 1317 "panel.vala"
		self = _data9_->self;
#line 1317 "panel.vala"
		_g_object_unref0 (_data9_->e);
#line 1317 "panel.vala"
		_g_object_unref0 (self);
#line 1317 "panel.vala"
		g_slice_free (Block9Data, _data9_);
#line 7336 "panel.c"
	}
}

static void
____lambda87_ (Block9Data* _data9_,
               GtkMenuItem* item)
{
	Panel* self;
#line 1331 "panel.vala"
	self = _data9_->self;
#line 1331 "panel.vala"
	g_return_if_fail (item != NULL);
#line 7349 "panel.c"
	{
		gint i = 0;
#line 1332 "panel.vala"
		i = 0;
#line 7354 "panel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1332 "panel.vala"
			_tmp0_ = TRUE;
#line 1332 "panel.vala"
			while (TRUE) {
#line 7361 "panel.c"
				IBusEngineDesc** _tmp2_;
				gint _tmp2__length1;
				IBusEngineDesc* _tmp3_;
				IBusEngineDesc** _tmp4_;
				gint _tmp4__length1;
				IBusEngineDesc* _tmp5_;
#line 1332 "panel.vala"
				if (!_tmp0_) {
#line 7370 "panel.c"
					gint _tmp1_;
#line 1332 "panel.vala"
					_tmp1_ = i;
#line 1332 "panel.vala"
					i = _tmp1_ + 1;
#line 7376 "panel.c"
				}
#line 1332 "panel.vala"
				_tmp0_ = FALSE;
#line 1332 "panel.vala"
				_tmp2_ = self->priv->m_engines;
#line 1332 "panel.vala"
				_tmp2__length1 = self->priv->m_engines_length1;
#line 1332 "panel.vala"
				if (!(i < _tmp2__length1)) {
#line 1332 "panel.vala"
					break;
#line 7388 "panel.c"
				}
#line 1333 "panel.vala"
				_tmp3_ = _data9_->e;
#line 1333 "panel.vala"
				_tmp4_ = self->priv->m_engines;
#line 1333 "panel.vala"
				_tmp4__length1 = self->priv->m_engines_length1;
#line 1333 "panel.vala"
				_tmp5_ = _tmp4_[i];
#line 1333 "panel.vala"
				if (_tmp3_ == _tmp5_) {
#line 1334 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1335 "panel.vala"
					break;
#line 7404 "panel.c"
				}
			}
		}
	}
}

static void
_____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 1331 "panel.vala"
	____lambda87_ (self, _sender);
#line 7417 "panel.c"
}

static GtkMenu*
panel_create_activate_menu (Panel* self)
{
	GtkMenu* _tmp0_;
	PropertyManager* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkSeparatorMenuItem* _tmp4_;
	GtkSeparatorMenuItem* _tmp5_;
	IBusEngineDesc** _tmp6_;
	gint _tmp6__length1;
	GtkMenu* _tmp38_;
	GtkMenu* _tmp39_;
	GtkMenu* _tmp40_;
	GtkMenu* _tmp41_;
	GtkMenu* result;
#line 1308 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1309 "panel.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 1309 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1309 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 1309 "panel.vala"
	self->priv->m_ime_menu = _tmp0_;
#line 1312 "panel.vala"
	_tmp1_ = self->priv->m_property_manager;
#line 1312 "panel.vala"
	_tmp2_ = self->priv->m_ime_menu;
#line 1312 "panel.vala"
	property_manager_create_menu_items (_tmp1_, _tmp2_);
#line 1314 "panel.vala"
	_tmp3_ = self->priv->m_ime_menu;
#line 1314 "panel.vala"
	_tmp4_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1314 "panel.vala"
	g_object_ref_sink (_tmp4_);
#line 1314 "panel.vala"
	_tmp5_ = _tmp4_;
#line 1314 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp3_, (GtkMenuItem*) _tmp5_);
#line 1314 "panel.vala"
	_g_object_unref0 (_tmp5_);
#line 1317 "panel.vala"
	_tmp6_ = self->priv->m_engines;
#line 1317 "panel.vala"
	_tmp6__length1 = self->priv->m_engines_length1;
#line 7468 "panel.c"
	{
		IBusEngineDesc** engine_collection = NULL;
		gint engine_collection_length1 = 0;
		gint _engine_collection_size_ = 0;
		gint engine_it = 0;
#line 1317 "panel.vala"
		engine_collection = _tmp6_;
#line 1317 "panel.vala"
		engine_collection_length1 = _tmp6__length1;
#line 1317 "panel.vala"
		for (engine_it = 0; engine_it < engine_collection_length1; engine_it = engine_it + 1) {
#line 7480 "panel.c"
			IBusEngineDesc* _tmp7_;
			IBusEngineDesc* engine = NULL;
#line 1317 "panel.vala"
			_tmp7_ = _g_object_ref0 (engine_collection[engine_it]);
#line 1317 "panel.vala"
			engine = _tmp7_;
#line 7487 "panel.c"
			{
				Block9Data* _data9_;
				gchar* language = NULL;
				IBusEngineDesc* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* longname = NULL;
				IBusEngineDesc* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* textdomain = NULL;
				IBusEngineDesc* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* transname = NULL;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gboolean _tmp20_ = FALSE;
				GtkMenuItem* item = NULL;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GtkMenuItem* _tmp31_;
				GtkMenuItem* _tmp32_;
				IBusEngineDesc* _tmp33_;
				IBusEngineDesc* _tmp34_;
				GtkMenuItem* _tmp35_;
				GtkMenu* _tmp36_;
				GtkMenuItem* _tmp37_;
#line 1317 "panel.vala"
				_data9_ = g_slice_new0 (Block9Data);
#line 1317 "panel.vala"
				_data9_->_ref_count_ = 1;
#line 1317 "panel.vala"
				_data9_->self = g_object_ref (self);
#line 1318 "panel.vala"
				_tmp8_ = engine;
#line 1318 "panel.vala"
				_tmp9_ = ibus_engine_desc_get_language (_tmp8_);
#line 1318 "panel.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 1318 "panel.vala"
				language = _tmp10_;
#line 1319 "panel.vala"
				_tmp11_ = engine;
#line 1319 "panel.vala"
				_tmp12_ = ibus_engine_desc_get_longname (_tmp11_);
#line 1319 "panel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 1319 "panel.vala"
				longname = _tmp13_;
#line 1320 "panel.vala"
				_tmp14_ = engine;
#line 1320 "panel.vala"
				_tmp15_ = ibus_engine_desc_get_textdomain (_tmp14_);
#line 1320 "panel.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 1320 "panel.vala"
				textdomain = _tmp16_;
#line 1321 "panel.vala"
				_tmp17_ = textdomain;
#line 1321 "panel.vala"
				_tmp18_ = longname;
#line 1321 "panel.vala"
				_tmp19_ = g_strdup (g_dgettext (_tmp17_, _tmp18_));
#line 1321 "panel.vala"
				transname = _tmp19_;
#line 1322 "panel.vala"
				if (self->priv->m_is_wayland) {
#line 7561 "panel.c"
					IBusEngineDesc* _tmp21_;
					const gchar* _tmp22_;
#line 1322 "panel.vala"
					_tmp21_ = engine;
#line 1322 "panel.vala"
					_tmp22_ = ibus_engine_desc_get_name (_tmp21_);
#line 1322 "panel.vala"
					_tmp20_ = g_str_has_prefix (_tmp22_, "xkb:");
#line 7570 "panel.c"
				} else {
#line 1322 "panel.vala"
					_tmp20_ = FALSE;
#line 7574 "panel.c"
				}
#line 1322 "panel.vala"
				if (_tmp20_) {
#line 7578 "panel.c"
					gchar* _tmp23_;
					gchar* _tmp24_;
#line 1323 "panel.vala"
					_tmp23_ = g_strdup (_ ("Other"));
#line 1323 "panel.vala"
					_g_free0 (language);
#line 1323 "panel.vala"
					language = _tmp23_;
#line 1324 "panel.vala"
					_tmp24_ = g_strdup (_ ("No input method"));
#line 1324 "panel.vala"
					_g_free0 (transname);
#line 1324 "panel.vala"
					transname = _tmp24_;
#line 7593 "panel.c"
				}
#line 1326 "panel.vala"
				_tmp25_ = language;
#line 1326 "panel.vala"
				_tmp26_ = ibus_get_language_name (_tmp25_);
#line 1326 "panel.vala"
				_tmp27_ = _tmp26_;
#line 1326 "panel.vala"
				_tmp28_ = transname;
#line 1326 "panel.vala"
				_tmp29_ = g_strdup_printf ("%s - %s", _tmp27_, _tmp28_);
#line 1326 "panel.vala"
				_tmp30_ = _tmp29_;
#line 1326 "panel.vala"
				_tmp31_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp30_);
#line 1326 "panel.vala"
				g_object_ref_sink (_tmp31_);
#line 1326 "panel.vala"
				_tmp32_ = _tmp31_;
#line 1326 "panel.vala"
				_g_free0 (_tmp30_);
#line 1326 "panel.vala"
				_g_free0 (_tmp27_);
#line 1326 "panel.vala"
				item = _tmp32_;
#line 1330 "panel.vala"
				_tmp33_ = engine;
#line 1330 "panel.vala"
				_tmp34_ = _g_object_ref0 (_tmp33_);
#line 1330 "panel.vala"
				_data9_->e = _tmp34_;
#line 1331 "panel.vala"
				_tmp35_ = item;
#line 1331 "panel.vala"
				g_signal_connect_data (_tmp35_, "activate", (GCallback) _____lambda87__gtk_menu_item_activate, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 1339 "panel.vala"
				_tmp36_ = self->priv->m_ime_menu;
#line 1339 "panel.vala"
				_tmp37_ = item;
#line 1339 "panel.vala"
				gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 1317 "panel.vala"
				_g_object_unref0 (item);
#line 1317 "panel.vala"
				_g_free0 (transname);
#line 1317 "panel.vala"
				_g_free0 (textdomain);
#line 1317 "panel.vala"
				_g_free0 (longname);
#line 1317 "panel.vala"
				_g_free0 (language);
#line 1317 "panel.vala"
				_g_object_unref0 (engine);
#line 1317 "panel.vala"
				block9_data_unref (_data9_);
#line 1317 "panel.vala"
				_data9_ = NULL;
#line 7651 "panel.c"
			}
		}
	}
#line 1342 "panel.vala"
	_tmp38_ = self->priv->m_ime_menu;
#line 1342 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp38_);
#line 1345 "panel.vala"
	_tmp39_ = self->priv->m_ime_menu;
#line 1345 "panel.vala"
	gtk_menu_shell_set_take_focus ((GtkMenuShell*) _tmp39_, FALSE);
#line 1347 "panel.vala"
	_tmp40_ = self->priv->m_ime_menu;
#line 1347 "panel.vala"
	_tmp41_ = _g_object_ref0 (_tmp40_);
#line 1347 "panel.vala"
	result = _tmp41_;
#line 1347 "panel.vala"
	return result;
#line 7671 "panel.c"
}

static void
panel_set_properties (Panel* self,
                      IBusPropList* props)
{
	gint i = 0;
#line 1350 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1350 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1351 "panel.vala"
	i = 0;
#line 1352 "panel.vala"
	while (TRUE) {
#line 7687 "panel.c"
		IBusProperty* prop = NULL;
		IBusProperty* _tmp0_;
		IBusProperty* _tmp1_;
		IBusProperty* _tmp2_;
		IBusProperty* _tmp3_;
		gint _tmp4_;
#line 1353 "panel.vala"
		_tmp0_ = ibus_prop_list_get (props, (guint) i);
#line 1353 "panel.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1353 "panel.vala"
		prop = _tmp1_;
#line 1354 "panel.vala"
		_tmp2_ = prop;
#line 1354 "panel.vala"
		if (_tmp2_ == NULL) {
#line 1355 "panel.vala"
			_g_object_unref0 (prop);
#line 1355 "panel.vala"
			break;
#line 7708 "panel.c"
		}
#line 1356 "panel.vala"
		_tmp3_ = ibus_prop_list_get (props, (guint) i);
#line 1356 "panel.vala"
		panel_set_property (self, _tmp3_, TRUE);
#line 1357 "panel.vala"
		_tmp4_ = i;
#line 1357 "panel.vala"
		i = _tmp4_ + 1;
#line 1352 "panel.vala"
		_g_object_unref0 (prop);
#line 7720 "panel.c"
	}
}

static void
panel_set_property (Panel* self,
                    IBusProperty* prop,
                    gboolean all_update)
{
	gchar* symbol = NULL;
	IBusText* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 1361 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1361 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1362 "panel.vala"
	_tmp0_ = ibus_property_get_symbol (prop);
#line 1362 "panel.vala"
	_tmp1_ = ibus_text_get_text (_tmp0_);
#line 1362 "panel.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1362 "panel.vala"
	symbol = _tmp2_;
#line 1364 "panel.vala"
	_tmp5_ = self->priv->m_icon_prop_key;
#line 1364 "panel.vala"
	if (g_strcmp0 (_tmp5_, "") != 0) {
#line 7752 "panel.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1364 "panel.vala"
		_tmp6_ = ibus_property_get_key (prop);
#line 1364 "panel.vala"
		_tmp7_ = self->priv->m_icon_prop_key;
#line 1364 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 7761 "panel.c"
	} else {
#line 1364 "panel.vala"
		_tmp4_ = FALSE;
#line 7765 "panel.c"
	}
#line 1364 "panel.vala"
	if (_tmp4_) {
#line 7769 "panel.c"
		const gchar* _tmp8_;
#line 1365 "panel.vala"
		_tmp8_ = symbol;
#line 1365 "panel.vala"
		_tmp3_ = g_strcmp0 (_tmp8_, "") != 0;
#line 7775 "panel.c"
	} else {
#line 1364 "panel.vala"
		_tmp3_ = FALSE;
#line 7779 "panel.c"
	}
#line 1364 "panel.vala"
	if (_tmp3_) {
#line 7783 "panel.c"
		const gchar* _tmp9_;
#line 1366 "panel.vala"
		_tmp9_ = symbol;
#line 1366 "panel.vala"
		panel_animate_icon (self, _tmp9_, all_update);
#line 7789 "panel.c"
	}
#line 1361 "panel.vala"
	_g_free0 (symbol);
#line 7793 "panel.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1369 "panel.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1369 "panel.vala"
	return _data10_;
#line 7803 "panel.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1369 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 7813 "panel.c"
		Panel* self;
#line 1369 "panel.vala"
		self = _data10_->self;
#line 1369 "panel.vala"
		_g_free0 (_data10_->symbol);
#line 1369 "panel.vala"
		_g_object_unref0 (self);
#line 1369 "panel.vala"
		g_slice_free (Block10Data, _data10_);
#line 7823 "panel.c"
	}
}

static gboolean
__lambda98_ (Block10Data* _data10_)
{
	Panel* self;
	gboolean result;
#line 1382 "panel.vala"
	self = _data10_->self;
#line 1383 "panel.vala"
	self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 1385 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 7838 "panel.c"
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 1386 "panel.vala"
		_tmp0_ = panel_create_icon_pixbuf_with_string (self, _data10_->symbol);
#line 1386 "panel.vala"
		pixbuf = _tmp0_;
#line 1387 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 1387 "panel.vala"
		_tmp2_ = pixbuf;
#line 1387 "panel.vala"
		gtk_status_icon_set_from_pixbuf (_tmp1_, _tmp2_);
#line 1385 "panel.vala"
		_g_object_unref0 (pixbuf);
#line 7855 "panel.c"
	} else {
#line 1389 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 7859 "panel.c"
			cairo_surface_t* image = NULL;
			cairo_surface_t* _tmp3_;
			Indicator* _tmp4_;
			cairo_surface_t* _tmp5_;
#line 1390 "panel.vala"
			_tmp3_ = panel_create_cairo_image_surface_with_string (self, _data10_->symbol, TRUE);
#line 1390 "panel.vala"
			image = _tmp3_;
#line 1392 "panel.vala"
			_tmp4_ = self->priv->m_indicator;
#line 1392 "panel.vala"
			_tmp5_ = image;
#line 1392 "panel.vala"
			indicator_set_cairo_image_surface_full (_tmp4_, _tmp5_, "");
#line 1389 "panel.vala"
			_cairo_surface_destroy0 (image);
#line 7876 "panel.c"
		}
	}
#line 1395 "panel.vala"
	result = FALSE;
#line 1395 "panel.vala"
	return result;
#line 7883 "panel.c"
}

static gboolean
___lambda98__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda98_ (self);
#line 1382 "panel.vala"
	return result;
#line 7893 "panel.c"
}

static void
panel_animate_icon (Panel* self,
                    const gchar* symbol,
                    gboolean all_update)
{
	Block10Data* _data10_;
	gchar* _tmp0_;
	guint timeout = 0U;
#line 1369 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1369 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1369 "panel.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1369 "panel.vala"
	_data10_->_ref_count_ = 1;
#line 1369 "panel.vala"
	_data10_->self = g_object_ref (self);
#line 1369 "panel.vala"
	_tmp0_ = g_strdup (symbol);
#line 1369 "panel.vala"
	_g_free0 (_data10_->symbol);
#line 1369 "panel.vala"
	_data10_->symbol = _tmp0_;
#line 1370 "panel.vala"
	if (self->priv->m_property_icon_delay_time < 0) {
#line 1371 "panel.vala"
		block10_data_unref (_data10_);
#line 1371 "panel.vala"
		_data10_ = NULL;
#line 1371 "panel.vala"
		return;
#line 7928 "panel.c"
	}
#line 1373 "panel.vala"
	timeout = (guint) 0;
#line 1374 "panel.vala"
	if (all_update) {
#line 1375 "panel.vala"
		timeout = (guint) self->priv->m_property_icon_delay_time;
#line 7936 "panel.c"
	}
#line 1377 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1378 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1379 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 7944 "panel.c"
	}
#line 1382 "panel.vala"
	self->priv->m_property_icon_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, timeout, ___lambda98__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 1369 "panel.vala"
	block10_data_unref (_data10_);
#line 1369 "panel.vala"
	_data10_ = NULL;
#line 7952 "panel.c"
}

static void
panel_real_set_cursor_location (IBusPanelService* base,
                                gint x,
                                gint y,
                                gint width,
                                gint height)
{
	Panel * self;
	CandidatePanel* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1400 "panel.vala"
	self = (Panel*) base;
#line 1402 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1402 "panel.vala"
	candidate_panel_set_cursor_location (_tmp0_, x, y, width, height);
#line 1403 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1403 "panel.vala"
	property_panel_set_cursor_location (_tmp1_, x, y, width, height);
#line 7975 "panel.c"
}

static gboolean
panel_switcher_focus_set_engine_real (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
	gboolean result;
#line 1406 "panel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1407 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1407 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1407 "panel.vala"
	selected_engine = _tmp1_;
#line 1408 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1408 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1408 "panel.vala"
	prev_context_path = _tmp3_;
#line 1409 "panel.vala"
	_tmp6_ = selected_engine;
#line 1409 "panel.vala"
	if (_tmp6_ != NULL) {
#line 8009 "panel.c"
		const gchar* _tmp7_;
#line 1410 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1410 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 8015 "panel.c"
	} else {
#line 1409 "panel.vala"
		_tmp5_ = FALSE;
#line 8019 "panel.c"
	}
#line 1409 "panel.vala"
	if (_tmp5_) {
#line 8023 "panel.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 1411 "panel.vala"
		_tmp8_ = prev_context_path;
#line 1411 "panel.vala"
		_tmp9_ = self->priv->m_current_context_path;
#line 1411 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
#line 8032 "panel.c"
	} else {
#line 1409 "panel.vala"
		_tmp4_ = FALSE;
#line 8036 "panel.c"
	}
#line 1409 "panel.vala"
	if (_tmp4_) {
#line 8040 "panel.c"
		IBusEngineDesc* _tmp10_;
		Switcher* _tmp11_;
#line 1412 "panel.vala"
		_tmp10_ = selected_engine;
#line 1412 "panel.vala"
		panel_set_engine (self, _tmp10_);
#line 1413 "panel.vala"
		_tmp11_ = self->priv->m_switcher;
#line 1413 "panel.vala"
		switcher_reset (_tmp11_);
#line 1414 "panel.vala"
		result = TRUE;
#line 1414 "panel.vala"
		_g_free0 (prev_context_path);
#line 1414 "panel.vala"
		_g_object_unref0 (selected_engine);
#line 1414 "panel.vala"
		return result;
#line 8059 "panel.c"
	}
#line 1417 "panel.vala"
	result = FALSE;
#line 1417 "panel.vala"
	_g_free0 (prev_context_path);
#line 1417 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 1417 "panel.vala"
	return result;
#line 8069 "panel.c"
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 1426 "panel.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 8077 "panel.c"
}

static gboolean
___lambda62_ (Panel* self)
{
	gboolean result;
#line 1434 "panel.vala"
	panel_switcher_focus_set_engine_real (self);
#line 1435 "panel.vala"
	self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1436 "panel.vala"
	result = FALSE;
#line 1436 "panel.vala"
	return result;
#line 8092 "panel.c"
}

static gboolean
____lambda62__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda62_ ((Panel*) self);
#line 1432 "panel.vala"
	return result;
#line 8102 "panel.c"
}

static void
panel_switcher_focus_set_engine (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
#line 1420 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1421 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1421 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1421 "panel.vala"
	selected_engine = _tmp1_;
#line 1422 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1422 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1422 "panel.vala"
	prev_context_path = _tmp3_;
#line 1423 "panel.vala"
	_tmp6_ = selected_engine;
#line 1423 "panel.vala"
	if (_tmp6_ == NULL) {
#line 8135 "panel.c"
		const gchar* _tmp7_;
#line 1424 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1424 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 8141 "panel.c"
	} else {
#line 1423 "panel.vala"
		_tmp5_ = FALSE;
#line 8145 "panel.c"
	}
#line 1423 "panel.vala"
	if (_tmp5_) {
#line 8149 "panel.c"
		Switcher* _tmp8_;
#line 1425 "panel.vala"
		_tmp8_ = self->priv->m_switcher;
#line 1425 "panel.vala"
		_tmp4_ = switcher_is_running (_tmp8_);
#line 8155 "panel.c"
	} else {
#line 1423 "panel.vala"
		_tmp4_ = FALSE;
#line 8159 "panel.c"
	}
#line 1423 "panel.vala"
	if (_tmp4_) {
#line 8163 "panel.c"
		GMainContext* context = NULL;
		GMainContext* _tmp9_;
		GMainContext* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 1426 "panel.vala"
		_tmp9_ = g_main_context_default ();
#line 1426 "panel.vala"
		_tmp10_ = _g_main_context_ref0 (_tmp9_);
#line 1426 "panel.vala"
		context = _tmp10_;
#line 1427 "panel.vala"
		if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 8176 "panel.c"
			GMainContext* _tmp12_;
			GSource* _tmp13_;
#line 1428 "panel.vala"
			_tmp12_ = context;
#line 1428 "panel.vala"
			_tmp13_ = g_main_context_find_source_by_id (_tmp12_, self->priv->m_switcher_focus_set_engine_id);
#line 1428 "panel.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 8185 "panel.c"
		} else {
#line 1427 "panel.vala"
			_tmp11_ = FALSE;
#line 8189 "panel.c"
		}
#line 1427 "panel.vala"
		if (_tmp11_) {
#line 1430 "panel.vala"
			g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 8195 "panel.c"
		}
#line 1432 "panel.vala"
		self->priv->m_switcher_focus_set_engine_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda62__gsource_func, g_object_ref (self), g_object_unref);
#line 1423 "panel.vala"
		_g_main_context_unref0 (context);
#line 8201 "panel.c"
	} else {
#line 1439 "panel.vala"
		if (panel_switcher_focus_set_engine_real (self)) {
#line 8205 "panel.c"
			GMainContext* context = NULL;
			GMainContext* _tmp14_;
			GMainContext* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1440 "panel.vala"
			_tmp14_ = g_main_context_default ();
#line 1440 "panel.vala"
			_tmp15_ = _g_main_context_ref0 (_tmp14_);
#line 1440 "panel.vala"
			context = _tmp15_;
#line 1441 "panel.vala"
			if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 8218 "panel.c"
				GMainContext* _tmp17_;
				GSource* _tmp18_;
#line 1442 "panel.vala"
				_tmp17_ = context;
#line 1442 "panel.vala"
				_tmp18_ = g_main_context_find_source_by_id (_tmp17_, self->priv->m_switcher_focus_set_engine_id);
#line 1442 "panel.vala"
				_tmp16_ = _tmp18_ != NULL;
#line 8227 "panel.c"
			} else {
#line 1441 "panel.vala"
				_tmp16_ = FALSE;
#line 8231 "panel.c"
			}
#line 1441 "panel.vala"
			if (_tmp16_) {
#line 1444 "panel.vala"
				g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 8237 "panel.c"
			}
#line 1446 "panel.vala"
			self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1439 "panel.vala"
			_g_main_context_unref0 (context);
#line 8243 "panel.c"
		}
	}
#line 1420 "panel.vala"
	_g_free0 (prev_context_path);
#line 1420 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 8250 "panel.c"
}

static void
panel_real_focus_in (IBusPanelService* base,
                     const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
	IBusEngineDesc* engine = NULL;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	IBusEngineDesc* _tmp6_;
	IBusEngineDesc* _tmp7_;
	IBusEngineDesc* _tmp20_;
#line 1451 "panel.vala"
	self = (Panel*) base;
#line 1451 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1452 "panel.vala"
	_tmp0_ = g_strdup (input_context_path);
#line 1452 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1452 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 1461 "panel.vala"
	if (!g_str_has_suffix (input_context_path, "InputContext_1")) {
#line 8277 "panel.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1462 "panel.vala"
		_tmp1_ = self->priv->m_current_context_path;
#line 1462 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1462 "panel.vala"
		_g_free0 (self->priv->m_real_current_context_path);
#line 1462 "panel.vala"
		self->priv->m_real_current_context_path = _tmp2_;
#line 1463 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1463 "panel.vala"
		property_panel_focus_in (_tmp3_);
#line 1464 "panel.vala"
		panel_switcher_focus_set_engine (self);
#line 8295 "panel.c"
	}
#line 1467 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1468 "panel.vala"
		return;
#line 8301 "panel.c"
	}
#line 1470 "panel.vala"
	_tmp4_ = self->priv->m_engine_contexts;
#line 1470 "panel.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, input_context_path);
#line 1470 "panel.vala"
	_tmp6_ = _g_object_ref0 ((IBusEngineDesc*) _tmp5_);
#line 1470 "panel.vala"
	engine = _tmp6_;
#line 1472 "panel.vala"
	_tmp7_ = engine;
#line 1472 "panel.vala"
	if (_tmp7_ == NULL) {
#line 8315 "panel.c"
		IBusEngineDesc* _tmp8_ = NULL;
		IBusEngineDesc** _tmp9_;
		gint _tmp9__length1;
		IBusEngineDesc* _tmp12_;
		IBusEngineDesc* _tmp13_;
#line 1484 "panel.vala"
		_tmp9_ = self->priv->m_engines;
#line 1484 "panel.vala"
		_tmp9__length1 = self->priv->m_engines_length1;
#line 1484 "panel.vala"
		if (_tmp9__length1 > 0) {
#line 8327 "panel.c"
			IBusEngineDesc** _tmp10_;
			gint _tmp10__length1;
			IBusEngineDesc* _tmp11_;
#line 1484 "panel.vala"
			_tmp10_ = self->priv->m_engines;
#line 1484 "panel.vala"
			_tmp10__length1 = self->priv->m_engines_length1;
#line 1484 "panel.vala"
			_tmp11_ = _tmp10_[0];
#line 1484 "panel.vala"
			_tmp8_ = _tmp11_;
#line 8339 "panel.c"
		} else {
#line 1484 "panel.vala"
			_tmp8_ = NULL;
#line 8343 "panel.c"
		}
#line 1484 "panel.vala"
		_tmp12_ = _g_object_ref0 (_tmp8_);
#line 1484 "panel.vala"
		_g_object_unref0 (engine);
#line 1484 "panel.vala"
		engine = _tmp12_;
#line 1486 "panel.vala"
		_tmp13_ = engine;
#line 1486 "panel.vala"
		if (_tmp13_ == NULL) {
#line 1487 "panel.vala"
			_g_object_unref0 (engine);
#line 1487 "panel.vala"
			return;
#line 8359 "panel.c"
		}
	} else {
		gboolean in_engines = FALSE;
		IBusEngineDesc** _tmp14_;
		gint _tmp14__length1;
#line 1489 "panel.vala"
		in_engines = FALSE;
#line 1491 "panel.vala"
		_tmp14_ = self->priv->m_engines;
#line 1491 "panel.vala"
		_tmp14__length1 = self->priv->m_engines_length1;
#line 8371 "panel.c"
		{
			IBusEngineDesc** e_collection = NULL;
			gint e_collection_length1 = 0;
			gint _e_collection_size_ = 0;
			gint e_it = 0;
#line 1491 "panel.vala"
			e_collection = _tmp14_;
#line 1491 "panel.vala"
			e_collection_length1 = _tmp14__length1;
#line 1491 "panel.vala"
			for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 8383 "panel.c"
				IBusEngineDesc* _tmp15_;
				IBusEngineDesc* e = NULL;
#line 1491 "panel.vala"
				_tmp15_ = _g_object_ref0 (e_collection[e_it]);
#line 1491 "panel.vala"
				e = _tmp15_;
#line 8390 "panel.c"
				{
					IBusEngineDesc* _tmp16_;
					const gchar* _tmp17_;
					IBusEngineDesc* _tmp18_;
					const gchar* _tmp19_;
#line 1492 "panel.vala"
					_tmp16_ = engine;
#line 1492 "panel.vala"
					_tmp17_ = ibus_engine_desc_get_name (_tmp16_);
#line 1492 "panel.vala"
					_tmp18_ = e;
#line 1492 "panel.vala"
					_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 1492 "panel.vala"
					if (g_strcmp0 (_tmp17_, _tmp19_) == 0) {
#line 1493 "panel.vala"
						in_engines = TRUE;
#line 1494 "panel.vala"
						_g_object_unref0 (e);
#line 1494 "panel.vala"
						break;
#line 8412 "panel.c"
					}
#line 1491 "panel.vala"
					_g_object_unref0 (e);
#line 8416 "panel.c"
				}
			}
		}
#line 1500 "panel.vala"
		if (!in_engines) {
#line 1501 "panel.vala"
			_g_object_unref0 (engine);
#line 1501 "panel.vala"
			return;
#line 8426 "panel.c"
		}
	}
#line 1504 "panel.vala"
	_tmp20_ = engine;
#line 1504 "panel.vala"
	panel_set_engine (self, _tmp20_);
#line 1451 "panel.vala"
	_g_object_unref0 (engine);
#line 8435 "panel.c"
}

static void
panel_real_focus_out (IBusPanelService* base,
                      const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
#line 1507 "panel.vala"
	self = (Panel*) base;
#line 1507 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1508 "panel.vala"
	_tmp0_ = g_strdup ("");
#line 1508 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1508 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 8454 "panel.c"
}

static void
panel_real_destroy_context (IBusPanelService* base,
                            const gchar* input_context_path)
{
	Panel * self;
	GHashTable* _tmp0_;
#line 1511 "panel.vala"
	self = (Panel*) base;
#line 1511 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1512 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1513 "panel.vala"
		return;
#line 8471 "panel.c"
	}
#line 1515 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1515 "panel.vala"
	g_hash_table_remove (_tmp0_, input_context_path);
#line 8477 "panel.c"
}

static void
panel_real_register_properties (IBusPanelService* base,
                                IBusPropList* props)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1518 "panel.vala"
	self = (Panel*) base;
#line 1518 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1519 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1519 "panel.vala"
	property_manager_set_properties (_tmp0_, props);
#line 1520 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1520 "panel.vala"
	property_panel_set_properties (_tmp1_, props);
#line 1521 "panel.vala"
	panel_set_properties (self, props);
#line 8501 "panel.c"
}

static void
panel_real_update_property (IBusPanelService* base,
                            IBusProperty* prop)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1524 "panel.vala"
	self = (Panel*) base;
#line 1524 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1525 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1525 "panel.vala"
	property_manager_update_property (_tmp0_, prop);
#line 1526 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1526 "panel.vala"
	property_panel_update_property (_tmp1_, prop);
#line 1527 "panel.vala"
	panel_set_property (self, prop, FALSE);
#line 8525 "panel.c"
}

static void
panel_real_update_preedit_text (IBusPanelService* base,
                                IBusText* text,
                                guint cursor_pos,
                                gboolean visible)
{
	Panel * self;
#line 1530 "panel.vala"
	self = (Panel*) base;
#line 1530 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1533 "panel.vala"
	if (visible) {
#line 8541 "panel.c"
		CandidatePanel* _tmp0_;
		PropertyPanel* _tmp1_;
#line 1534 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 1534 "panel.vala"
		candidate_panel_set_preedit_text (_tmp0_, text, cursor_pos);
#line 1535 "panel.vala"
		_tmp1_ = self->priv->m_property_panel;
#line 1535 "panel.vala"
		property_panel_set_preedit_text (_tmp1_, text, cursor_pos);
#line 8552 "panel.c"
	} else {
		CandidatePanel* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1537 "panel.vala"
		_tmp2_ = self->priv->m_candidate_panel;
#line 1537 "panel.vala"
		candidate_panel_set_preedit_text (_tmp2_, NULL, (guint) 0);
#line 1538 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1538 "panel.vala"
		property_panel_set_preedit_text (_tmp3_, NULL, (guint) 0);
#line 8564 "panel.c"
	}
}

static void
panel_real_hide_preedit_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1542 "panel.vala"
	self = (Panel*) base;
#line 1543 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1543 "panel.vala"
	candidate_panel_set_preedit_text (_tmp0_, NULL, (guint) 0);
#line 8579 "panel.c"
}

static void
panel_real_update_auxiliary_text (IBusPanelService* base,
                                  IBusText* text,
                                  gboolean visible)
{
	Panel * self;
	IBusText* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusText* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1546 "panel.vala"
	self = (Panel*) base;
#line 1546 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1548 "panel.vala"
	if (visible) {
#line 1548 "panel.vala"
		_tmp0_ = text;
#line 8600 "panel.c"
	} else {
#line 1548 "panel.vala"
		_tmp0_ = NULL;
#line 8604 "panel.c"
	}
#line 1548 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1548 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp1_, _tmp0_);
#line 1549 "panel.vala"
	if (visible) {
#line 1549 "panel.vala"
		_tmp2_ = text;
#line 8614 "panel.c"
	} else {
#line 1549 "panel.vala"
		_tmp2_ = NULL;
#line 8618 "panel.c"
	}
#line 1549 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1549 "panel.vala"
	property_panel_set_auxiliary_text (_tmp3_, _tmp2_);
#line 8624 "panel.c"
}

static void
panel_real_hide_auxiliary_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1552 "panel.vala"
	self = (Panel*) base;
#line 1553 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1553 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp0_, NULL);
#line 8638 "panel.c"
}

static void
panel_real_update_lookup_table (IBusPanelService* base,
                                IBusLookupTable* table,
                                gboolean visible)
{
	Panel * self;
	IBusLookupTable* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusLookupTable* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1556 "panel.vala"
	self = (Panel*) base;
#line 1556 "panel.vala"
	g_return_if_fail (table != NULL);
#line 1558 "panel.vala"
	if (visible) {
#line 1558 "panel.vala"
		_tmp0_ = table;
#line 8659 "panel.c"
	} else {
#line 1558 "panel.vala"
		_tmp0_ = NULL;
#line 8663 "panel.c"
	}
#line 1558 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1558 "panel.vala"
	candidate_panel_set_lookup_table (_tmp1_, _tmp0_);
#line 1559 "panel.vala"
	if (visible) {
#line 1559 "panel.vala"
		_tmp2_ = table;
#line 8673 "panel.c"
	} else {
#line 1559 "panel.vala"
		_tmp2_ = NULL;
#line 8677 "panel.c"
	}
#line 1559 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1559 "panel.vala"
	property_panel_set_lookup_table (_tmp3_, _tmp2_);
#line 8683 "panel.c"
}

static void
panel_real_hide_lookup_table (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1562 "panel.vala"
	self = (Panel*) base;
#line 1563 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1563 "panel.vala"
	candidate_panel_set_lookup_table (_tmp0_, NULL);
#line 8697 "panel.c"
}

static void
panel_real_set_content_type (IBusPanelService* base,
                             guint purpose,
                             guint hints)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1566 "panel.vala"
	self = (Panel*) base;
#line 1567 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1567 "panel.vala"
	candidate_panel_set_content_type (_tmp0_, purpose, hints);
#line 8713 "panel.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 8730 "panel.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 8757 "panel.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 8763 "panel.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 8769 "panel.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 8773 "panel.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 8781 "panel.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 8785 "panel.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 8797 "panel.c"
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1659 "panel.vala"
	if ((*length) == (*size)) {
#line 1659 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1659 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8812 "panel.c"
	}
#line 1659 "panel.vala"
	(*array)[(*length)++] = value;
#line 1659 "panel.vala"
	(*array)[*length] = NULL;
#line 8818 "panel.c"
}

static void
panel_real_state_changed (IBusPanelService* base)
{
	Panel * self;
	Switcher* _tmp0_;
	IBusEngineDesc** _tmp1_;
	gint _tmp1__length1;
	gchar* icon_name = NULL;
	gchar* _tmp3_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp4_;
	IBusEngineDesc* _tmp5_;
	IBusEngineDesc* _tmp6_;
	const gchar* _tmp14_;
	IBusEngineDesc* _tmp56_;
	gint i = 0;
	IBusEngineDesc** _tmp65_;
	gint _tmp65__length1;
	IBusEngineDesc** _tmp72_;
	gint _tmp72__length1;
	IBusEngineDesc* _tmp73_;
	IBusEngineDesc* _tmp74_;
	gchar** names = NULL;
	gchar** _tmp75_;
	gint names_length1;
	gint _names_size_;
	IBusEngineDesc** _tmp76_;
	gint _tmp76__length1;
	GSettings* _tmp81_;
	gchar** _tmp82_;
	gint _tmp82__length1;
#line 1570 "panel.vala"
	self = (Panel*) base;
#line 1572 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1572 "panel.vala"
	if (switcher_is_running (_tmp0_)) {
#line 1573 "panel.vala"
		return;
#line 8860 "panel.c"
	}
#line 1574 "panel.vala"
	_tmp1_ = self->priv->m_engines;
#line 1574 "panel.vala"
	_tmp1__length1 = self->priv->m_engines_length1;
#line 1574 "panel.vala"
	if (_tmp1__length1 == 0) {
#line 1575 "panel.vala"
		return;
#line 8870 "panel.c"
	}
#line 1577 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8874 "panel.c"
		Indicator* _tmp2_;
#line 1579 "panel.vala"
		_tmp2_ = self->priv->m_indicator;
#line 1579 "panel.vala"
		if (_tmp2_ == NULL) {
#line 1580 "panel.vala"
			return;
#line 8882 "panel.c"
		}
	}
#line 1583 "panel.vala"
	_tmp3_ = g_strdup ("ibus-keyboard");
#line 1583 "panel.vala"
	icon_name = _tmp3_;
#line 1585 "panel.vala"
	_tmp4_ = self->priv->m_bus;
#line 1585 "panel.vala"
	_tmp5_ = ibus_bus_get_global_engine (_tmp4_);
#line 1585 "panel.vala"
	engine = _tmp5_;
#line 1586 "panel.vala"
	_tmp6_ = engine;
#line 1586 "panel.vala"
	if (_tmp6_ != NULL) {
#line 8899 "panel.c"
		IBusEngineDesc* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		IBusEngineDesc* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1587 "panel.vala"
		_tmp7_ = engine;
#line 1587 "panel.vala"
		_tmp8_ = ibus_engine_desc_get_icon (_tmp7_);
#line 1587 "panel.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 1587 "panel.vala"
		_g_free0 (icon_name);
#line 1587 "panel.vala"
		icon_name = _tmp9_;
#line 1588 "panel.vala"
		_tmp10_ = engine;
#line 1588 "panel.vala"
		_tmp11_ = ibus_engine_desc_get_icon_prop_key (_tmp10_);
#line 1588 "panel.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1588 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1588 "panel.vala"
		self->priv->m_icon_prop_key = _tmp12_;
#line 8926 "panel.c"
	} else {
		gchar* _tmp13_;
#line 1590 "panel.vala"
		_tmp13_ = g_strdup ("");
#line 1590 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1590 "panel.vala"
		self->priv->m_icon_prop_key = _tmp13_;
#line 8935 "panel.c"
	}
#line 1593 "panel.vala"
	_tmp14_ = icon_name;
#line 1593 "panel.vala"
	if (string_get (_tmp14_, (glong) 0) == '/') {
#line 1594 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 8943 "panel.c"
			GtkStatusIcon* _tmp15_;
			const gchar* _tmp16_;
#line 1595 "panel.vala"
			_tmp15_ = self->priv->m_status_icon;
#line 1595 "panel.vala"
			_tmp16_ = icon_name;
#line 1595 "panel.vala"
			gtk_status_icon_set_from_file (_tmp15_, _tmp16_);
#line 8952 "panel.c"
		} else {
#line 1596 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8956 "panel.c"
				Indicator* _tmp17_;
				const gchar* _tmp18_;
#line 1597 "panel.vala"
				_tmp17_ = self->priv->m_indicator;
#line 1597 "panel.vala"
				_tmp18_ = icon_name;
#line 1597 "panel.vala"
				indicator_set_icon_full (_tmp17_, _tmp18_, "");
#line 8965 "panel.c"
			}
		}
	} else {
		gchar* language = NULL;
		IBusEngineDesc* _tmp19_;
		const gchar* _tmp34_;
#line 1599 "panel.vala"
		language = NULL;
#line 1601 "panel.vala"
		_tmp19_ = engine;
#line 1601 "panel.vala"
		if (_tmp19_ != NULL) {
#line 8978 "panel.c"
			gchar* name = NULL;
			IBusEngineDesc* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
#line 1602 "panel.vala"
			_tmp20_ = engine;
#line 1602 "panel.vala"
			_tmp21_ = ibus_engine_desc_get_name (_tmp20_);
#line 1602 "panel.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 1602 "panel.vala"
			name = _tmp22_;
#line 1603 "panel.vala"
			if (!self->priv->m_is_wayland) {
#line 8995 "panel.c"
				const gchar* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 1603 "panel.vala"
				_tmp25_ = name;
#line 1603 "panel.vala"
				_tmp26_ = strlen (_tmp25_);
#line 1603 "panel.vala"
				_tmp27_ = _tmp26_;
#line 1603 "panel.vala"
				_tmp24_ = _tmp27_ >= 4;
#line 9007 "panel.c"
			} else {
#line 1603 "panel.vala"
				_tmp24_ = FALSE;
#line 9011 "panel.c"
			}
#line 1603 "panel.vala"
			if (_tmp24_) {
#line 9015 "panel.c"
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 1603 "panel.vala"
				_tmp28_ = name;
#line 1603 "panel.vala"
				_tmp29_ = string_slice (_tmp28_, (glong) 0, (glong) 4);
#line 1603 "panel.vala"
				_tmp30_ = _tmp29_;
#line 1603 "panel.vala"
				_tmp23_ = g_strcmp0 (_tmp30_, "xkb:") == 0;
#line 1603 "panel.vala"
				_g_free0 (_tmp30_);
#line 9029 "panel.c"
			} else {
#line 1603 "panel.vala"
				_tmp23_ = FALSE;
#line 9033 "panel.c"
			}
#line 1603 "panel.vala"
			if (_tmp23_) {
#line 9037 "panel.c"
				Switcher* _tmp31_;
				IBusEngineDesc* _tmp32_;
				gchar* _tmp33_;
#line 1604 "panel.vala"
				_tmp31_ = self->priv->m_switcher;
#line 1604 "panel.vala"
				_tmp32_ = engine;
#line 1604 "panel.vala"
				_tmp33_ = switcher_get_xkb_language (_tmp31_, _tmp32_);
#line 1604 "panel.vala"
				_g_free0 (language);
#line 1604 "panel.vala"
				language = _tmp33_;
#line 9051 "panel.c"
			}
#line 1601 "panel.vala"
			_g_free0 (name);
#line 9055 "panel.c"
		}
#line 1607 "panel.vala"
		_tmp34_ = language;
#line 1607 "panel.vala"
		if (_tmp34_ != NULL) {
#line 1608 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9063 "panel.c"
				GdkPixbuf* pixbuf = NULL;
				const gchar* _tmp35_;
				GdkPixbuf* _tmp36_;
				GtkStatusIcon* _tmp37_;
				GdkPixbuf* _tmp38_;
#line 1609 "panel.vala"
				_tmp35_ = language;
#line 1609 "panel.vala"
				_tmp36_ = panel_create_icon_pixbuf_with_string (self, _tmp35_);
#line 1609 "panel.vala"
				pixbuf = _tmp36_;
#line 1611 "panel.vala"
				_tmp37_ = self->priv->m_status_icon;
#line 1611 "panel.vala"
				_tmp38_ = pixbuf;
#line 1611 "panel.vala"
				gtk_status_icon_set_from_pixbuf (_tmp37_, _tmp38_);
#line 1608 "panel.vala"
				_g_object_unref0 (pixbuf);
#line 9083 "panel.c"
			} else {
#line 1613 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9087 "panel.c"
					cairo_surface_t* image = NULL;
					const gchar* _tmp39_;
					cairo_surface_t* _tmp40_;
					Indicator* _tmp41_;
					cairo_surface_t* _tmp42_;
#line 1614 "panel.vala"
					_tmp39_ = language;
#line 1614 "panel.vala"
					_tmp40_ = panel_create_cairo_image_surface_with_string (self, _tmp39_, TRUE);
#line 1614 "panel.vala"
					image = _tmp40_;
#line 1617 "panel.vala"
					_tmp41_ = self->priv->m_indicator;
#line 1617 "panel.vala"
					_tmp42_ = image;
#line 1617 "panel.vala"
					indicator_set_cairo_image_surface_full (_tmp41_, _tmp42_, "");
#line 1613 "panel.vala"
					_cairo_surface_destroy0 (image);
#line 9107 "panel.c"
				}
			}
		} else {
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp43_;
			GtkIconTheme* _tmp44_;
			GtkIconTheme* _tmp45_;
			const gchar* _tmp46_;
			GtkIconInfo* _tmp47_;
			GtkIconInfo* _tmp48_;
			gboolean _tmp49_;
#line 1620 "panel.vala"
			_tmp43_ = gtk_icon_theme_get_default ();
#line 1620 "panel.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1620 "panel.vala"
			theme = _tmp44_;
#line 1621 "panel.vala"
			_tmp45_ = theme;
#line 1621 "panel.vala"
			_tmp46_ = icon_name;
#line 1621 "panel.vala"
			_tmp47_ = gtk_icon_theme_lookup_icon (_tmp45_, _tmp46_, 48, 0);
#line 1621 "panel.vala"
			_tmp48_ = _tmp47_;
#line 1621 "panel.vala"
			_tmp49_ = _tmp48_ != NULL;
#line 1621 "panel.vala"
			_g_object_unref0 (_tmp48_);
#line 1621 "panel.vala"
			if (_tmp49_) {
#line 1622 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9141 "panel.c"
					GtkStatusIcon* _tmp50_;
					const gchar* _tmp51_;
#line 1623 "panel.vala"
					_tmp50_ = self->priv->m_status_icon;
#line 1623 "panel.vala"
					_tmp51_ = icon_name;
#line 1623 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp50_, _tmp51_);
#line 9150 "panel.c"
				} else {
#line 1624 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9154 "panel.c"
						Indicator* _tmp52_;
						const gchar* _tmp53_;
#line 1625 "panel.vala"
						_tmp52_ = self->priv->m_indicator;
#line 1625 "panel.vala"
						_tmp53_ = icon_name;
#line 1625 "panel.vala"
						indicator_set_icon_full (_tmp52_, _tmp53_, "");
#line 9163 "panel.c"
					}
				}
			} else {
#line 1627 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9169 "panel.c"
					GtkStatusIcon* _tmp54_;
#line 1628 "panel.vala"
					_tmp54_ = self->priv->m_status_icon;
#line 1628 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp54_, "ibus-engine");
#line 9175 "panel.c"
				} else {
#line 1629 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9179 "panel.c"
						Indicator* _tmp55_;
#line 1630 "panel.vala"
						_tmp55_ = self->priv->m_indicator;
#line 1630 "panel.vala"
						indicator_set_icon_full (_tmp55_, "ibus-engine", "");
#line 9185 "panel.c"
					}
				}
			}
#line 1607 "panel.vala"
			_g_object_unref0 (theme);
#line 9191 "panel.c"
		}
#line 1593 "panel.vala"
		_g_free0 (language);
#line 9195 "panel.c"
	}
#line 1635 "panel.vala"
	_tmp56_ = engine;
#line 1635 "panel.vala"
	if (_tmp56_ == NULL) {
#line 1636 "panel.vala"
		_g_object_unref0 (engine);
#line 1636 "panel.vala"
		_g_free0 (icon_name);
#line 1636 "panel.vala"
		return;
#line 9207 "panel.c"
	}
	{
		gboolean _tmp57_ = FALSE;
#line 1639 "panel.vala"
		i = 0;
#line 1639 "panel.vala"
		_tmp57_ = TRUE;
#line 1639 "panel.vala"
		while (TRUE) {
#line 9217 "panel.c"
			IBusEngineDesc** _tmp59_;
			gint _tmp59__length1;
			IBusEngineDesc** _tmp60_;
			gint _tmp60__length1;
			IBusEngineDesc* _tmp61_;
			const gchar* _tmp62_;
			IBusEngineDesc* _tmp63_;
			const gchar* _tmp64_;
#line 1639 "panel.vala"
			if (!_tmp57_) {
#line 9228 "panel.c"
				gint _tmp58_;
#line 1639 "panel.vala"
				_tmp58_ = i;
#line 1639 "panel.vala"
				i = _tmp58_ + 1;
#line 9234 "panel.c"
			}
#line 1639 "panel.vala"
			_tmp57_ = FALSE;
#line 1639 "panel.vala"
			_tmp59_ = self->priv->m_engines;
#line 1639 "panel.vala"
			_tmp59__length1 = self->priv->m_engines_length1;
#line 1639 "panel.vala"
			if (!(i < _tmp59__length1)) {
#line 1639 "panel.vala"
				break;
#line 9246 "panel.c"
			}
#line 1640 "panel.vala"
			_tmp60_ = self->priv->m_engines;
#line 1640 "panel.vala"
			_tmp60__length1 = self->priv->m_engines_length1;
#line 1640 "panel.vala"
			_tmp61_ = _tmp60_[i];
#line 1640 "panel.vala"
			_tmp62_ = ibus_engine_desc_get_name (_tmp61_);
#line 1640 "panel.vala"
			_tmp63_ = engine;
#line 1640 "panel.vala"
			_tmp64_ = ibus_engine_desc_get_name (_tmp63_);
#line 1640 "panel.vala"
			if (g_strcmp0 (_tmp62_, _tmp64_) == 0) {
#line 1641 "panel.vala"
				break;
#line 9264 "panel.c"
			}
		}
	}
#line 1645 "panel.vala"
	if (i == 0) {
#line 1646 "panel.vala"
		_g_object_unref0 (engine);
#line 1646 "panel.vala"
		_g_free0 (icon_name);
#line 1646 "panel.vala"
		return;
#line 9276 "panel.c"
	}
#line 1649 "panel.vala"
	_tmp65_ = self->priv->m_engines;
#line 1649 "panel.vala"
	_tmp65__length1 = self->priv->m_engines_length1;
#line 1649 "panel.vala"
	if (i >= _tmp65__length1) {
#line 1650 "panel.vala"
		_g_object_unref0 (engine);
#line 1650 "panel.vala"
		_g_free0 (icon_name);
#line 1650 "panel.vala"
		return;
#line 9290 "panel.c"
	}
	{
		gint j = 0;
#line 1652 "panel.vala"
		j = i;
#line 9296 "panel.c"
		{
			gboolean _tmp66_ = FALSE;
#line 1652 "panel.vala"
			_tmp66_ = TRUE;
#line 1652 "panel.vala"
			while (TRUE) {
#line 9303 "panel.c"
				IBusEngineDesc** _tmp68_;
				gint _tmp68__length1;
				IBusEngineDesc** _tmp69_;
				gint _tmp69__length1;
				IBusEngineDesc* _tmp70_;
				IBusEngineDesc* _tmp71_;
#line 1652 "panel.vala"
				if (!_tmp66_) {
#line 9312 "panel.c"
					gint _tmp67_;
#line 1652 "panel.vala"
					_tmp67_ = j;
#line 1652 "panel.vala"
					j = _tmp67_ - 1;
#line 9318 "panel.c"
				}
#line 1652 "panel.vala"
				_tmp66_ = FALSE;
#line 1652 "panel.vala"
				if (!(j > 0)) {
#line 1652 "panel.vala"
					break;
#line 9326 "panel.c"
				}
#line 1653 "panel.vala"
				_tmp68_ = self->priv->m_engines;
#line 1653 "panel.vala"
				_tmp68__length1 = self->priv->m_engines_length1;
#line 1653 "panel.vala"
				_tmp69_ = self->priv->m_engines;
#line 1653 "panel.vala"
				_tmp69__length1 = self->priv->m_engines_length1;
#line 1653 "panel.vala"
				_tmp70_ = _tmp69_[j - 1];
#line 1653 "panel.vala"
				_tmp71_ = _g_object_ref0 (_tmp70_);
#line 1653 "panel.vala"
				_g_object_unref0 (_tmp68_[j]);
#line 1653 "panel.vala"
				_tmp68_[j] = _tmp71_;
#line 9344 "panel.c"
			}
		}
	}
#line 1655 "panel.vala"
	_tmp72_ = self->priv->m_engines;
#line 1655 "panel.vala"
	_tmp72__length1 = self->priv->m_engines_length1;
#line 1655 "panel.vala"
	_tmp73_ = engine;
#line 1655 "panel.vala"
	_tmp74_ = _g_object_ref0 (_tmp73_);
#line 1655 "panel.vala"
	_g_object_unref0 (_tmp72_[0]);
#line 1655 "panel.vala"
	_tmp72_[0] = _tmp74_;
#line 1657 "panel.vala"
	_tmp75_ = g_new0 (gchar*, 0 + 1);
#line 1657 "panel.vala"
	names = _tmp75_;
#line 1657 "panel.vala"
	names_length1 = 0;
#line 1657 "panel.vala"
	_names_size_ = names_length1;
#line 1658 "panel.vala"
	_tmp76_ = self->priv->m_engines;
#line 1658 "panel.vala"
	_tmp76__length1 = self->priv->m_engines_length1;
#line 9372 "panel.c"
	{
		IBusEngineDesc** desc_collection = NULL;
		gint desc_collection_length1 = 0;
		gint _desc_collection_size_ = 0;
		gint desc_it = 0;
#line 1658 "panel.vala"
		desc_collection = _tmp76_;
#line 1658 "panel.vala"
		desc_collection_length1 = _tmp76__length1;
#line 1658 "panel.vala"
		for (desc_it = 0; desc_it < desc_collection_length1; desc_it = desc_it + 1) {
#line 9384 "panel.c"
			IBusEngineDesc* _tmp77_;
			IBusEngineDesc* desc = NULL;
#line 1658 "panel.vala"
			_tmp77_ = _g_object_ref0 (desc_collection[desc_it]);
#line 1658 "panel.vala"
			desc = _tmp77_;
#line 9391 "panel.c"
			{
				IBusEngineDesc* _tmp78_;
				const gchar* _tmp79_;
				gchar* _tmp80_;
#line 1659 "panel.vala"
				_tmp78_ = desc;
#line 1659 "panel.vala"
				_tmp79_ = ibus_engine_desc_get_name (_tmp78_);
#line 1659 "panel.vala"
				_tmp80_ = g_strdup (_tmp79_);
#line 1659 "panel.vala"
				_vala_array_add22 (&names, &names_length1, &_names_size_, _tmp80_);
#line 1658 "panel.vala"
				_g_object_unref0 (desc);
#line 9406 "panel.c"
			}
		}
	}
#line 1661 "panel.vala"
	_tmp81_ = self->priv->m_settings_general;
#line 1661 "panel.vala"
	_tmp82_ = names;
#line 1661 "panel.vala"
	_tmp82__length1 = names_length1;
#line 1661 "panel.vala"
	g_settings_set_strv (_tmp81_, "engines-order", _tmp82_);
#line 1570 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1570 "panel.vala"
	_g_object_unref0 (engine);
#line 1570 "panel.vala"
	_g_free0 (icon_name);
#line 9424 "panel.c"
}

static void
panel_class_init (PanelClass * klass,
                  gpointer klass_data)
{
#line 24 "panel.vala"
	panel_parent_class = g_type_class_peek_parent (klass);
#line 24 "panel.vala"
	g_type_class_adjust_private_offset (klass, &Panel_private_offset);
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_cursor_location = (void (*) (IBusPanelService*, gint, gint, gint, gint)) panel_real_set_cursor_location;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_in = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_in;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_out = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_out;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->destroy_context = (void (*) (IBusPanelService*, const gchar*)) panel_real_destroy_context;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->register_properties = (void (*) (IBusPanelService*, IBusPropList*)) panel_real_register_properties;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_property = (void (*) (IBusPanelService*, IBusProperty*)) panel_real_update_property;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_preedit_text = (void (*) (IBusPanelService*, IBusText*, guint, gboolean)) panel_real_update_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_preedit_text = (void (*) (IBusPanelService*)) panel_real_hide_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_auxiliary_text = (void (*) (IBusPanelService*, IBusText*, gboolean)) panel_real_update_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_auxiliary_text = (void (*) (IBusPanelService*)) panel_real_hide_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_lookup_table = (void (*) (IBusPanelService*, IBusLookupTable*, gboolean)) panel_real_update_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_lookup_table = (void (*) (IBusPanelService*)) panel_real_hide_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_content_type = (void (*) (IBusPanelService*, guint, guint)) panel_real_set_content_type;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->state_changed = (void (*) (IBusPanelService*)) panel_real_state_changed;
#line 24 "panel.vala"
	G_OBJECT_CLASS (klass)->finalize = panel_finalize;
#line 9465 "panel.c"
}

static void
panel_instance_init (Panel * self,
                     gpointer klass)
{
	IBusEngineDesc** _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	XKBLayout* _tmp13_;
	gchar* _tmp14_;
#line 24 "panel.vala"
	self->priv = panel_get_instance_private (self);
#line 32 "panel.vala"
	self->priv->m_settings_general = NULL;
#line 33 "panel.vala"
	self->priv->m_settings_hotkey = NULL;
#line 34 "panel.vala"
	self->priv->m_settings_panel = NULL;
#line 35 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_STATUS_ICON;
#line 43 "panel.vala"
	_tmp0_ = g_new0 (IBusEngineDesc*, 0 + 1);
#line 43 "panel.vala"
	self->priv->m_engines = _tmp0_;
#line 43 "panel.vala"
	self->priv->m_engines_length1 = 0;
#line 43 "panel.vala"
	self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 45 "panel.vala"
	_tmp1_ = g_str_hash;
#line 45 "panel.vala"
	_tmp2_ = g_str_equal;
#line 45 "panel.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 45 "panel.vala"
	self->priv->m_engine_contexts = _tmp3_;
#line 48 "panel.vala"
	_tmp4_ = g_strdup ("");
#line 48 "panel.vala"
	self->priv->m_current_context_path = _tmp4_;
#line 49 "panel.vala"
	_tmp5_ = g_strdup ("");
#line 49 "panel.vala"
	self->priv->m_real_current_context_path = _tmp5_;
#line 50 "panel.vala"
	self->priv->m_use_global_engine = TRUE;
#line 51 "panel.vala"
	self->priv->m_use_engine_lang = TRUE;
#line 57 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 60 "panel.vala"
	self->priv->m_switcher_delay_time = 400;
#line 61 "panel.vala"
	self->priv->m_use_system_keyboard_layout = FALSE;
#line 62 "panel.vala"
	_tmp6_ = g_str_hash;
#line 62 "panel.vala"
	_tmp7_ = g_str_equal;
#line 62 "panel.vala"
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_object_unref0_);
#line 62 "panel.vala"
	self->priv->m_xkb_icon_pixbufs = _tmp8_;
#line 65 "panel.vala"
	_tmp9_ = g_str_hash;
#line 65 "panel.vala"
	_tmp10_ = g_str_equal;
#line 65 "panel.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _cairo_surface_destroy0_);
#line 65 "panel.vala"
	self->priv->m_xkb_icon_image = _tmp11_;
#line 68 "panel.vala"
	memset (&_tmp12_, 0, sizeof (GdkRGBA));
#line 68 "panel.vala"
	_tmp12_.red = 0.0;
#line 68 "panel.vala"
	_tmp12_.green = 0.0;
#line 68 "panel.vala"
	_tmp12_.blue = 0.0;
#line 68 "panel.vala"
	_tmp12_.alpha = 1.0;
#line 68 "panel.vala"
	self->priv->m_xkb_icon_rgba = _tmp12_;
#line 70 "panel.vala"
	_tmp13_ = xkb_layout_new ();
#line 70 "panel.vala"
	self->priv->m_xkblayout = _tmp13_;
#line 71 "panel.vala"
	self->priv->inited_engines_order = TRUE;
#line 74 "panel.vala"
	_tmp14_ = g_strdup ("");
#line 74 "panel.vala"
	self->priv->m_icon_prop_key = _tmp14_;
#line 75 "panel.vala"
	self->priv->m_property_icon_delay_time = 500;
#line 79 "panel.vala"
	self->priv->m_is_kde = panel_is_kde ();
#line 87 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 9575 "panel.c"
}

static void
panel_finalize (GObject * obj)
{
	Panel * self;
	Indicator* _tmp0_;
	GList* _tmp2_;
#line 24 "panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PANEL, Panel);
#line 155 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 155 "panel.vala"
	if (_tmp0_ != NULL) {
#line 9590 "panel.c"
		Indicator* _tmp1_;
#line 156 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 156 "panel.vala"
		indicator_unregister_connection (_tmp1_);
#line 9596 "panel.c"
	}
#line 158 "panel.vala"
	_tmp2_ = self->priv->m_keybindings;
#line 158 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp2_);
#line 160 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 160 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 31 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 32 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 33 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 34 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 36 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 38 "panel.vala"
	_g_object_unref0 (self->priv->m_session_bus_connection);
#line 40 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 41 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 42 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 43 "panel.vala"
	self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 44 "panel.vala"
	_g_object_unref0 (self->priv->m_en_engine);
#line 45 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_engine_contexts);
#line 48 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 49 "panel.vala"
	_g_free0 (self->priv->m_real_current_context_path);
#line 52 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 53 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 55 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 56 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 58 "panel.vala"
	_g_object_unref0 (self->priv->m_about_dialog);
#line 59 "panel.vala"
	_g_object_unref0 (self->priv->m_css_provider);
#line 62 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_pixbufs);
#line 65 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_image);
#line 70 "panel.vala"
	_xkb_layout_unref0 (self->priv->m_xkblayout);
#line 74 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 87 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 24 "panel.vala"
	G_OBJECT_CLASS (panel_parent_class)->finalize (obj);
#line 9658 "panel.c"
}

static GType
panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Panel), 0, (GInstanceInitFunc) panel_instance_init, NULL };
	GType panel_type_id;
	panel_type_id = g_type_register_static (ibus_panel_service_get_type (), "Panel", &g_define_type_info, 0);
	Panel_private_offset = g_type_add_instance_private (panel_type_id, sizeof (PanelPrivate));
	return panel_type_id;
}

GType
panel_get_type (void)
{
	static volatile gsize panel_type_id__once = 0;
	if (g_once_init_enter (&panel_type_id__once)) {
		GType panel_type_id;
		panel_type_id = panel_get_type_once ();
		g_once_init_leave (&panel_type_id__once, panel_type_id);
	}
	return panel_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 9690 "panel.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 9698 "panel.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 9713 "panel.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 9727 "panel.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 9732 "panel.c"
}

